SystemOrganization addCategory: #LispKit!
SystemOrganization addCategory: #'LispKit-Continuations'!
SystemOrganization addCategory: #'LispKit-Dialects'!
SystemOrganization addCategory: #'LispKit-Dialects-Tests'!
SystemOrganization addCategory: #'LispKit-GUI'!
SystemOrganization addCategory: #'LispKit-Tests'!


Object subclass: #ConsCell
	instanceVariableNames: 'car cdr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

TestCase subclass: #ConsCellTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Tests'!

Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Continuations'!

TestCase subclass: #ELispTest
	instanceVariableNames: 'lisp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects-Tests'!

Error subclass: #LispError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

Object subclass: #LispKernel
	instanceVariableNames: 'environment monitor upperLisp upperHead ignoreCase evalSemaphore constantVariables upperTail outputPort inputPort topmostLisp currentDirectory'
	classVariableNames: 'QuotingSugar'
	poolDictionaries: ''
	category: 'LispKit'!

LispKernel subclass: #ELisp
	instanceVariableNames: 'uninternedSymbols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects'!

TestCase subclass: #LispKernelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Tests'!

PackageInfo subclass: #LispKitInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

Object subclass: #LKBlock
	instanceVariableNames: 'block description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

Object subclass: #LKClosure
	instanceVariableNames: 'form environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

Continuation subclass: #LKContinuation
	instanceVariableNames: 'topMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Continuations'!

Object subclass: #LKEnvironment
	instanceVariableNames: 'symbolFunctions symbolValues symbolPlists upperBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

Object subclass: #LKIOPort
	instanceVariableNames: 'inStream outStream status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

Object subclass: #LKMonitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

PluggableTextMorph subclass: #LKPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-GUI'!

Object subclass: #LKPrimitive
	instanceVariableNames: 'selector lisp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

PluggableTextMorphWithModel subclass: #LKREPLMorph
	instanceVariableNames: 'lisp commandsHistory lastAnswer lastError debugContinuation lastValue queue timeMark'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-GUI'!

Object subclass: #LKReader
	instanceVariableNames: 'lisp labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

TextMorphEditor subclass: #LKTextMorphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-GUI'!

TextMorphForEditView subclass: #LKTextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-GUI'!

Notification subclass: #LKThrowNotification
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

WriteStream subclass: #LKToken
	instanceVariableNames: 'couldBeFraction couldBeExponent couldBeNumber base number dot sign nindex n1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

TestCase subclass: #LKTokenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Tests'!

LKMonitor subclass: #LKTracer
	instanceVariableNames: 'depth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

LKTracer subclass: #LKFunctionsTracer
	instanceVariableNames: 'functions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

LKTracer subclass: #LKHalt
	instanceVariableNames: 'functions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

LKTracer subclass: #LKSymbolsTracer
	instanceVariableNames: 'symbols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

Array variableSubclass: #LKValues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

ELisp subclass: #SLisp
	instanceVariableNames: 'syntax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects'!

LKReader subclass: #SLispReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

ELispTest subclass: #SLispTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects-Tests'!

ELisp subclass: #StaticLisp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects'!

StaticLisp subclass: #CLisp
	instanceVariableNames: 'dynamicSymbolValues specialVariables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects'!

ELispTest subclass: #StaticLispTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects-Tests'!

StaticLispTest subclass: #CLispTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects-Tests'!

Object subclass: #TailCallWrapper
	instanceVariableNames: 'args lisp procedure id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

StaticLisp subclass: #ULisp
	instanceVariableNames: 'initialEnvironment userEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects'!

ULisp subclass: #SScheme
	instanceVariableNames: 'macroEvalTemplate macroEvalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects'!

LKReader subclass: #ULispReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

StaticLispTest subclass: #ULispTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit-Dialects-Tests'!

LKToken subclass: #ULispToken
	instanceVariableNames: 'couldBeComplex i startWithSign'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LispKit'!

ConsCell class
	instanceVariableNames: ''!

ConsCellTest class
	instanceVariableNames: ''!

Continuation class
	instanceVariableNames: ''!

ELispTest class
	instanceVariableNames: ''!

LispError class
	instanceVariableNames: ''!

LispKernel class
	instanceVariableNames: 'Primitives SpecialForms Sugar'!

ELisp class
	instanceVariableNames: ''!

LispKernelTest class
	instanceVariableNames: ''!

LispKitInfo class
	instanceVariableNames: ''!

LKBlock class
	instanceVariableNames: ''!

LKClosure class
	instanceVariableNames: ''!

LKContinuation class
	instanceVariableNames: ''!

LKEnvironment class
	instanceVariableNames: ''!

LKIOPort class
	instanceVariableNames: ''!

LKMonitor class
	instanceVariableNames: ''!

LKPluggableTextMorph class
	instanceVariableNames: ''!

LKPrimitive class
	instanceVariableNames: ''!

LKREPLMorph class
	instanceVariableNames: ''!

LKReader class
	instanceVariableNames: 'CharacterNames Macros SharpMacros SyntacticTypes'!

LKTextMorphEditor class
	instanceVariableNames: ''!

LKTextMorphForEditView class
	instanceVariableNames: ''!

LKThrowNotification class
	instanceVariableNames: ''!

LKToken class
	instanceVariableNames: ''!

LKTokenTest class
	instanceVariableNames: ''!

LKTracer class
	instanceVariableNames: ''!

LKFunctionsTracer class
	instanceVariableNames: ''!

LKHalt class
	instanceVariableNames: ''!

LKSymbolsTracer class
	instanceVariableNames: ''!

LKValues class
	instanceVariableNames: ''!

SLisp class
	instanceVariableNames: ''!

SLispReader class
	instanceVariableNames: ''!

SLispTest class
	instanceVariableNames: ''!

StaticLisp class
	instanceVariableNames: ''!

CLisp class
	instanceVariableNames: ''!

StaticLispTest class
	instanceVariableNames: ''!

CLispTest class
	instanceVariableNames: ''!

TailCallWrapper class
	instanceVariableNames: ''!

ULisp class
	instanceVariableNames: ''!

SScheme class
	instanceVariableNames: ''!

ULispReader class
	instanceVariableNames: ''!

ULispTest class
	instanceVariableNames: ''!

ULispToken class
	instanceVariableNames: ''!


!CLisp commentStamp: '<historical>' prior: 0!
a Lisp-2 dialect with lexical scoping plus special (dynamic) variables following the rules of Common Lisp 

see the SUnit coverage in CLispTest!

!CLispTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class CLisp. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

!ConsCell commentStamp: 'spfa 6/16/2006 23:33' prior: 0!
a Lisp cons cell

	it can be converted into an Array:
	(ConsCell car: 1 cdr: (ConsCell car: 2 cdr: nil)) arrayForm    "printIt"

	... or not:
	(ConsCell car: 1 cdr: 2) arrayForm     "doIt"

	it can be created from an Array:
	#('hello' 'world') asCons        "printIt"




!

!ConsCellTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class ConsCell. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

!Continuation commentStamp: 'spfa 6/18/2006 22:13' prior: 0!
Continuation class borrowed from Seaside
(author: Avi Bryant) !
]style[(62)f1!

!ELisp commentStamp: 'spfa 11/14/2006 14:59' prior: 0!
a dynamic Lisp-2 similar to Emacs Lisp

it is basically LispKernel enriched with primitives and libraries so that it is actually usable !

!ELispTest commentStamp: 'spfa 6/1/2006 19:47' prior: 0!
This is the unit test for the class LispKernel. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

!LispError commentStamp: 'spfa 5/26/2006 18:40' prior: 0!
an error signaled by the lisp interpreter
!

!LispKernel commentStamp: 'spfa 11/20/2006 13:14' prior: 0!
minimal kernel for a Lisp implementation

	LispKernel openNew  "doIt"


provides:

	a Lisp-2 interpreter with
	- dynamic scoping
	- fundamental special forms: let, setq, defun, defmacro ...
	- a few dozens functions: list, car, funcall, ...
	- catch/throw, unwind-protect
	- tail call optimization
	- a GUI


usage:

	subclasses of LispKernel can implement their own dialect of Lisp, by adding new functions and special forms and/or by overriding methods.
	see ELisp, SLisp, CLisp and ULisp for examples


specificities

	LispKernel is implemented as a pure Smalltalk extension: Lisp code can be written as plain Smalltalk arrays, such as

	#(defmacro addToList (x y) `(list ,x ,@y))  "printIt" 

	the conversion into Lisp data is straightforward: see the very simple code in Array>>#asCons which converts the array into a tree of cons cells. example:

	#(defun add (x y) (list x y)) asCons     "exploretIt"

	this approach has many advantages. for example:
	- we can chase the senders of a symbol: try [defun] (alt-n)
	- we can use the debugger to debug Lisp code
	- we can easily implement powerful control structures (see catch/throw) 
	- we can integrate Lisp and Smalltalk. see SLisp


caveat

	since we are bound to Smalltalk syntax, our Lisp can not have exactly the same syntax as usual Lisps:

	- the syntactic shortcut for quotation is $' instead of a plain '
that is:
		(cdr $'(1 2 3))
instead of:
		(cdr '(1 2 3))

	- strings are 'quoted like this' instead of "like that"

	- comments are "double quoted", the character ; has no special meaning

	- the character # is generally ignored
for example
	(+ 1 #2) or (#+ #1 2) or even #(#+ #1 #2) are the same as (+ 1 2)
	# may at time seem like it is equivalent to nil, but it isn't...

	- reserved words true and false are not parsed as symbols in arrays; use #true and #false instead. 

	 - more generally, all legal Lisp symbols which are not parsed correctly should be explicited; for example do:
	ELisp new top: #(let ((#'//my--var//' 10)) (+ #'//my--var//' 5))
instead of
	ELisp new top: #(let ((//my--var// 10)) (+ //my--var// 5))

	note that some minimal rewriting is performed when reading code at top-level in order to support the most common cases.
for example you can do:
	ELisp new top: #(let ((my-composed-var 10)) (+ my-composed-var 5))


interpreting textual code

	when the Lisp code to be evaluated is written in a string (as it happens in the GUI for example) the process described above does not happen: instead we use the regular read function from Lisp (see its implementation in LKReader). 
	thus there is no restriction to the usual Lisp syntax; code files can be loaded directly.


inspiration

	many LispKernel design ideas are inspired by Emacs Lisp. 
	most notably, all variables have dynamic scoping (subclasses may change that: see StaticLisp which has lexical scoping and special variables very much like Common Lisp)	


extending LispKernel: adding primitives

	you can define a new function or special form by adding an instance-side method to the LispKernel subclass you are working on (it is not recommended to hack on LispKernel itself).

	it should be a method of one argument, a ConsCell. this single argument is the list of arguments for the implemented lisp function or special form. special forms are given a list of non evaluated arguments, while ordinary functions are given a list of already evaluated arguments.

	it is very important that methods for functions live in a 'LISP-functions ...' category, while methods for special forms are categorized under 'LISP-special forms'. 

	after adding the method, either eval (update-primitives) in any running Lisp interpreter or evaluate the Smalltalk code 'LispKernel updatePrimitives'. this will make all necessary internal registering for the new function or macro to be immediately available to all interpreters.

	if the method name is like #brandNewPrimitive: then the name for its corresponding Lisp function will be 'brand-new-primitive', although 'brandNewPrimitive:' will also be accepted.


extending LispKernel: adding Lisp libraries

	on the class-side of your Lisp you can add a method of no argument returning an array of Lisp code, say #myLib. 
	
	it can be loaded interactively by evaluating (load-library 'my-lib), or it can be automatically loaded at startup by adding #'my-lib' to the array returned by the instance-side method #defaultLibraries of your Lisp.


subclassing LispKernel

	among the many methods you might consider overidding in a subclass (see methods categorized 'private - subclasses may implement'), important ones are:
	
	#lispDoesNotUnderstand:
	this is the place for dynamic function lookup

	#symbolValue:
	#symbolValue:ifNone: 
	you can change the symbol values lookup here

	#defaultLibraries
	... for initializing the system, evaluating Lisp code at startup

	#lispPerform:with:
	this is the very last step before a primitive is evaluated. 

	... see SLisp for example: it redefines most of these methods.

	StaticLisp makes deeper changes in the nature of lambda expressions and variables lookup since it implements lexical scoping and closures.

	ULisp (a StaticLisp subclass) is a full-fledged Scheme implementation
!

!LispKitInfo commentStamp: 'spfa 5/26/2006 18:39' prior: 0!
see comments in LispKernel

!

!LKBlock commentStamp: 'spfa 11/19/2006 21:15' prior: 0!
Compiled form for a s-expression

basically just a wrapper around a BlockContext!

!LKClosure commentStamp: 'spfa 6/2/2006 23:55' prior: 0!
Wraps a Lisp form (actually a ConsCell) defining a lambda or macro along with its environment (i.e. the bindings of the variables it depends on).

This is used to implement lexical scoping in specific Lisp dialects!

!LKContinuation commentStamp: 'spfa 9/30/2006 21:37' prior: 0!
This is a variation on the Continuation from Seaside, by Avi Bryant.

It only snapshots the senders chain up to the top level invocation of the lisp interpreter (which is by convention its method #enterInterpreterContextAndEval:) so that we do not have the undesirable effects of a full Continuation which would leak out of Lisp
!

!LKEnvironment commentStamp: 'spfa 10/24/2006 21:08' prior: 0!
a Lisp environment!

!LKIOPort commentStamp: 'spfa 10/20/2006 13:03' prior: 0!
Interface presenting smalltalk streams as Lisp streams!

!LKMonitor commentStamp: '<historical>' prior: 0!
Watcher for the inputs to #evalObject: in a Lisp interpreter
!

!LKPrimitive commentStamp: 'spfa 10/19/2006 17:17' prior: 0!
a LispKernel primitive!

!LKReader commentStamp: 'spfa 10/11/2006 11:49' prior: 0!
a reader for textual Lisp code/data

based on Common Lisp the Language, 2nd edition, chapter 22.1!

!LKThrowNotification commentStamp: '<historical>' prior: 0!
used to implement catch & throw

!

!LKTokenTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class LKToken. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

!LKValues commentStamp: 'spfa 10/24/2006 21:12' prior: 0!
multiple values for Lisp
!

!SLisp commentStamp: 'spfa 11/20/2006 13:17' prior: 0!
a dynamic Lisp-2 dialect tightly integrated with Smalltalk.

	SLisp openNew 		"doIt"


features:
	
	- the 'smalltalk' function evaluates its single argument (a string) as Smalltalk code; this code can reference variables bound in SLisp, provided that their names follow Smalltalk syntax. example:

		(let ((x 1)) (smalltalk 'x'))  => 1
  

	- SLisp has access to the global Smalltalk namespace.

	- symbol 'self' is bound to the SLisp interpreter

	- unrecognizable Lisp code is converted on the fly into nested Smalltalk messages and silently evaluated. examples:

		(position (new Morph)) is equivalent to (smalltalk 'Morph new position') 

		(@ 10 15) is equivalent to (smalltalk '10@15') 

		(openInHand (position: (new Morph) (@ 100 200)))
			is equivalent to (smalltalk '(Morph new position: 100@200) openInHand') 

	- the special form with-smalltalk-syntax (represented by curly braces {}) allows insertion of Smalltalk-looking forms, in which regular lisp forms can be included within [] sections . examples:

		(with-smalltalk-syntax (Morph new position)) => 0@0
		{Morph new position} => 0@0
		{1 + 1 + 1} => 3
		(+ 10 {1 + [+ 2 2 {3 + 3 + 3}] + 1})  => 25
	

	- boolean values are Smalltalk's true and false (instead of #t and nil) . 


with-smalltalk-syntax caveat:

	(these do not apply to text input, only when directly writing cons cells from arrays via #asCons)

	- since '#' is ignored by the conversion from Array to ConsCell, symbols can not be parsed correctly.
	so instead of 
		#(if {#symbol isSymbol} 0 1) 
	you must write 
		#(if {$#symbol isSymbol} 0 1) 
	which works because '$#' inserts a quoted Lisp form within a Smalltalk syntax 
	
	- the comma ',' can not be used as a Smalltalk selector since it is a specific syntactic sugar in backquoted forms.
	so instead of 
		#(setq string {'abc' , 'def'}) 
	you must write 
		#(setq string (smalltalk '''abc'' , ''def''')) 


demo:

do
	SLisp openNew 		
then type
	(widgets-example1)
... and see the source code in SLisp class>>widgets

!

!SLispReader commentStamp: 'spfa 10/11/2006 11:50' prior: 0!
code reader for SLisp!

!SLispTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class SLisp. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

!SScheme commentStamp: 'spfa 3/28/2007 10:10' prior: 0!
ULisp enhanced with SLIB libraries (see class-side #sscheme) 
with R4RS hygienic macros support

	SScheme openNew		"doIt"

!

!StaticLisp commentStamp: 'spfa 11/20/2006 13:17' prior: 0!
a Lisp-2 dialect with lexical scoping and closures

!

!StaticLispTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class ULisp. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

!TailCallWrapper commentStamp: 'spfa 11/17/2006 22:42' prior: 0!
Represent a Lisp/Scheme procedure invocation.

When tail call optimization happens, a TailCallWrapper is returned so that the embedded procedure call gets evaluated in the optimizing loop instead of being evaluated recursively, which would grow the stack !

!ULisp commentStamp: '<historical>' prior: 0!
this is Scheme (the Uncommon Lisp), a Lisp-1 dialect fully static with closures

	ULisp openNew 		"doIt"

	SLIB version 3a4 is provided 
	(see http://swiss.csail.mit.edu/~jaffer/SLIB.html)






	!

!ULispReader commentStamp: 'spfa 10/11/2006 11:51' prior: 0!
code reader for ULisp (handles #f and #t)
!

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 11/30/2006 14:07'!
about: aConsCell

"(about SYMBOL)
Describe the function definition and value of SYMBOL."

	| v sym |

	(sym _ aConsCell car) isSymbol ifFalse: [self lispError: 'not a symbol'].

	v _ self symbolValue: sym ifNone: [nil].

	self output: ('Value: #', sym, (v ifNil: [' is unbound'] ifNotNil: [' is bound to
	', (v printStringForLisp: self)]), '
Function: ', (self documentation: aConsCell)).

	^ self trueValue! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 11/30/2006 14:08'!
about: aConsCell

"(about SYMBOL)
Describe the function definition and value of SYMBOL."

	| v sym |

	(sym _ aConsCell car) isSymbol ifFalse: [self lispError: 'not a symbol'].

	v _ self symbolValue: aConsCell car ifNone: [nil].

	self output:
		((self procedureP: v inCons) = self trueValue
			ifTrue: ['Procedure: ', (self documentation: aConsCell), String cr]
			ifFalse: [sym, (v ifNil: [' is unbound'] ifNotNil: [' is bound to ', (v printStringForLisp: self)]), String cr]).

	^ self trueValue! !

!LKREPLMorph methodsFor: 'contents' stamp: 'spfa 9/29/2006 10:50'!
acceptTextInModel

	| textToAccept command |

	(self hasProperty: #inCommand)
	ifFalse:
	[
		command _ self currentCommandFor: textMorph contents.
		command ifEmpty: [command _ self pointedCommand].
		(command isNil or: [command isEmpty]) ifTrue: [^ self].
		self insertCommand: command.
	].

	textToAccept := textMorph asText.
	^setTextSelector isNil or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: textToAccept with: self]
			ifFalse: [model perform: setTextSelector with: textToAccept]]
! !

!LispKitInfo methodsFor: 'as yet unclassified' stamp: 'spfa 3/29/2007 09:09'!
additionalFiles

	^ {'ulisp.zip'}! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 6/3/2006 01:24'!
addLast: anObject

	cdr ifNil: [self setcdr: (ConsCell car: anObject)]
		ifNotNil: [cdr addLast: anObject]! !

!LispKernel class methodsFor: 'private-subclasses may implement' stamp: 'spfa 11/19/2006 23:01'!
aliasForPrimitive: aSymbol

	"return the lispish symbol associated to the function or macro defined by primitive method aSymbol"

	| alias ups |

	alias _ aSymbol allButLast.
	alias _ alias copyReplaceAll: 'LISP' with: ''.
	(aSymbol endsWith: 'Star:')
		ifTrue: [alias _ (alias allButLast: 4), '*'].	
	alias _ alias copyReplaceAll: 'TO' with: '-to-'.
	(ups _ alias select: [:c | c isUppercase])	ifNotEmpty: 
	[
		alias _ (ups size = 1 and: [alias last == $P])
			ifTrue: [alias asLowercase] 
			ifFalse: [alias linkAtCaps]
	].

	^ alias asSymbol
	! !

!ULisp class methodsFor: 'private' stamp: 'spfa 11/19/2006 23:06'!
aliasForPrimitive: aSymbol

	| alias |

	alias _ aSymbol allButLast.
	alias _ alias copyReplaceAll: 'LISP' with: ''.
	(aSymbol endsWith: 'P:')
		ifTrue: [alias _ alias allButLast, '?'].
	(aSymbol endsWith: 'D:')
		ifTrue: [alias _ alias allButLast, '!!'].		
	(aSymbol endsWith: 'Star:')
		ifTrue: [alias _ (alias allButLast: 4), '*'].	
	alias _ alias copyReplaceAll: 'TO' with: '->'.
	(alias detect: [:c | c isUppercase] ifNone: [nil])
		ifNotNil: [alias _ alias linkAtCaps].

	^ alias asSymbol
	
	! !

!LKREPLMorph class methodsFor: 'colors' stamp: 'spfa 6/8/2006 14:01'!
answerAttribute

	^ TextColor color: Color gray darker! !

!LKREPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 11/30/2006 14:41'!
appendEntry

	self queue nextPut:  
		(((lisp standardOutputPort stream contents asString) 
				copyReplaceAll: String lf with: String cr)
		asText 
			addAttribute: self class displayAttribute;
			addAttribute: (TextFontReference toFont: self class displayFont)).

	"logic to be improved..."
	(timeMark isNil
		or: [(Time millisecondsSince: timeMark) >= 250]
		or: [self queue size > 20])
		ifTrue: [self outputQueue]
	"	ifFalse: [[300 milliSeconds asDelay wait. self outputQueue] fork]".
	timeMark _ Time millisecondClockValue

! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 3/23/2007 00:01'!
append: aConsCell

	cdr ifNil: [self setcdr: aConsCell]	
	ifNotNil: [cdr append: aConsCell].
	! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 3/22/2007 23:59'!
append: aConsCell

"(append &rest LISTS)
Concatenate all the arguments.
The result is a list whose elements are the elements of all LISTS."

	| cons |
	
	aConsCell ifNil: [^ nil].

	aConsCell cdr ifNil: [^ aConsCell car].

	aConsCell doWithCdr: [:ea :cdr |
		ea ifNotNil:[	| e |
			e _ (ea isConsCell and: [cdr notNil]) 
					ifTrue: [ea listCopy] ifFalse: [ea].
			cons ifNil: [cons _ e] ifNotNil: [cons append: e]]	].
	
	^ cons
! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 11/17/2006 20:12'!
apply: aConsCell

"(apply FUNCTION &rest ARGS)
Call FUNCTION with the remaining args, using the last arg as list of args.
Return the value FUNCTION returns.
For example, (apply $'+ 1 2 $'(3 4)) returns 10."

	| form |

	form _ aConsCell car inCons.
	
	aConsCell cdr cellsDo: [:ac |
		ac cdr 
			ifNil: [ac car ifNotNil: [form lastCdr: (ac car collect: [:arg | 
								ConsCell car: #quote: cdr: (ConsCell car: arg)])]]
			ifNotNil: [form addLast: (ConsCell car: #quote: cdr: (ConsCell car: ac car))]].

	^ self evalObject: form multipleValue: true! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 3/27/2007 14:45'!
apply: aConsCell

"(apply PROCEDURE &rest ARGS)
Call PROCEDURE with the remaining args, using the last arg as list of args.
Return the value PROCEDURE returns.
For example, (apply + 1 2 $'(3 4)) returns 10."

	(aConsCell car isLispClosure 
		or: [aConsCell car isLKPrimitive])
		ifFalse: [self lispError: 'Invalid function: ', aConsCell car asString].
	
	^ super apply: aConsCell! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:05'!
aref: aConsCell

"(aref SEQUENCE N)
Return element of SEQUENCE at index N.
SEQUENCE can be a list or a vector (first index is 0).
More generally it can be any Object (first index is then 1)"

	^ self elt: aConsCell

	! !

!TailCallWrapper methodsFor: 'accessing' stamp: 'spfa 11/17/2006 13:36'!
args

	^ args ! !

!TailCallWrapper methodsFor: 'accessing' stamp: 'spfa 11/17/2006 13:37'!
args: aConsCell

	args  _ aConsCell! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 8/3/2006 23:02'!
argumentsLists

"
code largely borrowed from GNU Emacs 21.1 cl.el and cl-macs.el files
author: Dave Gillepsie
copyright: Free Software Foundation
licence: GPL
"

	^ 
	#(in-library arguments-lists

(require-library $'common)

(when (featurep $'arguments-lists)
	"clear all else infinite loops await"
	(dolist (v #'*library:arguments-lists*')
		(makunbound v)
		(fmakunbound v)))

(defun cl-const-expr-p (x)
  (cond ((consp x)
	 (or (eq (car x) $'quote)
	     (and (memq (car x) $'(function function*))
		  (or (symbolp (nth 1 x))
		      (and (eq (car-safe (nth 1 x)) $'lambda) $'func)))))
	((symbolp x) (and (memq x $'(nil t)) t))
	(t t)))

(defun cl-const-expr-val (x)
  (and (eq (cl-const-expr-p x) t) (if (consp x) (nth 1 x) x)))

(defun ldiff (list sublist)
  'Return a copy of LIST with the tail SUBLIST removed.'
  (let ((res nil))
    (while (and (consp list) (not (eq list sublist)))
      (push (pop list) res))
    (nreverse res)))

(defconstant lambda-list-keywords
  $'(#'&optional' #'&rest' #'&key' #'&allow-other-keys' #'&aux' #'&whole' #'&body' #'&environment'))

(defvar cl-macro-environment nil)
(defvar bind-block) (defvar bind-defs) (defvar bind-enquote)
(defvar bind-inits) (defvar bind-lets) (defvar bind-forms)

(defun cl-transform-lambda (form bind-block)
  (let* ((args (car form)) (body (cdr form))
	 (bind-defs nil) (bind-enquote nil)
	 (bind-inits nil) (bind-lets nil) (bind-forms nil)
	 (header nil) (simple-args nil))
    (while (or (stringp (car body)) (eq (car-safe (car body)) $'interactive))
      (push (pop body) header))
    (setq args (if (listp args) (copy-list args) (list $'#'&rest' args)))
    (let ((p (last args))) (if (cdr p) (setcdr p (list $'#'&rest' (cdr p)))))
    (if (setq bind-defs (cadr (memq $'#'&cl-defs' args)))
	(setq args (delq $'#'&cl-defs' (delq bind-defs args))
	      bind-defs (cadr bind-defs)))
    (if (setq bind-enquote (memq $'#'&cl-quote' args))
	(setq args (delq $'#'&cl-quote' args)))
    (if (memq $'#'&whole' args) (error '&whole not currently implemented'))
    (let* ((p (memq $'#'&environment' args)) (v (cadr p)))
      (if p (setq args (nconc (delq (car p) (delq v args))
			      (list $'#'&aux' (list v $'cl-macro-environment))))))
    (while (and args (symbolp (car args))
		(not (memq (car args) $'(nil #'&rest' #'&body' #'&key' #'&aux')))
		(not (and (eq (car args) $'#'&optional')
			  (or bind-defs (consp (cadr args))))))
      (push (pop args) simple-args))
    (or (eq bind-block $'cl-none)
	(setq body (list (list* $'block bind-block body))))
    (if (null args)
	(list* nil (nreverse simple-args) (nconc (nreverse header) body))
      (if (memq $'#'&optional' simple-args) (push $'#'&optional' args))
      (arglist-do args nil (- (length simple-args)
				 (if (memq $'#'&optional' simple-args) 1 0)))
      (setq bind-lets (nreverse bind-lets))
      (list* (and bind-inits (list* $'eval-when $'(compile load eval)
				    (nreverse bind-inits)))
	     (nconc (nreverse simple-args)
		    (list $'#'&rest' (car (pop bind-lets))))
	     (nconc (nreverse header)
		    (list (nconc (list $'let* bind-lets)
				 (nreverse bind-forms) body)))))))

(defun arglist-do (args expr &optional num)
  (if (nlistp args)
      (if (or (memq args lambda-list-keywords) (not (symbolp args)))
	  (error (concat 'Invalid argument name: ' args))
	(push (list args expr) bind-lets))
    (setq args (copy-list args))
    (let ((p (last args))) (if (cdr p) (setcdr p (list $'#'&rest' (cdr p)))))
    (let ((p (memq $'#'&body' args))) (if p (setcar p $'#'&rest')))
    (if (memq $'#'&environment' args) (error '&environment used incorrectly'))
    (let ((save-args args)
	  (restarg (memq $'#'&rest' args))
	  (safety 3) "(if (cl-compiling-file) cl-optimize-safety 3))"
	  (keys nil)
	  (laterarg nil) (exactarg nil) minarg)
      (or num (setq num 0))
      (if (listp (cadr restarg))
	  (setq restarg (gensym 'rest-'))
	(setq restarg (cadr restarg)))
      (push (list restarg expr) bind-lets)
      (if (eq (car args) $'#'&whole')
	  (push (list (pop2 args) restarg) bind-lets))
      (let ((p args))
	(setq minarg restarg)
	(while (and p (not (memq (car p) lambda-list-keywords)))
	  (or (eq p args) (setq minarg (list $'cdr minarg)))
	  (setq p (cdr p)))
	(if (memq (car p) $'(nil #'&aux'))
	    (setq minarg (list $'= (list $'length restarg)
			       (length (ldiff args p)))
		  exactarg (not (eq args p)))))
      (while (and args (not (memq (car args) lambda-list-keywords)))
	(let ((poparg (list (if (or (cdr args) (not exactarg)) $'pop $'car)
			    restarg)))
	  (arglist-do
	   (pop args)
	   (if (or laterarg (= safety 0)) poparg
	     (list $'if minarg poparg
		   (list $'signal $'(quote wrong-number-of-arguments)
			 (list $'list (and (not (eq bind-block $'cl-none))
					  (list $'quote bind-block))
			       (list $'length restarg)))))))
	(setq num (1+ num) laterarg t))
      (while (and (eq (car args) $'#'&optional') (pop args))
	(while (and args (not (memq (car args) lambda-list-keywords)))
	  (let ((arg (pop args)))
	    (or (consp arg) (setq arg (list arg)))
	    (if (cddr arg) (arglist-do (nth 2 arg) (list $'and restarg t)))
	    (let ((def (if (cdr arg) (nth 1 arg)
			 (or (car bind-defs)
			     (nth 1 (assq (car arg) bind-defs)))))
		  (poparg (list $'pop restarg)))
	      (and def bind-enquote (setq def (list $'quote def)))
	      (arglist-do (car arg)
			     (if def (list $'if restarg poparg def) poparg))
	      (setq num (1+ num))))))
      (if (eq (car args) $'#'&rest')
	  (let ((arg (pop2 args)))
	    (if (consp arg) (arglist-do arg restarg)))
	(or (eq (car args) $'#'&key') (= safety 0) exactarg
	    (push (list $'if restarg
			   (list $'signal $'(quote wrong-number-of-arguments)
				 (list $'list
				       (and (not (eq bind-block $'cl-none))
					    (list $'quote bind-block))
				       (list $'+ num (list $'length restarg)))))
		     bind-forms)))
      (while (and (eq (car args) $'#'&key') (pop args))
	(while (and args (not (memq (car args) lambda-list-keywords)))
	  (let ((arg (pop args)))
	    (or (consp arg) (setq arg (list arg)))
	    (let* ((karg (if (consp (car arg)) (caar arg)
			   (intern (concat ':' (car arg)))))
		   (varg (if (consp (car arg)) (cadar arg) (car arg)))
		   (def (if (cdr arg) (cadr arg)
			  (or (car bind-defs) (cadr (assq varg bind-defs)))))
		   (look (list $'memq (list $'quote karg) restarg)))
	      (and def bind-enquote (setq def (list $'quote def)))
	      (if (cddr arg)
		  (let* ((temp (or (nth 2 arg) (gensym)))
			 (val (list $'car (list $'cdr temp))))
		    (arglist-do temp look)
		    (arglist-do varg
				   (list $'if temp
					 (list $'prog1 val (list $'setq temp t))
					 def)))
		(arglist-do
		 varg
		 (list $'car
		       (list $'cdr
			     (if (null def)
				 look
			       (list $'or look
				     (if (eq (cl-const-expr-p def) t)
					 (list
					  $'quote
					  (list nil (cl-const-expr-val def)))
				       (list $'list nil def))))))))
	      (push karg keys)))))
      (setq keys (nreverse keys))
      (or (and (eq (car args) $'#'&allow-other-keys') (pop args))
	  (null keys) (= safety 0)
	  (let* ((var (gensym 'keys-'))
		 (allow $'(:allow-other-keys))
		 (check (list
			 $'while var
			 (list
			  $'cond
			  (list (list $'memq (list $'car var)
				      (list $'quote (append keys allow)))
				(list $'setq var (list $'cdr (list $'cdr var))))
			  (list (list $'car
				      (list $'cdr
					    (list $'memq (cons $'quote allow)
						  restarg)))
				(list $'setq var nil))
			  (list t
				(list
				 $'error
				  'Bad keyword argument'
					 
				 (list $'car var)))))))
	    (push (list $'let (list (list var restarg)) check) bind-forms)))
      (while (and (eq (car args) $'#'&aux') (pop args))
	(while (and args (not (memq (car args) lambda-list-keywords)))
	  (if (consp (car args))
	      (if (and bind-enquote (cadar args))
		  (arglist-do (caar args)
				 (list $'quote (cadr (pop args))))
		(arglist-do (caar args) (cadr (pop args))))
	    (arglist-do (pop args) nil))))
      (if args (error 'Malformed argument list %s' save-args)))))

(defun cl-arglist-args (args)
  (if (nlistp args) (list args)
    (let ((res nil) (kind nil) arg)
      (while (consp args)
	(setq arg (pop args))
	(if (memq arg lambda-list-keywords) (setq kind arg)
	  (if (eq arg $'#'&cl-defs') (pop args)
	    (and (consp arg) kind (setq arg (car arg)))
	    (and (consp arg) (cdr arg) (eq kind $'#'&key') (setq arg (cadr arg)))
	    (setq res (nconc res (cl-arglist-args arg))))))
      (nconc res (and args (list args))))))

(defmacro deploy-arguments-list (lambda-type &rest args-n-body)
	(let ((new-form (cl-transform-lambda args-n-body $'cl-none)))
		(setcar new-form lambda-type)
		(list $'quote new-form)))
	)! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 6/15/2006 15:36'!
argumentsLists

	^ #()  "no arguments-lists library"! !

!Array methodsFor: '*LispKit' stamp: 'spfa 5/31/2006 11:00'!
arrayForm

	^ self! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 5/30/2006 17:05'!
arrayForm

	^ Array streamContents: [:stream | self inArray: stream]

! !

!UndefinedObject methodsFor: '*LispKit' stamp: 'spfa 5/30/2006 17:09'!
arrayForm

	^ #()! !

!Array methodsFor: '*LispKit' stamp: 'spfa 11/20/2006 10:31'!
asCons

	| cons |

	self reverseDo: [:elt | 
		cons _ ConsCell car: elt asCons cdr: cons].
	^ cons

! !

!Object methodsFor: '*LispKit' stamp: 'spfa 9/30/2006 15:06'!
asCons

	^ self! !

!Array methodsFor: '*LispKit' stamp: 'spfa 11/20/2006 13:18'!
asConsList

	| cons |

	self size = 0 ifTrue: [^ nil].

	self size to: 1 by: -1 do: [:index | 
			cons _ ConsCell car: (self at: index) cdr: cons].

	^ cons! !

!LKValues methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 10:28'!
asOneLispValue

	^ self at: 1 ifAbsent: [nil]! !

!Object methodsFor: '*LispKit' stamp: 'spfa 10/24/2006 10:30'!
asOneLispValue

	^ self! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 9/24/2006 15:40'!
assoc: aConsCell

"(assoc KEY LIST)
Return non-nil if KEY is `equal' to the car of an element of LIST.
The value is actually the element of LIST whose car is KEY.
Elements of LIST that are not conses are ignored."

	| key |

	key _ aConsCell car.
	(aConsCell cadr ifNil: [^ self falseValue]) do: [:elt |
		(elt isConsCell and: [elt car = key]) ifTrue: [^ elt]].

	^ self falseValue

	! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 9/25/2006 14:42'!
assq: aConsCell

"(assq KEY LIST)
Return non-nil if KEY is `eq' to the car of an element of LIST.
The value is actually the element of LIST whose car is KEY.
Elements of LIST that are not conses are ignored."

	| key |

	key _ aConsCell car.
	(aConsCell cadr ifNil: [^ self falseValue]) do: [:elt |
		(elt isConsCell and: [elt car == key]) ifTrue: [^ elt]].

	^ self falseValue

	! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 9/25/2006 14:35'!
assv: aConsCell

"(assv KEY LIST)
Return non-nil if KEY is `eqv' to the car of an element of LIST.
The value is actually the element of LIST whose car is KEY.
Elements of LIST that are not conses are ignored."

	| key |

	key _ aConsCell car.
	(key isConsCell
		or: [key isString]
		or: [key isArray])
	ifTrue: [^ self assq: aConsCell].

	^ self assoc: aConsCell
! !

!LKIOPort methodsFor: 'proxy' stamp: 'spfa 10/20/2006 13:19'!
atEnd

	^ self stream atEnd! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/22/2006 22:42'!
atom: aConsCell

"(atom OBJECT)
Return t if OBJECT is not a cons cell.  This includes nil."

	^ self class test: aConsCell car isConsCell not
! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 11/21/2006 19:06'!
autoCompile

	"on-the-fly compilation --experimental--"

	^ 
	#(in-library auto-compile

(defmacro defun (name args &rest body)
	`(progn
		(defun: ,name ,args ,@body)
		(compile $',name)))

"
(defmacro defmacro (name args &rest body)
	`(progn
		(defmacro: ,name ,args ,@body)
		(compile $',name)))
"
)! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 11/26/2006 22:50'!
autoCompile

	"on-the-fly compilation --experimental--"

	^ 
	#(in-library auto-compile

(defmacro defun (name args &rest body)
	`(progn
		(defun: ,name ,args ,@body)
		(compile ,name)))

(defmacro define (name &rest spec)
	(if (and (symbol? name)
			(pair? (car spec))
			(eq? $'lambda (caar spec)))
		`(progn
			(define: ,name ,@spec)
			(compile ,name))
		(if (pair? name)
			`(progn
				(define: ,name ,@spec)
				(compile ,(car name)))
			`(define: ,name ,@spec))))
)! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/6/2006 13:41'!
backquote: aStream

	^ #quasiquote inCons addLast: (self read: aStream)! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2006 00:19'!
base: aNumber

	base _ aNumber! !

!ELisp class methodsFor: 'benchmarks' stamp: 'spfa 3/26/2007 09:43'!
bench

	"ELisp bench"

	| lisp report allCode progress steps |

	lisp _ self new loadDefaultLibraries.

	self setUpCode do: [:ea | lisp evalString: ea].
	allCode _ self testCode.

	progress _ ProgressMorph label: 'Running ', self asString, ' benchmarks...'.
	progress center: World center.
	progress color: Color lightSteelBlue.
	progress openInWorld.
	progress incrDone: 0.

	steps _ (allCode size * 3) + 1.

	report _ String streamContents: [:str |

		str nextPutAll: 'initialisation => ';
	 		nextPutAll: [self new loadDefaultLibraries] gcbench; cr; cr.
		progress incrDone: 1/steps.

		allCode do: [:code | | form val |
				str nextPutAll: code; nextPutAll: ' => ';
	 				nextPutAll: [val _ lisp evalString: code] gcbench; cr.
				progress incrDone: 1/steps.
				str nextPutAll: '  ..reading ';
	 				nextPutAll: [form _ lisp reader readString: code] gcbench;
				 	cr.		
				progress incrDone: 1/steps.
				str nextPutAll: '  ..evaluating ';
	 				nextPutAll: [lisp evaluate: form] gcbench; cr;	
					nextPutAll: (val printStringForLisp: lisp); cr; cr.	
				progress incrDone: 1/steps.
			].

	].

	progress delete.
	report openInWorkspaceWithTitle: self asString, ' benchmarks'! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:02'!
bench: aConsCell

"(bench FORM)
Evaluate FORM repeatedly for 5 seconds, return the average number of times it was run per second"

	^ [self evalObject: aConsCell car] bench asNumber! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 11/27/2006 13:21'!
bindAll: aConsCell fromSpec: bConsCell macrop: macrop

	"minimal arguments list parsing for lambda forms:
	handles &rest and &optional (no other keyword implemented).
	&body and . are synonyms of &rest"

	| symbs vals optf bindings n |

	symbs _ bConsCell.
	vals _ aConsCell.

	symbs isSymbol ifTrue: 
		[^ {symbs -> (macrop ifTrue: [vals] ifFalse: [self evalList: vals])}].
	symbs ifNil: [^ #()].
	vals ifNil: [^ {symbs cadr -> nil}].

	optf _ false.
	bindings _ Array new: symbs safeLength.
	n _ 0.

	[symbs isNil and: [vals isNil]] whileFalse: 
	[
		| val sym |
		sym _ symbs car ifNil: [self lispError: 'too many arguments'].
		symbs _ symbs cdr.
		n _ n + 1.

		(sym == #'&optional') 
			ifTrue: [optf _ true . sym _ symbs car. symbs _ symbs cdr].

		(sym == #'&rest' or: [sym == #'&body'])
			ifTrue: [	
				val _ macrop ifTrue: [vals] ifFalse: [self evalList: vals].
				bindings at: n put: (symbs car -> val).
				^ bindings cutAt: n].

		vals ifNil: [optf ifFalse: [self lispError: 'not enough arguments']].
		val _ vals car. 
		macrop ifFalse: [val _ self evalObject: val].
		vals _ vals cdr.
		bindings at: n put: (sym -> val).

		symbs isSymbol ifTrue: [
			val _ macrop ifTrue: [vals] ifFalse: [self evalList: vals].
			bindings at: n+1 put: (symbs -> val).
			^ bindings cutAt: n+1]
	].

	^ bindings cutAt: n! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 10/11/2006 22:06'!
bindingOf: aString

	^ self symbolValues associationAt: aString asSymbol
		ifAbsent: [(upperLisp ifNil: [^ nil]) bindingOf: aString]! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 6/22/2006 22:49'!
block

	^ 
	#(in-library block


(defmacro block (name &rest body)
  'Define a lexically-scoped block named NAME.
NAME may be any symbol.  Code inside the BODY forms can call return-from
to jump prematurely out of the block.  This differs from catch and throw
in two respects:  First, the NAME is an unevaluated symbol rather than a
quoted symbol or other form; and second, NAME is lexically rather than
dynamically scoped:  Only references to it within BODY will work.  These
references may appear inside macro expansions, but not inside functions
called from BODY.'
  "(if (cl-safe-expr-p (cons $'progn body))" (cons $'progn body)
    (list $'identity
	  (list* $'catch (list $'quote (block-tag name))
		 body)))")"

(defmacro return (&optional result)
  'Return from the block named nil.
This is equivalent to (return-from nil RESULT).'
  (list $'return-from nil result))

(defmacro return-from (name &optional result)
  'Return from the block named NAME.
This jump out to the innermost enclosing (block NAME ...) form,
returning RESULT from that form (or nil if RESULT is omitted).
This is compatible with Common Lisp, but note that defun and
defmacro do not create implicit blocks as they do in Common Lisp.'
  (let ((name2 (block-tag name)))
    (list $'throw (list $'quote name2) result)))

(defun block-tag (name)
  (intern (concat 'b-block-' name '-b')))


	)! !

!LKBlock methodsFor: 'as yet unclassified' stamp: 'spfa 11/19/2006 20:21'!
block

	^ block! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 6/15/2006 15:36'!
block

	^ #()  "no block library"! !

!LKBlock methodsFor: 'as yet unclassified' stamp: 'spfa 11/19/2006 20:21'!
block: aBlockContext

	block _ aBlockContext! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/16/2006 18:45'!
booleanP: aConsCell

"(boolean? OBJECT)
Return t if OBJECT is either #t or #f."

	^ self class test: (aConsCell car == self trueValue or: [aConsCell car == self falseValue])! !

!LispKernel methodsFor: 'LISP-functions-predicates' stamp: 'spfa 9/30/2006 15:37'!
boundp: aConsCell

"(boundp SYMBOL)
Return t if SYMBOL's value is not void."	

	self symbolValue: aConsCell car ifNone: [^ self falseValue].
	^ self trueValue
! !

!CLisp methodsFor: 'GUI' stamp: 'spfa 10/13/2006 09:30'!
buildMenu: aMenu

	aMenu defaultTarget: self.
	
	aMenu 
		add: 'dynamic symbol values' target: self dynamicSymbolValues selector: #explore ;
		add: 'symbol values'	target: self symbolValues selector: #explore ;
		add: 'symbol functions' target: self symbolFunctions selector: #explore;
		add: 'symbol plists' target: self symbolPlists selector: #explore;
		addLine;
		add: 'this lisp' target: self selector: #explore;
		addLine;
		add: 'spawn gui' target: self selector: #openGui.

	upperLisp ifNotNil: 
		[aMenu add: 'go up' target: upperLisp selector: #openGui].

	^ aMenu
	
! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 6/18/2006 20:29'!
buildMenu: aMenu

	aMenu defaultTarget: self.
	
	aMenu 
		add: 'symbol values'	target: self symbolValues selector: #explore ;
		add: 'symbol functions' target: self symbolFunctions selector: #explore;
		add: 'symbol plists' target: self symbolPlists selector: #explore;
		addLine;
		add: 'this lisp' target: self selector: #explore;
		addLine;
		add: 'spawn gui' target: self selector: #openGui.

	upperLisp ifNotNil: 
		[aMenu add: 'go up' target: upperLisp selector: #openGui].

	^ aMenu
	
! !

!LKPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 20:23'!
buildMenu: aMenu

	model buildMenu: aMenu.
	^ aMenu! !

!LKREPLMorph methodsFor: 'command processing' stamp: 'spfa 6/19/2006 22:25'!
buildMenu: aMenu

	self commandsHistory do: [:command |
		| str |
		str _ command asString withBlanksTrimmed.
		aMenu add: (str truncateWithElipsisTo: 70)
				selector: #insertCommand: argument: str].

	commandsHistory isEmpty ifTrue:
		[aMenu add: 'no history yet' action: #yourself].

	lastAnswer ifNotNil: [
		| str |
		str _ lastAnswer asString withBlanksTrimmed.
		aMenu addLine.
		aMenu add: (str truncateWithElipsisTo: 70)
				selector: #insertCommand: argument: str;
				addLine; 
				add: 'explore last value' target: lastValue selector: #explore].

	debugContinuation ifNotNil: [
		aMenu addLine.
		aMenu add: 'DEBUG ', lastError target: debugContinuation selector: #value].

	^ aMenu! !

!ULisp methodsFor: 'GUI' stamp: 'spfa 6/18/2006 21:37'!
buildMenu: aMenu

	aMenu defaultTarget: self.
	
	aMenu 
		add: 'symbol bindings' target: self symbolValues selector: #explore ;
		add: 'symbol plists' target: self symbolPlists selector: #explore;
		addLine;
		add: 'this lisp' target: self selector: #explore;
		addLine;
		add: 'spawn gui' target: self selector: #openGui.

	upperLisp ifNotNil: 
		[aMenu add: 'go up' target: upperLisp selector: #openGui].

	^ aMenu
	
! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/8/2006 21:20'!
caar

	^ car car! !

!ConsCell class methodsFor: 'instance creation' stamp: 'spfa 6/3/2006 01:28'!
caar: anObject

	^ self car: (self car: anObject) ! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:06'!
caar: aConsCell

"(caar LIST)
Return the car of the car of LIST"

	^ aConsCell car car car

	! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/9/2006 10:22'!
cadr

	^ cdr car! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:06'!
cadr: aConsCell

"(cadr LIST)
Return the car of the cdr of LIST"

	^ aConsCell car cdr car

	! !

!ULisp methodsFor: 'LISP-functions-continuations' stamp: 'spfa 3/27/2007 13:38'!
callWithCurrentContinuation: aConsCell

	| escapeFunction val |

	val _ LKContinuation 
		upTo: (self class lookupSelector: #enterInterpreterContextAndEval:).
	(val isLKContinuation) ifFalse: [^ val topForms as: LKValues].

	escapeFunction _ self evalObject: {#lambda . #args . {#restoreContinuationWithValue: . {#cons . val . #args}}} asCons.  

	^ self evalTailObject: ((ConsCell car: aConsCell car) addLast: escapeFunction) 
	

! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 11/7/2006 14:28'!
callWithInputFile: aConsCell

"(call-with-input-file FILENAME PROC)
"

	| result file |

	file _ StandardFileStream readOnlyFileNamed: aConsCell car.
	file ifNil: [self lispError: 'Could not read file "', aConsCell car asString, '"'].
	result _ self apply: ((ConsCell car: aConsCell cadr) 
							addLast: (LKIOPort input: file) inCons).
	file close.

	^ result! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 10/24/2006 14:16'!
callWithValues: aConsCell

	^ self apply: 
		(aConsCell cdr copy addLast:
				(self evalToValues: aConsCell car inCons) asCons)! !

!String methodsFor: '*LispKit' stamp: 'spfa 6/9/2006 13:58'!
capAtLinks
	| stream here |
	stream _ WriteStream on: (self species new: self size * 2).
	here _ false.
	self do: [ :c |
		c == $-
			ifTrue: [ here _ true ]
			ifFalse: [ stream nextPut: (here ifFalse: [c] ifTrue: [c asUppercase]).
					  here _ false].
	].
	^stream contents! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:27'!
car

	^ car! !

!UndefinedObject methodsFor: '*LispKit' stamp: 'spfa 6/9/2006 10:21'!
car

	^ nil! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:06'!
carSafe: aConsCell

"(car-safe OBJECT)
Return the car of OBJECT if it is a cons cell, or else nil."

	^ aConsCell car isConsCell ifFalse: [nil] ifTrue: [aConsCell caar]

	! !

!ConsCell class methodsFor: 'instance creation' stamp: 'spfa 6/3/2006 01:32'!
car: anObject

	^ self new car: anObject ! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:27'!
car: anObject

	car _ anObject! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 7/8/2006 16:02'!
car: aConsCell

"(car LIST)
Return the car (also called the head) of LIST.  If LIST is nil, return nil."

	(aConsCell car isNil
		or:[aConsCell car isConsCell]) 
		ifFalse: [self lispError: 'not a cons'].

	^ aConsCell car car 

	! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/8/2006 16:03'!
car: aConsCell

"(car LIST)
Return the car (also called the head) of LIST.  If LIST is nil, signal an error"

	aConsCell car ifNil: [self lispError: 'pair expected, got the empty list'].

	^ super car: aConsCell 
! !

!ConsCell class methodsFor: 'instance creation' stamp: 'spfa 6/3/2006 01:31'!
car: anObject cdr: bObject

	^ (self new) car: anObject; cdr: bObject! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 20:31'!
case: aConsCell

"(case KEY &rest CLAUSES)"

	| key |

	key _ self evalObject: aConsCell car.

	aConsCell cdr do: [:clause | | block |
		block _ [:forms | 
				(forms ifNil: [^ nil]) 
					doWithCdr: [:c :cdr | 
						cdr ifNil: [^ self evalTailObject: c].
						self evalObject: c]].
		clause car = #else ifTrue: [^ block value: clause cdr].
		clause car do: [:datum | 
			datum = key ifTrue: [^ block value: clause cdr]]].
	
	^ nil

! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 21:04'!
catch: aConsCell

"(catch TAG &rest BODY)
Eval BODY allowing nonlocal exits using `throw'.
TAG is evalled to get the tag to use; it must not be nil.
Then the BODY is executed.
Within BODY, (throw TAG) with same TAG exits BODY and exits this `catch'.
If no throw happens, `catch' returns the value of the last BODY form.
If a throw happens, it specifies the value to return from `catch'."

	| val |

	aConsCell ifNil: [^ nil].

	[val _ self progn: aConsCell cdr.
	val isTailCall ifTrue: [val _ val evaluate]]
		on: LKThrowNotification
		do: [:spec |
				(spec tag = (self evalObject: aConsCell car))
					ifTrue: [val _ spec value]
					ifFalse: [spec signal]].

	^ val

	! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/8/2006 21:50'!
cdar

	^ car cdr! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:06'!
cdar: aConsCell

"(cdar LIST)
Return the cdr of the car of LIST"

	^ aConsCell car cdar

	! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/9/2006 10:22'!
cddr

	^ cdr cdr! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:06'!
cddr: aConsCell

"(cddr LIST)
Return the cdr of the cdr of LIST"

	^ aConsCell car cdr cdr

	! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:27'!
cdr

	^ cdr! !

!UndefinedObject methodsFor: '*LispKit' stamp: 'spfa 6/9/2006 10:21'!
cdr

	^ nil! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:27'!
cdr: anObject

	cdr _ anObject! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 6/9/2006 10:21'!
cdr: aConsCell

"(cdr LIST)
Return the cdr (also called the tail) of LIST.  If LIST is nil, return nil."

	^ aConsCell car cdr 

	! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/8/2006 16:03'!
cdr: aConsCell

"(cdr LIST)
Return the cdr (also called the tail) of LIST.  If LIST is nil, signal an error"

	aConsCell car ifNil: [self lispError: 'pair expected, got the empty list'].

	^ super cdr: aConsCell 
! !

!ELisp methodsFor: 'LISP-functions-math' stamp: 'spfa 10/25/2006 14:21'!
ceiling: aConsCell

	| x n |

	x _ aConsCell car.	
	n _ x ceiling.
	^ LKValues with: n with: x-n! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 6/21/2006 10:46'!
cells

	^ Array streamContents: [:str | 
		self cellsDo: [:cell | str nextPut: cell]]! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 6/7/2006 10:07'!
cellsDo: aBlock

	aBlock value: self.
	cdr isConsCell ifTrue: [cdr cellsDo: aBlock]

! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 7/18/2006 21:32'!
charAlphabeticP: aConsCell

"(char-alphabetic? CHARACTER)
Return #t if CHARACTER is a letter"

	aConsCell car isCharacter ifFalse: [self lispError: 'character expected'].
	^ self class test: aConsCell car isLetter! !

!LKREPLMorph methodsFor: 'contents' stamp: 'spfa 9/28/2006 23:27'!
characterLimit

	"we should be able to set this interactively"

	^ 30000! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 21:44'!
characterNames 

	^ CharacterNames ! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/4/2006 23:30'!
charDowncase: aConsCell 

	^ aConsCell car asLowercase! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 7/18/2006 21:34'!
charLowerCaseP: aConsCell

"(char-lower-case? CHARACTER)
Return #t if CHARACTER is a lower case letter"

	aConsCell car isCharacter ifFalse: [self lispError: 'character expected'].
	^ self class test: aConsCell car isLowercase! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 7/18/2006 21:31'!
charNumericP: aConsCell

"(char-numeric? CHARACTER)
Return #t if CHARACTER is a digit"

	aConsCell car isCharacter ifFalse: [self lispError: 'character expected'].
	^ self class test: aConsCell car isDigit ! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/22/2006 00:33'!
charP: aConsCell

"(char? OBJECT)
Return #t if OBJECT is a character."

	^ self class test: aConsCell car isCharacter! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/4/2006 23:15'!
charTOinteger: aConsCell 

	^ aConsCell car asciiValue! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/4/2006 23:30'!
charUpcase: aConsCell 

	^ aConsCell car asUppercase! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 7/18/2006 21:34'!
charUpperCaseP: aConsCell

"(char-upper-case? CHARACTER)
Return #t if CHARACTER is an upper case letter"

	aConsCell car isCharacter ifFalse: [self lispError: 'character expected'].
	^ self class test: aConsCell car isUppercase! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 7/18/2006 21:29'!
charWhitespaceP: aConsCell

"(char-whitespace? CHARACTER)
Return #t if CHARACTER is either space, tab, line feed, form feed, or carriage return"

	aConsCell car isCharacter ifFalse: [self lispError: 'character expected'].
	^ self class test: aConsCell car isSeparator ! !

!CLisp methodsFor: 'private - declarations' stamp: 'spfa 10/21/2006 14:49'!
checkDeclarations: bForm

	bForm ifNil: [^ self].

	bForm do: [:sform |
		(sform isString or: [sform isConsCell and: [sform car == #declare]])
			ifFalse: [^ self].
		sform isString ifFalse: [sform cdr do: [:spec | self declaration: spec]]].		
! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 10/21/2006 00:11'!
checkSymbol: aSymbol

	"aSymbol bindings are about to be changed.
	if there is anything to check up, do it here and return the actual symbol to be used" 

	aSymbol isSymbol 
		ifFalse: [self lispError: 'symbol expected, got ', aSymbol asString].

	(constantVariables includes: aSymbol)
		ifTrue: [self lispError: aSymbol, ' is a constant, can''t be bound'].

	^ aSymbol! !

!LKIOPort methodsFor: '-- hacks --' stamp: 'spfa 10/20/2006 14:06'!
clear
	"Clear all characters and redisplay the view"
	self changed: #clearText.
	self stream reset! !

!LKREPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 9/28/2006 23:46'!
clear

	self updateText: self prompt.
	self refreshDisplay.! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 10/10/2006 10:23'!
clear: ignored

"(clear)
clear the standard output, if supported"

	self standardOutput clear.
	^ self trueValue
! !

!LKIOPort methodsFor: 'proxy' stamp: 'spfa 10/20/2006 13:56'!
close

	self stream close
! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/6/2006 00:40'!
closeListMarker

	^ #'------(end------'! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/6/2006 00:40'!
closeList: aStream

	^ self closeListMarker! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 6/20/2006 23:38'!
closeOutputPort: aConsCell

"(close-output-port OUTPUT-PORT)
Closes an output port"
	
	aConsCell car close.
	^ self trueValue! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 6/7/2006 10:25'!
collect: aBlock

	^ ConsCell car: (aBlock value: car)
		cdr: (cdr isConsCell ifTrue: [cdr collect: aBlock] ifFalse: [cdr])! !

!LKREPLMorph class methodsFor: 'colors' stamp: 'spfa 6/8/2006 14:12'!
commandAttribute

	^ TextColor color: Color blue muchDarker! !

!LKREPLMorph methodsFor: 'command processing' stamp: 'spfa 6/7/2006 23:44'!
commandsHistory

	^ commandsHistory ifNil: [commandsHistory _ OrderedCollection new]
! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/6/2006 00:46'!
comment: aStream

	| char |

	[char == Character lf  
		or: [char == Character cr] 
		or: [aStream atEnd]]
	whileFalse:
		[char _ aStream next].

	^ nil! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 3/14/2007 22:47'!
common

	^
#(in-library common

(let ((i 0))
	(dolist (rank 
				$'(first second third fourth fifth sixth seventh eighth ninth tenth))
		(eval `(defun ,rank (list) 
					(nth ,i list)))
		(setq i (+ 1 i))))

(defun = (&rest args) (apply $'n-equal args))

(defun #'1+' (number) (+ 1 number))
(defun #'1-' (number) (- number 1))

(defun rplaca (&rest args) (apply $'setcar args))
(defun rplacd (&rest args) (apply $'setcdr args))

(defun nlistp (arg) (not (listp arg))) 

(defun butlast (x &optional n)
  'Returns a copy of LIST with the last N elements removed.'
  (if (and (not (null n)) (<= n 0)) x
    (nbutlast (copy-seq x) n)))

(defun nbutlast (x &optional n)
  'Modifies LIST to remove the last N elements.'
  (let ((m (length x)))
    (or (not (null n)) (setq n 1))
    (and (< n m)
	 (progn
	   (if (> n 0) (setcdr (nthcdr (- (#'1-' m) n) x) nil))
	   x))))

(defmacro push (newelt listname)
  'Add NEWELT to the list stored in the symbol LISTNAME.
This is equivalent to (setq LISTNAME (cons NEWELT LISTNAME)).
LISTNAME must be a symbol.'
  (list $'setq listname
	(list $'cons newelt listname)))

(defmacro pop (listname)
  'Return the first element of LISTNAME''s value, and remove it from the list.
LISTNAME must be a symbol whose value is a list.
If the value is nil, pop returns nil but does not actually
change the list.'
  (list $'prog1 (list $'car listname)
	(list $'setq listname (list $'cdr listname))))

(defmacro pop2 (place)
  (list $'prog1 (list $'car (list $'cdr place))
	(list $'setq place (list $'cdr (list $'cdr place)))))

(defmacro when (cond &rest body)
  'If COND yields non-nil, do BODY, else return nil.'
  (list $'if cond (cons $'progn body)))

(defmacro unless (cond &rest body)
  'If COND yields nil, do BODY, else return nil.'
  (cons $'if (cons cond (cons nil body))))


(defun list* (arg &rest rest) 
 'Return a new list with specified args as elements, cons''d to last arg.
Thus, (list* A B C D) is equivalent to (nconc (list A B C) D) or to
(cons A (cons B (cons C D))).'
 	(cond ((null rest) arg)
			((null (cdr rest)) (cons arg (car rest)))
			((yes*) (let* ((n (length rest))
	  				(copy (copy-seq rest))
	  				(last (nthcdr (- n 2) copy)))
	    			(setcdr last (car (cdr last)))
	    			(cons arg copy)))))

(defun remove (elt seq)
 'Return a copy of SEQ with all occurences of ELT removed.
SEQ must be a list, vector, or string.  The comparison is done with ''equal''.'  
(if (listp seq)
		(delete elt (copy-seq seq))
      (delete elt seq)))

(defun remq (elt list)
'Return a copy of LIST with all occurences of ELT removed.
The comparison is done with ''eq''.'
  (if (memq elt list)
      (delq elt (copy-seq list))
    list))


(defun subseq (seq start &optional end)
'Return the subsequence of SEQ from START to END.
If END is omitted, it defaults to the length of the sequence.
If START or END is negative, it counts from the end.'
  (if (stringp seq) (substring seq start end)
    (let (len)
      (and end (< end 0) (setq end (+ end (setq len (length seq)))))
      (if (< start 0) (setq start (+ start (or len (setq len (length seq))))))
      (cond ((listp seq)
	     (if (> start 0) (setq seq (nthcdr start seq)))
	     (if end
		 (let ((res ()))
		   (while (>= (setq end (#'1-' end)) start)
		     (push (pop seq) res))
		   (nreverse res))
	       (copy-seq seq)))
	    (t
	     (or end (setq end (or len (length seq))))
	     (let ((res (make-vector (max (- end start) 0) ()))
		   (i 0))
	       (while (< start end)
		 (aset res i (aref seq start))
		 (setq i (1+ i) start (1+ start)))
	       res))))))

(defselectors caaar (car car car) 'Return the car of the car of the car of X')
(defselectors caadr (cdr car car) 'Return the car of the car of the cdr of X')
(defselectors cadar (car cdr car) 'Return the car of the cdr of the car of X')
(defselectors caddr (cdr cdr car) 'Return the car of the cdr of the cdr of X')
(defselectors cdaar (car car cdr) 'Return the cdr of the car of the car of X')
(defselectors cdadr (cdr car cdr) 'Return the cdr of the car of the cdr of X')
(defselectors cddar (car cdr cdr) 'Return the cdr of the cdr of the car of X')
(defselectors cdddr (cdr cdr cdr) 'Return the cdr of the cdr of the cdr of X')

(defselectors caaaar (car car car car) 
	'Return the car of the car of the car of the car of X')
(defselectors caaadr (cdr car car car) 
	'Return the car of the car of the car of the cdr of X')
(defselectors caadar (car cdr car car) 
	'Return the car of the car of the cdr of the car of X')
(defselectors caaddr (cdr cdr car car) 
	'Return the car of the car of the cdr of the cdr of X')
(defselectors cadaar (car car cdr car) 
	'Return the car of the cdr of the car of the car of X')
(defselectors cadadr (cdr car cdr car) 
	'Return the car of the cdr of the car of the cdr of X')
(defselectors caddar (car cdr cdr car) 
	'Return the car of the cdr of the cdr of the car of X')
(defselectors cadddr (cdr cdr cdr car) 
	'Return the car of the cdr of the cdr of the cdr of X')
(defselectors cdaaar (car car car cdr) 
	'Return the cdr of the car of the car of the car of X')
(defselectors cdaadr (cdr car car cdr) 
	'Return the cdr of the car of the car of the cdr of X')
(defselectors cdadar (car cdr car cdr) 
	'Return the cdr of the car of the cdr of the car of X')
(defselectors cdaddr (cdr cdr car cdr) 
	'Return the cdr of the car of the cdr of the cdr of X')
(defselectors cddaar (car car cdr cdr) 
	'Return the cdr of the cdr of the car of the car of X')
(defselectors cddadr (cdr car cdr cdr) 
	'Return the cdr of the cdr of the car of the cdr of X')
(defselectors cdddar (car cdr cdr cdr) 
	'Return the cdr of the cdr of the cdr of the car of X')
(defselectors cddddr (cdr cdr cdr cdr) 
	'Return the cdr of the cdr of the cdr of the cdr of X')

"mapping Smalltalk selectors into functions:"

(defunary sqrt sqrt 'Return the square root of the argument')
(defunary atan arcTan)
(defunary sin sin)
(defunary tan tan)
(defunary cos cos)
(defunary exp exp 'Return the exponential of X as a floating point number')
(defunary log ln 'Return the natural logarithm of X')
(defunary abs abs 'Return the absolute value of X')

(defbinary expt raisedTo: 'Return X raised to Y')
(defbinary #'string=' =)

"extra"

(defunary procedure-source lispCode 
	'Return the source code for the argument (a procedure)
This can be a ConsCell, if the argument is a lambda form,
 or a String of Smalltalk code if it is a primitive')

(defun display-source (symbol) 
	'Display the source code for the procedure bound to SYMBOL
This can be either Lisp or Smalltalk code'
	(princ (procedure-source (symbol-function symbol))))

(defun disassemble (symbol)
	(procedure-source (symbol-function symbol)))
)! !

!LispKernel methodsFor: 'private - compiler' stamp: 'spfa 11/27/2006 14:40'!
compileBinaryMessage: selector sendTo: arg1 arg: arg2

	| block sa1 sa2 |

	sa1 _ arg1 isCompiled ifTrue: ['(a1 withLisp: lisp)'] ifFalse: ['a1'].
	sa2 _ arg2 isCompiled ifTrue: ['(a2 withLisp: lisp)'] ifFalse: ['a2'].

	block _ (Compiler evaluate: '[:a1 :a2 | [:lisp :mflag | ', sa1 ,' ', selector, ' ', sa2, ']]') value: arg1 value: arg2.

	^ LKBlock new
		block: block fixTemps;
		description: (arg1 printStringForLisp: self), ' ', selector, ' ', (arg2 printStringForLisp: self)! !

!LispKernel methodsFor: 'private - compiler' stamp: 'spfa 11/27/2006 14:40'!
compileBooleanBinaryMessage: selector sendTo: arg1 arg: arg2

	| block sa1 sa2 |

	"no need for a specific construct when the boolean values are the regular true and false"
	(self trueValue == true and: [self falseValue == false])
	ifTrue: [^ self compileBinaryMessage: selector sendTo: arg1 arg: arg2].


	sa1 _ arg1 isCompiled ifTrue: ['(a1 withLisp: lisp)'] ifFalse: ['a1'].
	sa2 _ arg2 isCompiled ifTrue: ['(a2 withLisp: lisp)'] ifFalse: ['a2'].

	block _ (Compiler evaluate: '[:a1 :a2 :t :f | [:lisp :mflag | (', sa1 ,' ', selector, ' ', sa2, ') ifTrue: [t] ifFalse: [f]]]') value: arg1 value: arg2 value: self trueValue value: self falseValue.

	^ LKBlock new
		block: block fixTemps;
		description: (arg1 printStringForLisp: self), ' ', selector, ' ', (arg2 printStringForLisp: self), ' ?'! !

!LispKernel methodsFor: 'private - compiler' stamp: 'spfa 11/27/2006 15:14'!
compileCallPrimitive: primitive withArgs: args

	| block label special |

	special  _ self class specialForms includes: primitive.
	label _ special ifTrue: ['SPECIAL'] ifFalse: ['PRIM'].

	block _ (Compiler evaluate: 
		(special 
			ifTrue: ['[:a | [:lisp :mflag | lisp ', primitive,' a]]'] 
			ifFalse: 
			[
				args ifNil: ['[:a | [:lisp :mflag | lisp ', primitive,' nil]]']
				ifNotNil: ['[:a | [:lisp :mflag | lisp ', primitive,' (a collect: [:ea | ea withLisp: lisp])]]']
			])) value: args.

	^ LKBlock new 
		block: block fixTemps;
		description: label, ' #', primitive, ' ', (args printStringForLisp: self)! !

!LispKernel methodsFor: 'private - compiler' stamp: 'spfa 11/27/2006 14:41'!
compileCallTo: func withArgs: args

	^ LKBlock new 
		block:
		 [:lisp :mflag | | procedure |
			procedure _ lisp symbolFunction: func 
				ifNone: [lisp lispError: 'undefined function ', func].
			procedure lambdaForm car == #macro
				ifTrue: [lisp lispError: 'bad position for a macro'].
			lisp evalProcedure: procedure withArgs: args id: func
			]fixTemps;
		description: 'CALL ', func, ' ', (args printStringForLisp: self)! !

!LispKernel methodsFor: 'private - compiler' stamp: 'spfa 11/29/2006 15:20'!
compileLet: bodyforms environment: anEnvironment bindings: bindings

	| d |

	d _ String streamContents: [:str |
		str nextPutAll: 'LET ('.
		bindings do: [:assoc | 
			str nextPutAll: assoc key;
			nextPutAll: ' -> ';
			nextPutAll: (assoc value printStringForLisp: self)].
		str nextPut: $).
		bodyforms do: [:form |
			str nextPutAll: ' ', (form printStringForLisp: self)]].

	anEnvironment ifNil:
	[

	^ LKBlock new 
		block: [:lisp :mflag | | sublisp val |
			sublisp _ lisp subLisp: nil form: nil body: nil. "we'll see later on..."	 
			bindings do: [:b | 
				sublisp symbolValuesAdd: (b key -> (b value withLisp: lisp))].
			bodyforms doWithCdr: [:c :cdr |
				cdr ifNil: [val _ c withLisp: sublisp multipleValue: mflag tail: true]
				ifNotNil: [c withLisp: sublisp]]. 
			val
		] fixTemps;
		description: d

	].

	^ LKBlock new 
		block:  [:lisp :mflag | | sublisp val |
			sublisp _ lisp subLisp: nil form: nil body: nil environment: anEnvironment newChild.
			bindings do: [:b | 
				sublisp symbolValuesAdd: (b key -> (b value withLisp: lisp))].
			bodyforms doWithCdr: [:c :cdr |
				cdr ifNil: [val _ c withLisp: sublisp multipleValue: mflag tail: true]
				ifNotNil: [c withLisp: sublisp]]. 
			val
		] fixTemps;
		description: d! !

!LispKernel methodsFor: 'LISP-functions-compiler' stamp: 'spfa 11/27/2006 14:39'!
compileMessageSend: aConsCell

	"(selector receiver [arguments])"

	| sel rec args |

	sel _ aConsCell car first.
	rec _ aConsCell car second.
	args _ aConsCell car cddr topForms.

	sel isQuotedSymbol ifTrue: [sel _ sel cadr].

	args ifEmpty: 
	[
		sel isSymbol ifTrue:
			[^ self compileUnaryMessage: sel sendTo: rec].

		^ LKBlock new 
			block: [:lisp :mflag| 
						(rec withLisp: lisp) perform: (sel withLisp: lisp)] fixTemps;
 			description: (rec printStringForLisp: self), ' perform: ', (sel printStringForLisp: self)
	].

	(args size = 1) ifTrue: 
	[
		| arg |

		arg _ args first.

		sel isSymbol ifTrue:
			[^ self compileBinaryMessage: sel sendTo: rec arg: arg].

		^ LKBlock new 
			block: [:lisp :mflag |
						 (rec withLisp: lisp) perform: (sel withLisp: lisp) with: (arg withLisp: lisp)] fixTemps;
			description: (rec printStringForLisp: self), ' perform: ', (sel printStringForLisp: self), ' with: ', (arg printStringForLisp: self)
	].

	^ LKBlock new 
			block: [:lisp :mflag | (rec withLisp: lisp) perform: (sel withLisp: lisp) withArguments: (args collect: [:arg | arg withLisp: lisp])] fixTemps;
			description: (rec printStringForLisp: self), ' perform: ', (sel printStringForLisp: self), ' args: ', (args printStringForLisp: self)! !

!LispKernel methodsFor: 'private - compiler' stamp: 'spfa 11/27/2006 15:06'!
compileObject: anObject

	| func object fsymb args prop special |

	object _ anObject.

	"symbol & atoms"
	object isSymbol ifTrue: [^ self compileSymbolValue: object].
	object isConsCell ifFalse: [^ object]. 

	"-------- below: function application ---------"

	func _ self lookUpFunction: (fsymb _ object car).
	func isSymbol ifTrue: [fsymb _ func].
	func isLKPrimitive ifTrue: [fsymb _ func selector].

	func isProcedure ifTrue:
	[  
		(func lambdaForm car == #macro)
			ifTrue: [^ self compileObject: (self macroexpand: object inCons)].

		object cdr ifNotNil:
			[args _ object cdr collect: [:form | self compileObject: form]].

		"inlining"
		(fsymb isSymbol not	or: [(self get: #'inline' symbol: fsymb) notNil])
		ifTrue:[ 
			^ self compileLet: ((func lambdaForm nthcdr: 2) collect: [:form | self compileObject: form]) environment: func environment bindings: ((self bindAll: args fromSpec: func lambdaForm second macrop: true) collect: [:b | b key -> (self compileObject: b value)])
		]
	].

	fsymb isSymbol ifFalse: [self lispError: 'Invalid function: ', fsymb asString].
	special _ self class specialForms includes: fsymb.

	(object cdr notNil and: [args isNil]) ifTrue: [
		args _ special
			ifTrue: [object cdr] 
			ifFalse: [object cdr collect: [:form | self compileObject: form]]].

	"context-free function" 
	(self get: #'context-free' symbol: fsymb)
		ifNotNil: [args detect: [:a | a isCompiled 
										or: [a isConsCell and: [a isQuotedCons not]]]
					ifNone: [ | o |
						o _ self evalObject: anObject.
						((o isSymbol and: [(constantVariables includes: o) not])
								or: [o isConsCell and: [o isQuotedCons not]])
							ifTrue: [^ o inQuotedCons] ifFalse: [^ o]]].

	"a specific compilation procedure may be provided" 
	(prop _ self get: #'compiler' symbol: fsymb)
		ifNotNil: [^ self evalObject: (prop inCons addLast: args inQuotedCons)].

	"cf defunary in library #common" 
	((prop _ self get: #'unary-message' symbol: fsymb) notNil
		and: [args length = 1])
	ifTrue:  [^ self compileUnaryMessage: prop sendTo: args first].

	"cf defbinary in library #common" 
	((prop _ self get: #'binary-message' symbol: fsymb) notNil
		and: [args length = 2])
	ifTrue: [^ self compileBinaryMessage: prop sendTo: args first arg: args second].

	((prop _ self get: #'boolean-binary-message' symbol: fsymb) notNil
		and: [args length = 2])
	ifTrue: [^ self compileBooleanBinaryMessage: prop sendTo: args first arg: args second].

	(self class primitives identityIncludes: fsymb)
		ifTrue: [^ self compileCallPrimitive: fsymb withArgs: args].
	
	^ self compileCallTo: fsymb withArgs: args




	


	

! !

!ULisp methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 3/27/2007 18:21'!
compileObject: anObject

	| func object fsymb args prop special |

	object _ anObject.

	"symbol & atoms"
	object isSymbol ifTrue: [^ self compileSymbolValue: object].
	object isConsCell ifFalse: [^ object]. 

	"-------- below: function application ---------"

	func _ self lookUpFunction: (fsymb _ object car).
	func isLKPrimitive ifTrue: [fsymb _ func selector].

	func isLispClosure ifTrue:
	[  
		(func lambdaForm car == #macro)
			ifTrue: [^ self compileObject: (self macroexpand: object inCons)].

		object cdr ifNotNil:
			[args _ object cdr collect: [:form | self compileObject: form]].

		"inlining"
		(fsymb isSymbol not or: [(self get: #'inline' symbol: fsymb) notNil])
		ifTrue:[ 
			^ self compileLet: ((func lambdaForm nthcdr: 2) collect: [:form | self compileObject: form]) environment: func environment bindings: ((self bindAll: args fromSpec: func lambdaForm second macrop: true) collect: [:b | b key -> (self compileObject: b value)])
		]
	].

	fsymb isSymbol ifFalse: [self lispError: 'Invalid function: ', fsymb asString].

	special _ self class specialForms includes: fsymb.

	(object cdr notNil and: [args isNil]) ifTrue: [
		args _ special
			ifTrue: [object cdr] 
			ifFalse: [object cdr collect: [:form | self compileObject: form]]].

	"context-free function" 
	(self get: #'context-free' symbol: fsymb)
		ifNotNil: [args detect: [:a | a isCompiled 
										or: [a isConsCell and: [a isQuotedCons not]]]
					ifNone: [ | o |
						o _ self evalObject: anObject.
						((o isSymbol and: [(constantVariables includes: o) not])
								or: [o isConsCell and: [o isQuotedCons not]])
							ifTrue: [^ o inQuotedCons] ifFalse: [^ o]]].

	"a specific compilation procedure may be provided" 
	(prop _ self get: #'compiler' symbol: fsymb)
		ifNotNil: [^ self evalObject: (prop inCons addLast: args inQuotedCons)].

	"cf defunary in library #common" 
	((prop _ self get: #'unary-message' symbol: fsymb) notNil
		and: [args length = 1])
	ifTrue:  [^ self compileUnaryMessage: prop sendTo: args first].

	"cf defbinary in library #common" 
	((prop _ self get: #'binary-message' symbol: fsymb) notNil
		and: [args length = 2])
	ifTrue: [^ self compileBinaryMessage: prop sendTo: args first arg: args second].

	((prop _ self get: #'boolean-binary-message' symbol: fsymb) notNil
		and: [args length = 2])
	ifTrue: [^ self compileBooleanBinaryMessage: prop sendTo: args first arg: args second].

	(self class primitives identityIncludes: fsymb)
		ifTrue: [^ self compileCallPrimitive: fsymb withArgs: args].
	
	^ self compileCallTo: fsymb withArgs: args




	


	

! !

!LispKernel methodsFor: 'LISP-functions-compiler' stamp: 'spfa 11/20/2006 14:18'!
compilePrimitiveCall: aConsCell

	^ self compileCallPrimitive: aConsCell car withArgs: aConsCell cadr! !

!LispKernel class methodsFor: 'private' stamp: 'spfa 10/19/2006 16:09'!
compilePrimitiveLists

	"to be evaluated whenever new primitives are implemented"

	| categories |

	SpecialForms _ IdentitySet new.
	(self allMethodsInCategory: 'LISP-special forms') do: [:sel |
		SpecialForms add: sel].

	categories _ Array streamContents: [:str |
			self withAllSuperclasses do: [:c | 
				str nextPutAll: (c organization categories 
						select: [:cat | cat beginsWith: 'LISP-functions'])]].

	Primitives _ IdentitySet new.

	categories asSet do: [:cat | 
		(self allMethodsInCategory: cat) do: [:sel | Primitives add: sel]].

	Primitives addAll: SpecialForms.

	self definePrimitiveAliases
! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 11/27/2006 10:24'!
compilers

	"compiler optimizations -- experimental"

	^ 
	#(in-library compilers

(put $'if: $'compiler $'compile-if)
(defun compile-if (args) 
	(if (eq: (compile-sexp (car args)) (yes*)) (compile-sexp (cadr args))
		(if (eq: (compile-sexp (car args)) (no*)) 
				(compile-sexp (append $'(progn:) (cddr args)))
			(compile-primitive-call `if: (mapcar: $'compile-sexp args)))))

(put $'progn: $'compiler $'compile-progn)
(defun compile-progn (args) 
	(if (= 1 (length args))
		 (compile-sexp (car args))
		(compile-primitive-call `progn: (mapcar: $'compile-sexp args))))

(put $'sendMessage: $'compiler $'compile-message-send)
(put $'quote: $'compiler 
	(lambda (args) 
		(if (and (atom (car args)) 
				(not (symbolP: (car args))))
			(car args)
			`(quote ,@args))))

"context-free functions"

(put $'+ $'context-free (yes*))
(put $'- $'context-free (yes*))
(put $'* $'context-free (yes*))
(put $'/ $'context-free (yes*))

(mapcar (lambda (s) (put s $'context-free (yes*)))
	$'(#'1+' #'1-' car: cdr: > >= < <= sqrt sin cos tan atan exp log abs expt LISPand: LISPor: max: min:))

"binary messages"

(put $'+ $'binary-message $'+)
(put $'- $'binary-message  $'-)
(put $'* $'binary-message $'*)
(put $'/ $'binary-message $'/)

(mapcar (lambda (s) (put s $'boolean-binary-message s))
	$'(> >= < <=))

)! !

!LispKernel methodsFor: 'LISP-functions-compiler' stamp: 'spfa 11/10/2006 16:23'!
compileSexp: aConsCell

"(compile-sexp FORM)
"

	^ self compileObject: aConsCell car! !

!LispKernel methodsFor: 'private - compiler' stamp: 'spfa 11/27/2006 14:41'!
compileSymbolValue: aSymbol

	(constantVariables includes: aSymbol)
		ifTrue: [^ self symbolValue: aSymbol ifNone: [self lispError: 'uh?']].

	^ LKBlock new 
		block: [:lisp :mflag |
					lisp symbolValue: aSymbol
					ifNone: [lisp lispError: 'no value for symbol ', aSymbol]] fixTemps;
		description: 'SV ', aSymbol
	! !

!ULisp methodsFor: 'private - compiler' stamp: 'spfa 11/19/2006 17:32'!
compileSymbolValue: aSymbol

"
	... for this to work, the compiler must invoke all environments in due time, which it does not at the moment. 
"


	"Scheme being fully static, the lookup can be performed at compile-time for 'stable' environments (top-level or closures)"

"
	| env binding |

	env _ environment environmentBinding: aSymbol 
						ifNone: [^ super compileSymbolValue: aSymbol].

	env isStable ifTrue:
	[
		binding _ env symbolValues associationAt: aSymbol.
		^ [:lisp | binding value] fixTemps
	].
"
	^ super compileSymbolValue: aSymbol
	! !

!LispKernel methodsFor: 'private - compiler' stamp: 'spfa 11/27/2006 14:41'!
compileUnaryMessage: selector sendTo: argument

	| block sarg |

	sarg _ argument isCompiled ifTrue: ['(arg withLisp: lisp)'] ifFalse: ['arg'].
	block _ (Compiler evaluate: '[:arg | [:lisp :mflag | ', sarg ,' ', selector, ']]') value: argument.

	^ LKBlock new
		block: block fixTemps;
		description: (argument printStringForLisp: self), ' ', selector! !

!LispKernel methodsFor: 'LISP-functions-compiler' stamp: 'spfa 11/21/2006 22:33'!
compile: aConsCell

"(compile FUNCTION)
"
	| lambdaForm cf func |

	aConsCell car isSymbol
		ifTrue: [ 
			func _ self symbolFunction: aConsCell car
				ifNone: [self lispError: 'undefined function'].
			func isLKPrimitive ifTrue: [self lispError: 'you can''t compile a primitive'].
			lambdaForm _ func lambdaForm
		]
		ifFalse:
		[
			aConsCell car isProcedure ifFalse: [self lispError: 'not a function'].
			lambdaForm _ aConsCell car lambdaForm.
		].

	cf _ lambdaForm first inCons addLast: lambdaForm second;
		append: ((lambdaForm nthcdr: 2) collect: [:f | self compileObject: f]).
"
	cf _ self compileProcedure: lambdaForm.
"
	func isLispClosure ifTrue: [func form: cf. ^ aConsCell car ].

	aConsCell car isSymbol
		ifTrue: [(environment symbolFunctionsDictionaryFor: aConsCell car)
					add: (aConsCell car -> cf).
					^ aConsCell car ].

	^ cf! !

!ULisp methodsFor: 'LISP-functions-compiler' stamp: 'spfa 11/26/2006 22:44'!
compile: aConsCell

"(compile FUNCTION)
"
	| lambdaForm cf func |

	(func _ aConsCell car) isProcedure ifFalse: [self lispError: 'not a function'].
	lambdaForm _ func lambdaForm.

	cf _ lambdaForm first inCons addLast: lambdaForm second;
		append: ((lambdaForm nthcdr: 2) collect: [:f | self compileObject: f]).
"
	cf _ self compileProcedure: lambdaForm.
"
	func form: cf. 

	^ func! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:38'!
complexP: aConsCell

	^ self test: aConsCell car isComplex! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 11/13/2006 10:32'!
complexP: aConsCell

	^ self test: (aConsCell car isComplex or: [aConsCell car isNumber])
".. we need the double test for Squeak 3.8 where a Complex answsers false to #isNumber"! !

!LispKernel class methodsFor: 'private-subclasses may implement' stamp: 'spfa 7/7/2006 15:53'!
complexString: aComplex base: base

	"printed representation for aComplex"

	^ '#C(', (aComplex real printStringBase: base), ' ', 
		(aComplex imaginary printStringBase: base), ')'
		! !

!ULisp class methodsFor: 'private' stamp: 'spfa 7/7/2006 15:57'!
complexString: aComplex base: base

	^ (aComplex real printStringBase: base), 
		(0 <= aComplex imaginary ifTrue: ['+']	ifFalse: ['']),
		(aComplex imaginary printStringBase: base),
		'i'! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/2/2006 14:01'!
concat: aConsCell

"(concat &rest STRINGS)
Concatenate all STRINGS"

	aConsCell ifNil: [^ ''].
	^ String streamContents: [:str |
			aConsCell 	do: [:s | str nextPutAll: s asString]]
! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 20:28'!
cond: aConsCell

"(cond &rest CLAUSES)
Try each clause until one succeeds.
Each clause looks like (CONDITION &rest BODY).  CONDITION is evaluated
and, if the value is non-nil, this clause succeeds:
then the expressions in BODY are evaluated and the last one's
value is the value of the cond-form.
If no clause succeeds, cond returns nil.
If a clause has one element, as in (CONDITION),
CONDITION's value if non-nil is returned from the cond-form."

	aConsCell do: [:clause | | v |
		v _ self evalObject: clause first.
		(v == self falseValue) ifFalse: 
		[
			(clause cdr ifNil: [^ v]) 
				doWithCdr: [:c :cdr | 
					cdr ifNil: [^ self evalTailObject: c].
					self evalObject: c]
		]].

	^ self falseValue
! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 20:31'!
cond: aConsCell

"(cond &rest CLAUSES)
Try each clause until one succeeds.
Each clause normally look like (CONDITION &rest BODY).  CONDITION is evaluated and, if the value is non-nil, this clause succeeds:
then the expressions in BODY are evaluated and the last one's
value is the value of the cond-form.
Special clauses are:
(CONDITION => EXPRESSION)
(else EXPRESSION)

If no clause succeeds, cond returns nil.
If a clause has one element, as in (CONDITION),
CONDITION's value if non-nil is returned from the cond-form."

	aConsCell do: [:clause | | v |
		v _ clause first == #else
			ifTrue: [self trueValue]
			ifFalse: [self evalObject: clause first].
		(v == self falseValue) ifFalse: 
		[
			clause cdr ifNil: [^ v].
			clause cadr == #=> ifTrue: 
				[^ self evalTailObject: ((self evalObject: clause cdr cdr car) inCons
											 addLast: v inQuotedCons)].
			clause cdr doWithCdr: [:c :cdr | 
				cdr ifNil: [^ self evalTailObject: c].
				self evalObject: c]
		]].

	^ self falseValue! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:56'!
consP: aConsCell

"(consp OBJECT)
Return t if OBJECT is a cons cell"

	^ self class test: aConsCell car isConsCell! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 10/6/2006 13:35'!
constantBindings

	"constant bindings. those cannot be changed, see #checkSymbol:"

	^ Dictionary 
		with: #t -> self trueValue
		with: #nil -> nil
		! !

!SLisp methodsFor: 'initialization' stamp: 'spfa 10/6/2006 15:45'!
constantBindings

	| cb |

	cb _ super constantBindings.	
	cb add: #self -> self.
	cb add: #true -> true.
	cb add: #false -> false.
	^ cb
! !

!ULisp methodsFor: 'private - initialization' stamp: 'spfa 6/21/2006 23:09'!
constantBindings

	^ Dictionary new
	
! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/21/2006 00:07'!
constantVariables

	^ constantVariables! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/21/2006 00:07'!
constantVariables: anIdentitySet

	constantVariables _ anIdentitySet
	
	! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 22:37'!
cons: aConsCell
	
"(cons CAR CDR)
Create and return a new cons cell.
CAR and CDR can be any object. The result will be a list if CDR is nil."

	^ ConsCell car: aConsCell car cdr: aConsCell cadr
! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:06'!
copyList: aConsCell

"(copy-list LIST)
Return a copy of LIST. 
The elements of the copy are not copied themselves"

	^ (aConsCell car ifNil: [^nil]) listCopy

	! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:06'!
copySeq: aConsCell

"(copy-seq SEQUENCE)
Return a copy of SEQUENCE, a list, vector or string. 
The elements of the copy are not copied themselves"

	(aConsCell car ifNil: [^nil]) isConsCell ifTrue: [^ aConsCell car listCopy].
	^ aConsCell car copy

	! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 7/4/2006 23:12'!
copy: aConsCell

"(copy OBJECT)
Returns a copy of OBJECT, by sending #copy"

	^ aConsCell car copy! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!LKREPLMorph methodsFor: 'command processing' stamp: 'spfa 10/3/2006 10:39'!
currentCommandFor: text

	| lastLinePos lastLine  |

	lastLinePos _ text lastIndexOfSubCollection: (String cr, self prompt asString withoutTrailingBlanks)  ifAbsent: [0].
"	lastLinePos _ text lastIndexOf: Character cr ifAbsent: [ 0 ]."
	lastLinePos _ text asString skipAnySubStr: {self prompt asString withoutTrailingBlanks} startingAt: lastLinePos + 1.
	lastLine _ text copyFrom: lastLinePos to: text size.
	^ lastLine asString withBlanksTrimmed! !

!LispKernel methodsFor: 'private - utils' stamp: 'muOuser 3/20/2007 22:13'!
currentDirectory

	^ currentDirectory ifNil: [currentDirectory _ FileDirectory default]! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'muOuser 3/20/2007 22:33'!
currentDirectory: ignored

"(current-directory)
Used by 'load' to resolve relative file names"

	^ self currentDirectory

! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 10/10/2006 10:29'!
currentInputPort: ignored

"(current-input-port)
Returns the current input port"
	
	^ self standardInput! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 10/10/2006 10:24'!
currentOutputPort: ignored

"(current-output-port)
Returns the current output port"
	
	^ self standardOutput! !

!SequenceableCollection methodsFor: '*LispKit' stamp: 'spfa 10/22/2006 00:03'!
cutAt: aNumber

	self size <= aNumber ifTrue: [^ self].
	^ self first: aNumber! !

!ConsCell methodsFor: 'brackets rewriting' stamp: 'spfa 6/19/2006 17:37'!
cut: delim

	self nest: delim.
	cdr car = delim second ifTrue: [^ self].
	^ cdr cut: delim
	
! !

!ConsCell methodsFor: 'brackets rewriting' stamp: 'spfa 6/23/2006 00:16'!
cut: del with: o

	self nest: del with: o.
	cdr car == del second ifTrue: [^ self].
	^ cdr cut: del with: o
	
! !

!Array methodsFor: '*LispKit' stamp: 'spfa 3/23/2007 17:12'!
cycles

	^ self storeCycles: IdentityDictionary new with: IdentitySet new
! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 3/23/2007 16:46'!
cycles

	^ self storeCycles: IdentityDictionary new with: IdentitySet new
! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 11/30/2006 18:00'!
debug

	"useful when invoked from the Smaltalk debugger
	opens a GUI for the appropriate sub-lisp with contextual information"

	(Text streamContents: [:str | | n upf |
		str nextPutAll: ';; interpreter contexts'; cr;
			nextPutAll: ';; (click -N- to jump to Nth context)'; cr.
		upf _ self upperForms.
		n _ 0.

		upf size > 50 
			ifTrue: [n _ upf size - 50. upf _ upf first: 50].
			upf reverseDo: [:form |
			str withAttribute: (PluggableTextAttribute evalBlock: [ ((self nthUpperLisp: upf size - n - 1) ifNil: [self]) openGui ] fixTemps)
			do: [str nextPutAll: '-', n asString, '-'; tab].
			n _ n + 1.
			str nextPutAll: (form printStringForLisp: self); cr]])
	openInWorkspaceWithTitle: (self upperForm printStringForLisp: self)
	! !

!LispKernel methodsFor: 'LISP-functions-debugging' stamp: 'spfa 11/30/2006 18:26'!
debug: aConsCell

"(debug)
Halt the evaluation, open a Smalltalk debugger plus a Lisp GUI living in the appropriate environment"

	self debug.
	Debugger
		openContext: thisContext
		label: '(debug)'
		contents: (self upperForm printStringForLisp: self)! !

!CLisp methodsFor: 'private - declarations' stamp: 'spfa 10/13/2006 09:30'!
declaration: specForm

	"only 'special' is supported"

	specForm car == #special ifFalse: [^ self].

	specForm cdr do: [:var |
		"if var does not have a dynamic value at this point, 
		then give it one from its lexical binding (if any)"
		((self hasDynamicValue: var) not and: [environment hasValue: var])  
		ifTrue:	
		[self dynamicSymbolValues add: var -> (self symbolValue: var ifNone: [])].
		"then register var as special for this form"
		specialVariables add: var]! !

!CLisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/12/2006 13:01'!
declare: ignored

"(declare SPECS)
A declare form is known as a declaration. Declarations may occur only at the beginning of the bodies of certain special forms; that is, a declaration may occur only as a statement of such a special form, and all statements preceding it (if any) must also be declare forms (or possibly documentation strings, in some cases). Declarations may occur in lambda-expressions and in the forms listed here.

define-setf-method              labels 
defmacro                        let 
defsetf                         let* 
deftype                         locally 
defun                           macrolet 
do                              multiple-value-bind 
do*                             prog 
do-all-symbols                  prog* 
do-external-symbols             with-input-from-string 
do-symbols                      with-open-file 
dolist                          with-open-stream 
dotimes                         with-output-to-string 
flet
"

	^ self falseValue! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 3/23/2007 18:38'!
defaultBindings

	"return a Dictionary defining all variables that should be present when the interpreter starts"

	| db |

	db _ Dictionary new.
	db add: #'*standard-output*' -> self standardOutputPort.
	db add: #'*standard-input*' -> self standardInputPort.
	db add: #'*print-circle*' -> nil.
	db add: #'*print-length*' -> nil.
	db add: #'*print-level*' -> nil.
	db add: #'*features*' -> nil.

	^ db
! !

!ULisp methodsFor: 'private - initialization' stamp: 'spfa 3/23/2007 18:35'!
defaultBindings

	| db |

	db _ super defaultBindings.

	db add: #'*print-circle*' -> false.

	^ db

	
	
! !

!CLisp class methodsFor: 'libraries' stamp: 'spfa 11/21/2006 22:39'!
defaultLibraries

	^ #(glue #'provide-library' plist compilers #'small-macros' common #'arguments-lists' loop)! !

!ELisp class methodsFor: 'private' stamp: 'spfa 11/21/2006 22:38'!
defaultLibraries

	^ #(glue #'provide-library' plist compilers #'small-macros' common  #'arguments-lists' loop)! !

!LispKernel class methodsFor: 'private-subclasses may implement' stamp: 'spfa 6/22/2006 22:23'!
defaultLibraries

	"which libraries should be loaded at start up"

	^ #(glue)! !

!SLisp class methodsFor: 'libraries' stamp: 'spfa 11/21/2006 22:38'!
defaultLibraries

	^ #(glue #'provide-library' plist compilers #'small-macros' common widgets)! !

!SScheme class methodsFor: 'libraries' stamp: 'muOuser 3/27/2007 23:00'!
defaultLibraries

	^ super defaultLibraries, #(sscheme #'sscheme-intro')! !

!StaticLisp class methodsFor: 'private' stamp: 'spfa 11/21/2006 22:39'!
defaultLibraries

	^ #(glue #'provide-library' plist compilers #'small-macros' common "#'arguments-lists' loop")! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 11/21/2006 22:39'!
defaultLibraries

	"the bindings defined by these libraries will belong to the interaction-environment"

	^ #(compilers #'slib-init' #'slib-integration')! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 10/21/2006 00:10'!
defconstant: aConsCell

"(defconstant: SYMBOL VALUE)
Set VALUE for SYMBOL, then make it a constant"

	| sym |
	
	sym _ self checkSymbol: aConsCell car.

	self topmostLisp symbolValuesAdd: 
					sym -> (self evalObject: aConsCell cadr).

	constantVariables add: sym.

	^ sym! !

!CLisp methodsFor: 'initialization' stamp: 'spfa 10/21/2006 00:09'!
defineDefaultBindings

	self constantBindings associationsDo: [:assoc | 
		dynamicSymbolValues add: assoc.
		constantVariables add: assoc key].

	self defaultBindings associationsDo: [:assoc | 
		dynamicSymbolValues add: assoc]


! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 10/21/2006 00:08'!
defineDefaultBindings

	self constantBindings associationsDo: [:assoc | 
		self symbolValues add: assoc.
		constantVariables add: assoc key].

	self defaultBindings associationsDo: [:assoc | 
		self symbolValues add: assoc]
! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/5/2006 00:35'!
defineMacro: aConsCell

	| s val |

	(s _ aConsCell car) isSymbol
		ifTrue: [val _ self evalObject: (aConsCell cadr copy setcar: #macro)]
		ifFalse:
		[
			(aConsCell car isConsCell
				and: [(s _ aConsCell car car) isSymbol])
			ifTrue: [ | spec |
				spec _ aConsCell car cdr.
				spec isSymbol ifTrue: [spec _ {#'&rest' . spec} asCons].
				val _ self makeClosureFor: (((ConsCell car: #macro) addLast: spec) append: aConsCell cdr)
				]
			ifFalse: [self lispError: 'symbol expected, got ', s asString]
		].	

	self symbolValuesAdd: (self checkSymbol: s) -> val.
	^ s! !

!LispKernel class methodsFor: 'private' stamp: 'spfa 10/19/2006 17:48'!
definePrimitiveAliases

	| aliases |
	
	"defines functions for primitives with lispish names, so that we can do for example
					(defun myCons (x y) (cons x y))
	instead of
					(defun: myCons (x y) (cons: x y))

	do this for all instances of the receiver. care is taken not to override the possibly already existing definition of the alias symbol, so that the overall effect of sending this message to a running interpreter is simply to register newly created primitives and have them available on-the-fly"

	aliases _ self primitives select: [:prim | prim last == $:] 
		thenCollect: [:prim  | 
			(self aliasForPrimitive: prim) -> (LKPrimitive selector: prim for: self)].
	
	(self allInstances select: [:lisp | lisp upperLisp isNil])
		do: [:lisp | 
			"clean up previous definitions"
			lisp symbolFunctions keysDo: [:f |  | p |
				(((p _ lisp symbolFunctions at: f ) isLKPrimitive)
						and: [(self primitives includes: p selector) not])
					ifTrue: [lisp symbolFunctions removeKey: f]].
			"create new definitions"
			aliases do: [:alias | 
				((lisp symbolFunction: alias key  
						ifNone: [lisp symbolFunctions add: alias])
		 			isSymbol) 
				ifTrue: [lisp symbolFunctions add: alias]].

].
! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 10/19/2006 17:34'!
definePrimitiveAliases

	| aliases |
	
	"defines functions for primitives with lispish names, so that we can do for example
					(defun myCons (x y) (cons x y))
	instead of
					(defun: myCons (x y) (cons: x y))"

	aliases _ self class primitives select: [:prim | prim last == $:] 
		thenCollect: [:prim  | 
		(self class aliasForPrimitive: prim) -> (LKPrimitive selector: prim for: self)].
	
	aliases do: [:alias | 
		((self symbolFunction: alias key  
				ifNone: [self symbolFunctions add: alias]) isLKPrimitive) 
		ifTrue: [self symbolFunctions add: alias]].


! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:06'!
define: aConsCell

	| s val |

	(s _ aConsCell car) isSymbol
		ifTrue: [val _ self evalObject: aConsCell cadr]
		ifFalse:
		[
			(aConsCell car isConsCell
				and: [(s _ aConsCell car car) isSymbol])
			ifTrue: [ | spec |
				spec _ aConsCell car cdr.
				spec isSymbol ifTrue: [spec _ {#'&rest' . spec} asCons].
				val _ self makeClosureFor: (((ConsCell car: #lambda) addLast: spec) append: aConsCell cdr)
				]
			ifFalse: [self lispError: 'symbol expected, got ', s asString]
		].	

	self symbolValuesAdd: (self checkSymbol: s) -> val.
	^ s! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 6/9/2006 14:29'!
defmacro: aConsCell

"(defmacro NAME ARGLIST &rest BODY...)
Set the function definition of NAME as (macro lambda ARGLIST &rest BODY).
When the macro is called, as in (NAME &rest ARGS), the function (lambda ARGLIST &rest BODY) is applied to the list ARGS as it appears in the expression, and the result should be a form to be evaluated instead of the original.
If the first form in BODY is a string, it is considered as the macro documentation"

	| macro |
	macro _ self lambdaForm: #macro withArgsAndBody: aConsCell cdr.
	self topmostLisp symbolFunctions add: aConsCell car -> macro.
	^ macro! !

!StaticLisp methodsFor: 'LISP-special forms' stamp: 'spfa 6/5/2006 20:56'!
defmacro: aConsCell

"(defmacro NAME ARGLIST &rest BODY...)
Set the function definition of NAME as (macro lambda ARGLIST &rest BODY).
When the macro is called, as in (NAME &rest ARGS), the function (lambda ARGLIST &rest BODY) is applied to the list ARGS as it appears in the expression, and the result should be a form to be evaluated instead of the original.
If the first form in BODY is a string, it is considered as the macro documentation"

	| macro |

	macro _ self makeClosureFor: aConsCell cdr as: #macro.

	self topmostLisp symbolFunctions add: 
		aConsCell car -> macro.

	^ macro! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/25/2006 10:46'!
defun: aConsCell

"(defun NAME ARGLIST &rest BODY)
Set the function definition of NAME as (lambda ARGLIST &rest BODY).
If the first form in BODY is a string, it is considered as the function documentation"

	| lambda |
	lambda _ self lambdaForm: #lambda withArgsAndBody: aConsCell cdr.
	self topmostLisp symbolFunctions add: aConsCell car -> lambda.
	^ aConsCell car! !

!StaticLisp methodsFor: 'LISP-special forms' stamp: 'spfa 9/25/2006 10:46'!
defun: aConsCell

"(defun NAME ARGLIST &rest BODY)
Set the function definition of NAME as (lambda ARGLIST &rest BODY).
If the first form in BODY is a string, it is considered as the function documentation"

	| lambda |

	lambda _ self makeClosureFor: aConsCell cdr as: #lambda.

	self topmostLisp symbolFunctions add: 
		aConsCell car -> lambda.

	^ aConsCell car! !

!CLisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/13/2006 09:30'!
defvar: aConsCell

"(defvar SYMBOL [INITVALUE])
Declare SYMBOL as a special variable, dynamically scoped.
Set value for SYMBOL to INITVALUE, only if SYMBOL has no value"

	| toplisp symbol |

	toplisp _ self topmostLisp.
	symbol _ self checkSymbol: aConsCell car.
	toplisp specialVariables add: symbol.

	aConsCell cdr ifNil: [^ symbol].

	(toplisp dynamicSymbolValues includesKey: symbol)
		ifFalse: 
		[	| binding |
			"if a setq was done at top-level before the defvar (which is supposed to be illegal but is actually accepted by most Common Lisp implementations), then we already have a binding in the topmost symbolValues. 
in this case we must move it into globalSymbolValues"
			(toplisp symbolValues includesKey: symbol)
				ifTrue: [binding _ toplisp symbolValues associationAt: symbol.
							toplisp symbolValues removeKey: symbol]
				ifFalse: [binding _ symbol -> (self evalObject: aConsCell cadr)].
			toplisp dynamicSymbolValues add: binding
		].

	^ symbol! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/12/2006 20:47'!
defvar: aConsCell

"(defvar SYMBOL [INITVALUE])
Set value for SYMBOL to INITVALUE, only if SYMBOL has no value"

	| sym |
	
	sym _ self checkSymbol: aConsCell car.

	(self topmostLisp symbolValues includesKey: sym)
		ifFalse: [self topmostLisp symbolValuesAdd: 
					sym -> (self evalObject: aConsCell cadr)].
	^ sym! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 6/8/2006 14:27'!
defvar: aConsCell

"(defvar SYMBOL VALUE)
An alias for define.
-- you should not use this special form in Scheme --"

	^ self define: aConsCell! !

!ELisp methodsFor: 'LISP-functions-system' stamp: 'spfa 10/2/2006 11:35'!
deleteFile: aConsCell

	| fname |
	
	fname _ FileDirectory default fullNameFor:aConsCell car.

	(FileDirectory default fileExists: fname)
		ifFalse: [self lispError: 'no such file: ', fname].

	FileDirectory deleteFilePath: fname.
	^ self trueValue! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 3/14/2007 22:36'!
delete: aConsCell

"(delete ELT SEQUENCE)
Delete by side effect any occurrences of ELT as a member of SEQUENCE.
The modified SEQUENCE is returned.  Comparison is done with `equal'.
If the first member of SEQUENCE is ELT, there is no way to remove it by side effect; therefore, write `(setq foo (delete element foo))'
to be sure of changing the value of `foo'"

	| list elt cell |

	elt _ aConsCell car.
	list _ aConsCell cadr ifNil: [^ nil].

	list isCollection ifTrue: [^ list select: [:ea | ea ~= elt]].

	cell _ ConsCell new cdr: list.

	[(cell _ cell cdr) notNil] whileTrue:
		[[cell cdr notNil and: [cell cadr = elt]] whileTrue: [cell setcdr: cell cddr]].
	
	list car = elt ifTrue: [^ list cdr].
	^ list! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 3/14/2007 22:35'!
delq: aConsCell

"(delq ELT SEQUENCE)
Delete by side effect any occurrences of ELT as a member of SEQUENCE.
The modified SEQUENCE is returned.  Comparison is done with `eq'.
If the first member of SEQUENCE is ELT, there is no way to remove it by side effect; therefore, write `(setq foo (delq element foo))'
to be sure of changing the value of `foo'"

	| list elt cell |

	elt _ aConsCell car.
	list _ aConsCell cadr ifNil: [^ nil].

	list isCollection ifTrue: [^ list select: [:ea | ea ~~ elt]].

	cell _ ConsCell new cdr: list.

	[(cell _ cell cdr) notNil] whileTrue:
		[[cell cdr notNil and: [cell cadr == elt]] whileTrue: [cell setcdr: cell cddr]].
	
	list car = elt ifTrue: [^ list cdr].
	^ list! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 6/7/2006 22:34'!
depth

	^ upperLisp ifNil: [0] ifNotNil: [upperLisp depth + 1]! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 8/5/2006 15:30'!
depth

	upperBindings ifNil: [^ 0].
	^ upperBindings depth + 1! !

!LKTracer methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 22:14'!
depth 
	
	^ depth ifNil: [0]! !

!LKBlock methodsFor: 'as yet unclassified' stamp: 'spfa 11/19/2006 20:22'!
description

	^ description ! !

!LKBlock methodsFor: 'as yet unclassified' stamp: 'spfa 11/19/2006 20:22'!
description: aString

	description _ aString! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 6/12/2006 08:53'!
detect: aBlock ifNone: bBlock

	^ (aBlock value: car) ifTrue: [car]
		ifFalse: [cdr isConsCell ifFalse: [bBlock value] 
								ifTrue: [cdr detect: aBlock ifNone: bBlock]]! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2006 11:26'!
digit: aCharacter

	| value |
	value _ aCharacter asciiValue.
	(value >= 48 and: [value <= (48 + base - 1)]) ifTrue: [^ value - 48].

	base > 10 ifFalse: [^ nil].

	(value >= 65 and: [value <= (65 + base - 11)]) ifTrue: [^ value - 55].
	(value >= 97 and: [value <= (97 + base - 11)]) ifTrue: [^ value - 87].

	^ nil! !

!LKREPLMorph class methodsFor: 'colors' stamp: 'spfa 6/8/2006 14:01'!
displayAttribute

	^ TextColor color: Color red muchDarker muchDarker! !

!LKREPLMorph class methodsFor: 'colors' stamp: 'spfa 10/2/2006 09:53'!
displayFont

	^ (TextStyle named: #Accumon) 
		fontOfSize: TextStyle defaultFont pointSize! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 11/30/2006 13:59'!
display: aConsCell

"(display obj [port])
Writes a representation of obj to the given port. Strings that appear in the written representation are not enclosed in doublequotes, and no characters are escaped within those strings. Character objects appear in the representation as if written by write-char instead of by write."

	self princ: aConsCell.
	^ self trueValue! !

!LKREPLMorph methodsFor: 'command processing' stamp: 'spfa 9/30/2006 22:09'!
doCommand: aString

	| answer |

	self commandsHistory remove: aString ifAbsent: [].
	commandsHistory addFirst: aString.
	commandsHistory size > self class historyLength
		 ifTrue: [commandsHistory removeLast].

	debugContinuation _ lastAnswer _ lastError _ lastValue _  nil.

	answer _  [lastAnswer _ ((lastValue _ lisp evalString: aString) 
							printStringForLisp: lisp) 
							asText addAttribute: self class answerAttribute]
		on: Error
		do: [:ex | 
				debugContinuation _ Continuation current.
				debugContinuation isContinuation
					ifTrue: [(lastError _ ex description) asText 
								addAttribute: self class errorAttribute]
					ifFalse: [ex signal]].

	^ answer

! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 11/30/2006 13:48'!
documentation: aConsCell

"(documentation FUNCTION)
Return the documentation string of FUNCTION."

	| func doc |

	func _ self symbolFunction: aConsCell car 
		ifNone: [^ ((aConsCell car printStringForLisp: self), ' is not a function') asSymbol].

	func isProcedure ifTrue: 
	[
		doc _ func lambdaForm nth: 2.
		doc isString ifTrue: 
		[ 
			doc _ (aConsCell lastCdr: ((func lambdaForm nth: 1) formatForDocumentationString)) asString, String cr, doc
		]
		ifFalse: [doc _ nil]
	].

	func isLKPrimitive ifTrue: [func _ func selector].

	func isSymbol ifTrue: [
		doc _ (self class whichClassIncludesSelector: func) 
			firstPrecodeCommentFor: func.
		doc _ '(', aConsCell car, ' ', (doc copyAfter: $ )].

	doc ifNil: [^ #undocumented].
	^ doc! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/19/2006 16:01'!
doesNotUnderstand: aMessage

	(aMessage arguments notEmpty
		and: [aMessage arguments first isNil
				or: [aMessage arguments first isConsCell]])
	ifTrue: [^ self lispDoesNotUnderstand: aMessage].
	
	^ super doesNotUnderstand: aMessage! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/24/2006 10:23'!
dolist: aConsCell

"(dolist (VAR LIST [RESULT]) &rest BODY)
Evaluate BODY for each VAR in LIST, then evaluate RESULT and return the value. If no RESULT argument is given, return nil."

	| var list result body sublisp |

	var _ aConsCell caar.
	list _ self evalObject: aConsCell car cadr.
	result _ aConsCell car nth: 2 ifAbsent: [nil].
	body _ aConsCell cdr.

	sublisp _ self subLisp: #dolist form: aConsCell body: body. 

	list do: [:v |
		sublisp checkSymbol: var.
		sublisp symbolValuesAdd: var -> v.
		body do: [:form |
			sublisp evalObject: form]].

	^ self evalObject: result multipleValue: true
! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/24/2006 10:24'!
dotimes: aConsCell

" (dotimes (VAR COUNT [RESULT]) &rest BODY)
Evaluate BODY with VAR bound to successive integers running from 0,
inclusive, to COUNT, exclusive.  Then evaluate RESULT to get
the return value (nil if RESULT is omitted)."

	| var n result body sublisp |

	var _ aConsCell caar.
	n _ self evalObject: aConsCell car cadr.
	result _ aConsCell car nth: 2 ifAbsent: [nil].
	body _ aConsCell cdr.

	sublisp _ self subLisp: #dotimes form: aConsCell body: body. 

	0 to: n-1 do: [:v |
		sublisp checkSymbol: var.
		sublisp symbolValuesAdd: var -> v.
		body do: [:form |
			sublisp evalObject: form]].

	^ self evalObject: result multipleValue: true
! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 10/23/2006 13:22'!
doWithCdr: aBlock

	aBlock value: self car value: self cdr.
	cdr isConsCell ifTrue: [cdr doWithCdr: aBlock]

! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 9/22/2006 23:13'!
doWithCell: aBlock

	aBlock value: self car value: self.
	cdr isConsCell ifTrue: [cdr doWithCell: aBlock]

! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 6/7/2006 10:07'!
do: aBlock

	aBlock value: self car.
	cdr isConsCell ifTrue: [cdr do: aBlock]

! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 20:29'!
do: aConsCell

"(do ((<variable1> <init1> <step1>) ...)
  (<test><expression>...)
      <command>...)"

	| sublisp varspecs test expression command |

	varspecs _ aConsCell car.
	test _ aConsCell second car.
	expression _ aConsCell second cdr.
	command _ aConsCell nthcdr: 2.

	sublisp _ self subLisp: #do form: aConsCell body: command. 
	
	varspecs ifNotNil:
	[
		varspecs do: [:spec |
		sublisp symbolValuesAdd: (sublisp checkSymbol: spec car) -> (sublisp evalObject: spec second)]
	].

	[(sublisp evalObject: test) == self falseValue]
	whileTrue:
	[
		command ifNotNil: [command do: [:form | sublisp evalObject: form]].
		varspecs ifNotNil:
		[
			(varspecs collect: [:spec | 
				spec car -> (sublisp evalObject: (spec third ifNil: [spec car]))	]) 
			do: [:v | sublisp symbolValues add: v]
		]
	].

	(expression ifNil: [^ nil]) 
		doWithCdr: [:c :cdr | 
			cdr ifNil: [^ sublisp evalTailObject: c].
			sublisp evalObject: c]

! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:02'!
durationToRun: aConsCell

"(duration-to-run FORM)
Evaluate FORM and return all long it took to do so."

	^ [self evalObject: aConsCell car] durationToRun! !

!CLisp methodsFor: 'private - special variables' stamp: 'spfa 10/13/2006 09:30'!
dynamicSymbolValues

	^ dynamicSymbolValues! !

!CLisp methodsFor: 'private - special variables' stamp: 'spfa 10/13/2006 09:32'!
dynamicSymbolValuesDictionaryFor: aSymbol

	(dynamicSymbolValues keys includes: aSymbol)
		ifFalse: [
			(self specialVariables includes: aSymbol)	
				ifTrue: [^ dynamicSymbolValues].
			upperLisp 
				ifNil: [^ nil]
				ifNotNil: [^ upperLisp dynamicSymbolValuesDictionaryFor: aSymbol]].

	^ dynamicSymbolValues! !

!CLisp methodsFor: 'private - special variables' stamp: 'spfa 10/13/2006 09:31'!
dynamicSymbolValues: aDictionary

	dynamicSymbolValues _ aDictionary! !

!CLisp methodsFor: 'private - special variables' stamp: 'spfa 10/13/2006 09:29'!
dynamicSymbolValue: aSymbol ifNone: aBlock

	^ dynamicSymbolValues at: aSymbol 
		ifAbsent: [(self upperLisp ifNil: [^ aBlock value])
						dynamicSymbolValue: aSymbol ifNone: aBlock]
	
	! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 11/20/2006 13:02'!
elt: aConsCell

"(elt SEQUENCE N)
Return element of SEQUENCE at index N.
SEQUENCE can be a list or a vector (first index is 0)"

	| o |

	(o _ aConsCell car) isConsCell
		ifTrue: [^ o nth: aConsCell cadr].

	o isCollection ifTrue: [^ o at: aConsCell cadr + 1].

	self lispError: 'not a sequence'

	! !

!SLisp methodsFor: 'LISP-functions-arrays' stamp: 'spfa 6/21/2006 23:30'!
elt: aConsCell

"(elt SEQUENCE N)
Return element of SEQUENCE at index N.
SEQUENCE can be a list or an array. First index is 0."

	| o |

	(o _ aConsCell car) isConsCell
		ifTrue: [^ aConsCell car nth: aConsCell cadr].

	"no vectors in SLisp"
	o isArray ifTrue: [^ o at: aConsCell cadr + 1].

	^ o at: aConsCell cadr + 1

	! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/6/2006 13:20'!
emptyListMarker

	^ #'------()------'! !

!LKIOPort methodsFor: '-- hacks --' stamp: 'spfa 10/20/2006 14:05'!
endEntry
	"Display all the characters since the last endEntry, and reset the stream"

	self changed: #appendEntry.
	self dependents ifNotEmpty: [self reset].
	! !

!LispKernel methodsFor: 'entry points' stamp: 'spfa 10/23/2006 21:44'!
enterInterpreterContextAndEval: anObject

	"IMPORTANT: 

	all entry points to the Lisp interpreter must call this method, which simply wraps an #eval: call. 

	this method should never be invoked by lisp primitives, since it is always considered as the topmost context of a Lisp interpreter. 

	the correct behavior of continuations depends on these rules being followed. see LKContinuation>>#getTopSenderFrom:"

	self monitor ifNotNil:
		[self monitor goTopLevel].

	^ self evalSemaphore critical: [self evalObject: anObject multipleValue: true]
! !

!SScheme methodsFor: 'private - interpreter' stamp: 'spfa 10/24/2006 15:57'!
enterInterpreterContextAndEval: anObject

	macroEvalTemplate ifNil:
		[^ super enterInterpreterContextAndEval: anObject].

	^ self evalSemaphore critical: [self macroEvalObject: anObject].
					
! !

!ConsCell methodsFor: 'procedure protocol' stamp: 'spfa 6/3/2006 01:41'!
environment

	^ nil! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 8/3/2006 21:04'!
environment

	^ environment ! !

!LKClosure methodsFor: 'accessing' stamp: 'spfa 6/2/2006 23:53'!
environment

	^ environment ! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 11/19/2006 17:24'!
environmentBinding: aSymbol ifNone: aBlock

	(self symbolValues includesKey: aSymbol) ifTrue: [^ self].
	^ (upperBindings ifNil: [^ aBlock value]) environmentBinding: aSymbol ifNone: aBlock! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 10/6/2006 13:58'!
environment: someBindings

	environment _ someBindings! !

!LKClosure methodsFor: 'accessing' stamp: 'spfa 11/21/2006 15:03'!
environment: aDictionary

	environment _ aDictionary! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:20'!
eof

	^ #'<eof>'! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 11/7/2006 14:28'!
eofObjectP: aConsCell 

"(eof-object? OBJECT)
Returns #t if OBJECT is an end of file object, otherwise returns #f"

	^ self test: (aConsCell car == LKIOPort eof)! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/6/2006 18:41'!
equalP: aConsCell
	
"(equal? O1 O2)
Return #t if O1 and O2 are similar objects."

	^ self class test: aConsCell car = aConsCell cadr
! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/22/2006 21:11'!
equal: aConsCell
	
"(equal O1 O2)
Return t objects O1 and O2 have similar structure and contents."

	^ self class test: aConsCell car = aConsCell cadr
! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 9/24/2006 15:28'!
eqvP: aConsCell
	
"(eqv? O1 O2)
Return #t if O1 and O2 are equivalent objects."

	(aConsCell car isConsCell
		or: [aConsCell car isString]
		or: [aConsCell car isArray])
	ifTrue: [^ self class test: aConsCell car == aConsCell cadr].

	^ self class test: aConsCell car = aConsCell cadr
! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 17:15'!
eq: aConsCell
	
"(eq O1 O2)
Return t if O1 and O2 are the same object."

	| o1 o2 |

	o1 _ aConsCell car.
	o2 _ aConsCell cadr.

	^ self class test: (o1 == o2
		or: [o1 isLKPrimitive 
				and: [o2 isLKPrimitive]
				and: [o1 selector == o2 selector]])
! !

!LKREPLMorph class methodsFor: 'colors' stamp: 'spfa 6/18/2006 22:26'!
errorAttribute

	^ TextColor color: Color red! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 5/31/2006 11:48'!
errorUndefinedFunction: aSymbol

	^ self lispError: 'no function bound to symbol ', aSymbol! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 6/8/2006 14:33'!
error: aConsCell

"(error STRING)
Raise a LispError with text STRING"

	self lispError: aConsCell car! !

!LispKernel class methodsFor: 'private-subclasses may implement' stamp: 'spfa 9/23/2006 22:17'!
escapeSequences

	"subclasses can define their own escape sequences"

	^ {
		'\n' -> String lf. 
		'\r' -> String cr .            
		'\t' -> String tab.   
		}
! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/22/2006 00:33'!
evalList: aConsCell 

	^ (aConsCell ifNil: [^ nil]) collect: [:v | self evalObject: v]! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 11/17/2006 20:25'!
evalObject: anObject

	^ self evalObject: anObject multipleValue: false tail: false! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 11/17/2006 13:38'!
evalObject: anObject multipleValue: mvflag

	^ self evalObject: anObject multipleValue: mvflag tail: false! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 3/27/2007 16:14'!
evalObject: anObject multipleValue: mvflag tail: tflag

	| val |

	self monitor ifNotNil:	
		[self monitor trace: anObject in: self].

	val _ self rawEvalObject: anObject multipleValue: mvflag tail: tflag.

	self monitor ifNotNil:	
		[self monitor traceResult: val for: anObject in: self].

	(val isTailCall and: [tflag not]) ifTrue: 
		[val _ val evaluate].

	(val isLKValues and: [mvflag not]) 
		ifTrue: [val _ val asOneLispValue].

	^ val

! !

!SLisp methodsFor: 'private' stamp: 'spfa 11/17/2006 20:41'!
evalObject: anObject multipleValue: mvflag tail: tflag

	"all code here to implement with-smalltalk-syntax..."

	| form cell selector i |

	(syntax = #smalltalk and: [anObject isConsCell]) 
		ifFalse: [^ super evalObject: anObject multipleValue: mvflag tail: tflag].

	"inserted Lisp form"
	(form _ anObject) car == #lispInSmalltalkSyntax: ifTrue: 
		[^ (self copy syntax: #lisp) evalObject: anObject cadr multipleValue: mvflag tail: tflag].

	"inserted quoted Lisp form"
	form car == #quotedLispInSmalltalkSyntax: ifTrue: 
		[^ (self copy syntax: #lisp) 
		evalObject: (ConsCell car: #quote: cdr: anObject cdr) multipleValue: mvflag tail: tflag].

	"first pass: enclosing 0-arity messages"
	[form length > 2
		and: [(form nth: 1) numArgs = 0]]
	whileTrue: [form _ ((ConsCell car: form first) addLast: form second) inCons cdr: (form nthcdr: 2)].

	"second pass: enclosing 1-arity cascaded messages"
	[form length > 3
		and: [(form nth: 1) last ~= $:]] "that is +, -, *, etc."
	whileTrue: [form _ (((ConsCell car: form first) addLast: form second) addLast: form third) inCons cdr: (form nthcdr: 3)].
	
	"third pass: reordering parameters and building selector"
	cell _ ConsCell new.
	selector _ ''.
	i _ 0.
	form do: [:elt |
		i odd ifTrue: [selector _ selector, elt]
			ifFalse: [cell addLast: elt].
		i _ i + 1].

	cell setcar: selector asSymbol.

	^ super evalObject: cell multipleValue: mvflag tail: tflag! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 11/27/2006 13:25'!
evalProcedure: aProcedure withArgs: aConsCell id: aSymbol

	"aProcedure is either a lambda form (a ConsCell) or a LKClosure"

	| lisp sublisp args val env lambdaform body macrop |

	lambdaform _ aProcedure lambdaForm.
	body _ lambdaform cdr cdr ifNil: [^ nil].
	macrop _ lambdaform car == #macro.
	args _ aConsCell.
	env _ (aProcedure environment ifNil: [environment]) newChild.
	lisp _ self.
	sublisp _ self subLisp: aSymbol form: lambdaform body: body environment: env. 

	val _ TailCallWrapper new "dummy".

	"the tail call optimizing loop:"
	[val isTailCall] whileTrue:
	[
		(lisp bindAll: args fromSpec: lambdaform second macrop: macrop)
		do: [:a | 
				lisp checkSymbol: a key.
				sublisp symbolValuesAdd: a].

		val _ sublisp progn: body.

		macrop ifTrue: 
		[
			val isTailCall ifTrue: [val _ val evaluate].
			^ lisp evalObject: val multipleValue: true
		].

		val isTailCall ifTrue:
		[
			lambdaform _ val procedure lambdaForm.
			body _ lambdaform cdr cdr ifNil: [^ nil].
			macrop _ lambdaform car == #macro.
			args _ val args.
			val procedure environment ifNotNil:
				[env _ val procedure environment newChild].
			"note that because of the lisps hierarchy, we are not really in constant space. the stack does not grow, though."
			lisp _ val lisp.
			sublisp _ lisp subLisp: val id form: lambdaform body: body environment: env. 
		]
	].

	^ val! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/15/2006 14:46'!
evalSemaphore

	^ evalSemaphore ifNil: [Semaphore forMutualExclusion]! !

!LispKernel methodsFor: 'entry points' stamp: 'spfa 10/6/2006 14:25'!
evalString: aString

	"textual entry point to the Lisp interpreter for a single expression. 

	aString should contain well-formed lisp code. if it contains multiple expressions, only the first one will be evaluated and its value returned.

	because it is an entry point to the interpreter context, #evalCodeString: should never be sent form within a Lisp program; it should not be used by any primitive. use #read: and #eval instead.

	see #enterInterpreterContextAndEval: for the rationale"

	^ self enterInterpreterContextAndEval: 
		(self reader read: (ReadStream on: aString)) 

! !

!SLisp methodsFor: 'entry points' stamp: 'spfa 9/30/2006 23:11'!
evalString: aString

	syntax = #smalltalk ifFalse: [^ super evalString: aString].

	^ self eval: (self class rewrite: (Compiler evaluate: aString asString) asCons) inCons! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 3/27/2007 13:51'!
evalTailObject: anObject

	^ self evalObject: anObject multipleValue: true tail: true! !

!LispKernel methodsFor: 'entry points' stamp: 'spfa 11/7/2006 14:28'!
evalText: aString

	"textual entry point to the Lisp interpreter. 

	aString should contain well-formed lisp code. it can be a full program with multiple expressions: they will be evaluated sequentially at top-level, with the value of the last one returned

	because it is an entry point to the interpreter context, #evalText: should never be sent from within a Lisp program; it should not be used by any primitive. use #read: and #eval instead.

	see #enterInterpreterContextAndEval: for the rationale"

	| stream val cons |

	stream _ ReadStream on: aString.
	cons _ (LKIOPort input: stream) inCons.
	[stream atEnd] whileFalse: 
		[	| expr |
			expr _ self read: cons.
			expr == #'<eof>' ifTrue: [^ val].
			val _ self enterInterpreterContextAndEval: expr
		].

	^ val

! !

!LKREPLMorph methodsFor: 'contents' stamp: 'spfa 9/30/2006 15:20'!
evalText: aString

	^ lisp evalText: aString! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 9/30/2006 15:19'!
evalText: aString from: aPluggableTextMorph

	self evalText: aString.
	aPluggableTextMorph hasUnacceptedEdits: false.! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/23/2006 21:50'!
evalToValues: anObject

	| val |
	val _ self evalObject: anObject multipleValue: true.
	val isLKValues ifFalse: [^ LKValues with: val].		
	^ val
! !

!TailCallWrapper methodsFor: 'evaluating' stamp: 'spfa 11/17/2006 17:32'!
evaluate

	^ lisp evalProcedure: procedure withArgs: args id: id! !

!LKTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 11:45'!
evaluateSelection
	"Treat the current selection as an expression; evaluate it and return the result"

	self lineSelectAndEmptyCheck: [^ ''].
	^ model evalText: self selectionAsStream contents! !

!LispKernel class methodsFor: 'public' stamp: 'spfa 10/1/2006 00:11'!
evaluate: anObject

	^ self new evaluate: anObject! !

!LispKernel methodsFor: 'entry points' stamp: 'spfa 10/1/2006 00:12'!
evaluate: anObject

	"entry point to the Lisp interpreter. 

	anObject can be any acceptable data for Lisp. it is evaluated as is, without being converted nor transformed.

	because it is an entry point to the interpreter context, #evaluate: should never be sent from within a Lisp program; it should not be used by any primitive. use #evalObject: instead.

	see #enterInterpreterContextAndEval: for the rationale"

	^ self enterInterpreterContextAndEval: anObject

! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 9/30/2006 23:21'!
eval: aConsCell

"(eval FORM [ENVIRONMENT])
Evaluate FORM in the specified ENVIRONMENT (which defaults to the interaction top level), return its value"

	^ self eval: aConsCell car 
		inEnvironment: (aConsCell cadr ifNil: [self topmostLisp environment])

	
! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/24/2006 10:37'!
eval: anObject inEnvironment: aLKEnvironment

	^ (self copy
		environment: aLKEnvironment;
		upperLisp: self;
		upperTail: nil;
		upperHead: nil) evalObject: anObject multipleValue: true! !

!SScheme methodsFor: 'private - interpreter' stamp: 'spfa 10/24/2006 15:58'!
eval: anObject inEnvironment: aLKEnvironment

	macroEvalTemplate ifNil:
		[^ super eval: anObject inEnvironment: aLKEnvironment].

	^ (self copy
		environment: aLKEnvironment;
		upperLisp: self;
		upperTail: nil;
		upperHead: nil) macroEvalObject: anObject! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:32'!
evenP: aConsCell

"(evenp NUMBER)
Return #t if NUMBER is even."

	^ self class test: aConsCell car even

! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 7/1/2006 21:06'!
exactP: aConsCell

	"not implemented"

	^ self trueValue	! !

!LispKernel methodsFor: 'LISP-functions-debugging' stamp: 'spfa 6/12/2006 08:42'!
explore: aConsCell

"(explore OBJECT)
Open an Explorer on OBJECT, return OBJECT"

	aConsCell car explore.
	^ aConsCell car.
! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 6/5/2006 23:42'!
falseValue

	^ self class falseValue! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 6/5/2006 23:39'!
falseValue

	^ nil! !

!SLisp class methodsFor: 'booleans' stamp: 'spfa 6/7/2006 21:38'!
falseValue

	^ false! !

!ULisp class methodsFor: 'booleans' stamp: 'spfa 6/30/2006 18:33'!
falseValue

	^ false! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 6/18/2006 19:55'!
falseValuePrintString

	^ 'nil'! !

!SLisp class methodsFor: 'booleans' stamp: 'spfa 6/18/2006 19:55'!
falseValuePrintString

	^ 'false'! !

!ULisp class methodsFor: 'booleans' stamp: 'spfa 6/18/2006 19:54'!
falseValuePrintString

	^ '#f'! !

!LispKernel methodsFor: 'LISP-functions-predicates' stamp: 'spfa 9/30/2006 15:39'!
fboundp: aConsCell

"(fboundp SYMBOL)
Return t if SYMBOL's function is not void."	

	self symbolFunction: aConsCell car ifNone: [^ self falseValue].
	^ self trueValue
! !

!LispKernel methodsFor: 'private - variables' stamp: 'spfa 10/15/2006 14:51'!
features

	^ self symbolValue: #'*features*'	ifNone: [nil]! !

!ELisp methodsFor: 'LISP-functions-system' stamp: 'spfa 10/2/2006 11:29'!
fileExistsP: aConsCell

	^ self test: (FileDirectory default fileExists: 
					(FileDirectory default fullNameFor:aConsCell car))! !

!LispKitInfo methodsFor: 'as yet unclassified' stamp: 'spfa 3/29/2007 09:25'!
fileOutOnStream: aStream

	"we use this place as a hook for building the /ulisp archive"

	super fileOutOnStream: aStream.
	self makeUlispArchive! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/21/2007 23:12'!
filesInULispDirectory: dir

	^ ((FileDirectory default directoryNamed: 'ulisp') directoryNamed: dir) 
			fileNames 
			collect: [:fn | 'ulisp', FileDirectory slash, dir, FileDirectory slash, fn]! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:25'!
first

	^ car! !

!ELisp methodsFor: 'LISP-functions-math' stamp: 'spfa 10/25/2006 14:18'!
floor: aConsCell

	| x n |

	x _ aConsCell car.	
	n _ x floor.
	^ LKValues with: n with: x-n! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 7/19/2006 14:40'!
fmakunbound: aConsCell

"(fmakunbound SYMBOL)
Make SYMBOL's function be void."

	| s |
	s _ self checkSymbol: aConsCell car.
	(environment symbolFunctionsDictionaryFor: s) removeKey: s ifAbsent: [].
	^ s

	! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 11/7/2006 14:46'!
focusedREPL

	self standardOutputPort dependents ifEmpty: [^ nil].
	^ self standardOutputPort dependents first

! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 11/7/2006 14:46'!
focusOnREPL: aLKREPLMorph

	self standardOutputPort breakDependents; addDependent: aLKREPLMorph
! !

!LKIOPort methodsFor: '-- hacks --' stamp: 'spfa 10/20/2006 14:06'!
force
	"Force all pending output to be processed"
	self changed: #force.
	self stream reset! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 3/27/2007 15:03'!
forEach: aConsCell

	self map: aConsCell.
	^ nil! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:16'!
forInput

	^ self input: (ReadWriteStream on: Text new)
! !

!LKClosure methodsFor: 'accessing' stamp: 'spfa 6/2/2006 23:34'!
form

	^ form ! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 6/9/2006 21:57'!
formatForDocumentationString

	^ self collect: [:s |
		(s first = $& or: [s first = $:]) 
			ifTrue: [s] ifFalse: [s asUppercase asSymbol]]! !

!LKClosure methodsFor: 'accessing' stamp: 'spfa 6/2/2006 23:34'!
form: aConsCell

	form _ aConsCell! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:30'!
forOutput

	^ self output: (WriteStream on: Text new)
! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 10/6/2006 13:43'!
for: aLisp

	^ self new lisp: aLisp! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/9/2006 15:22'!
foundToken: aStream

	"tells weither a token can be read from aStream"

	[aStream atEnd not 
		and: [(self class syntacticTypes at: aStream peek asciiValue) == #whiteSpace]] 
	whileTrue: [aStream next].

	^ aStream atEnd not! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 10/10/2006 13:49'!
fullPrintStringForLisp: aLisp

	^ String streamContents: [:s | self printOn: s forLisp: aLisp]
! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 11/9/2006 16:07'!
funcall: aConsCell

"(funcall FUNCTION &rest ARGUMENTS)
Call FUNCTION as a function, passing remaining ARGUMENTS to it.
Return the value that function returns.
For example, (funcall $'cons $'x $'y) returns (x . y).
FUNCTION must not be a macro nor a special form."

	| form |

	form _ ConsCell car: aConsCell car.
	aConsCell cdr ifNotNil:
	[
		form lastCdr: (aConsCell cdr collect: [:arg | 
						ConsCell car: #quote: cdr: (ConsCell car: arg)])
	].

	^ self evalObject: form multipleValue: true! !

!LKFunctionsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 18:17'!
functions: anArray

	functions _ anArray! !

!LKHalt methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 22:32'!
functions: anArray

	functions _ anArray! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:04'!
function: aConsCell

"(function FN)
Return the functional interpretation of FN"

	"FN is symbol: simple redirection"
	aConsCell car isSymbol ifTrue: [^ self symbolFunction: aConsCell].

	"else FN is a lambda form. we don't check though.."

	"since #lambda: does the closure, we don't have to do anything here"		
	^ self evalObject: aConsCell car
	! !

!BlockContext methodsFor: '*LispKit' stamp: 'spfa 11/4/2006 14:54'!
gcbench

	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	^ self bench! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 11/14/2006 21:39'!
gcbench: aConsCell

"(gcbench FORM)
Perform a full garbage collect, then evaluate FORM repeatedly for 5 seconds, return the average number of times it was run per second. "

	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	^ [self evalObject: aConsCell car] bench asNumber! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/19/2006 14:16'!
gcd: aConsCell

"(gcd n1 ...)
Returns the greatest common divisor of its arguments"

	| n |
	n _ aConsCell car ifNil: [^ 0].

	aConsCell cdr do: [:m | n _ n gcd: m].
	^ n
	

! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/22/2006 20:54'!
gensym: aConsCell

"(gensym [PREFIX])
Generate a new uninterned symbol.
Its name is made by appending a number to PREFIX, default is 'g'"

	| n sym |

	n _ 0.
	[sym isNil or: [uninternedSymbols identityIncludes: sym]]
	whileTrue: 
		[sym _ self unintern: (aConsCell car ifNil: ['g']), (n _ n+1) asString n: n].
	uninternedSymbols add: sym.
	^ sym
	 ! !

!LKREPLMorph methodsFor: 'contents' stamp: 'spfa 6/7/2006 22:09'!
getMyText
	^myContents! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 23:11'!
getN1

	n1 _ number * sign. 
	nindex _ 0. 
	dot _ nil. 
	sign _ 1.
	number _ nil! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 10/12/2006 14:48'!
getNewEnvironment

	self environment: LKEnvironment new.

! !

!LKContinuation methodsFor: 'private' stamp: 'spfa 10/22/2006 23:58'!
getTopSenderFrom: aContext.

	aContext method == topMethod ifTrue: [^ aContext].

	^ self getTopSenderFrom: aContext sender.

	! !

!LKContinuation methodsFor: 'private' stamp: 'spfa 6/16/2006 13:32'!
getTopSendersFrom: aContext
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ self getTopSenderFrom: aContext. 

	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context _ context sender].
	^ valueStream contents! !

!LispKernel methodsFor: 'property lists' stamp: 'spfa 11/12/2006 18:58'!
get: aSymbol symbol: bSymbol

	| plist |

	plist _ self symbolPlists at: bSymbol ifAbsent: [^ nil].

	[plist notNil] whileTrue:
	[
		plist car == aSymbol ifTrue: [^ plist cadr].
		plist _ plist cddr
	].

	^ nil! !

!LispKernel class methodsFor: 'libraries' stamp: 'spfa 6/18/2006 18:56'!
glue

	"helpers for writing compatible code among dialects"

	^ 
	#(progn

		(defun yes* () #t)
		(defun no* () nil)

	)! !

!SLisp class methodsFor: 'libraries' stamp: 'spfa 6/18/2006 18:56'!
glue

	"helpers for writing compatible code among dialects"

	^ 
	#(progn

		(defun yes* () t)
		(defun no* () false)

	)! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 7/3/2006 15:34'!
glue

	"helpers for writing compatible code among dialects"

	^ 
	#(progn

		(defun yes* () true)
		(defun no* () false)

	)! !

!LKMonitor methodsFor: 'as yet unclassified' stamp: 'spfa 7/3/2006 14:02'!
goTopLevel! !

!LKTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 22:53'!
goTopLevel

	depth _ 0! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 10/3/2006 15:19'!
gui

	| window color |

	window _ (SystemWindow labelled: self guiLabel).
	self addDependent: window.

	color _ self guiColor.
	window setProperty: #paneColor toValue: color.

	window addMorph: (
		 LKPluggableTextMorph 
			on: self text: nil accept: #evalText:from: readSelection: nil
		menu: #buildMenu:)
		frame: (0@0 corner: 1@0.5).

	window addMorph: (	LKREPLMorph lisp: self)
		frame: (0@0.5 corner: 1@1).

	^ window
! !

!CLisp methodsFor: 'GUI' stamp: 'spfa 6/2/2006 23:36'!
guiColor

	^ Color green darker darker blacker! !

!ELisp methodsFor: 'GUI' stamp: 'spfa 11/14/2006 15:12'!
guiColor

	^ (Color r: 0.0 g: 0.452 b: 0.677) lighter
	! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 11/14/2006 15:13'!
guiColor

	^ Color orange
	! !

!SLisp methodsFor: 'initialization' stamp: 'spfa 6/2/2006 09:59'!
guiColor

	^ Color r: 0.8 g: 0.648 b: 0.344
	! !

!SScheme methodsFor: 'GUI' stamp: 'spfa 11/14/2006 15:17'!
guiColor

	^ (Color r: 0.6 g: 0.3 b: 0.6) lighter! !

!StaticLisp methodsFor: 'GUI' stamp: 'spfa 6/5/2006 20:56'!
guiColor

	^ Color green darker darker blacker! !

!ULisp methodsFor: 'GUI' stamp: 'spfa 6/6/2006 22:34'!
guiColor

	^ (Color r: 0.8 g: 0.664 b: 0.8) darker! !

!LispKernel class methodsFor: 'GUI' stamp: 'spfa 10/3/2006 15:19'!
guiLabel

	^ self name
! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 10/3/2006 15:20'!
guiLabel

	^ self class guiLabel
! !

!LispKernel methodsFor: 'LISP-functions-debugging' stamp: 'spfa 6/1/2006 14:32'!
halt: aConsCell

"(halt)
Halt the evaluation and open a Smalltalk debugger"

	^ self halt! !

!CLisp methodsFor: 'private - special variables' stamp: 'spfa 10/13/2006 09:30'!
hasDynamicValue: aSymbol

	"tells if a value is dynamically bound to aSymbol."

	 self dynamicSymbolValues at: aSymbol 
		ifAbsent: [^ (upperLisp ifNil: [^ false]) hasDynamicValue: aSymbol].
	
	^ true
						
	! !

!CLisp methodsFor: 'private - special variables' stamp: 'spfa 10/12/2006 22:57'!
hasGlobalDynamicValue: aSymbol

	"at top-level, having aSymbol in specialVariables means it is globally dynamic"

	^ self topmostLisp specialVariables includes: aSymbol

						
	! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 3/24/2007 18:40'!
hash
	"Hash is reimplemented because = is implemented."

	self isCircular ifTrue: [^ self withCut hash].

	^ car hash bitXor: cdr hash.! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 10/12/2006 22:45'!
hasValue: aSymbol

	"tells if a value is bound to aSymbol."

	 self symbolValues at: aSymbol 
		ifAbsent: [^ (upperBindings ifNil: [^ false]) hasValue: aSymbol].
	
	^ true
	! !

!LKREPLMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2006 14:11'!
historyLength

	^ 30! !

!TailCallWrapper methodsFor: 'accessing' stamp: 'spfa 11/17/2006 17:32'!
id

	^ id ! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:07'!
identity: aConsCell

"(identity ARG)
Return ARG itself, unchanged"

	^ aConsCell car! !

!TailCallWrapper methodsFor: 'accessing' stamp: 'spfa 11/17/2006 17:32'!
id: aSymbol

	id _ aSymbol! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/21/2006 16:00'!
if: aConsCell

"(if COND THEN &rest ELSE)
If COND yields non-nil, do THEN, else do ELSE
Returns the value of THEN or the value of the last of the ELSE's.
If COND yields nil and there is no ELSE, return nil."

	^ ((self evalObject: (aConsCell nth: 0)) == self falseValue)
		ifFalse: [self evalTailObject: (aConsCell nth: 1)]
		ifTrue: [(aConsCell nthCell: 2 ifAbsent: [^ self falseValue])
					doWithCdr: [:c :cdr | 
						cdr ifNil: [^ self evalTailObject: c].
						self evalObject: c]]
! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 10/14/2006 18:08'!
ignoreCase

	ignoreCase _ true! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 10/14/2006 18:08'!
ignoresCase

	^ ignoreCase! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 6/18/2006 14:45'!
inArray: aStream

	| k |

	k _ car isConsCell ifTrue: [car arrayForm] ifFalse: [car].
	k ifNil: [k _ #()].

	cdr isNil ifTrue: [^ aStream nextPut: k].
	cdr isConsCell ifTrue: [^ aStream nextPut: k; nextPutAll: cdr arrayForm].
	self error: 'Not a list'
! !

!Object methodsFor: '*LispKit' stamp: 'spfa 5/31/2006 21:21'!
inCons

	^ ConsCell car: self! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 7/1/2006 20:38'!
inexactP: aConsCell

	"not implemented"

	^ self falseValue	! !

!CLisp methodsFor: 'initialization' stamp: 'spfa 11/26/2006 22:28'!
initialize

	dynamicSymbolValues _ IdentityDictionary new.
	specialVariables _ IdentitySet new.
	super initialize.
! !

!ELisp methodsFor: 'private - symbols' stamp: 'spfa 10/22/2006 21:28'!
initialize

	super initialize.
	uninternedSymbols _ WeakSet new! !

!LispKernel class methodsFor: 'private' stamp: 'spfa 8/14/2006 21:20'!
initialize

	"LispKernel initialize"

	QuotingSugar _ Dictionary
				with: $' -> #quote
				with: #` -> #quasiquote
				with: #, -> #unquote
				with: #,@ -> #'unquote-splicing'.

	QuotingSugar add: #'#`' -> #function:.

	Preferences 
		addPreference: #lispKitDebugOnError
		categories: #(lisp) 
		default: false 
		balloonHelp: 'when true, a GUI appears upon any lisp interpreter error'.

	self withAllSubclasses do: [:lisp | lisp compilePrimitiveLists]


	! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 11/26/2006 22:22'!
initialize

	topmostLisp _ self.
	ignoreCase _ false.

	self getNewEnvironment.
	constantVariables _ IdentitySet new.
	self defineDefaultBindings.
	self definePrimitiveAliases.


! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2006 15:11'!
initialize

	symbolFunctions _ IdentityDictionary new.
	symbolValues _ IdentityDictionary new.
	symbolPlists _ IdentityDictionary new.! !

!LKFunctionsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 18:16'!
initialize

	functions _ #()! !

!LKHalt methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 22:32'!
initialize

	functions _ #()! !

!LKREPLMorph methodsFor: 'initialization' stamp: 'spfa 10/17/2006 22:14'!
initialize
	super initialize.
	self extent: 600@400.
	self color: Color white.
	self acceptOnCR: true.
	getMenuSelector _ #buildMenu:.


	! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 11/20/2006 00:07'!
initialize

	"see Common Lisp the Language, 2nd edition, section 22.1.1"

	SyntacticTypes _ Array new: 256 withAll: #constituent. "default"
	SyntacticTypes 
		atAll: #(9 10 12 13 32 ) put: #whiteSpace. "tab lf ff cr space"

	SyntacticTypes 
		atAll: (#($" $; $' $( $) $, $`) collect: [:c | c asciiValue]) 
		put: #terminatingMacro.

	SyntacticTypes at: $\ asciiValue put: #singleEscape.
	SyntacticTypes at: $| asciiValue put: #multipleEscape.
	SyntacticTypes at: $# asciiValue put: #nonTerminatingMacro.
	
	Macros _ Dictionary new.
	{
		$# -> #sharpMacro:.
		$( -> #openList:.
		$) -> #closeList:.
		$' -> #quote:.
		$; -> #comment:.
		$" -> #string:.
		$` -> #backquote:.
		$, -> #unquote:.
	}
	do: [:assoc | Macros add: assoc].

	SharpMacros _ Dictionary new.
	{
		$# -> #sharpLabelReference:n:.
		$( -> #sharpVector:n:.
		$' -> #sharpFunction:n:.
		$* -> #sharpBitVector:n:.
		$= -> #sharpLabel:n:.
		$\ -> #sharpCharacter:n:.
		$, -> #sharpLoadTimeEvaluation:n:.
		$| -> #sharpBalancedComment:n:.
		$- -> #sharpReadTimeUnless:n:.
		$+ -> #sharpReadTimeWhen:n:.
		$. -> #sharpReadTimeEvaluation:n:.
		$: -> #sharpUninternedSymbol:n:.
		$a -> #sharpArray:n:.
		$A -> #sharpArray:n:.
		$b -> #sharpBinaryRational:n:.
		$B -> #sharpBinaryRational:n:.
		$c -> #sharpComplexNumber:n:.
		$C -> #sharpComplexNumber:n:.
		$o -> #sharpOctalRational:n:.
		$O -> #sharpOctalRational:n:.
		$p -> #sharpPathName:n:.
		$P -> #sharpPathName:n:.
		$r -> #sharpRadixNRational:n:.
		$R -> #sharpRadixNRational:n:.
		$s -> #sharpStructure:n:.
		$S -> #sharpStructure:n:.
		$x -> #sharpHexaRational:n:.
		$X -> #sharpHexaRational:n:.
		$; -> #sharpComment:n:.
	}
	do: [:assoc | SharpMacros add: assoc].

	CharacterNames _ Dictionary new.
	{
		'newline' -> Character lf.
		'tab' -> Character cr.
		'linefeed' -> Character linefeed.
		'space' -> Character space.			
		'backspace' -> Character backspace.			
		'escape' -> Character escape.			
		'return' -> Character cr.			
		'rubout' -> Character delete.	
	}
	do: [:assoc | CharacterNames add: assoc].

	"self initialize"! !

!LKSymbolsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 18:25'!
initialize

	symbols _ #()! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/14/2006 17:59'!
initialize

	couldBeNumber _ true.
	couldBeFraction _ couldBeExponent _ true.
	base _ 10.
	number _ nil.
	dot _ n1 _ nil.
	sign _ 1.
	nindex _ 0.

! !

!SLisp class methodsFor: 'private-subclasses may implement' stamp: 'spfa 7/8/2006 21:17'!
initialize

	"SLisp initialize"

	Sugar _ Dictionary
			with: $' -> #quote
			with: #` -> #quasiquote
			with: #, -> #unquote
			with: #,@ -> #'unquote-splicing'.

	Sugar add: $# -> #quotedLispInSmalltalkSyntax:
! !

!SLisp methodsFor: 'initialization' stamp: 'spfa 6/8/2006 16:06'!
initialize

	syntax _ #lisp.
	super initialize.! !

!SLispReader class methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 20:36'!
initialize

	super initialize.

	SyntacticTypes 
		atAll: (#($[ $] ${ $}) collect: [:c | c asciiValue]) 
		put: #terminatingMacro.

	{
		$[ -> #lispInSmalltalkSyntax:.
		$] -> #closeList:.
		${ -> #withSmalltalkSyntax:.
		$} -> #closeList:.
	}
	do: [:assoc | Macros add: assoc].

	"self initialize"! !

!ULisp methodsFor: 'private - initialization' stamp: 'spfa 10/23/2006 18:52'!
initialize

	super initialize.

	self class primitives do: [:prim  | 
		self symbolValuesAdd: prim -> (LKPrimitive selector: prim for: self)].

	! !

!ULispReader class methodsFor: 'as yet unclassified' stamp: 'spfa 11/13/2006 10:36'!
initialize

	super initialize.

	{
		$f -> #sharpFalse:n:.
		$t -> #sharpTrue:n:.
		$F -> #sharpFalse:n:.
		$T -> #sharpTrue:n:.
		$d -> #sharpReadNumber:n:.
		$i -> #sharpReadInexactNumber:n:
	}
	do: [:assoc | SharpMacros add: assoc].

	" [..] for PLT Scheme compatibility:"

	SyntacticTypes 
		atAll: (#($[ $]) collect: [:c | c asciiValue]) 
		put: #terminatingMacro.

	{
		$[ -> #openList:.
		$] -> #closeList:.
	}
	do: [:assoc | Macros add: assoc].

	"self initialize"! !

!ULispToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2006 00:30'!
initialize

	super initialize.
	couldBeComplex _ true.
	startWithSign _ false.
	i _ nil


! !

!ULisp methodsFor: 'private - initialization' stamp: 'spfa 11/21/2006 15:03'!
initializeEnvironments

	initialEnvironment _ environment.
	userEnvironment _ environment _ environment newChild.
! !

!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
initializeFromContext: aContext
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context _ context sender].
	values _ valueStream contents! !

!LKContinuation methodsFor: 'private' stamp: 'spfa 10/23/2006 14:36'!
initializeFromContext: aContext upTo: aMethod
	| valueStream context topSender |
	valueStream _ WriteStream on: (Array new: 20).
	context _ aContext.

	topMethod _ aMethod.

	topSender _ self getTopSenderFrom: aContext.

	[context notNil and: [context ~= topSender]] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context _ context sender].
	values _ valueStream contents! !

!SScheme methodsFor: 'private - initialization' stamp: 'muOuser 3/27/2007 22:27'!
initializeMacroExpander

	macroEvalTemplate _ #macro:expand inCons addLast: #anObject inQuotedCons.
	macroEvalSlot _ macroEvalTemplate cadr cdr
! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 11/7/2006 14:29'!
inputPortP: aConsCell

"(input-port? OBJECT)
Returns #t if OBJECT is an input port, #f otherwise"
	
	^ self test: (aConsCell car isLKIOPort and: [aConsCell car isInput])! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 12/1/2006 15:16'!
input: aStream

	aStream ifNil: [self error: 'no stream specified'].

	^ self new 
		status: #in;
		inStream: aStream! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:11'!
input: aStream output: bStream

	^ self new 
		status: #bi;
		outStream: aStream;
		inStream: aStream! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/21/2006 14:01'!
inQuotedCons

	^ (ConsCell car: #quote) addLast: self! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:04'!
inStream

	^ inStream ! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:04'!
inStream: aStream

	inStream _ aStream! !

!LKREPLMorph methodsFor: 'command processing' stamp: 'spfa 6/8/2006 14:12'!
insertCommand: aString

	textMorph newContents: 
		(myContents ifNil: [self prompt asText]), 
		((Text fromString: aString) 	addAttribute: self class commandAttribute)! !

!LKTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2006 23:30'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray _ priorEditor stateArray].
	editor _ LKTextMorphEditor new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:58'!
integerP: aConsCell

"(integerp OBJECT)
Return #t if OBJECT is an Integer."

	^ self test: aConsCell car isInteger

! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/1/2006 21:58'!
integerTOchar: aConsCell

	^ Character value: aConsCell car! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 10/24/2006 19:01'!
interactionEnvironment: ignored

	^ userEnvironment

! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/20/2006 13:21'!
interactivelyFeedInputStream

	| str |

	str _ FillInTheBlank request: 'input'.
	self standardInput stream nextPutAll: str.
	self standardInput stream skip: str size negated! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 22:40'!
intern: aConsCell

"(intern STRING)
Return the symbol with name STRING"

	^ aConsCell car asSymbol

	! !

!String methodsFor: '*LispKit' stamp: 'spfa 10/6/2006 22:49'!
isAllLetters
	"whether the receiver is composed entirely of letters"
	self do: [:c | c isLetter ifFalse: [^ false]].
	^ true! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 3/24/2007 16:16'!
isCircular

	^ self isCircular: IdentitySet new
! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 3/24/2007 16:16'!
isCircular: anIdentitySet

	cdr isConsCell ifFalse: [^ false].
	(anIdentitySet includes: cdr) ifTrue: [^ true].

	anIdentitySet add: self.
	^ cdr isCircular: anIdentitySet ! !

!LKBlock methodsFor: 'as yet unclassified' stamp: 'spfa 11/19/2006 20:21'!
isCompiled 

	^ true! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/19/2006 20:21'!
isCompiled

	^ false! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 5/24/2006 19:45'!
isConsCell

	^ true! !

!Object methodsFor: '*LispKit' stamp: 'spfa 5/24/2006 19:45'!
isConsCell

	^ false! !

!Continuation methodsFor: 'testing' stamp: 'spfa 6/18/2006 22:14'!
isContinuation

	^ true! !

!Object methodsFor: '*LispKit' stamp: 'spfa 6/18/2006 22:14'!
isContinuation

	^ false! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:06'!
isInput

	^ status == #in! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 3/27/2007 14:36'!
isLexical

	^ false! !

!StaticLisp methodsFor: 'private-closures' stamp: 'spfa 3/27/2007 14:35'!
isLexical

	^ true! !

!LKClosure methodsFor: 'testing' stamp: 'spfa 6/15/2006 20:47'!
isLispClosure

	^ true! !

!Object methodsFor: '*LispKit' stamp: 'spfa 6/15/2006 20:48'!
isLispClosure

	^ false! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 9/24/2006 10:07'!
isList

	^ self isList: (IdentitySet with: self)! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 9/24/2006 10:07'!
isList: anIdentitySet

	(anIdentitySet includes: cdr) ifTrue: [^ false].
	anIdentitySet add: self.
	^ cdr isNil or: [cdr isConsCell and: [cdr isList: anIdentitySet]]! !

!LKContinuation methodsFor: 'testing' stamp: 'spfa 6/16/2006 13:43'!
isLKContinuation

	^ true! !

!Object methodsFor: '*LispKit' stamp: 'spfa 6/16/2006 13:43'!
isLKContinuation

	^ false! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 11/7/2006 14:29'!
isLKIOPort

	^ true! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/7/2006 14:29'!
isLKIOPort

	^ false! !

!LKPrimitive methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 16:27'!
isLKPrimitive

	^ true
! !

!Object methodsFor: '*LispKit' stamp: 'spfa 10/19/2006 16:27'!
isLKPrimitive

	^ false! !

!LKValues methodsFor: 'as yet unclassified' stamp: 'spfa 10/23/2006 21:49'!
isLKValues

	^ true! !

!Object methodsFor: '*LispKit' stamp: 'spfa 10/23/2006 20:52'!
isLKValues

	^ false! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:06'!
isOutput

	^ status == #out! !

!ConsCell methodsFor: 'procedure protocol' stamp: 'spfa 11/17/2006 15:27'!
isProcedure

	^ car == #lambda or: [car == #macro]! !

!LKClosure methodsFor: 'testing' stamp: 'spfa 11/17/2006 15:27'!
isProcedure

	^ form isProcedure! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/17/2006 15:27'!
isProcedure

	"protocol for a lisp procedure:
#environment -> return a Dictionary or nil
#lambdaForm -> return a lambda or macro expression (a ConsCell)
#isProcedure -> return true"

	^ false! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/27/2006 13:07'!
isQuotedCons

	^ car == #quote or: [car == #quote:]! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/27/2006 13:07'!
isQuotedCons

	^ false! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 11/27/2006 13:07'!
isQuotedSymbol

	^ (car == #quote or: [car == #quote:]) and: [cdr car isSymbol]! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/27/2006 13:07'!
isQuotedSymbol

	^ false! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/17/2006 13:35'!
isTailCall
	
	^ false! !

!TailCallWrapper methodsFor: 'testing' stamp: 'spfa 11/17/2006 13:35'!
isTailCall
	
	^ true! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:07'!
isTwoWay

	^ status == #bi! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 3/21/2007 23:19'!
jacal

	"JACAL, an interactive symbolic mathematics program, by Aubrey Jaffer

	http://www-swiss.ai.mit.edu/~jaffer/JACAL.html
	"

	^#(in-library jacal
			(#'slib:load' (system-path 'ulisp/jacal/math')))


! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/21/2007 23:15'!
jacalFiles

	^ self filesInULispDirectory: 'jacal'! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/21/2007 23:12'!
kanrenFiles

	^ self filesInULispDirectory: 'minikanren'! !

!LKTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 14:38'!
keyStroke: evt
	
"	editView lisp standardInput stream nextPut: evt keyCharacter."
	super keyStroke: evt! !

!LispKernel methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/22/2006 21:50'!
keywordP: aConsCell

"(keywordp SYMBOL)
Return t if SYMBOL is a keyword"	

	^ self class test: (aConsCell car isSymbol and: [aConsCell car first == $:]) 
! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/22/2006 21:58'!
keywordP: aConsCell

	"keyword? is not a valid Scheme function"	

	self lispError: 'keyword? is currently undefined in ULisp'
! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/27/2006 14:21'!
LISPand: aConsCell

"(and &rest CONDITIONS)
Eval CONDITIONS until one of them yields nil, then return nil.
The remaining conditions are not evaluated at all.
If no condition yields nil, return the last arg's value."

	| val |

	(aConsCell ifNil: [^ self trueValue])  doWithCdr: [:form :cdr |
		val _ cdr ifNil: [self evalTailObject: form]
			ifNotNil: [self evalObject: form].
		(val asOneLispValue ==  self falseValue) ifTrue: [^ self falseValue]].

	^ val
! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/19/2006 22:59'!
LISPor: aConsCell

"(or &rest CONDITIONS)
Eval CONDITIONS until one of them yields non-nil, then return that value.
The remaining args are not evaluated at all.
If all args return nil, return nil."

	|  val |

	(aConsCell ifNil: [^ self falseValue]) doWithCdr: [:form :cdr | 
		val _ cdr ifNil: [self evalTailObject: form]
			ifNotNil: [self evalObject: form multipleValue: true].
		(val asOneLispValue == self falseValue) ifFalse: [^ val]].

	^ self falseValue
! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/9/2006 14:11'!
labels

	^ labels ifNil: [labels _ Dictionary new]! !

!ConsCell methodsFor: 'procedure protocol' stamp: 'spfa 11/17/2006 17:16'!
lambdaForm

	(car == #lambda or: [car == #macro])
		ifTrue: [^ self] ifFalse: [self error: 'not a lambda form']! !

!LKClosure methodsFor: 'lambda protocol' stamp: 'spfa 6/3/2006 00:16'!
lambdaForm

	^ form! !

!ELisp methodsFor: 'private - subclasses may implement' stamp: 'spfa 11/17/2006 18:53'!
lambdaForm: aSymbol withArgsAndBody: aConsCell

	"this implementation relies on the Lisp code in library #argumentsList (see class-side) to redefine all supported arg list keywords (&key, &aux etc.) in terms of &rest and &optional only"

	(aConsCell car notNil
	and: [self class wantsFullArgumentsListsSupport]
	and: [(self fboundp: #'deploy-arguments-list' inCons) = self trueValue])
		ifFalse: [^ ConsCell car: aSymbol cdr: aConsCell ].

	aConsCell car detect: [:form | 
		form isConsCell
		or: [form first = $&
			 and: [(#(#'&rest' #'&body' #'&optional') identityIncludes: form) not]]]
		ifNone: [^ ConsCell car: aSymbol cdr: aConsCell ].

	^ self evalObject: ((ConsCell car: #'deploy-arguments-list') 
							addLast: aSymbol;
							append: aConsCell)
			 multipleValue: true.
! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 6/22/2006 22:01'!
lambdaForm: aSymbol withArgsAndBody: aConsCell

	"build and return the actual form representing the lambda form 
(lambdatype (args) ... body ...)
	where lambdatype is aSymbol, either #lambda or #macro
	(args) is aConsCell car
	... (body) ... is aConsCell cdr"

	"this implementation does nothing special"
	^ ConsCell car: aSymbol cdr: aConsCell 
! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 6/9/2006 14:28'!
lambda: aConsCell

"(lambda ARGS &rest BODY)
Return a lambda expression.
A call of the form (lambda ARGS &rest BODY) is self-quoting: the result of evaluating the lambda expression is the expression itself.  
A lambda expression has the semantic of a function"

	^ self lambdaForm: #lambda withArgsAndBody: aConsCell
! !

!StaticLisp methodsFor: 'LISP-special forms' stamp: 'spfa 6/5/2006 20:56'!
lambda: aConsCell

"(lambda ARGS &rest BODY)
Return a lambda expression.
A call of the form (lambda ARGS &rest BODY) is self-quoting: the result of evaluating the lambda expression is the expression itself.  
A lambda expression has the semantic of a function"

	^ self makeClosureFor: aConsCell as: #lambda
! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:25'!
last

	^ cdr ifNil: [self] ifNotNil: [cdr last]! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 11/9/2006 16:00'!
lastCdr: anObject

	cdr 
		ifNil: [self setcdr: anObject]
		ifNotNil: [cdr isConsCell 
					ifTrue: [cdr lastCdr: anObject] ifFalse: [self error: 'not a list']].
	! !

!SequenceableCollection methodsFor: '*LispKit' stamp: 'spfa 10/3/2006 10:29'!
lastIndexOfSubCollection: sub ifAbsent: exceptionBlock
	"Answer the index of the receiver's last element, such that that element 
	equals the first element of sub, and the next elements equal 
	the rest of the elements of sub. Begin the search at element 
	end of the receiver. If no such match is found, answer the result of 
	evaluating argument, exceptionBlock."
	| first index |
	sub isEmpty ifTrue: [^ exceptionBlock value].
	first _ sub first.
	self size - sub size + 1 to: 1 by: -1 do:
		[:startIndex |
		(self at: startIndex) = first ifTrue:
			[index _ 1.
			[(self at: startIndex+index-1) = (sub at: index)]
				whileTrue:
				[index = sub size ifTrue: [^startIndex].
				index _ index+1]]].
	^ exceptionBlock value! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:07'!
last: aConsCell

"(last X [N])
Return the last link of the list X.  Its car is the last element.
If X is nil, return nil.
If N is non-nil, return the Nth-to-last link of X.
If N is bigger than the length of X, return X."

	| n |

	aConsCell car ifNil: [^ nil].
	(n _ aConsCell cadr) ifNil: [^ aConsCell car last]
		ifNotNil: [ | len |
					len _ aConsCell length.
					^ aConsCell car nthcdr: ((len - n + 1) max: 0)]
	! !

!ULisp methodsFor: 'LISP-functions-beware' stamp: 'spfa 10/2/2006 11:12'!
last: aConsCell

"(last LIST)
Return the last element of LIST"

"BEWARE: this is not the same semantics as the last function in Common Lisp
see SRFI-1"

	aConsCell car ifNil: [self lispError: 'list expected'].
	^ aConsCell car last car
	! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/19/2006 14:16'!
lcm: aConsCell

"(lcm n1 n2)
Returns the least common multiple of its arguments"

	aConsCell car ifNil: [^ 1].
	aConsCell cdr cadr ifNotNil: [self lispError: 'too many arguments for lcm'].
	"to be fixed... "	

	^ ((self * aConsCell) // (self gcd: aConsCell)) abs



! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:33'!
length

	cdr isNil ifTrue: [^ 1].
	cdr isConsCell ifFalse: [self error: 'not a list'].
	^ cdr length + 1
! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 11/20/2006 13:22'!
length: aConsCell

"(length SEQUENCE)
Return the length of vector, list or string SEQUENCE."

	(aConsCell car isString or: [aConsCell car isArray])
		ifTrue: [^ aConsCell car size].

	^ (aConsCell car ifNil: [^ 0]) length! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'muOuser 3/27/2007 22:16'!
letrec: aConsCell

"(let VARLIST &rest BODY)
Bind variables according to VARLIST then eval BODY.
The value of the last form in BODY is returned.
Each element of VARLIST is a symbol (which is bound to nil) or a list (SYMBOL VALUEFORM) (which binds SYMBOL to the value of VALUEFORM).
All the VALUEFORMs are evaluated before any symbol is bound."

	| sublisp |

	sublisp _ self subLisp: #letrec form: aConsCell body: aConsCell cdr. 

	aConsCell first ifNotNil:
	[
		(aConsCell first do: [:form | | sym |
			sym _ sublisp checkSymbol: (form isSymbol
										ifTrue: [form ] ifFalse: [form first]).
			sublisp symbolValuesAdd: sym -> nil]).

		(aConsCell first collect: [:form | 
			form isSymbol
				ifTrue: [form -> nil]
				ifFalse: [form first -> (sublisp evalObject: (form nth: 1))]])
			do: [:v | sublisp symbolValuesAdd: v]
	].

	((aConsCell nthCell: 1) ifNil: [^ nil]) 
		doWithCdr: [:c :cdr | 
			cdr ifNil: [^ sublisp evalTailObject: c]. 
			sublisp evalObject: c]
! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 20:30'!
letStar: aConsCell

"(let* VARLIST &rest BODY)
Bind variables according to VARLIST then eval BODY.
The value of the last form in BODY is returned.
Each element of VARLIST is a symbol (which is bound to nil) or a list (SYMBOL VALUEFORM) (which binds SYMBOL to the value of VALUEFORM).
Each VALUEFORM can refer to the symbols already bound by this VARLIST."

	| sublisp |

	sublisp _ self subLisp: #'let*' form: aConsCell body: aConsCell cdr. 

	aConsCell first ifNotNil:
	[
		aConsCell first do: [:form |
			sublisp checkSymbol: (form isSymbol
					ifTrue: [form]	ifFalse: [form first]). 
			sublisp symbolValuesAdd: 
				(form isSymbol
					ifTrue: [form -> nil]
					ifFalse: [form first -> (sublisp evalObject: (form nth: 1))])]
	].

	((aConsCell nthCell: 1) ifNil: [^ nil]) 
		doWithCdr: [:c :cdr | 
			cdr ifNil: [^ sublisp evalTailObject: c].
			sublisp evalObject: c]
! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 20:30'!
let: aConsCell

"(let VARLIST &rest BODY)
Bind variables according to VARLIST then eval BODY.
The value of the last form in BODY is returned.
Each element of VARLIST is a symbol (which is bound to nil) or a list (SYMBOL VALUEFORM) (which binds SYMBOL to the value of VALUEFORM).
All the VALUEFORMs are evaluated before any symbol is bound."

	| sublisp |

	sublisp _ self subLisp: #let form: aConsCell body: aConsCell cdr. 

	aConsCell first ifNotNil:
	[
		(aConsCell first collect: [:form | 
			sublisp checkSymbol: (form isSymbol
					ifTrue: [form]	ifFalse: [form first]). 
			form isSymbol
				ifTrue: [form -> nil]
				ifFalse: [form first -> (self evalObject: (form nth: 1))]])
			do: [:v | sublisp symbolValuesAdd: v]
	].

	((aConsCell nthCell: 1) ifNil: [^ nil]) 
		doWithCdr: [:c :cdr | 
			cdr ifNil: [^ sublisp evalTailObject: c].
			sublisp evalObject: c]! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/24/2006 10:50'!
let: aConsCell

"(let VARLIST &rest BODY)
Bind variables according to VARLIST then eval BODY.
The value of the last form in BODY is returned.
Each element of VARLIST is a symbol (which is bound to nil) or a list (SYMBOL VALUEFORM) (which binds SYMBOL to the value of VALUEFORM).
All the VALUEFORMs are evaluated before any symbol is bound."

	| name vars vals forms |

	(name _ aConsCell first) isSymbol ifFalse: [^ super let: aConsCell].

	"named let"

	forms _ aConsCell nthcdr: 2.
	aConsCell second 
		ifNil: [vars _ vals _ nil]
		ifNotNil: [
	vars _ aConsCell second collect: [:form | form first].
	vals _ aConsCell second collect: [:form | ConsCell car: #begin cdr: form cdr]].

	^ self evalObject: 
	(((ConsCell car: #letrec:)
		addLast: (((ConsCell car: name) 
					addLast: ((ConsCell car: #lambda) addLast: vars; 
					append: forms)) inCons);
		addLast: name) inCons
		append: vals) multipleValue: true


! !

!String methodsFor: '*LispKit' stamp: 'spfa 6/6/2006 13:06'!
linkAtCaps
	| stream  |
	stream _ WriteStream on: (self species new: self size * 2).
	self do: [ :c |
		c isUppercase 
			ifTrue: [ stream nextPut: $-; nextPut: c asLowercase ]
			ifFalse: [ stream nextPut: c ].
	].
	^stream contents! !

!LKPrimitive methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 16:24'!
lisp

	^ lisp ! !

!LKREPLMorph methodsFor: 'initialization' stamp: 'spfa 5/26/2006 09:51'!
lisp

	^ lisp ! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/6/2006 13:43'!
lisp

	^ lisp ! !

!TailCallWrapper methodsFor: 'accessing' stamp: 'spfa 11/17/2006 17:34'!
lisp

	^ lisp! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 9/25/2006 14:07'!
lispCode

	^ self! !

!LKClosure methodsFor: 'accessing' stamp: 'spfa 9/25/2006 13:11'!
lispCode

	^ form ! !

!LKPrimitive methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 17:18'!
lispCode

	^ (lisp class ultimateSourceCodeAt: selector 
		ifAbsent: [self error: 'missing primitive']) asString! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 6/22/2006 22:09'!
lispDoesNotUnderstand: aMessage

	"HOOK"

	"aMessage was sent to the lisp interpreter as a primitive invocation, but primitive there is not. 
	can we do something about it ?"

	self errorUndefinedFunction: aMessage selector

! !

!SLisp methodsFor: 'smalltalk invocation' stamp: 'spfa 6/1/2006 19:28'!
lispDoesNotUnderstand: aMessage

	"SLisp understands just everything since it converts all weird forms into message sends.
	you may still get a DNU from Smalltalk of course"

	| object sel args |
	
	object _ aMessage argument car.
	args _ aMessage argument cdr.
	args _ args ifNil: [#()] ifNotNil: [args arrayForm].
	sel _ aMessage selector.

	^ object perform: sel withArguments: args! !

!LispKernel class methodsFor: 'util' stamp: 'spfa 6/18/2006 22:47'!
lispError: aString

	^ LispError new signal: aString! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 8/14/2006 21:17'!
lispError: aString

	(Preferences lispKitDebugOnError 
		and: [self topLevelLisp ~~ self]) ifTrue: [self debug].

	^ LispError new signal: aString

! !

!SLispReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 20:35'!
lispInSmalltalkSyntax: aStream

	^ #lispInSmalltalkSyntax: inCons addLast: (self openList: aStream)! !

!Object methodsFor: '*LispKit' stamp: 'spfa 3/23/2007 17:39'!
lispPrintString

	^ self printStringForLisp: nil.! !

!LKPrimitive methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 16:24'!
lisp: aLisp

	lisp _ aLisp! !

!LKREPLMorph methodsFor: 'initialization' stamp: 'spfa 11/7/2006 14:46'!
lisp: aLispKernel

	lisp _ aLispKernel.

	self appendEntry; outputQueue.
	lisp standardOutputPort stream reset.

	textMorph newContents: (myContents _ myContents, self prompt).
	self refreshDisplay.
	lisp focusOnREPL: self.


! !

!LKREPLMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 09:51'!
lisp: aLispKernel

	^ self new lisp: aLispKernel! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/6/2006 13:43'!
lisp: aLisp

	lisp _ aLisp! !

!TailCallWrapper methodsFor: 'accessing' stamp: 'spfa 11/17/2006 17:29'!
lisp: aLisp

	lisp  _ aLisp! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 6/8/2006 22:01'!
listCopy

	^ self copy setcdr: (cdr isConsCell ifFalse: [cdr] ifTrue: [cdr listCopy])
! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:35'!
listP: aConsCell

"(listp OBJECT)
Return #t if OBJECT is a list. "

	aConsCell ifNil: [self lispError: 'one argument is required'].
	aConsCell car ifNil: [^ self trueValue].
	^ self class test: (aConsCell car isConsCell and: [aConsCell car isList])! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 6/6/2006 22:01'!
listRef: aConsCell

"(list-ref LIST N)
Return the Nth element of LIST.
N counts from zero.  If LIST is not that long, an error is raised"

	^ aConsCell car nth: aConsCell cadr ifAbsent: [self lispError: 'index out of range']
! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 6/6/2006 22:06'!
listTail: aConsCell

"(list-tail LIST N)
Return the elements of LIST after the Nth one.
N counts from zero.  If LIST is not that long, an error is raised"

	^ aConsCell car nthcdr: aConsCell cadr ifAbsent: [self lispError: 'index out of range']
! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 8/4/2006 01:06'!
listTOstring: aConsCell

	^ String streamContents: [:str |
			(aConsCell car ifNil: [^ '']) do: [:car | str nextPut: car ]]! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 6/1/2006 14:15'!
list: aConsCell

"(list &rest OBJECTS)
Return a newly created list with OBJECTS as elements.
Any number of arguments, even zero, is allowed."

	^ aConsCell ! !

!LispKernel methodsFor: 'private - initialization' stamp: 'spfa 6/20/2006 22:51'!
loadDefaultLibraries

	self class defaultLibraries do: [:lib | self top: {#loadLibrary: . lib inQuotedCons}]
! !

!SScheme methodsFor: 'private - initialization' stamp: 'muOuser 3/27/2007 23:40'!
loadDefaultLibraries

	self loadLibraries: self class systemLibraries 
		label: self class asString, ': loading system libraries'.

	self initializeEnvironments.

	self loadLibraries: self class defaultLibraries 
		label: self class asString, ': loading default libraries'.

	self initializeMacroExpander.
! !

!ULisp methodsFor: 'private - initialization' stamp: 'spfa 10/24/2006 15:55'!
loadDefaultLibraries

	self loadSystemLibraries.
	self initializeEnvironments.
	super loadDefaultLibraries.! !

!ULisp methodsFor: 'private - initialization' stamp: 'spfa 10/24/2006 22:54'!
loadLibraries: anArray label: aString

	aString displayProgressAt: Sensor cursorPoint
		from: 0 to: anArray size
		during: [:bar |
			anArray doWithIndex: [:lib :i | 
				self top: {#loadLibrary: . lib inQuotedCons}.
				bar value: i]]
! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 9/30/2006 21:49'!
loadLibrary: aConsCell

"(load-library SYMBOL)
Evaluate the lisp code returned by this lisp class-side SYMBOL method"

	^ self rewriteAndEval: 
		(self class perform: aConsCell car capAtLinks asSymbol).
	! !

!ULisp methodsFor: 'private - initialization' stamp: 'spfa 10/24/2006 15:54'!
loadSystemLibraries

	self class systemLibraries do: [:lib | self top: {#loadLibrary: . lib inQuotedCons}]
! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 3/20/2007 23:19'!
load: aConsCell

"(load FILENAME [TOP])
Reads and evaluates in sequence each expression in the file specified by FILENAME (a string). 
Returns the value of the last expression.
If TOP is true, resolve a relative filename with respect to FileDirectory default, else with respect to (current-directory). In the latter case, (current-directory) is temporarily set to that file directory during the evaluation.
If the specified file does not exists, and its name does not have any extension, a default extension ('.lisp' or '.scm') is appended."

	| fileStream fname str val env currentDirectoryCache top |

	env _ self topmostLisp environment.

	fname _ self systemPath: aConsCell.
	top _ aConsCell cadr == self trueValue.

	fname _ (top ifTrue: [FileDirectory default]
						ifFalse: [self currentDirectory]) fullNameFor: fname.

	((FileDirectory default fileExists: fname) not
		and: [((fname subStrings: FileDirectory slash) last includes: $.) not])
			ifTrue: [fname _ fname, self sourceFileExtension].

	fileStream _ StandardFileStream readOnlyFileNamed: fname.

	currentDirectoryCache _ self currentDirectory.
	top ifFalse: [self setCurrentDirectory: (FileDirectory forFileName: fname)].

	[
		str _ (LKIOPort input: fileStream) inCons.

		[fileStream atEnd]
			whileFalse:
			[	| exp |
				exp _ self read: str.
				exp == LKIOPort eof
					ifFalse: [val _ self eval: exp inEnvironment: env]
			].
	]
	ensure: [self setCurrentDirectory: currentDirectoryCache].

	^ val

! !

!ContextPart methodsFor: '*LispKit-continuations' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber
	^ self at: aNumber! !

!ContextPart methodsFor: '*LispKit-continuations' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber put: anObject
	^ self at: aNumber put: anObject! !

!CLisp methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 22:02'!
locally: aConsCell

	^ (self subLisp: #locally form: aConsCell body: aConsCell environment: environment) progn: aConsCell
! !

!ContextPart methodsFor: '*LispKit-continuations' stamp: 'avi 4/24/2004 12:27'!
localSize
	^ self size! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 11/17/2006 17:14'!
lookUpFunction: anObject

	"anObject was found in the functional position of a function invocation, that is as the car of a cons cell to be evaluated.
	return the actual function to be used" 

	anObject isProcedure ifTrue: [^ anObject].
	^ self symbolFunction: anObject ifNone: [anObject]  ! !

!ULisp methodsFor: 'private - subclasses may implement' stamp: 'spfa 3/27/2007 14:28'!
lookUpFunction: anObject

	"in Scheme a function can be an arbitrary form which evaluates to a lambda expression

	 ^ self evalObject: anObject

		would be enough, but we are a little faster here"

	anObject isLKPrimitive ifTrue: [^ anObject].
	anObject isLispClosure ifTrue: [^ anObject].
	anObject isSymbol ifFalse: [^ self evalObject: anObject].

	^ self symbolFunction: anObject ifNone: [anObject]  	
! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 10/3/2006 10:05'!
loop

	"the loop macro"

"
code borrowed from GNU Emacs 21.1 cl-macs.el file
author: Dave Gillepsie
copyright: Free Software Foundation
licence: GPL
"

	^ 
	#(in-library loop

(require-library $'block)
(require-library $'common)

(defmacro loop (&rest args)
  '(loop CLAUSE...): The Common Lisp loop macro.
Valid clauses are:
  for VAR from/upfrom/downfrom NUM to/upto/downto/above/below NUM by NUM,
  for VAR in LIST by FUNC, for VAR on LIST by FUNC, for VAR = INIT then EXPR,
  for VAR across ARRAY, repeat NUM, with VAR = INIT, while COND, until COND,
  always COND, never COND, thereis COND, collect EXPR into VAR,
  append EXPR into VAR, nconc EXPR into VAR, sum EXPR into VAR,
  count EXPR into VAR, maximize EXPR into VAR, minimize EXPR into VAR,
  if COND CLAUSE [and CLAUSE]... else CLAUSE [and CLAUSE...],
  unless COND CLAUSE [and CLAUSE]... else CLAUSE [and CLAUSE...],
  do EXPRS..., initially EXPRS..., finally EXPRS..., return EXPR,
  finally return EXPR, named NAME.'
  (if (not (memq t (mapcar $'symbolp (delq nil (delq t (copy-list args))))))
      (list $'block nil (list* $'while t args))
    (let ((loop-name nil)	(loop-bindings nil)
	  (loop-body nil)	(loop-steps nil)
	  (loop-result nil)	(loop-result-explicit nil)
	  (loop-result-var nil) (loop-finish-flag nil)
	  (loop-accum-var nil)	(loop-accum-vars nil)
	  (loop-initially nil)	(loop-finally nil)
	  (loop-map-form nil)   (loop-first-flag nil)
	  (loop-destr-temps nil) (loop-symbol-macs nil))
      (setq args (append args $'(cl-end-loop)))
      (while (not (eq (car args) $'cl-end-loop)) (loop-parse-clause))
      (if loop-finish-flag
	  (push (list (list loop-finish-flag t)) loop-bindings))
      (if loop-first-flag
	  (progn (push (list (list loop-first-flag t)) loop-bindings)
		 (push (list $'setq loop-first-flag nil) loop-steps)))
      (let* ((epilogue (nconc (nreverse loop-finally)
			      (list (or loop-result-explicit loop-result))))
	     (ands (cl-loop-build-ands (nreverse loop-body)))
	     (while-body (nconc (cadr ands) (nreverse loop-steps)))
	     (body (append
		    (nreverse loop-initially)
		    (list (if loop-map-form
			      (list $'block $'t-t-cl-finish-t-t
				    (subst
				     (if (eq (car ands) t) while-body
				       (cons (list $'or (car ands)
						   $'(return-from t-t-cl-finish-t-t
						      nil))
					     while-body))
				     $'t-t-cl-map loop-map-form))
			    (list* $'while (car ands) while-body)))
		    (if loop-finish-flag
			(if (equal epilogue $'(nil)) (list loop-result-var)
			  (list (list $'if loop-finish-flag
				      (cons $'progn epilogue) loop-result-var)))
		      epilogue))))
	(if loop-result-var (push (list loop-result-var) loop-bindings))
	(while loop-bindings
	  (if (cdar loop-bindings)
	      (setq body (list (cl-loop-let (pop loop-bindings) body t)))
	    (let ((lets nil))
	      (while (and loop-bindings
			  (not (cdar loop-bindings)))
		(push (car (pop loop-bindings)) lets))
	      (setq body (list (cl-loop-let lets body nil))))))
	(if loop-symbol-macs
	    (setq body (list (list* $'symbol-macrolet loop-symbol-macs body))))
	(list* $'block loop-name body)))))

(defun loop-parse-clause () 
  (let ((word (pop args))
	(hash-types $'(hash-key hash-keys hash-value hash-values))
	(key-types $'(key-code key-codes key-seq key-seqs
		     key-binding key-bindings)))
    (cond

     ((null args)
      (error 'Malformed loop macro'))

     ((eq word $'named)
      (setq loop-name (pop args)))

     ((eq word $'initially)
      (if (memq (car args) $'(do doing)) (pop args))
      (or (consp (car args)) (error 'Syntax error on initially clause'))
      (while (consp (car args))
	(push (pop args) loop-initially)))

     ((eq word $'finally)
      (if (eq (car args) $'return)
	  (setq loop-result-explicit (or (pop2 args) $'(quote nil)))
	(if (memq (car args) $'(do doing)) (pop args))
	(or (consp (car args)) (error 'Syntax error on finally clause'))
	(if (and (eq (caar args) $'return) (null loop-name))
	    (setq loop-result-explicit (or (nth 1 (pop args)) $'(quote nil)))
	  (while (consp (car args))
	    (push (pop args) loop-finally)))))

     ((memq word $'(for as))
      (let ((loop-for-bindings nil) (loop-for-sets nil) (loop-for-steps nil)
	    (ands nil))
	(while
	    (let ((var (or (pop args) (gensym))))
	      (setq word (pop args))
	      (if (eq word $'being) (setq word (pop args)))
	      (if (memq word $'(the each)) (setq word (pop args)))
	      (cond

	       ((memq word $'(from downfrom upfrom to downto upto
			     above below by))
		(push word args)
		(if (memq (car args) $'(downto above))
		    (error 'Must specify from value for downward loop'))
		(let* ((down (or (eq (car args) $'downfrom)
				 (memq (caddr args) $'(downto above))))
		       (excl (or (memq (car args) $'(above below))
				 (memq (caddr args) $'(above below))))
		       (start (and (memq (car args) $'(from upfrom downfrom))
				   (pop2 args)))
		       (end (and (memq (car args)
				       $'(to upto downto above below))
				 (pop2 args)))
		       (step (and (eq (car args) $'by) (pop2 args)))
		       (end-var (and (not (cl-const-expr-p end)) (gensym)))
		       (step-var (and (not (cl-const-expr-p step))
				      (gensym))))
		  (and step (numberp step) (<= step 0)
		       (error 'Loop by value is not positive: %s' step))
		  (push (list var (or start 0)) loop-for-bindings)
		  (if end-var (push (list end-var end) loop-for-bindings))
		  (if step-var (push (list step-var step)
					loop-for-bindings))
		  (if end
		      (push (list
				(if down (if excl $'#'>' $'#'>=') (if excl $'< $'#'<='))
				var (or end-var end)) loop-body))
		  (push (list var (list (if down $'- $'+) var
					   (or step-var step 1)))
			   loop-for-steps)))

	       ((memq word $'(in in-ref on))
		(let* ((on (eq word $'on))
		       (temp (if (and on (symbolp var)) var (gensym))))
		  (push (list temp (pop args)) loop-for-bindings)
		  (push (list $'consp temp) loop-body)
		  (if (eq word $'in-ref)
		      (push (list var (list $'car temp)) loop-symbol-macs)
		    (or (eq temp var)
			(progn
			  (push (list var nil) loop-for-bindings)
			  (push (list var (if on temp (list $'car temp)))
				   loop-for-sets))))
		  (push (list temp
				 (if (eq (car args) $'by)
				     (let ((step (pop2 args)))
				       (if (and (memq (car-safe step)
						      $'(quote function
							      function*))
						(symbolp (nth 1 step)))
					   (list (nth 1 step) temp)
					 (list $'funcall step temp)))
				   (list $'cdr temp)))
			   loop-for-steps)))

	       ((eq word $'=)
		(let* ((start (pop args))
		       (then (if (eq (car args) $'then) (pop2 args) start)))
		  (push (list var nil) loop-for-bindings)
		  (if (or ands (eq (car args) $'and))
		      (progn
			(push (list var
				       (list $'if
					     (or loop-first-flag
						 (setq loop-first-flag
						       (gensym)))
					     start var))
				 loop-for-sets)
			(push (list var then) loop-for-steps))
		    (push (list var
				   (if (eq start then) start
				     (list $'if
					   (or loop-first-flag
					       (setq loop-first-flag (gensym)))
					   start then)))
			     loop-for-sets))))

	       ((memq word $'(across across-ref))
		(let ((temp-vec (gensym)) (temp-idx (gensym)))
		  (push (list temp-vec (pop args)) loop-for-bindings)
		  (push (list temp-idx -1) loop-for-bindings)
		  (push (list $'< (list $'setq temp-idx (list $'#'1+' temp-idx))
				 (list $'length temp-vec)) loop-body)
		  (if (eq word $'across-ref)
		      (push (list var (list $'aref temp-vec temp-idx))
			       loop-symbol-macs)
		    (push (list var nil) loop-for-bindings)
		    (push (list var (list $'aref temp-vec temp-idx))
			     loop-for-sets))))

	       ((memq word $'(element elements))
		(let ((ref (or (memq (car args) $'(in-ref of-ref))
			       (and (not (memq (car args) $'(in of)))
				    (error 'Expected of '))))
		      (seq (pop2 args))
		      (temp-seq (gensym))
		      (temp-idx (if (eq (car args) $'using)
				    (if (and (= (length (cadr args)) 2)
					     (eq (caadr args) $'index))
					(cadr (pop2 args))
				      (error 'Bad using clause'))
				  (gensym))))
		  (push (list temp-seq seq) loop-for-bindings)
		  (push (list temp-idx 0) loop-for-bindings)
		  (if ref
		      (let ((temp-len (gensym)))
			(push (list temp-len (list $'length temp-seq))
				 loop-for-bindings)
			(push (list var (list $'elt temp-seq temp-idx))
				 loop-symbol-macs)
			(push (list $'< temp-idx temp-len) loop-body))
		    (push (list var nil) loop-for-bindings)
		    (push (list $'and temp-seq
				   (list $'or (list $'consp temp-seq)
					 (list $'< temp-idx
					       (list $'length temp-seq))))
			     loop-body)
		    (push (list var (list $'if (list $'consp temp-seq)
					     (list $'pop temp-seq)
					     (list $'aref temp-seq temp-idx)))
			     loop-for-sets))
		  (push (list temp-idx (list $'#'1+' temp-idx))
			   loop-for-steps)))

	       ((memq word hash-types)
		(or (memq (car args) $'(in of)) (error 'Expected of'))
		(let* ((table (pop2 args))
		       (other (if (eq (car args) $'using)
				  (if (and (= (length (cadr args)) 2)
					   (memq (caadr args) hash-types)
					   (not (eq (caadr args) word)))
				      (cadr (pop2 args))
				    (error 'Bad using clause'))
				(gensym))))
		  (if (memq word $'(hash-value hash-values))
		      (setq var (prog1 other (setq other var))))
		  (setq loop-map-form
			(list $'maphash (list $'function
					     (list* $'lambda (list var other)
						    $'t-t-cl-map)) table))))

	       (t
		(let ((handler (and (symbolp word)
				    (get word $'cl-loop-for-handler))))
		  (if handler
		      (funcall handler var)
		    (error (concat 'Expected a for preposition, found ' word))))))
	      (eq (car args) $'and))
	  (setq ands t)
	  (pop args))
	(if (and ands loop-for-bindings)
	    (push (nreverse loop-for-bindings) loop-bindings)
	  (setq loop-bindings (nconc (mapcar $'list loop-for-bindings)
				     loop-bindings)))
	(if loop-for-sets
	    (push (list $'progn
			   (cl-loop-let (nreverse loop-for-sets) $'setq ands)
			   t) loop-body))
	(if loop-for-steps
	    (push (cons (if ands $'psetq $'setq)
			   (apply $'append (nreverse loop-for-steps)))
		     loop-steps))))

     ((eq word $'repeat)
      (let ((temp (gensym)))
	(push (list (list temp (pop args))) loop-bindings)
	(push (list $'#'>=' (list $'setq temp (list $'#'1-' temp)) 0) loop-body)))

     ((memq word $'(collect collecting))
      (let ((what (pop args))
	    (var (cl-loop-handle-accum nil $'nreverse)))
	(if (eq var loop-accum-var)
	    (push (list $'progn (list $'push what var) t) loop-body)
	  (push (list $'progn
			 (list $'setq var (list $'nconc var (list $'list what)))
			 t) loop-body))))

     ((memq word $'(nconc nconcing append appending))
      (let ((what (pop args))
	    (var (cl-loop-handle-accum nil $'nreverse)))
	(push (list $'progn
		       (list $'setq var
			     (if (eq var loop-accum-var)
				 (list $'nconc
				       (list (if (memq word $'(nconc nconcing))
						 $'nreverse $'reverse)
					     what)
				       var)
			       (list (if (memq word $'(nconc nconcing))
					 $'nconc $'append)
				     var what))) t) loop-body)))

     ((memq word $'(concat concating))
      (let ((what (pop args))
	    (var (cl-loop-handle-accum '')))
	(push (list $'progn (list $'callf $'concat var what) t) loop-body)))

     ((memq word $'(vconcat vconcating))
      (let ((what (pop args))
	    (var (cl-loop-handle-accum [])))
	(push (list $'progn (list $'callf $'vconcat var what) t) loop-body)))

     ((memq word $'(sum summing))
      (let ((what (pop args))
	    (var (cl-loop-handle-accum 0)))
	(push (list $'progn (list $'incf var what) t) loop-body)))

     ((memq word $'(count counting))
      (let ((what (pop args))
	    (var (cl-loop-handle-accum 0)))
	(push (list $'progn (list $'if what (list $'incf var)) t) loop-body)))

     ((memq word $'(minimize minimizing maximize maximizing))
      (let* ((what (pop args))
	     (temp (if (cl-simple-expr-p what) what (gensym)))
	     (var (cl-loop-handle-accum nil))
	     (func (intern (substring (symbol-name word) 0 3)))
	     (set (list $'setq var (list $'if var (list func var temp) temp))))
	(push (list $'progn (if (eq temp what) set
				(list $'let (list (list temp what)) set))
		       t) loop-body)))

     ((eq word $'with)
      (let ((bindings nil))
	(while (progn (push (list (pop args)
				     (and (eq (car args) $'=) (pop2 args)))
			       bindings)
		      (eq (car args) $'and))
	  (pop args))
	(push (nreverse bindings) loop-bindings)))

     ((eq word $'while)
      (push (pop args) loop-body))

     ((eq word $'until)
      (push (list $'not (pop args)) loop-body))

     ((eq word $'always)
      (or loop-finish-flag (setq loop-finish-flag (gensym)))
      (push (list $'setq loop-finish-flag (pop args)) loop-body)
      (setq loop-result t))

     ((eq word $'never)
      (or loop-finish-flag (setq loop-finish-flag (gensym)))
      (push (list $'setq loop-finish-flag (list $'not (pop args)))
	       loop-body)
      (setq loop-result t))

     ((eq word $'thereis)
      (or loop-finish-flag (setq loop-finish-flag (gensym)))
      (or loop-result-var (setq loop-result-var (gensym)))
      (push (list $'setq loop-finish-flag
		     (list $'not (list $'setq loop-result-var (pop args))))
	       loop-body))

     ((memq word $'(if when unless))
      (let* ((cond (pop args))
	     (then (let ((loop-body nil))
		     (loop-parse-clause)
		     (cl-loop-build-ands (nreverse loop-body))))
	     (else (let ((loop-body nil))
		     (if (eq (car args) $'else)
			 (progn (pop args) (loop-parse-clause)))
		     (cl-loop-build-ands (nreverse loop-body))))
	     (simple (and (eq (car then) t) (eq (car else) t))))
	(if (eq (car args) $'end) (pop args))
	(if (eq word $'unless) (setq then (prog1 else (setq else then))))
	(let ((form (cons (if simple (cons $'progn (nth 1 then)) (nth 2 then))
			  (if simple (nth 1 else) (list (nth 2 else))))))
	  (if (cl-expr-contains form $'it)
	      (let ((temp (gensym)))
		(push (list temp) loop-bindings)
		(setq form (list* $'if (list $'setq temp cond)
				  (subst temp $'it form))))
	    (setq form (list* $'if cond form)))
	  (push (if simple (list $'progn form t) form) loop-body))))

     ((memq word $'(do doing))
      (let ((body nil))
	(or (consp (car args)) (error 'Syntax error on do clause'))
	(while (consp (car args)) (push (pop args) body))
	(push (cons $'progn (nreverse (cons t body))) loop-body)))

     ((eq word $'return)
      (or loop-finish-flag (setq loop-finish-flag (gensym)))
      (or loop-result-var (setq loop-result-var (gensym)))
      (push (list $'setq loop-result-var (pop args)
		     loop-finish-flag nil) loop-body))

     (t
      (let ((handler (and (symbolp word) (get word $'cl-loop-handler))))
	(or handler (error (concat 'Expected a loop keyword, found ' word)))
	(funcall handler))))
    (if (eq (car args) $'and)
	(progn (pop args) (loop-parse-clause)))))

(defun cl-loop-let (specs body par)   
  (let ((p specs) (temps nil) (new nil))
    (while (and p (or (symbolp (car-safe (car p))) (null (cadar p))))
      (setq p (cdr p)))
    (and par p
	 (progn
	   (setq par nil p specs)
	   (while p
	     (or (cl-const-expr-p (cadar p))
		 (let ((temp (gensym)))
		   (push (list temp (cadar p)) temps)
		   (setcar (cdar p) temp)))
	     (setq p (cdr p)))))
    (while specs
      (if (and (consp (car specs)) (listp (caar specs)))
	  (let* ((spec (caar specs)) (nspecs nil)
		 (expr (cadr (pop specs)))
		 (temp (cdr (or (assq spec loop-destr-temps)
				(car (push (cons spec (or (last spec 0)
							     (gensym)))
					      loop-destr-temps))))))
	    (push (list temp expr) new)
	    (while (consp spec)
	      (push (list (pop spec)
			     (and expr (list (if spec $'pop $'car) temp)))
		       nspecs))
	    (setq specs (nconc (nreverse nspecs) specs)))
	(push (pop specs) new)))
    (if (eq body $'setq)
	(let ((set (cons (if par $'psetq $'setq) (apply $'nconc (nreverse new)))))
	  (if temps (list $'let* (nreverse temps) set) set))
      (list* (if par $'let $'let*)
	     (nconc (nreverse temps) (nreverse new)) body))))

(defun cl-loop-handle-accum (def &optional func)  
  (if (eq (car args) $'into)
      (let ((var (pop2 args)))
	(or (memq var loop-accum-vars)
	    (progn (push (list (list var def)) loop-bindings)
		   (push var loop-accum-vars)))
	var)
    (or loop-accum-var
	(progn
	  (push (list (list (setq loop-accum-var (gensym)) def))
		   loop-bindings)
	  (setq loop-result (if func (list func loop-accum-var)
			      loop-accum-var))
	  loop-accum-var))))

(defun cl-loop-build-ands (clauses)
  (let ((ands nil)
	(body nil))
    (while clauses
      (if (and (eq (car-safe (car clauses)) $'progn)
	       (eq (car (last (car clauses))) t))
	  (if (cdr clauses)
	      (setq clauses (cons (nconc (butlast (car clauses))
					 (if (eq (car-safe (cadr clauses))
						 $'progn)
					     (cdadr clauses)
					   (list (cadr clauses))))
				  (cddr clauses)))
	    (setq body (cdr (butlast (pop clauses)))))
	(push (pop clauses) ands)))
    (setq ands (or (nreverse ands) (list t)))
    (list (if (cdr ands) (cons $'and ands) (car ands))
	  body
	  (let ((full (if body
			  (append ands (list (cons $'progn (append body $'(t)))))
			ands)))
	    (if (cdr full) (cons $'and full) (car full))))))


(defun cl-expr-contains (x y)
  (cond ((equal y x) 1)
	((and (consp x) (not (memq (car-safe x) $'(quote function function*))))
	 (let ((sum 0))
	   (while x
	     (setq sum (+ sum (or (cl-expr-contains (pop x) y) 0))))
	   (and (> sum 0) sum)))
	(t nil)))

	)! !

!SLisp class methodsFor: 'libraries' stamp: 'spfa 6/15/2006 15:36'!
loop

	^ #() "the loop macro is not implemented in SLisp at the moment"! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 3/25/2007 14:33'!
loop

	^ 
	#(in-library loop
		(load: (system-path 'ulisp\loop.scm')))! !

!SScheme methodsFor: 'private - interpreter' stamp: 'spfa 3/28/2007 15:04'!
macroEvalObject: anObject

	anObject isConsCell ifFalse: 
		[^ self evalObject: anObject multipleValue: true].
	
	macroEvalSlot setcar: anObject.

	^ self evalObject: (self evalObject: macroEvalTemplate multipleValue: true) 
		multipleValue: true
	
					
! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 11/27/2006 13:20'!
macroexpand: aConsCell 

	| func bindings |

	aConsCell car isConsCell ifFalse: [^ aConsCell car].

	func _ self symbolFunction: aConsCell car car ifNone: [^ aConsCell car].
	func isProcedure ifFalse: [^ aConsCell car].
	func lambdaForm car = #macro ifFalse: [^ aConsCell car].
	func _ func lambdaForm.

	bindings _ ((self bindAll: aConsCell car cdr 
					fromSpec: func second 
					macrop: true) 
				collect: [:a | a key inCons setcdr: a value inQuotedCons inCons]) asCons.

	^ self let: (bindings inCons append: (func nthcdr: 2))! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 21:41'!
macros

	^ Macros! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 6/9/2006 14:29'!
macro: aConsCell

"(macro ARGS &rest BODY)
Return a nlambda expression.
A call of the form (macro ARGS &rest BODY) is self-quoting: the result of evaluating the nlambda expression is the expression itself.  
A nlambda expression has the semantic of a special form, or macro"

	^ self lambdaForm: #macro withArgsAndBody: aConsCell! !

!StaticLisp methodsFor: 'LISP-special forms' stamp: 'spfa 6/5/2006 20:56'!
macro: aConsCell

"(macro ARGS &rest BODY)
Return a nlambda expression.
A call of the form (macro ARGS &rest BODY) is self-quoting: the result of evaluating the nlambda expression is the expression itself.  
A nlambda expression has the semantic of a special form, or macro"

	^ self makeClosureFor: aConsCell as: #macro

! !

!StaticLisp methodsFor: 'private-closures' stamp: 'spfa 7/19/2006 14:51'!
makeClosureFor: aConsCell 

	| clo |

	clo _ LKClosure new.
	clo form: aConsCell.
	clo environment: environment.

	^ clo
! !

!StaticLisp methodsFor: 'private-closures' stamp: 'spfa 6/9/2006 14:37'!
makeClosureFor: aConsCell as: aSymbol

	^ self makeClosureFor: 
		(self lambdaForm: aSymbol withArgsAndBody: aConsCell)
! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 6/23/2006 15:39'!
makeString: aConsCell

	^ String new: aConsCell car withAll: (aConsCell cadr ifNil: [$-])

! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/22/2006 20:40'!
makeSymbol: aConsCell

"(make-symbol STRING)
Return a newly allocated uninterned symbol whose name is STRING"

	| n sym |

	n _ 0.
	[sym isNil or: [uninternedSymbols identityIncludes: sym]]
		whileTrue: [sym _ self unintern: aConsCell car n: (n _ n+1)].
	uninternedSymbols add: sym.
	^ sym
	 

	! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/29/2007 09:09'!
makeUlispArchive

	| zip |

	zip _  ZipArchive new.

	( self slibFiles, 
		{'ulisp\loop.scm'},
		self pregexpFiles, 
		self SCMFiles, 
		self schelogFiles, 
		self schelogExampleFiles,
		self testFiles,
		self olegFiles,
		self tinyclosFiles,
		self jacalFiles,
		self kanrenFiles,
		self meroonetFiles
	) 
	do: [:f | zip addFile: f].

	zip writeToFileNamed: 'ulisp.zip'! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 11/20/2006 12:54'!
makeVector: aConsCell

"(make-vector LENGTH INIT)
Return a newly created vector of length LENGTH, with each element being INIT."

	^ Array new: aConsCell car withAll: aConsCell cadr! !

!CLisp methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 10/12/2006 14:09'!
makunbound: aConsCell

"(makunbound SYMBOL)
Make SYMBOL's value be void."

	| s |
	s _ self checkSymbol: aConsCell car.
	(self symbolValuesDictionaryFor: s) removeKey: s ifAbsent: [].
	(self symbolValuesDictionaryFor: s) removeKey: s ifAbsent: [].
	^ s
! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 6/16/2006 23:47'!
makunbound: aConsCell

"(makunbound SYMBOL)
Make SYMBOL's value be void."

	| s |
	s _ self checkSymbol: aConsCell car.
	(self symbolValuesDictionaryFor: s) removeKey: s ifAbsent: [].
	^ s

	! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 11/20/2006 10:21'!
mapcar: aConsCell

"(mapcar FUNCTION SEQUENCE)
Apply FUNCTION to each element of SEQUENCE, and make a list of the results.
The result is a list just as long as SEQUENCE.
SEQUENCE may be a list, a vector, a string or any Collection"

	| fcell slot seq |

	fcell _ 	(ConsCell car: aConsCell car) cdr: (slot _ (ConsCell new)).

	(seq _ aConsCell cadr ifNil: [^ nil]) isConsCell ifTrue:
	[
		^ seq collect: [:cell | 
				slot setcar: cell.
				self funcall: fcell]
	].

	^ (seq collect: [:each | slot setcar: each. self funcall: fcell]) asArray asCons
! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 3/27/2007 15:04'!
map: aConsCell

	| proc lists |

	proc _ aConsCell car.

	(proc isLispClosure or: [proc isLKPrimitive])
		ifFalse: [self lispError: 'Invalid function: ', proc asString].

	lists _ aConsCell cdr.

	^ (aConsCell cadr ifNil: [^ nil]) collect: [:each | | v args |
		args _ (lists collect: [:list | list car inQuotedCons]).
		v _ self evalObject: (ConsCell car: proc cdr: args).
		lists _ lists collect: [:list | list cdr].
		v]! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 7/6/2006 21:11'!
max: aConsCell

"(max &rest NUMBERS)
Returns the minimum of NUMBERS"

	^ (aConsCell ifNil: [self lispError: 'At least one argument expected'])
		arrayForm max

! !

!LKPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 11:31'!
mayHaveVignette

	^ true! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:07'!
member: aConsCell

"(member ELT LIST)
Return non-nil if ELT is an element of LIST.  
Comparison is done with equal.
The returned value is the tail of LIST whose car is ELT."

	aConsCell cadr ifNil: [^ self falseValue].
	aConsCell cadr cellsDo: [:cell | cell car = aConsCell car ifTrue: [^ cell]].
	^ self falseValue! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:07'!
memq: aConsCell

"(memq ELT LIST)
Return non-nil if ELT is an element of LIST.  
Comparison is done with eq.
The returned value is the tail of LIST whose car is ELT."

	aConsCell cadr ifNil: [^ self falseValue].
	aConsCell cadr cellsDo: [:cell | cell car == aConsCell car ifTrue: [^ cell]].
	^ self falseValue! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 3/24/2007 23:17'!
meroonet

	"an object system by Christian Queinnec

	http://www-spi.lip6.fr/~queinnec/WWW/Meroon.html
	"

	^#(in-library meroonet
			(define define-meroonet-macro define-macro)
			(define meroonet-error error)
			(load (system-path 'ulisp/meroonet/meroonet.scm')))


! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/24/2007 23:06'!
meroonetFiles

	^ self filesInULispDirectory: 'meroonet'! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 3/28/2007 10:04'!
miniKanren

	"miniKANREN, by Oleg and al.
	http://kanren.sourceforge.net/
	"

	^#(in-library mini-kanren
			(load (system-path 'ulisp/minikanren/mkprelude.scm')))


! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 7/6/2006 21:11'!
min: aConsCell

"(min &rest NUMBERS)
Returns the minimum of NUMBERS"

	^ (aConsCell ifNil: [self lispError: 'At least one argument expected'])
		arrayForm min.

! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/4/2006 21:45'!
modulo: aConsCell

"
"

	^ aConsCell car \\ aConsCell cadr

! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 7/3/2006 13:03'!
monitor

	^ monitor! !

!LispKernel methodsFor: 'LISP-functions-monitoring' stamp: 'spfa 7/7/2006 23:32'!
monitorAll: ignored

"(monitor-all)
Trace all evaluated forms"

	self monitor: LKTracer new.
	^ self monitor! !

!LispKernel methodsFor: 'LISP-functions-monitoring' stamp: 'spfa 7/7/2006 18:18'!
monitorFunctions: aConsCell

"(monitor-functions &rest ARGS)
Trace all calls to ARGS"

	self monitor: (LKFunctionsTracer new functions: aConsCell arrayForm).
	^ self monitor! !

!LispKernel methodsFor: 'LISP-functions-monitoring' stamp: 'spfa 7/8/2006 22:33'!
monitorHalt: aConsCell

"(monitor-halt &rest PREDS)
Halt right before evaluating a call to any of PREDS (which are symbols)"

	self monitor: (LKHalt new functions: aConsCell arrayForm).
	^ self monitor! !

!LispKernel methodsFor: 'LISP-functions-monitoring' stamp: 'spfa 7/7/2006 23:33'!
monitorOff: ignored

"(monitor-off])
Stop all monitoring activities"

	self monitor: nil.
	^ self monitor! !

!LispKernel methodsFor: 'LISP-functions-monitoring' stamp: 'spfa 7/7/2006 18:29'!
monitorSymbols: aConsCell

"(monitor-symbols &rest SYMBOLS)
Trace all references to ARGS"

	self monitor: (LKSymbolsTracer new symbols: aConsCell arrayForm).
	^ self monitor! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 7/3/2006 13:03'!
monitor: aLKMonitor

	monitor _ aLKMonitor! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 10/23/2006 23:38'!
multipleValueBind: aConsCell

"(multiple-value-bind VARS FORM &rest BODY)
Bind VARS (a  list of symbols) according to the values of FORM,
then eval BODY.
The value of the last form in BODY is returned"

	| sublisp values i val |

	sublisp _ self subLisp: #'multiple-value-bind' 
		form: aConsCell body: aConsCell cddr. 

	values _ self evalToValues: aConsCell cadr.
	i _ 0.
	aConsCell first do: [:sym | 
			sublisp checkSymbol: sym. 
			i _ i + 1.
			sublisp symbolValuesAdd: (sym -> (values at: i ifAbsent: [nil]))].

	((aConsCell nthCell: 2) ifNil: [^ nil]) do: [:c | val _ sublisp evalObject: c].
	^ val! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 10/23/2006 23:20'!
multipleValueCall: aConsCell

	""

	| argstr |
	
	argstr _ WriteStream on: #().

	argstr nextPut: (self evalObject: aConsCell car).
	aConsCell cdr do: [:form |
		argstr nextPutAll: (self evalToValues: form)].

	^ self evalObject: argstr contents asCons! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 10/23/2006 23:20'!
multipleValueList: aConsCell

	""
	
	^ (self evalToValues: aConsCell car) asCons! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/23/2006 23:25'!
multipleValueProg1: aConsCell

"(multiple-value-prog1 FIRST &rest BODY)
Eval FIRST and BODY sequentially; return the values from FIRST"

	| val |
	val _ self evalToValues: aConsCell first.
	(aConsCell cdr ifNil: [^ val]) do: [:form | self evalObject: form].
	^ val! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 10/23/2006 23:50'!
multipleValueSetq: aConsCell

"(multiple-value-setq VARS FORM)
VARS must be a list of variables. FORM is evaluated, and the variables are set (not bound) to the values returned by FORM. 
If there are more variables than values returned, extra values of nil are assigned to the remaining variables. 
If there are more values than variables, the excess values are simply discarded.
multiple-value-setq always returns a single value, which is the first value returned by form, or nil if form produces zero values."

	| dict values i |
	
	values _ self evalToValues: aConsCell cadr.
	i _ 0.
	aConsCell car do: [:sym |
		self checkSymbol: sym.
		dict _ self symbolValuesDictionaryFor: sym.
		i _ i + 1.
		dict add: sym -> (values at: i ifAbsent: [nil])].
	
	^ values at: 1 ifAbsent: [nil]! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 22:40'!
nconc: aConsCell

"(nconc &rest LISTS)
Concatenate any number of LISTS by altering them.
Only the last argument is not altered, and need not be a list."

	| i lists |
	
	lists _ ConsCell new.
	(aConsCell ifNil: [^ nil]) do: [:each | each ifNotNil: [lists addLast: each]].
	lists _ lists cdr ifNil: [^ nil].

	i _ 0.
	[true] whileTrue:
	[
		(lists nth: i) last 
			setcdr: (lists nth: i+1 ifAbsent: [^ lists car]).
		i _ i + 1
	]	

! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 9/26/2006 13:46'!
nEqual: aConsCell
	
"(n-equal NUM1 NUM2 &rest NUMS)
Return t if the arguments (which should be numbers) are equal"

	aConsCell cellsDo: [:c |
		(c car isNumber or: [c car isComplex]) 
			ifFalse: [^ self lispError: 'number expected'].
		(c car = (c cadr ifNil: [^ self trueValue])) ifFalse: [^ self falseValue]]. 

! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/15/2006 22:29'!
negativeP: aConsCell

"(negative? NUMBER)
Test weither NUMBER < 0."

	^ self class test: aConsCell car < 0! !

!ConsCell methodsFor: 'brackets rewriting' stamp: 'spfa 6/19/2006 21:43'!
nest: delim

	| cut |

	car isConsCell ifTrue: [car nest: delim].

	car = delim first ifFalse: [^ (cdr ifNil: [^ nil]) nest: delim].
	cut _ cdr cut: delim.
	car _ cdr.
	cdr _ cut cdr cdr.
	cut setcdr: nil.
	cdr ifNotNil: [cdr nest: delim] ! !

!ConsCell methodsFor: 'brackets rewriting' stamp: 'spfa 6/23/2006 00:15'!
nest: del with: o

	| cut |

	car isConsCell ifTrue: [car nest: del with: o].

	car == del first ifFalse: [^ (cdr ifNil: [^ nil]) nest: del with: o].
	cut _ cdr cut: del with: o.
	car _ (ConsCell car: o cdr: cdr inCons).
	cdr _ cut cdr cdr.
	cut setcdr: nil.
	cdr ifNotNil: [cdr nest: del with: o] ! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 7/22/2006 15:12'!
newChild

	^ self class new parent: self; symbolPlists: symbolPlists! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 11/3/2006 22:18'!
newline: aConsCell

"(newline [port])
Writes an end of line to port."

	| port |

	(port _ aConsCell car ifNil: [self standardOutput]) stream cr.
	port endEntry.
	^ self trueValue! !

!LKPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 11:31'!
newPage

	^ (MGraphPluggableTextMorph on: MGraphWorkspace new
			text: #contents
			accept: #acceptContents:
			readSelection: nil 
			menu: #codePaneMenu:shifted:)
		color: (Color white alpha: 0.9)! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2006 11:31'!
nextCharacter: aCharacter

	nindex _ nindex + 1.

	nindex = 1 ifTrue: 
	[
		aCharacter == $- 
			ifTrue: [sign _ -1]
			ifFalse: [
				((self digit: aCharacter) notNil 
					or: [aCharacter == $+] or: [aCharacter == $.])
				ifFalse: [couldBeNumber _ false]].
	].
		
	couldBeNumber ifFalse: [^ self].

	dot ifNotNil: [dot _ dot / 10].
	aCharacter == $. ifTrue: [	
		base = 10 ifFalse: [couldBeNumber _ false].
		couldBeFraction _ false.
		n1 ifNotNil: [couldBeExponent _ false].
		dot ifNotNil: [couldBeNumber _ false] ifNil: [dot _ 1].
	]
	ifFalse: [
		(couldBeExponent
			and: [n1 isNil] 
			and: [aCharacter == $e or: [aCharacter == $E]])
		ifTrue: [self getN1. couldBeFraction _ false]
		ifFalse: [
			(couldBeFraction
				and: [n1 isNil] 
				and: [aCharacter == $/])
			ifTrue: [self getN1. couldBeExponent _ false]
			ifFalse:
			[  | d |
				(d _ self digit: aCharacter) notNil 
				ifFalse: [
					(((aCharacter == $+)	or: [aCharacter == $-])
						and: [nindex = 1])
					ifFalse: [couldBeNumber _ false]
					ifTrue: [n1 ifNotNil: [couldBeFraction _ false]]]
				ifTrue: [
					number ifNil: [number _ 0].
					dot ifNil: [number _ (base * number) + d]
					ifNotNil: [number _ number asFloat + (d * dot)]]]]]

	! !

!ULispToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/13/2006 11:01'!
nextCharacter: aCharacter

	nindex _ nindex + 1.

	i ifNotNil: [couldBeNumber _ false]
	ifNil: [((aCharacter == $i) or: [aCharacter == $I])
			ifTrue:[i _ nindex. number ifNil: [number _ 1]. ^ self]].

	nindex = 1 ifTrue: 
	[
		((aCharacter == $+) or: [aCharacter == $-])
			ifTrue: [startWithSign _ true].
		aCharacter == $- 
			ifTrue: [sign _ -1]
			ifFalse: [
				((self digit: aCharacter) notNil 
					or: [aCharacter == $+] or: [aCharacter == $.])
				ifFalse: [couldBeNumber _ false]].
	].
		
	couldBeNumber ifFalse: [^ self].

	dot ifNotNil: [dot _ dot / 10].
	aCharacter == $. ifTrue: [	
		base = 10 ifFalse: [couldBeNumber _ false].
		couldBeFraction _ false.
		n1 ifNotNil: [couldBeExponent _ false].
		dot ifNotNil: [couldBeNumber _ false] ifNil: [dot _ 1].
	]
	ifFalse: [
		(couldBeExponent
			and: [n1 isNil] 
			and: [aCharacter == $e or: [aCharacter == $E]])
		ifTrue: [self getN1. couldBeFraction _ couldBeComplex _ false]
		ifFalse: [
			(couldBeFraction
				and: [n1 isNil] 
				and: [aCharacter == $/])
			ifTrue: [self getN1. couldBeExponent _ couldBeComplex _ false]
			ifFalse: [
				(couldBeComplex
					and: [n1 isNil] 
					and: [number notNil]
					and: [(aCharacter == $+) or: [aCharacter == $-]])
				ifTrue: [self getN1. couldBeExponent _ couldBeFraction _ false.
						(aCharacter == $-) ifTrue: [sign _ -1]]
				ifFalse:
				[ | d |
					(d _ self digit: aCharacter) notNil 
					ifFalse: [
						((aCharacter == $i) or: [aCharacter == $I])
							ifFalse: [	(((aCharacter == $+) or: [aCharacter == $-])
											and: [nindex = 1])
										ifFalse: [couldBeNumber _ false]
										ifTrue: [n1 ifNotNil: [couldBeFraction _ false]]]]
					ifTrue: [
						number ifNil: [number _ 0].
						dot ifNil:[number _ (base * number) + d]
							ifNotNil: [number _ number asFloat + (d * dot)]]]]]]

	! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 21:58'!
nextPutAll: aCollection 
	"Append the elements of aCollection to the sequence of objects accessible 
	by the receiver. Answer aCollection."

	aCollection do: [:v | self nextPut: v].
	^aCollection! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/14/2006 18:00'!
nextPut: aCharacter

	super nextPut: aCharacter.
	self nextCharacter: aCharacter! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 9/30/2006 15:38'!
nonPrimitiveSymbolFunction: aSymbol ifNone: aBlock

	^ environment symbolFunction: aSymbol ifNone: aBlock
	

! !

!ULisp methodsFor: 'private' stamp: 'spfa 9/30/2006 15:38'!
nonPrimitiveSymbolFunction: aSymbol ifNone: aBlock

	^ self symbolValue: aSymbol ifNone: aBlock
	! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/22/2006 21:11'!
not: aConsCell

"(not OBJECT)
Return t if OBJECT is false."

	^ self class test: aConsCell car = self falseValue! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:07'!
nreverse: aConsCell

"(nreverse LIST)
Reverse LIST by modifying cdr pointers.
Returns the beginning of the reversed list."

	| lastCell |

	(aConsCell car ifNil: [^ nil]) cells do: [:cell |
		cell setcdr: lastCell.
		lastCell _ cell].

	^ lastCell ! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:26'!
nthCell: n

	n isZero ifTrue: [^ self].
	n = 1 ifTrue: [^ cdr].
	^ cdr nthCell: n - 1! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/7/2006 10:59'!
nthCell: n ifAbsent: aBlock

	n isZero ifTrue: [^ self].
	n = 1 ifTrue: [^ cdr ifNil: [aBlock value]].
	^ cdr nthCell: n - 1 ifAbsent: aBlock! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:26'!
nthcdr: n

	n isZero ifTrue: [^ self].
	n = 1 ifTrue: [^ cdr].
	^ cdr nthcdr: n - 1! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 22:41'!
nthcdr: aConsCell

"(nthcdr N LIST)
Return the Nth cons cell in LIST.
For example, (nthcdr 2 (list 1 2 3 4 5)) returns (3 4 5)"

	^ aConsCell cadr nthcdr: aConsCell car

	! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/6/2006 22:08'!
nthcdr: n ifAbsent: aBlock

	n isZero ifTrue: [^ self].
	cdr ifNil: [n = 1 ifTrue: [^ nil] ifFalse: [aBlock value]].
	n = 1 ifTrue: [^ cdr].
	^ cdr nthcdr: n - 1ifAbsent: aBlock! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 8/14/2006 16:48'!
nthUpperLisp: aNumber

	aNumber = 1 ifTrue: [^ upperLisp].

	^ (upperLisp ifNil: [^ nil]) nthUpperLisp: aNumber - 1  ! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 10/24/2006 10:06'!
nthValue: aConsCell

	""
	
	^ (self evalToValues: aConsCell cadr) at: aConsCell car + 1 ifAbsent: [nil]! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:26'!
nth: n

	n isZero ifTrue: [^ car].
	cdr ifNil: [^ nil].
	n = 1 ifTrue: [^ cdr car].
	^ cdr nth: n - 1! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 22:41'!
nth: aConsCell

"(nth N LIST)
Return the Nth element of LIST.
N counts from zero.  If LIST is not that long, nil is returned."

	^ aConsCell cadr nth: aConsCell car

	! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/6/2006 22:02'!
nth: n ifAbsent: aBlock

	n isZero ifTrue: [^ car].
	cdr ifNil: [^ aBlock value].
	n = 1 ifTrue: [^ cdr car].
	^ cdr nth: n - 1ifAbsent: aBlock! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 7/7/2006 14:34'!
nullPrintString

	^ 'nil'! !

!ULisp class methodsFor: 'booleans' stamp: 'spfa 7/7/2006 14:33'!
nullPrintString

	^ '()'! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/22/2006 21:10'!
null: aConsCell

"(null OBJECT)
Return t if OBJECT is nil."

	^ self class test: aConsCell car isNil! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 11/13/2006 10:31'!
numberP: aConsCell

"(numberp OBJECT)
Return #t if OBJECT is a number."

	^ self class test: (aConsCell car isNumber or: [aConsCell car isComplex])
".. we need the double test for Squeak 3.8 where a Complex answsers false to #isNumber"! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/19/2006 15:10'!
numberTOstring: aConsCell

"(number->string NUMBER [BASE])
Returns as a string an external representation of NUMBER in the given BASE.
BASE is either 2, 8, 10, or 16. If omitted, BASE defaults to 10. "

	| n base |

	n _ aConsCell car.
	base _ aConsCell cadr ifNil: [10].

	n isComplex ifTrue: [^ self class complexString: n base: base].
	^ n printStringBase: base! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:32'!
oddP: aConsCell

"(oddp NUMBER)
Return #t if NUMBER is odd."

	^ self class test: aConsCell car odd! !

!SScheme class methodsFor: 'libraries' stamp: 'spfa 11/9/2006 21:04'!
oleg

	"highly experimental"

	^#(in-library oleg

	(load 'ulisp\\oleg\\myenv-ulisp.scm') "the Prelude"

	(define (test-oleg)
		(load 'ulisp\\oleg\\assert.scm')
	 	(load 'ulisp\\oleg\\catch-error.scm')
		(load 'ulisp\\oleg\\srfi-13-local.scm')
	 	(load 'ulisp\\oleg\\util.scm')
	 	(load 'ulisp\\oleg\\env.scm')
		(load 'ulisp\\oleg\\vmyenv.scm'))

	(define (REPL)     "to do: change this and the code in lambda-calc.scm ..."
		(load 'ulisp\\oleg\\lambda-calc.scm'))
)

! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/21/2007 23:12'!
olegFiles

	^ self filesInULispDirectory: 'oleg'! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 5/26/2006 11:47'!
openGui

	self gui openInWorld.! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 11/7/2006 14:27'!
openInputFile: aConsCell

"(open-input-file FILENAME)
Takes a string naming an existing file and returns an input port capable of delivering characters from the file"
	
	^ LKIOPort input: (FileDirectory default oldFileNamed: aConsCell car)! !

!LKReader methodsFor: 'macros' stamp: 'spfa 11/2/2006 14:02'!
openList: aStream

	| list item lastCell |

	[item == self closeListMarker] whileFalse:
	[
		aStream atEnd ifTrue: [self error: 'open list'].
		item == #.
			ifTrue: "dotted pair notation" 
			[
				lastCell _ (self read: aStream).
				"handle special case: [. , -> ,@] 
				for example`(a b . ,c) becomes `(a b ,@c)"
				(lastCell isConsCell and: [lastCell car == #unquote])
					ifTrue: [
								list _ ((lastCell car: #'unquote-splicing') inCons cdr: list).
								lastCell _ nil
								].
				"the form `(... . @, ...) is not allowed"
				(lastCell isConsCell and: [lastCell car == #'unquote-splicing'])
					ifTrue: [self error: 'inappropriate context for unquote-splicing'].
			]
			ifFalse: [list _ (item inCons cdr: list)].
		item _ self read: aStream.
	].

	(list ifNil: [^ self emptyListMarker]) cells do: [:cell |
		cell setcdr: lastCell.
		lastCell _ cell].

	^ lastCell cdr ifNil: [self emptyListMarker]! !

!LispKernel class methodsFor: 'public' stamp: 'spfa 6/16/2006 21:30'!
openNew

	^ self new loadDefaultLibraries openGui! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 11/7/2006 14:28'!
openOutputFile: aConsCell

"(open-output-file FILENAME)
Creates and returns a new output port for the file named by FILENAME. 
An error is signaled if the file cannot be opened for output."
	
	^ LKIOPort output: (FileDirectory default forceNewFileNamed: aConsCell car)! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 11/7/2006 14:29'!
outputPortP: aConsCell

"(output-port? OBJECT)
Returns #t if OBJECT is an output port, #f otherwise"
	
	^ self test: (aConsCell car isLKIOPort and: [aConsCell car isOutput])! !

!LKREPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 9/29/2006 16:23'!
outputQueue

	self queue isEmpty ifTrue: [^ self].

	self updateText: (Text streamContents: [:stream |
							stream nextPutAll: (myContents ifNil: ['']).
							self queue size timesRepeat: 
								[stream nextPutAll: self queue next]]).
	self refreshDisplay.! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 11/30/2006 14:08'!
output: aString

	| port |

	(port _ self standardOutput) stream nextPutAll: aString.
	port endEntry.
! !

!LKIOPort class methodsFor: 'as yet unclassified' stamp: 'spfa 12/1/2006 15:16'!
output: aStream

	aStream ifNil: [self error: 'no stream specified'].

	^ self new 
		status: #out;
		outStream: aStream! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:04'!
outStream

	^ outStream ! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:04'!
outStream: aStream

	outStream _ aStream! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 7/19/2006 14:27'!
parent: someLKBindings

	upperBindings _ someLKBindings! !

!LKToken methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2006 00:38'!
parsed

	(couldBeNumber not or: [number isNil]) ifTrue: [^ self contents asSymbol].

	n1 ifNotNil: 
	[
		(couldBeFraction and: [number isZero not]) ifTrue: [^ n1/number].
		couldBeExponent ifTrue: [^ n1 asFloat * (10 raisedTo: (number * sign))].
		^ self contents asSymbol
	].

	^ number * sign! !

!ULispToken methodsFor: 'as yet unclassified' stamp: 'spfa 11/13/2006 11:04'!
parsed

	((couldBeNumber & couldBeComplex)
		and: [i notNil])
	ifTrue:	[^ Complex real: (n1 ifNil: [startWithSign ifTrue: [0] ifFalse: [^ self contents asSymbol]]) 
					imaginary: number * sign].

	^ super parsed
! !

!LKToken class methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2006 00:19'!
parse: aString

	^ self parse: aString base: 10
	! !

!LKToken class methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2006 00:19'!
parse: aString base: aNumber

	| tok |
	tok _ self void.
	tok base: aNumber.
	tok nextPutAll: aString.
	^ tok parsed
	! !

!ELisp methodsFor: 'LISP-functions-system' stamp: 'spfa 9/28/2006 15:26'!
pathNameDelimiter: ignored

"(path-name-delimiter)
return the directory separator character"

	^ FileDirectory activeDirectoryClass pathNameDelimiter! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 11/7/2006 14:29'!
peekChar: aConsCell

"(peek-char &optional STREAM)
Returns the next character available from STREAM, without updating the STREAM to point to the following character. If no more characters are available, an end of file object is returned."

	| str |  

	(str _ aConsCell car ifNil: [self standardInput]) isLKIOPort 
		ifTrue: 
		[
			str atEnd ifTrue: [^ LKIOPort eof].
			^ str stream peek
		].

	^ str asString first
	
	
	! !

!ELisp methodsFor: 'LISP-functions-system' stamp: 'spfa 9/26/2006 21:27'!
platformName: unused

"(platform-name)
Returns the name of the current operating system"

	^ SmalltalkImage current platformName! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 11/14/2006 22:05'!
plist

	"property lists support"

	^ 
	#(in-library plist

		(defun plist-member (plist prop)
'Return non-nil if PLIST has the property PROP.
PLIST is a property list, which is a list of the form (PROP1 VALUE1 PROP2 VALUE2 ...).  PROP is a symbol.
Unlike plist-get, this allows you to distinguish between a missing property and a property with the value nil.
The value is actually the tail of PLIST whose car is PROP.'
			(cond
				((null plist) nil)
				((equal prop (car plist)) (cdr plist))
				((yes*) (plist-member (cdr (cdr plist)) prop))))

		(defun plist-get (plist prop)
'Extract a value from a property list.
PLIST is a property list, which is a list of the form (PROP1 VALUE1 PROP2 VALUE2...).  
This function returns the value corresponding to the given PROP, or nil if PROP is not one of the properties on the list.'
			(let ((pm (plist-member plist prop)))
				(if (null pm)
					(no*)
					(car pm))))

		(defun plist-remove (plist prop)
'Remove PROP from property list PLIST.'
			(plist-tail-remove plist prop nil))

		(defun plist-tail-remove (plist prop oplist)
'private. used by plist-remove'
			(cond
				((null plist) oplist)		
				((equal prop (car plist)) (append oplist (cdr (cdr plist))))
				((yes*) (plist-tail-remove (cdr (cdr plist)) prop
										  (append oplist (list (car plist))
															(list (cadr plist)))))))			

		(defun plist-put (plist prop val)
'Change value in PLIST of PROP to VAL.
PLIST is a property list, which is a list of the form (PROP1 VALUE1 PROP2 VALUE2 ...).  PROP is a symbol and VAL is any object.
If PROP is already a property on the list, its value is set to VAL,otherwise the new PROP VAL pair is added.  
The PLIST is modified by side effects.The new value is returned'
			(let ((cell (plist-member plist prop)))
				(if (not (null cell)) (setcar cell val)
					(setq plist (append plist (list prop val))))
				plist))

 		(defun put (symbol prop value)
'Store SYMBOL''s PROP property with value VALUE.
It can be retrieved with (get SYMBOL PROP).'
			(setplist symbol 
				(if (null (symbol-plist symbol))
					(list prop value)
					(plist-put (symbol-plist symbol) prop value)))
			value)

 		(defun get (symbol prop)
'Return the value of SYMBOL''s PROP property.
It can be stored with (put SYMBOL PROP VAL).'
			(plist-get (symbol-plist symbol) prop)) 

		(defun remove-property (symbol prop)
'Remove PROP from the property list of SYMBOL'
			(setplist symbol (plist-remove (symbol-plist symbol) prop)))

)! !

!LKREPLMorph methodsFor: 'command processing' stamp: 'spfa 6/8/2006 13:55'!
pointedCommand

	| beg end text line prompt |

	text _ textMorph contents asString.
	end _ (text indexOf: Character cr startingAt: selectionInterval last ifAbsent: [text size + 1]) - 1.
	
	beg _ text lastIndexOf: Character cr startingAt: end ifAbsent: [0].
	line _ text asString copyFrom: beg + 1 to: end.
	prompt  _ self prompt asString withoutTrailingBlanks.

	(line beginsWith: prompt) ifFalse: [^ nil].

	^ (line copyFrom: (line skipAnySubStr: {prompt} startingAt: 1) to: line size)
			withBlanksTrimmed! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 6/22/2006 00:54'!
positiveP: aConsCell

"(positive? NUMBER)
Test weither NUMBER > 0."

	^ self class test: aConsCell car > 0! !

!LispKitInfo methodsFor: 'as yet unclassified' stamp: 'spfa 3/29/2007 09:21'!
postscriptText

	^
'
	(ZipArchive new readFrom: ''ulisp.zip'') extractAllTo: FileDirectory default.
'

! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 9/26/2006 21:23'!
pregexp

	"Portable Regular Expressions for Scheme and Common Lisp, by Dorai Sitaram

	http://www.ccs.neu.edu/~dorai/pregexp/pregexp.html
	"

	^#(in-library pregexp

			(define (test-pregexp)
				(load (system-path 'ulisp/pregexp/tester.scm'))
				(load (system-path 'ulisp/pregexp/pregexp-test.scm')))

			(load (system-path 'ulisp/pregexp/pregexp.scm')))


! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/21/2007 23:12'!
pregexpFiles

	^ self filesInULispDirectory: 'pregexp'
! !

!LispKitInfo methodsFor: 'as yet unclassified' stamp: 'spfa 3/17/2007 22:26'!
prerequisitePackages
	"These are the names of packages that get loaded before the main change set"
	^#('People-spfa-utils-3.8' 'People-spfa-fixes-common') ! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 6/22/2006 23:57'!
preserveFalse

	^ false! !

!SLisp class methodsFor: 'booleans' stamp: 'spfa 6/22/2006 23:57'!
preserveFalse

	^ true! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 10/3/2006 14:04'!
preserveNil

	^ true! !

!ULisp class methodsFor: 'booleans' stamp: 'spfa 10/3/2006 14:04'!
preserveNil

	^ false! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 6/22/2006 23:57'!
preserveTrue

	^ false! !

!SLisp class methodsFor: 'booleans' stamp: 'spfa 6/22/2006 23:57'!
preserveTrue

	^ true! !

!LispKernel methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 17:30'!
primitiveP: aConsCell

"(primitive-p SYMBOL)
If SYMBOL globally names a primitive, then a non-nil value is returned; otherwise nil is returned"	

	| sf sel |

	sf _ self symbolFunction: aConsCell car ifNone: [^ self falseValue].
	sf isLKPrimitive ifTrue: [sel _ sf selector].
	sf isSymbol ifTrue: [sel _ sf].
	sel ifNil: [^ self falseValue].

	^ self class test: (self class primitives includes: sel) 
	
! !

!LispKernel class methodsFor: 'private' stamp: 'spfa 6/7/2006 14:12'!
primitives

	^ Primitives! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 10/19/2006 16:05'!
primitives: aConsCell

"(primitives)
Return a list of all functions and special forms implemented as primitives."

	^ self class primitives asArray sort asCons
	! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:09'!
prin1ToString: aConsCell

"(prin1-to-string FORM)
Return a string representing FORM, readable whenever possible"

	^ aConsCell car printStringForLisp: self! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/20/2006 14:43'!
prin1: aConsCell

"(prin1 FORM &optional STREAM)
Write to STREAM a string representing FORM, readable whenever possible"

	| stream port |

	stream _ (port _ aConsCell cadr ifNil: [self standardOutput]) stream.
	aConsCell car printOn: stream forLisp: self.
	port endEntry.
	^ aConsCell car! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/20/2006 14:44'!
princ: aConsCell

"(princ FORM &optional STREAM)
Write to STREAM a string representing FORM"

	| port |
	
	(port _ aConsCell cadr ifNil: [self standardOutput])
		 stream nextPutAll: aConsCell car asString.
	port endEntry.
	^ aConsCell car! !

!LispKernel methodsFor: 'private - variables' stamp: 'spfa 3/23/2007 17:32'!
printCircle

	^ self symbolValue: #'*print-circle*' ifNone: [nil]! !

!LKTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 20:05'!
printIt
	"Treat the current text selection as an expression; evaluate it. Insert the 
	description of the result of evaluation after the selection and then make 
	this description the new text selection."
	| result |
	result _ self evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [view flash]
			ifFalse: [self afterSelectionInsertAndSelect: (result printStringForLisp: model)]! !

!LispKernel methodsFor: 'private - variables' stamp: 'spfa 3/23/2007 17:31'!
printLength

	^ self symbolValue: #'*print-length*' ifNone: [nil]! !

!LispKernel methodsFor: 'private - variables' stamp: 'spfa 3/23/2007 17:31'!
printLevel

	^ self symbolValue: #'*print-level*' ifNone: [nil]! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 10/10/2006 13:49'!
printOn: aStream

	self printOn: aStream forLisp: nil
! !

!LKClosure methodsFor: 'printing' stamp: 'spfa 6/2/2006 23:35'!
printOn: aStream

	^ form printOn: aStream! !

!LKPrimitive methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 16:52'!
printOn: aStream

	aStream nextPutAll: 'primitive '; nextPutAll: selector
! !

!Array methodsFor: '*LispKit' stamp: 'spfa 3/23/2007 17:26'!
printOn: aStream depth: aNumber forLisp: aLisp level: cpl maxLevel: mpl length: len maxLength: mlen done: anIdentitySet cycles: anIdentityDictionary

	(anIdentityDictionary keys includes: self)
	ifTrue: 
	[
		aStream nextPut: $#; 
				nextPutAll: (anIdentityDictionary at: self) asString; 
				nextPut: $=.
		anIdentitySet add: self.
	].

	aStream nextPut: $#; nextPut: $(.
	self do: [:element | 
		(anIdentitySet includes: element)
		ifTrue:
		[
			aStream nextPut: $#; 
				nextPutAll: (anIdentityDictionary at: element) asString; 
				nextPut: $#
		]
		ifFalse:
		[
			element printOn: aStream depth: aNumber forLisp: aLisp 
				level: cpl maxLevel: mpl length: len maxLength: mlen 
				done: anIdentitySet cycles: anIdentityDictionary
		].
		aStream space
	].
	self ifNotEmpty: [aStream skip: -1].
	aStream nextPut: $)! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 3/24/2007 18:27'!
printOn: aStream depth: aNumber forLisp: aLisp level: cpl maxLevel: mpl length: len maxLength: mlen done: anIdentitySet cycles: anIdentityDictionary

	"the so-called 'level' controls the depth of nesting cons cells
	the 'length' controls the numbers of elements in a list to be printed
both refers to standard Common Lisp variables: respectively *print-level* and *print-length*

	see Common Lisp the Language,  2nd edition, chapter 22.1.6"

	| depth |

	depth _ aNumber.

	(anIdentityDictionary keys includes: self)
	ifTrue: 
	[
		aStream nextPut: $#; 
				nextPutAll: (anIdentityDictionary at: self) asString; 
				nextPut: $=.
		anIdentitySet add: self.
	].

	depth isZero ifTrue: [aStream nextPut: $(].

	(car isConsCell | car isArray) ifTrue: 
	[
		(anIdentitySet includes: car) 
		ifTrue: 
		[
			aStream nextPut: $#; 
					nextPutAll: (anIdentityDictionary at: car) asString; 
					nextPut: $#
		]
		ifFalse:
		[
			(mpl notNil and: [cpl >= mpl]) 
				ifTrue: [aStream nextPut: $#]
				ifFalse: 
				[
					car printOn: aStream depth: 0 forLisp: aLisp 
						level: cpl + 1 maxLevel: mpl length: mlen maxLength: mlen
						done: anIdentitySet cycles: anIdentityDictionary
				]
		]
	]
	ifFalse: [car printOn: aStream depth: depth + 1 forLisp: aLisp 
						level: cpl + 1 maxLevel: mpl length: mlen maxLength: mlen
						done: anIdentitySet cycles: anIdentityDictionary].

	cdr ifNil: [^ aStream nextPut: $)].

	aStream space.

	(len notNil and: [len = 1]) ifTrue: [^ aStream nextPutAll: '...)'].

	(cdr isConsCell
		and: [(anIdentitySet includes: cdr) not]
		and: [(anIdentityDictionary keys includes: cdr) not]) ifTrue: 
	[
		^ cdr printOn: aStream depth: depth + 1 forLisp: aLisp 
			level: cpl maxLevel: mpl 
			length: (len ifNotNil: [len - 1]) maxLength: mlen
			done: anIdentitySet cycles: anIdentityDictionary
	].

	aStream nextPut: $.; space. 
	(anIdentitySet includes: cdr) 		
	ifTrue: 
	[
		aStream nextPut: $#; 
			nextPutAll: (anIdentityDictionary at: cdr) asString; 
			nextPut: $#
	]
	ifFalse: 
	[
		cdr printOn: aStream depth: 0 forLisp: aLisp 
			level: cpl maxLevel: mpl
			length: (len ifNotNil: [len - 1]) maxLength: mlen
		 	done: anIdentitySet cycles: anIdentityDictionary
	].
	aStream nextPut: $)
! !

!Object methodsFor: '*LispKit' stamp: 'spfa 3/23/2007 11:23'!
printOn: aStream depth: aNumber forLisp: aLisp level: cpl maxLevel: mpl length: len maxLength: mlen done: anIdentitySet cycles: anIdentityDictionary

	^ self printOn: aStream forLisp: aLisp

! !

!Array methodsFor: '*LispKit' stamp: 'spfa 3/24/2007 16:33'!
printOn: aStream forLisp: aLisp

	| mlen mlev |

	mlen _ aLisp ifNil: [nil] ifNotNil: [aLisp printLength].
	mlev _ aLisp ifNil: [nil] ifNotNil: [aLisp printLevel].

	(aLisp isNil or: [aLisp printCircle == aLisp trueValue])
	ifTrue:
	[
		^ self printOn: aStream depth: 0 forLisp: aLisp 
			level: 1 maxLevel: mlev length: mlen maxLength: mlen 
			done: IdentitySet new cycles: self cycles
	].

	self printOn: aStream depth: 0 forLisp: aLisp 
		level: 1 maxLevel: mlev length: mlen maxLength: mlen 
		done: IdentitySet new cycles: IdentityDictionary new
! !

!Character methodsFor: '*LispKit' stamp: 'spfa 7/5/2006 12:20'!
printOn: aStream forLisp: aLisp

	aStream nextPutAll:(value caseOf:
	{
		[10] -> ['#\newline'] .
		[9] -> ['#\tab'] .
		[32] -> ['#\space'] .			
		[8] -> ['#\backspace'] .			
		[27] -> ['#\escape'] .			
		[13] -> ['#\return'] .			
		[127] -> ['#\rubout'] .	
	} 
	otherwise: ['#\', self asString])! !

!Complex methodsFor: '*LispKit' stamp: 'spfa 7/7/2006 15:53'!
printOn: aStream forLisp: aLisp

	aLisp ifNil: [^ self printOn: aStream].
	aStream nextPutAll: (aLisp class complexString: self base: 10)! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 3/24/2007 16:32'!
printOn: aStream forLisp: aLisp

	| mlen mlev |

	mlen _ aLisp ifNil: [nil] ifNotNil: [aLisp printLength].
	mlev _ aLisp ifNil: [nil] ifNotNil: [aLisp printLevel].

	(aLisp isNil or: [aLisp printCircle == aLisp trueValue])
	ifTrue:
	[
		^ self printOn: aStream depth: 0 forLisp: aLisp 
			level: 1 maxLevel: mlev length: mlen maxLength: mlen 
			done: IdentitySet new cycles: self cycles
	].

	self printOn: aStream depth: 0 forLisp: aLisp 
		level: 1 maxLevel: mlev length: mlen maxLength: mlen 
		done: IdentitySet new cycles: IdentityDictionary new
! !

!False methodsFor: '*LispKit' stamp: 'spfa 7/5/2006 12:23'!
printOn: aStream forLisp: aLisp

	aLisp ifNil: [^ self printOn: aStream].
	aStream nextPutAll: (aLisp class falseValuePrintString)! !

!Fraction methodsFor: '*LispKit' stamp: 'spfa 7/5/2006 12:24'!
printOn: aStream forLisp: aLisp

	numerator printOn: aStream.
	aStream nextPut: $/. 
	denominator printOn: aStream! !

!LKBlock methodsFor: 'as yet unclassified' stamp: 'spfa 11/19/2006 20:24'!
printOn: aStream forLisp: aLisp

	aStream nextPutAll: '#[', (description ifNil: ['?']), ']'
! !

!LKClosure methodsFor: 'printing' stamp: 'spfa 9/25/2006 10:38'!
printOn: aStream forLisp: aLisp

	^ aStream nextPutAll: '#<', form first, '-procedure>'! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 8/5/2006 15:34'!
printOn: aStream forLisp: aLisp 

	| ds |

	ds _ self depth.
	ds _ ds isZero ifTrue: ['top'] ifFalse: [ds asString].

	aStream nextPutAll: '#<env.frame (', ds, ')>' ! !

!LKValues methodsFor: 'as yet unclassified' stamp: 'spfa 10/23/2006 22:35'!
printOn: aStream forLisp: aLisp

	self isEmpty ifTrue: [^ self].
	self size = 1 ifTrue: [^ self first printOn: aStream forLisp: aLisp].

	1 to: self size -1do: [:i | 
		(self at: i) printOn: aStream forLisp: aLisp.
		aStream cr].

	self last printOn: aStream forLisp: aLisp! !

!Number methodsFor: '*LispKit' stamp: 'spfa 7/8/2006 20:14'!
printOn: aStream forLisp: aLisp

	self printOn: aStream.
! !

!Object methodsFor: '*LispKit' stamp: 'spfa 7/8/2006 20:13'!
printOn: aStream forLisp: aLisp

	aStream nextPutAll: '#<'.
	self printOn: aStream.
	aStream nextPut: $>! !

!String methodsFor: '*LispKit' stamp: 'spfa 9/23/2006 21:17'!
printOn: aStream forLisp: aLisp

	aStream nextPut: $".
	aStream nextPutAll: 
		(aLisp ifNil: [self] ifNotNil: [aLisp class representString: self]).
	aStream nextPut: $"! !

!Symbol methodsFor: '*LispKit' stamp: 'spfa 10/22/2006 18:50'!
printOn: aStream forLisp: aLisp

	aLisp ifNotNil: [^ aLisp printSymbol: self on: aStream].
	aStream nextPutAll: self



! !

!True methodsFor: '*LispKit' stamp: 'spfa 7/5/2006 12:23'!
printOn: aStream forLisp: aLisp

	aLisp ifNil: [^ self printOn: aStream].
	aStream nextPutAll: (aLisp class trueValuePrintString)! !

!UndefinedObject methodsFor: '*LispKit' stamp: 'spfa 7/7/2006 14:33'!
printOn: aStream forLisp: aLisp

	aLisp ifNil: [^ self printOn: aStream].
	aStream nextPutAll: aLisp class nullPrintString
! !

!Object methodsFor: '*LispKit' stamp: 'spfa 7/5/2006 12:17'!
printStringForLisp: aLisp

	^ String streamContents: [:s | self printOn: s forLisp: aLisp]! !

!Object methodsFor: '*LispKit' stamp: 'spfa 7/7/2006 19:05'!
printStringForLisp: aLisp limitedTo: limit

	| limitedString |
	limitedString _ String streamContents: [:s | self printOn: s forLisp: aLisp] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...'! !

!ELisp methodsFor: 'private - symbols' stamp: 'spfa 10/22/2006 18:49'!
printSymbol: aSymbol on: aStream

	| sym |

	sym _ self uninternedSymbol: aSymbol.

	(sym isAllLetters
		or: [([self reader read: (ReadStream on: sym)] 
				on: Error do: [nil]) == sym])
	ifFalse: [^ aStream nextPut: $| ;nextPutAll: sym; nextPut: $|].

	aStream nextPutAll: sym
! !

!LispKernel methodsFor: 'private - symbols' stamp: 'spfa 10/22/2006 18:51'!
printSymbol: aSymbol on: aStream

	aStream nextPutAll: aSymbol! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/20/2006 14:44'!
print: aConsCell

"(print FORM &optional STREAM)
Write to STREAM a string representing FORM, readable whenever possible, preceded by a newline and followed by a space"

	| stream port |

	stream _ (port _ aConsCell cadr ifNil: [self standardOutput]) stream.
	stream cr.
	aConsCell car printOn: stream forLisp: self.
	stream space.
	port endEntry.
	^ aConsCell car! !

!TailCallWrapper methodsFor: 'accessing' stamp: 'spfa 11/17/2006 17:31'!
procedure

	^ procedure ! !

!ULisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 17:20'!
procedureP: aConsCell
	
"(procedure? OBJECT)
Return #t if OBJECT is a procedure."

	| o |

	o _ aConsCell car.

	^ self class test: (o isLispClosure
			or: [o isLKPrimitive and: [self class primitives includes: o selector]])

! !

!TailCallWrapper methodsFor: 'accessing' stamp: 'spfa 11/17/2006 17:31'!
procedure: aConsCell

	procedure _  aConsCell! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:05'!
profile: aConsCell

"(profile FORM)
Evaluate FORM with a TimeProfileBrowser spying."

	^ TimeProfileBrowser spyOn: [self evalObject: aConsCell car] ! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/24/2006 10:45'!
prog1: aConsCell

"(prog1 FIRST &rest BODY)
Eval FIRST and BODY sequentially; return the value from FIRST"

	| val |
	val _ self evalObject: aConsCell first.
	(aConsCell cdr ifNil: [^ val]) do: [:form | self evalObject: form].
	^ val! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/24/2006 10:46'!
prog2: aConsCell

"(prog1 FIRST SECOND &rest BODY)
Eval FIRST, SECOND and BODY sequentially; return the value from SECOND"

	| val |

	self evalObject: aConsCell first.
	val _ self evalObject: aConsCell second.
	((aConsCell nthcdr: 2) ifNil: [^ val]) do: [:form | self evalObject: form].
	^ val! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 11/17/2006 20:59'!
progn: aConsCell

"(progn &rest BODY)
Eval BODY forms sequentially and return value of last one."

	aConsCell ifNil: [^ nil].
	aConsCell doWithCdr: [:form :cdr | 
		cdr ifNil: [^ self evalTailObject: form].
		self evalObject: form].
	! !

!LispKernel methodsFor: 'GUI' stamp: 'spfa 6/8/2006 13:57'!
prompt
	
	| d |

	^ ((d _ self depth) isZero ifTrue: ['top'] ifFalse: ['-',d asString,'-']), '>'! !

!LKREPLMorph methodsFor: 'initialization' stamp: 'spfa 6/8/2006 13:59'!
prompt
	
	^ lisp prompt, ' '! !

!SLisp methodsFor: 'GUI' stamp: 'spfa 6/8/2006 16:02'!
prompt

	syntax = #smalltalk ifFalse: [^ super prompt].

	^ '[smalltalk]', super prompt ! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 7/7/2006 14:06'!
provideLibrary

	"inspired by the 'provide' feature of Emacs Lisp"
	
	^ 
	#(progn

		(defmacro in-library (lib . body)
'Evaluate BODY as the code provided by library LIB, a symbol.
A variable called Library:LIB stores all symbols bound at top-level in BODY, be it as variables, functions or macros.
After BODY has been evaluated, LIB is added to the *libraries*.'
			(let (functions)
				(dolist (form body)
					(if (memq (nth 0 form) $'(defun defmacro defvar))
						(setq functions (append functions (list (nth 1form))))))
			`(progn
				(defvar ,(sconcat $'#'*library:' lib $'*) (quote ,functions))
				,@body
				(provide-library (quote ,lib)))))
	
		(in-library provide-library

			(defvar #'*libraries*' nil)

			(defun provide-library (symbol)
'Declare SYMBOL a provided feature. 
The list of features is stored in variable *libraries*'
				(add-to-list $'#'*libraries*' symbol)
				(yes*))

			(defun require-library (symbol)
'Load library SYMBOL if it is not provided yet'
				(if (not (featurep symbol))
						(load-library symbol)
					(yes*)))

			(defun add-to-list (lst element)
'If ELEMENT is not a member of LIST (a quoted symbol), add it as the last element'
				(if (member element (symbol-value lst))
						(symbol-value lst)
					(set lst (append (symbol-value lst) (list element)))))
	
			(defun featurep (symbol)
'Tells weither library SYMBOL is provided'
				(if (member symbol #'*libraries*') (yes*)))

		))
! !

!LispKernel methodsFor: 'property lists' stamp: 'spfa 11/12/2006 19:02'!
put: aSymbol symbol: bSymbol value: anObject

	| plist prop |

	plist _ (self remprop: aSymbol symbol: bSymbol).
	prop _ {aSymbol . anObject} asCons.	

	plist ifNotNil: [plist append: prop]
		ifNil: [self symbolPlists add: (bSymbol -> prop)].

	^ anObject! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 11/9/2006 16:20'!
quasiquoteForm: aForm depth: depth

	| cons |

	aForm isArray ifTrue: 
		[^ (self quasiquoteForm: aForm asConsList depth: depth) topForms].
	aForm isConsCell ifFalse: [^ aForm].

	cons _ ConsCell new.

	(aForm doWithCdr: [:form :cdr|
		(form == #unquote
			and: [(cdr == aForm cdr) not] 
			and: [cdr cdr isNil]
			and: [depth = 0])
		ifTrue: [cons append: (self evalObject: cdr car). ^ cons cdr]
		ifFalse: 
		[
			((form isConsCell
					and: [form first == #unquote 
							or: [form first == #'unquote-splicing']])
				ifTrue: 
				[	
					depth = 0 ifTrue:
					[
						form first == #unquote 
							ifTrue: [cons addLast: (self evalObject: form second)]
							ifFalse: [cons append: (self evalObject: form second)]
					]
					ifFalse:
					[cons addLast: (self quasiquoteForm: form depth: depth - 1)]
				]
				ifFalse: 
				[
					(form isConsCell and: [form first == #quasiquote])
					ifTrue: [cons addLast: 
								(self quasiquoteForm: form depth: depth + 1)]
					ifFalse: [cons addLast: 
								(self quasiquoteForm: form depth: depth)]
				]).
			(cdr notNil and: [cdr isConsCell not]) ifTrue: [cons append: cdr]
		]]) .

	^ cons cdr

! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/25/2006 10:20'!
quasiquote: aConsCell

"(quasiquote TEMPLATE)
The whole TEMPLATE acts as if it was quoted except for certain
places where expressions are evaluated and inserted or spliced in.

For example: if b is bound to (1 2 3)		
`(a b c) => (a b c)		
`(a ,b c) => (a (1 2 3) c)	
`(a ,@b c) => (a 1 2 3 c)	

Nested quasiquotes are permitted."

	(aConsCell car ifNil: [^ nil]) first == #unquote 
			ifTrue: [^ (self quasiquoteForm: aConsCell depth: 0) car].

	aConsCell car first == #'unquote-splicing'
			ifTrue: [self lispError: 'invalid context for unquote-splicing'].

	^ self quasiquoteForm: aConsCell car depth: 0

! !

!LKREPLMorph methodsFor: 'initialization' stamp: 'spfa 9/28/2006 22:43'!
queue

	^ queue ifNil: [queue _ SharedQueue new]! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 6/22/2006 21:14'!
quote: aConsCell

"(quote ARG)
Return ARG without evaluating it."

	^ aConsCell car! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/6/2006 00:21'!
quote: aStream

	^ #quote inCons addLast: (self read: aStream)! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/4/2006 21:36'!
quotient: aConsCell

"
"

	^ aConsCell car quo: aConsCell cadr

! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:36'!
rationalP: aConsCell

	^ self test: (aConsCell car isInteger or: [aConsCell car isFraction])! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 3/27/2007 17:44'!
rawEvalObject: anObject multipleValue: mvflag tail: tflag

	| func |

	"compiled s-expression"
	anObject isCompiled ifTrue:
		[^ anObject withLisp: self multipleValue: mvflag  tail: tflag].

	"symbol"
	anObject isSymbol ifTrue: [^ self symbolValue: anObject
				ifNone: [self lispError: 'no value for symbol ', anObject]].

	"atom"
	anObject isConsCell ifFalse: [^ anObject]. 

	"function lookup"
	func _ self lookUpFunction: anObject car.

"this is not used yet.."
"	func isCompiled ifTrue:
		[self notYetImplemented. 
		^ (anObject withLisp: self multipleValue: mvflag tail: tflag) value: anObject cdr].
"

	"lambda form: (macro...  (lambda... or closure"
	func isProcedure ifTrue:
	[
		tflag ifFalse:
		[
			^ self evalProcedure: func 
					withArgs: anObject cdr 
					id: anObject car
		]
		ifTrue:
		[
			^ TailCallWrapper new
				procedure: func ;
				args: anObject cdr;
				id: anObject car;
				lisp: self
		]
	].

	func isLKPrimitive ifFalse: [self lispError: 'Invalid function: ', func asString].

	"primitive or considered as such. 
	... maybe #lispDoesNotUnderstand: will do something"
	(self class specialForms includes: func selector) 
		ifTrue: [^ self perform: func selector with: anObject cdr].

	^ self perform: func selector 
		with: (anObject cdr 
				ifNotNil: [anObject cdr collect: [:form | self evalObject: form]])
! !

!SLisp methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 3/27/2007 17:44'!
rawEvalObject: anObject multipleValue: mvflag tail: tflag

	| func |

	"compiled s-expression"
	anObject isCompiled ifTrue:
		[^ anObject withLisp: self multipleValue: mvflag  tail: tflag].

	"symbol"
	anObject isSymbol ifTrue: [^ self symbolValue: anObject
				ifNone: [self lispError: 'no value for symbol ', anObject]].

	"atom"
	anObject isConsCell ifFalse: [^ anObject]. 

	"function lookup"
	func _ self lookUpFunction: anObject car.

	func isSymbol ifTrue: "func considered as a Smalltalk selector"
	[
		anObject cddr
			ifNil: [^ (self evalObject: anObject cadr) perform: func].
		^ (self evalObject: anObject cadr) perform: func 
			withArguments: (anObject cddr collect: [:form | self evalObject: form]) arrayForm
	].

"this is not used yet.."
"	func isCompiled ifTrue:
		[self notYetImplemented. 
		^ (anObject withLisp: self multipleValue: mvflag tail: tflag) value: anObject cdr].
"

	"lambda form: (macro...  (lambda... or closure"
	func isProcedure ifTrue:
	[
		tflag ifFalse:
		[
			^ self evalProcedure: func 
					withArgs: anObject cdr 
					id: anObject car
		]
		ifTrue:
		[
			^ TailCallWrapper new
				procedure: func ;
				args: anObject cdr;
				id: anObject car;
				lisp: self
		]
	].

	func isLKPrimitive ifFalse: [self lispError: 'Invalid function: ', func asString].

	"primitive"
	(self class specialForms includes: func selector) 
		ifTrue: [^ self perform: func selector with: anObject cdr].

	^ self perform: func selector 
			with: (anObject cdr 
					ifNotNil: [anObject cdr collect: [:form | self evalObject: form]])
! !

!ULisp methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 3/27/2007 17:44'!
rawEvalObject: anObject multipleValue: mvflag tail: tflag

	| func |

	"compiled s-expression"
	anObject isCompiled ifTrue:
		[^ anObject withLisp: self multipleValue: mvflag tail: tflag].

	"symbol"
	anObject isSymbol ifTrue: [^ self symbolValue: anObject
				ifNone: [self lispError: 'no value for symbol ', anObject]].

	"atom"
	anObject isConsCell ifFalse: [^ anObject]. 

	"function lookup"
	func _ self lookUpFunction: anObject car.

"this is not used yet.."
"	func isCompiled ifTrue:
		[self notYetImplemented. 
		^ (anObject withLisp: self multipleValue: mvflag tail: tflag) value: anObject cdr].
"

	"lambda form: (macro...  (lambda... or closure"
	func isLispClosure ifTrue:
	[
		tflag ifFalse:
		[
			^ self evalProcedure: func 
					withArgs: anObject cdr 
					id: anObject car
		]
		ifTrue:
		[
			^ TailCallWrapper new
				procedure: func ;
				args: anObject cdr;
				id: anObject car;
				lisp: self
		]
	].

	func isLKPrimitive ifFalse: [self lispError: 'Invalid function: ', func asString].

	"primitive"
	(self class specialForms includes: func selector) 
		ifTrue: [^ self perform: func selector with: anObject cdr].
	
	^ self perform: func selector 
			with: (anObject cdr 
					ifNotNil: [anObject cdr collect: [:form | self evalObject: form]])! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 11/7/2006 14:29'!
readChar: aConsCell

"(read-char &optional STREAM)
Inputs one character from STREAM and returns it as a character object. The corresponding output function is write-char. "

	| stream stdin | 

	stdin _ self standardInput.
	(stream _ aConsCell car) ifNil: [stream _ stdin].

	(stream == stdin and: [stream atEnd]) "weird logic,to be corrected.."
		ifTrue: [
			self focusedREPL 
				ifNil: [self interactivelyFeedInputStream]        "no GUI"
				ifNotNil: ["we have a GUI, just wait for input"
					"first make sure there is no pending output:"
					self standardOutput force. 
					"now wait"
					[stream atEnd] whileTrue: [World doOneCycle]]].

	stream isLKIOPort 
		ifTrue: [^ stream atEnd 
					ifTrue: [LKIOPort eof] ifFalse: [stream stream next]]
		ifFalse: [^ stream asString first]
	! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 10/6/2006 14:24'!
reader

	^ LKReader for: self! !

!SLisp methodsFor: 'private' stamp: 'spfa 10/6/2006 14:25'!
reader

	^ SLispReader for: self! !

!ULisp methodsFor: 'private' stamp: 'spfa 10/9/2006 14:03'!
reader

	^ ULispReader for: self! !

!LispKitInfo methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 21:25'!
readmeText
	"Text shown to the user after load"
	
	^ 'LispKit: a kit for building one''s own custom Lisp implementation 

LispKit provides:

1)	an extensible minimal Lisp-2 interpreter (the kernel) with
	- dynamic scoping  la Emacs Lisp
	- all fundamental special forms: let, setq, and, or, if, defun, defmacro ...
	- more than 100 basic functions: list, car, funcall, null ...
	- catch/throw, unwind-protect
	- a GUI:
			LispKernel openNew     "doIt"
			ELisp openNew 		"doIt ..this one is more usable"

2)	an actual Scheme implementation	
			ULisp openNew 		"doIt"
			SScheme openNew     "doIt ..slower, experimental, supports macros"

3)  a draft for a Common Lisp like dialect
			CLisp openNew 		"doIt"			


LispKernel usage:

	subclasses of LispKernel can implement their own dialect of Lisp, by adding new functions and special forms and/or by overriding methods.
	see SLisp, CLisp  and ULisp for examples:
	- SLisp integrates Smalltalk into LispKernel
	- CLisp is a static Lisp-2 with special variables like Common Lisp
	- ULisp is a comprehensive Scheme implementation


implementation specificities

	LispKernel is a pure Smalltalk extension. There is no parser (only the "read" lisp function) nor compiler; the interpreter is the ''eval'' lisp function itself (see LispKernel>>#eval:)

	Lisp code can be written as plain Smalltalk arrays, such as

	#(defmacro addToList (x y) `(+ ,x ,@y))  "printIt" 

	the conversion into Lisp data is straightforward: see the very simple code in Array>>#asCons which converts the array into a tree of cons cells. example:

	#(defun add (x y) (+ x y)) asCons     "exploretIt"

	this approach has many advantages. for example:
	- we can chase the senders of a symbol: try [defun] (alt-n)
	- we can use the debugger to debug Lisp code
	- we can easily implement powerful control structure (see catch/throw) 
	- we can integrate Lisp and Smalltalk (see SLisp)

... see LispKernel and its subclasses class comments for more documentation
		'! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'muOuser 3/26/2007 09:36'!
readString: aString

	^ self read: (ReadStream on: aString)! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 11/9/2006 15:21'!
read: aConsCell

"(read &optional PORT)
Read a Lisp expression from PORT, return it as a Lisp object.
PORT can be a string
If it is nil, user is interactively prompted for a string"

	| port stdin reader | 

	stdin _ self standardInput.
	(port _ aConsCell car) ifNil: [port _ stdin].
	reader _ self reader.

	(port == stdin 
		and: [(reader foundToken: port stream) not]) "weird logic,to be corrected.."
	ifTrue: [
			self focusedREPL 
				ifNil: [self interactivelyFeedInputStream]        "no GUI"
				ifNotNil: ["we have a GUI, just wait for input"
					"first make sure there is no pending output:"
					self standardOutput force. 
					"now wait"
					[port atEnd] whileTrue: [World doOneCycle]]].

	port isString ifTrue: [^ reader read: (ReadStream on: port)].

	^ reader read: port stream

! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/7/2006 14:28'!
read: aStream

	"this follows the algorithm described in
	Common Lisp the Language, 2nd edition, section 22.1.1"

	| x y token type ytype nme escflag caseMatters |

	token _ self token void.
	type _ #whiteSpace.
	nme _ 0.
	escflag _ false.
	caseMatters _ lisp ifNil: [false] ifNotNil: [lisp ignoresCase not].
	
	[type == #whiteSpace] whileTrue: [
"step 1"
		aStream atEnd ifTrue: [^ LKIOPort eof].
		x _ aStream next.
		type _ self class syntacticTypes at: (x asciiValue).
"step 4"
		(type == #terminatingMacro or: [type == #nonTerminatingMacro])
		ifTrue:	[	| val |
					val _ self perform: (self class macros at: x) with: aStream.
					val == self emptyListMarker ifTrue: [^ nil].
					val ifNotNil: [^ val].
					type _ #whiteSpace]].	
"step 5"
	type == #singleEscape 
		ifTrue: [token nextPut: aStream next. escflag _ true].
"step 6"
	type == #multipleEscape ifTrue: [nme _ nme + 1].
"step 7"	
	(nme even and: [type == #constituent]) 
		ifTrue: [token nextPut: (caseMatters ifFalse: [x asLowercase]
														ifTrue: [x])].
"step 8"
	[true] whileTrue: [	
		[nme even] whileTrue: [	
			y _ aStream peek.
			(y isNil "e.g.   aStream atEnd"
				or: [(ytype _ self class syntacticTypes at: (y asciiValue)) 
						== #terminatingMacro or: [ytype == #whiteSpace]])
 				ifTrue: [(nme isZero & escflag not) 
							ifFalse: [^ token contents asSymbol]
							ifTrue: [^ token parsed]].
			aStream next. 
			(ytype == #constituent or: [ytype == #nonTerminatingMacro])
				ifTrue: [token nextPut: (caseMatters ifFalse: [y asLowercase]
														ifTrue: [y])].
			ytype == #singleEscape 
				ifTrue: [token nextPut: aStream next. escflag _ true].
			ytype == #multipleEscape ifTrue: [nme _ nme + 1]].
"step 9"
		[nme odd] whileTrue: [	
			aStream atEnd ifTrue: [self error: 'missing escape'].
			y _ aStream next.
			ytype _ self class syntacticTypes at: (y asciiValue). 
			ytype == #multipleEscape 
				ifTrue: [nme _ nme + 1]
				ifFalse: [ ytype == #singleEscape
								ifTrue: [token nextPut: aStream next. escflag _ true]
								ifFalse: [token nextPut: y]]]].
! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:36'!
realP: aConsCell

	^ self test: aConsCell car isNumber! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 9/30/2006 23:48'!
recRewrite2: anObject

	"second pass of recRewrite"

	| car cdr |

	anObject ifNil: [^ nil].

	anObject isArray ifTrue: [^ (self recRewrite2: anObject asConsList) topForms].
	anObject isConsCell ifFalse: [^ anObject].

	car _ anObject car.
	cdr _ anObject cdr.

	anObject setcar: (self recRewrite2: car).
	anObject setcdr: (self recRewrite2: cdr).

	car isSymbol ifFalse: [^ anObject ].

	"see #rewriteString:"
	(car beginsWith: 'asciiValue') ifFalse: [^ anObject ].

	anObject setcar: (Character codePoint: (car last: 2) asNumber) asSymbol.

	^ anObject 

	! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 11/9/2006 16:08'!
recRewrite: anObject

	| car cdr sym bsym s |

	anObject ifNil: [^ nil].

	anObject isArray ifTrue: [^ (self recRewrite: anObject asConsList) topForms].
	anObject isConsCell ifFalse: [^ anObject].

	"dotted pair notation" 
	(anObject cdr isConsCell
		and: [anObject cadr == #.]) ifTrue:	
	[		
		anObject cddr car == #,
		ifTrue: [ "very special case: [. , -> ,@] 
					for example`(a b . ,c) becomes `(a b ,@c)"
			anObject setcdr: (#',@' inCons lastCdr: anObject cddr cdr)]
		ifFalse: [
			self recRewrite: anObject cdr cdr. 
			anObject setcdr: anObject cdr cadr]
	].  

	car _ anObject  car.
	cdr _ anObject cdr.

	anObject setcar: (self recRewrite: car).
	anObject setcdr: (self recRewrite: cdr).

	(car isSymbol or: [car isCharacter]) ifFalse: [^ anObject ].

	(self sugarKeys identityIncludes: car)
		ifTrue: [anObject setcar: 
					(ConsCell car: (self sugar at: car)
							cdr: (ConsCell car: anObject cadr cdr: nil)).
				anObject setcdr: cdr cdr].

	anObject cdr isConsCell ifFalse: [^ anObject].

	sym _ anObject car.

	(sym == #& and: [(bsym _ anObject cadr) isSymbol])
		ifTrue:
		[
			anObject setcar: (sym, bsym) asSymbol.
			anObject setcdr: anObject cdr cdr
		].

	s _ anObject cadr.
	(#(!! ? *) identityIncludes: s)
		ifTrue: 
		[
			anObject setcar: (sym, s) asSymbol.
			anObject setcdr: anObject cdr cdr
		].

	((s == #- or: [s == #/]) and: [(bsym _ anObject cdr cadr) isSymbol])
		ifTrue: 
		[
			anObject setcar: (sym, s, bsym) asSymbol.
			anObject setcdr: anObject cdr cdr cdr
		].

	^ anObject 

	! !

!LKREPLMorph methodsFor: 'contents' stamp: 'spfa 9/28/2006 23:12'!
refreshDisplay

	textMorph newContents:  myContents.
	self selectFrom: myContents size + 1 to: myContents size + 1.
	self scrollSelectionIntoView; refreshWorld
! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/4/2006 21:40'!
remainder: aConsCell

"
"

	^ aConsCell car - ((aConsCell car quo: aConsCell cadr) * aConsCell cadr)

! !

!LispKernel methodsFor: 'property lists' stamp: 'spfa 11/12/2006 19:07'!
remprop: aSymbol symbol: bSymbol

	| plist |

	plist _ self symbolPlists at: bSymbol ifAbsent: [^ nil].

	plist car == aSymbol 
		ifTrue: [self symbolPlists add: (bSymbol -> plist cddr). ^ plist cddr]
		ifFalse:
		[
			plist _ plist cdr.
			[plist cdr notNil] whileTrue:
			[
				plist cadr == aSymbol 
					ifTrue: [plist setcdr: plist cddr cdr. 
								^ self symbolPlists at: bSymbol].
				plist _ plist cddr
			].
		].
	
	^ self symbolPlists at: bSymbol! !

!LispKernel class methodsFor: 'string format conversion' stamp: 'spfa 11/30/2006 13:33'!
representString: aString

	"transcode aString from Smalltalk format into this lisp format"

	| str |

	str _ aString.
	str _ str copyReplaceAll: '\' with: '\\'.
	str _ str copyReplaceAll: '"' with: '\"' .

	self escapeSequences do: [:assoc |
		str _ str copyReplaceAll: assoc value with: assoc key].            

	^ str
	! !

!LKIOPort methodsFor: 'proxy' stamp: 'spfa 10/20/2006 14:46'!
reset

	self stream reset! !

!ULisp methodsFor: 'LISP-functions-continuations' stamp: 'spfa 10/24/2006 14:12'!
restoreContinuationWithValue: aConsCell

	aConsCell car car value: aConsCell car cdr
	

! !

!Continuation methodsFor: 'as yet unclassified' stamp: 'avi 4/24/2004 12:39'!
restoreValues
	| valueStream context |
	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]]! !

!LKContinuation methodsFor: 'private' stamp: 'spfa 6/16/2006 13:35'!
restoreValuesWithTop: topSenders
	| valueStream context  |

	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]].

	context privSender: topSenders first.

	valueStream _ topSenders readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]].
! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 7/1/2006 00:17'!
reverse: aConsCell

"(reverse LIST)
Reverse LIST, copying.  Returns the beginning of the reversed list."

	^ self nreverse: (aConsCell car ifNil: [^ nil]) listCopy inCons! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 9/30/2006 23:11'!
rewriteAndEval: anObject

	"lisp primitives should use this methods instead of #top: which is always considered as the topmost context of a Lisp interpreter."

	^ self eval: (self class rewrite: anObject asCons) inCons.
! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 6/19/2006 13:51'!
rewriteCurlyBlocks: aConsCell

	"aConsCell wrapCurlyBlocksWith: ..."


	! !

!SLisp class methodsFor: 'rewriter' stamp: 'spfa 6/19/2006 13:52'!
rewriteCurlyBlocks: aConsCell.

	aConsCell wrapCurlyBlocksWith: #withSmalltalkSyntax:. 

! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 6/19/2006 14:59'!
rewriteSquareBlocks: aConsCell

	"aConsCell wrapBlocksWith: ... "! !

!SLisp class methodsFor: 'rewriter' stamp: 'spfa 6/19/2006 15:01'!
rewriteSquareBlocks: aConsCell.

	aConsCell wrapSquareBlocksWith: #lispInSmalltalkSyntax:. 

! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 9/30/2006 22:22'!
rewrite: anObject

	"mostly useful when anObject has been freshly created by sending #asCons to an hand-writen Array of lisp code

	this rewriting procedure handles syntactic sugar such as dotted pair notation, the direct usage of ,@ or ` within an Array, or using compound symbols such as this-one, plus more...

	without rewriting, the lisp-like Array
		#(setq an-example `(1 + ,some-var)) 
	would need to be written
		#(setq #'an-example'  (quasiquote (1 + (unquote #'some-var'))))

	see by yourself by inspecting or printing the following: 

	#(setq an-example `(1 + ,some-var)) asCons
	LispKernel rewrite: #(setq an-example `(1 + ,some-var)) asCons
	#(setq #'an-example'  (quasiquote (1 + (unquote #'some-var')))) asCons
"

	| datacode |

	(datacode _ anObject) isConsCell ifTrue:
	[	
		self useSquareBrackets ifTrue: [self rewriteSquareBlocks: datacode].
		self useCurlyBrackets ifTrue: [self rewriteCurlyBlocks: datacode].
	 ].
	datacode _ self recRewrite: datacode.
	datacode _ self recRewrite2: datacode. 
	^ datacode 

	! !

!ELisp methodsFor: 'LISP-functions-math' stamp: 'spfa 10/25/2006 14:34'!
round: aConsCell

	| x n r |

	x _ aConsCell car.	
	n _ x rounded.
	(((r _ x-n) abs = 0.5)
		and: [n odd]) ifTrue: [n _ n - n sign. r _ r negated].
	^ LKValues with: n with: r! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 9/26/2006 21:32'!
SCMFiles

	^ {}! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 3/23/2007 10:01'!
safeDo: aBlock

	^ self safeDo: aBlock done: IdentitySet new! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 3/23/2007 10:01'!
safeDo: aBlock done: anIdentitySet

	(anIdentitySet includes: car)
		ifFalse: [aBlock value: self car. anIdentitySet add: car].

	((anIdentitySet includes: cdr) 
		or: [cdr isConsCell not]) ifTrue: [^ self].

	cdr safeDo: aBlock done: anIdentitySet

! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 10/22/2006 00:11'!
safeLength

	cdr isNil ifTrue: [^ 1].
	cdr isConsCell ifFalse: [^ 2].
	^ cdr safeLength + 1
! !

!Character methodsFor: '*LispKit' stamp: 'spfa 8/14/2006 15:36'!
sameAs: aCharacter 
	"Answer whether the receiver is equal to aCharacter, ignoring case"
	^ (self asLowercase = aCharacter asLowercase)	! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 9/26/2006 21:23'!
schelog

	"Prolog-style logic programming in Scheme, by Dorai Sitaram

	http://www.ccs.neu.edu/home/dorai/schelog/schelog.html
	"

	^#(in-library schelog
			(load (system-path 'ulisp/schelog/schelog.scm')))


! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 9/26/2006 16:05'!
schelogExampleFiles

	^ (((FileDirectory default directoryNamed: 'ulisp') directoryNamed: 'schelog') 
			directoryNamed: 'examples') 
			fileNames 
			collect: [:fn | 'ulisp', FileDirectory slash, 'schelog', FileDirectory slash,  'examples', FileDirectory slash, fn]
! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/21/2007 23:13'!
schelogFiles

	^ self filesInULispDirectory: 'schelog'! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 3/27/2007 14:52'!
scheme

	"some code here from 'The Scheme Programming Language' (third edition) by R. Kent Dybvig [tspl3]
	http://www.scheme.com/tspl3/

	some code from 'Teach Yourself Scheme in Fixnum Days' by Dorai Sitaram [tysfn]
	http://www.ccs.neu.edu/home/dorai/t-y-scheme/t-y-scheme.html
	"

	^#(in-library scheme

"aliases for already defined lisp functions. 
we keep the lisp symbol definition"
(define memv member)
(define begin progn)
(define #'null?' null)

"recycle destructively already defined lisp functions
we do not keep the lisp symbol definition"
(defmacro defsalias (ssymb lsymb)
	`(progn:
		(define ,ssymb ,lsymb)
		(makunbound $',lsymb)))

(defsalias add1 #'1+')
(defsalias = n-equal)
(defsalias #'eq?' eq)
(defsalias #'pair?' #'cons?')
(defsalias #'set-car!!' setcar)
(defsalias #'set-cdr!!' setcdr)
(defsalias #'string->symbol' intern)
(defsalias #'string->uninterned-symbol' make-symbol)
(defsalias write prin1)

"aliases"
(define #'call/cc' call-with-current-continuation)


"pairs"
(defunary last-pair last)	"srfi-1"

"characters"

(define #'char=?' eq?)
(define #'char<=?' <=)
(define #'char>=?' >=)
(define #'char<?' <)
(define #'char>?' >)
(defbinary #'char-ci=?' sameAs:)
(defunary char-upcase asUppercase)
(defunary char-downcase asLowercase)
(define (#'char-ci<?' c1 c2) (< (char-upcase c1) (char-upcase c2)))
(define (#'char-ci<=?' c1 c2) (<= (char-upcase c1) (char-upcase c2)))
(define (#'char-ci>?' c1 c2) (> (char-upcase c1) (char-upcase c2)))
(define (#'char-ci>=?' c1 c2) (>= (char-upcase c1) (char-upcase c2)))

"strings"

(define string-copy copy)
(define string-append concat)
(define string-length length)
(define string-ref elt)
(defbinary #'string=?' =)
(defbinary #'string-ci=?' sameAs:)
(define #'string<=?' <=)
(define #'string>=?' >=)
(define #'string<?' <)
(define #'string>?' >)
(defunary string-upcase asUppercase)
(defunary string-downcase asLowercase)
(define (#'string-ci<?' c1 c2) (< (string-upcase c1) (string-upcase c2)))
(define (#'string-ci<=?' c1 c2) (<= (string-upcase c1) (string-upcase c2)))
(define (#'string-ci>?' c1 c2) (> (string-upcase c1) (string-upcase c2)))
(define (#'string-ci>=?' c1 c2) (>= (string-upcase c1) (string-upcase c2)))


(define substring
  (lambda (s1 m n)
    (let ((s2 (make-string (- n m))))
      (do ((j 0 (+ j 1)) (i m (+ i 1)))
          ((= i n) s2)
          (string-set!! s2 j (string-ref s1 i)))))) 

"vectors"

(define vector-length length)
(define vector-ref elt)
(define (#'list->vector' args) (apply vector args))

"I/O"

(define call-with-output-file
  (lambda (filename proc)
'Creates a new output port for the file named by FILENAME and passes this port to PROC. An error is signaled if the file cannot be opened for output. If PROC returns, call-with-output-file closes the output port and returns the value returned by PROC'
    (let ((p (open-output-file filename)))
      (let ((v (proc p)))
        (close-output-port p)
        v))))

(defunary close-input-port close)
(defunary close-output-port close)

"delayed evaluation with multiple value support
from tspl3, sections 5.6 and 5.7"

(defmacro delay (exp)
  `(make-promise (lambda () ,exp)))

(define make-promise
  (lambda (p)
    (let ((vals false) (set? false))
      (lambda ()
        (if (not set?)
            (call-with-values p
              (lambda x
                (if (not set?)
                    (begin (set!! vals x)
                           (set!! set? true))))))
        (apply values vals))))) 

(define force
  (lambda (promise)
    (promise)))


"fluid-let
from tysfn, section 8.3"

(define-macro fluid-let 
	(lambda (xexe . body)
		(let ((xx (map car xexe))
			(ee (map cadr xexe))
			(old-xx (map (lambda (ig) (gensym)) xexe))
			(result (gensym)))
	`(let ,(map (lambda (old-x x) `(,old-x ,x)) 
							old-xx xx)
		,@(map (lambda (x e)
					`(set!! ,x ,e)) 
				xx ee)
		(let ((,result (begin ,@body)))
			,@(map (lambda (x old-x)
								`(set!! ,x ,old-x)) 
					xx old-xx)
           ,result)))))


"to do..."

(define #'inexact->exact' identity)
(define #'exact->inexact' identity)


(define disassemble procedure-source)

)! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 10/24/2006 19:02'!
schemeReportEnvironment: ignored

	^ initialEnvironment

! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:07'!
sconcat: aConsCell

"(sconcat SYMBOLS)
Concatenate all SYMBOLS into one and return it"

	^ (String streamContents: [:str |
			aConsCell do: [:s | str nextPutAll: s asString]]) asSymbol! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:26'!
second

	^ cdr car! !

!LKTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 11:25'!
selectionAsStream
	"Answer a ReadStream on the text in the paragraph that is currently 
	selected."

	^PositionableStream
		on: paragraph string
		from: self startIndex
		to: self stopIndex - 1! !

!SLisp methodsFor: 'hacks' stamp: 'spfa 5/26/2006 16:15'!
selectionInterval
	
	"required by Parser>>#temporariesIn: "

	^ 1 to: 1! !

!LKPrimitive methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 16:23'!
selector

	^ selector! !

!LKPrimitive methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 16:24'!
selector: aSymbol

	selector _ aSymbol! !

!LKPrimitive class methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 16:31'!
selector: aSymbol for: aLisp

	^ self new selector: aSymbol; lisp: aLisp
		
! !

!LispKernel methodsFor: 'LISP-functions-Smalltalk' stamp: 'spfa 11/12/2006 20:18'!
sendCascade: aConsCell

"(send-cascade SELECTORS RECEIVER)
SELECTORS is a list of symbols SELECTOR-N or list (SELECTOR-N [ARGSN])
this function evaluate in turn the Smalltalk expressions
RECEIVER perform: SELECTOR1 withArguments: ARGS1
RECEIVER perform: SELECTOR2 ... 
and return the last value we get
"
	
	| val receiver |

	receiver _ aConsCell second.

	aConsCell first do: [:spec | 
		| sel args |
		sel _ spec isSymbol ifTrue: [spec] ifFalse: [spec car].
		args _ spec isSymbol ifTrue: [#()] ifFalse: [spec cdr topForms].
		val _ receiver perform: sel withArguments: args].

	^ val! !

!LispKernel methodsFor: 'LISP-functions-Smalltalk' stamp: 'spfa 9/24/2006 13:37'!
sendMessageBoolean: aConsCell

"(send-message-boolean SELECTOR RECEIVER &rest ARGUMENTS)
Evaluate the Smalltalk expression
RECEIVER perform: SELECTOR withArguments: ARGUMENTS
and return its value as a proper boolean for this lisp"

	^ self class test: (self sendMessage: aConsCell)! !

!LispKernel methodsFor: 'LISP-functions-Smalltalk' stamp: 'spfa 8/5/2006 23:12'!
sendMessage: aConsCell

"(send-message SELECTOR RECEIVER &rest ARGUMENTS)
Evaluate the Smalltalk expression
RECEIVER perform: SELECTOR withArguments: ARGUMENTS"

	^ aConsCell second perform: aConsCell first
		withArguments: (aConsCell nthCell: 2) arrayForm! !

!LispKernel methodsFor: 'LISP-functions-Smalltalk' stamp: 'spfa 11/12/2006 20:18'!
sendSelectors: aConsCell

"(send-selectors SELECTORS RECEIVER)
SELECTORS is a list of symbols SELECTOR-N or list (SELECTOR-N [ARGSN])
this function evaluate the Smalltalk expression
(RECEIVER perform: SELECTOR1 withArguments: ARGS1) perform: SELECTOR2 ... "
	
	| receiver |

	receiver _ aConsCell second.
	aConsCell first do: [:spec | 
		| sel args |
		sel _ spec isSymbol ifTrue: [spec] ifFalse: [spec car].
		args _ spec isSymbol ifTrue: [#()] ifFalse: [spec cdr topForms].
		receiver _ receiver perform: sel withArguments: args].

	^ receiver! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 3/20/2007 23:02'!
setCurrentDirectory: aFileDirectory

	currentDirectory _ aFileDirectory

! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:26'!
setcar: anObject

	self car: anObject! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 22:41'!
setcar: aConsCell

"(setcar CELL OBJECT)
Set the car of CELL to be OBJECT.  Returns OBJECT."

	| o |
	aConsCell car setcar: (o _ aConsCell cadr).
	^ o

	! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:26'!
setcdr: anObject

	self cdr: anObject! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 22:41'!
setcdr: aConsCell

"(setcdr CELL OBJECT)
Set the cdr of CELL to be OBJECT.  Returns OBJECT."

	| o |
	aConsCell car setcdr: (o _ aConsCell cadr).
	^ o


	! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:07'!
setD: aConsCell

"(set? SYMBOL)
Changes the value bound to SYMBOL.
An error is raised if symbol is not bound."

	| dict val sym |
	sym _ self checkSymbol: aConsCell car.
	dict _ self symbolValuesDictionaryFor: sym.
	(dict includesKey: sym) 	ifFalse: [self lispError: 'unbound symbol ', sym].
	dict add: sym -> (val _ self evalObject: aConsCell cadr).	
	^ val! !

!LKREPLMorph methodsFor: 'contents' stamp: 'spfa 10/20/2006 22:10'!
setMyText: text

	| command response |

	"ensure we have the lisp focus"
	lisp focusOnREPL: self.

	(self hasProperty: #inCommand)
	ifTrue:
	[ | psize form |
		psize _ myContents size.
		(psize <= text size) ifTrue:
		[
			self updateText: text, String cr.
			form _ text copyFrom: psize to: text size.
			lisp standardInput stream nextPutAll: form asString.
			lisp standardInput stream skip: form size negated.
		].
		^ self 
	].

	self setProperty: #inCommand toValue: true.

	[
		(command _ self currentCommandFor: text) isEmpty 
		ifFalse: [ 
			self updateText: text, String cr.
			self refreshDisplay.
			response _ self doCommand: command.
			self updateText: (Text streamContents: [:stream |
				stream nextPutAll: myContents.
				self queue size timesRepeat: 
					[stream nextPutAll: self queue next].
				stream nextPutAll: response; cr; nextPutAll: self prompt]).
		]
		ifTrue: [self updateText: text ].
	]
	ensure: [self setProperty: #inCommand toValue: false].

	self refreshDisplay.! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 7/19/2006 14:34'!
setplist: aConsCell

"(setplist SYMBOL PLIST)
Set SYMBOL's property list to PLIST. Return PLIST."

	aConsCell car isSymbol ifFalse: [self lispError: 'not a symbol'].
	self symbolPlists add: aConsCell car -> aConsCell cadr.
	^ aConsCell cadr! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:05'!
setq: aConsCell

"(setq SYM VAL SYM VAL ...)
Set each SYM to the value of its VAL.
The symbols SYM are variables; they are literal (not evaluated).
The values VAL are expressions; they are evaluated.
Thus, (setq x (1+ y)) sets `x' to the value of `(1+ y)'.
The second VAL is not computed until after the first SYM is set, and so on;
each VAL can use the new value of variables set earlier in the `setq'.
The return value of the `setq' form is the value of the last VAL."

	| dict val form |
	
	form _ aConsCell.
	[form notNil] whileTrue:
	[
		self checkSymbol: form car.
		dict _ self symbolValuesDictionaryFor: form car.

		dict add: form car -> (val _ (self evalObject: form cadr)).
		form _ form cdr cdr
	].
	
	^ val! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:07'!
setq: aConsCell

"(setq SYMBOL)
Changes the value bound to SYMBOL.
If symbol is not bound then define it at top level.
-- you should not use this special form in Scheme --"

	| dict val sym |
	sym _ self checkSymbol: aConsCell car.
	dict _ self symbolValuesDictionaryFor: sym.
	(dict includesKey: sym) 
		ifFalse: [self define: aConsCell. ^ self evalObject: aConsCell car].
	dict add: sym -> (val _ self evalObject: aConsCell cadr).	
	^ val! !

!LKPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2006 23:30'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph _ LKTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!LKREPLMorph methodsFor: 'initialization' stamp: 'spfa 6/16/2006 23:30'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph _ LKTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!CLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/2/2006 21:23'!
setUp

	lisp _ CLisp new! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/22/2006 23:45'!
setUp

 	lisp _ ELisp new
! !

!SLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 15:01'!
setUp

	lisp _ SLisp new! !

!StaticLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/5/2006 21:13'!
setUp

	lisp _ StaticLisp new! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 14:56'!
setUp

	lisp _ ULisp new loadDefaultLibraries! !

!ELisp class methodsFor: 'benchmarks' stamp: 'muOuser 3/26/2007 09:30'!
setUpCode

	^ {
'(defun fib (x)
	 (if (< x 2)
		x
		(+ (fib (- x 1)) (fib (- x 2)))))'.
	}
! !

!ULisp class methodsFor: 'benchmarks' stamp: 'muOuser 3/26/2007 09:31'!
setUpCode

	^ {
'(define (fib x)
	 (if (< x 2)
		x
		(+ (fib (- x 1)) (fib (- x 2)))))'.
	}
! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:05'!
set: aConsCell

"(set SYMBOL NEWVAL)
Set SYMBOL's value to NEWVAL, and return NEWVAL."

	| dict symb val |
	symb _ self checkSymbol: (self evalObject: aConsCell car).
	dict _ self symbolValuesDictionaryFor: symb.
	dict add: symb -> (val _ (self evalObject: aConsCell cadr)).	
	^ val! !

!ULisp methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:07'!
set: aConsCell

"(set SYMBOL NEWVAL)
Set SYMBOL's value to NEWVAL, and return NEWVAL.
-- you should not use this special form in Scheme --"

	| form |
	form _ aConsCell listCopy.
	form setcar: (self evalObject: form car).

	^ self setD: form
! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:36'!
sharpArray: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:34'!
sharpBalancedComment: aStream n: unused

	| c nc depth |

	unused ifNotNil: [self error].

	depth _ 0.

	[aStream atEnd] whileFalse:
	[
		c _ aStream next.
		nc _ aStream peek.
		(c == $# and: [nc == $|])
			ifTrue: [aStream next . depth _ depth + 1].
		(c == $| and: [nc == $#])
			ifTrue: 
			[
				aStream next.
				depth isZero ifTrue: [^ nil].
				depth _ depth - 1
			]
	].

	self error! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 10:26'!
sharpBinaryRational: aStream n: unused

	unused ifNotNil: [self error].

	^ Number readFrom: (self read: aStream) asString base: 2! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 14:15'!
sharpBitVector: aStream n: unused

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/24/2006 21:44'!
sharpCharacter: aStream n: unused

	| char |

	unused ifNotNil: [self error].

	aStream skip: -1.
	char _ (self read: aStream) asString.
	char size = 1 ifTrue: [^ char first].

	^ self class characterNames at: char asLowercase! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/20/2006 00:10'!
sharpComment: aStream n: unused

	unused ifNotNil: [self error].

	self read: aStream.
	^ nil! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 13:13'!
sharpComplexNumber: aStream n: unused

	| cons |

	unused ifNotNil: [self error].

	cons _ self read: aStream.
	^ Complex real: cons car imaginary: cons cadr! !

!ULispReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/6/2006 14:23'!
sharpFalse: aStream n: usused

	^ lisp falseValue! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:22'!
sharpFunction: aStream n: unused

	unused ifNotNil: [self error].

	^ #function inCons addLast: (self read: aStream)! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 14:37'!
sharpHexaRational: aStream n: unused

	| hn c nc |
	
	unused ifNotNil: [self error].

	nc _ #($A $B $C $D $E $F).
	hn _ WriteStream on: ''.

	[(c _ aStream peek) notNil
		and: [c isDigit or: [nc identityIncludes: c asUppercase]]]
	whileTrue: [hn nextPut: aStream next].
	
	^ Number readFrom: hn contents asUppercase base: 16! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/10/2006 09:58'!
sharpLabelReference: aStream n: aNumber 

	"if the reference is undefined at this point, let it be a dummy object to be replaced in place with the correct one later on (see the #becomeForward: call in #sharpLabel:n:"

	^ self labels at: aNumber 
			ifAbsent: [self labels at: aNumber put: {#badRef . aNumber}]! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/10/2006 09:47'!
sharpLabel: aStream n: aNumber

	| v |

	aNumber ifNil: [self error: 'incorrect label syntax'].

	v _ self read: aStream.
	
	(self labels includesKey: aNumber)
		ifFalse: [self labels at: aNumber put: v]
		ifTrue: [(self labels at: aNumber) becomeForward: v].

	^ self labels at: aNumber! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:25'!
sharpLoadTimeEvaluation: aStream n: unused

	self notYetImplemented! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 21:42'!
sharpMacros 

	^ SharpMacros ! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/24/2006 21:45'!
sharpMacro: aStream

	| number key |

	[aStream peek isDigit] whileTrue:
		[number _ ((number ifNil: [0]) * 10) + (aStream next asciiValue - 48)].

	^ self perform: (key _ self class sharpMacros at: aStream next) 
		withArguments: {aStream . number}

! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 13:06'!
sharpOctalRational: aStream n: unused

	unused ifNotNil: [self error].

	^ Number readFrom: (self read: aStream) asString base: 8! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:37'!
sharpPathName: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:37'!
sharpRadixNRational: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!ULispReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/13/2006 10:48'!
sharpReadInexactNumber: aStream n: unused

	| num |

	unused ifNotNil: [self error].

	num _ self read: aStream.
	(num isNumber or: [num isComplex]) 
		ifFalse: [lisp lispError: 'bad syntax for number'].

	num isComplex ifTrue: 
		[^ Complex real: num real asFloat imaginary: num imaginary asFloat].

	^ num asFloat! !

!ULispReader methodsFor: 'as yet unclassified' stamp: 'spfa 11/13/2006 10:35'!
sharpReadNumber: aStream n: unused

	| num |

	unused ifNotNil: [self error].

	num _ self read: aStream.
	(num isNumber or: [num isComplex]) 
		ifFalse: [lisp lispError: 'bad syntax for number'].
	^ num! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 13:55'!
sharpReadTimeEvaluation: aStream n: unused

	| sexp |

	unused ifNotNil: [self error].

	^ lisp eval: (sexp _ self read: aStream) inCons
! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:35'!
sharpReadTimeUnless: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:36'!
sharpReadTimeWhen: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 09:37'!
sharpStructure: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!ULispReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/6/2006 14:23'!
sharpTrue: aStream n: usused

	^ lisp trueValue! !

!LKReader methodsFor: '# macros' stamp: 'spfa 10/6/2006 15:24'!
sharpUninternedSymbol: aStream n: unused

	unused ifNotNil: [self error].

	self notYetImplemented! !

!LKReader methodsFor: '# macros' stamp: 'spfa 11/20/2006 12:58'!
sharpVector: aStream n: aNumber

	| v |

	aStream skip: -1.
	v _ (self read: aStream) topForms.

	aNumber ifNotNil: 
	[
		v size > aNumber ifTrue: [self error: 'incorrect vector format'].
		v size < aNumber ifTrue:
		[  | nv |
			nv _ Array new: aNumber withAll: v last.
			1 to: v size - 1 do: [:n |
				nv at: n put: (v at: n)].
			v _ nv
		]
	].

	^ v.

	! !

!ULispReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/9/2006 14:07'!
sharpVector: aStream n: aNumber

	| v |

	aStream skip: -1.
	v _ (self read: aStream) topForms.

	aNumber ifNil: [^ v]. 

	v size > aNumber ifTrue: [self error: 'incorrect vector format'].
	v size < aNumber ifTrue:
	[  | nv |
		nv _ Array new: aNumber withAll: v last.
		1 to: v size - 1 do: [:n |
			nv at: n put: (v at: n)].
		^ nv
	]
! !

!CLispTest class methodsFor: 'as yet unclassified' stamp: 'spfa 6/5/2006 20:43'!
shouldInheritSelectors

	^ true! !

!SLispTest class methodsFor: 'as yet unclassified' stamp: 'spfa 6/5/2006 20:43'!
shouldInheritSelectors

	^ true! !

!StaticLispTest class methodsFor: 'as yet unclassified' stamp: 'spfa 6/5/2006 21:02'!
shouldInheritSelectors

	^ true! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 8/4/2006 00:53'!
slibFiles

	^ ((FileDirectory default directoryNamed: 'ulisp') directoryNamed: 'slib') 
			fileNames 
			select: [:n | n endsWith: '.scm'] 
			thenCollect: [:fn | 'ulisp', FileDirectory slash, 'slib', FileDirectory slash, fn]! !

!ULisp class methodsFor: 'libraries' stamp: 'muOuser 3/20/2007 22:26'!
slibInit

	"SLIB is a portable library for Scheme:
	http://swiss.csail.mit.edu/~jaffer/SLIB.html

	the code here should enable SLIB for ULisp on Windows, Unix and MacOS systems. 
	on other systems your mileage may vary. please report any trouble and according fixes.  
	----------------"

	^#(in-library slib-init


" (software-type) should be set to the generic operating system type.
unix, macos, ms-dos, vms, and amiga are supported by SLIB ."
(define (software-type) 
	(case (platform-name)
		(('Win32') $'ms-dos)
		(('unix') $'unix)
		(('Mac OS') $'macos)))

"(scheme-implementation-type) should return the name of the scheme
implementation loading this file."
(define (scheme-implementation-type) $'ULisp)

"(scheme-implementation-home-page) should return a (string) URI
(Uniform Resource Identifier) for this scheme implementation's home
page; or false if there isn't one."
(define (scheme-implementation-home-page) false)

"(scheme-implementation-version) should return a string describing
the version the scheme implementation loading this file."
(define (scheme-implementation-version) ' v1')

"(implementation-vicinity) should be defined to be the pathname of
the directory where any auxillary files to your Scheme
implementation reside."
(define (implementation-vicinity) (system-path 'ulisp/'))

"(library-vicinity) should be defined to be the pathname of the
directory where files of Scheme library functions reside."
(define (library-vicinity) (system-path 'ulisp/slib/'))

"(home-vicinity) should return the vicinity of the user's HOME
directory, the directory which typically contains files which
customize a computer environment for a user."
(define home-vicinity implementation-vicinity)

(define in-vicinity string-append)

(define (user-vicinity) '')
 
(define #'*load-pathname*' false)

(define #'vicinity:suffix?'
    (lambda (chr) (eqv? chr (path-name-delimiter))))

(define (#'pathname->vicinity' pathname)
  (let loop ((i (- (string-length pathname) 1)))
    (cond ((negative? i) '')
	  ((#'vicinity:suffix?' (string-ref pathname i))
	   (substring pathname 0 (+ i 1)))
	  (else (loop (- i 1))))))

(define (program-vicinity)
  (if #'*load-pathname*' 
      (#'pathname->vicinity' #'*load-pathname*' )
      (slib:error $'program-vicinity ' called; use slib:load to load')))

(define sub-vicinity
	(lambda (vic name)
		(string-append vic name (make-string 1 (path-name-delimiter)))))

(define (make-vicinity #'<pathname>') #'<pathname>')

(define with-load-pathname
  (let ((exchange
	 (lambda (new)
	   (let ((old #'*load-pathname*' ))
	     (set!! #'*load-pathname*'  new)
	     old))))
    (lambda (path thunk)
      (let ((old false))
		(set!! old (exchange path))
	"	(unwind-protect"
	"....................dynamic-wind"
			(apply thunk $'())
	    		(exchange old))))) ")"

"*FEATURES* is a list of symbols naming the (SLIB) features
initially supported by this implementation."
(define #'slib:features'
      $'(
	source		
	vicinity
"	#'srfi-59'  "

	r5rs				
	eval				
	values				
"	dynamic-wind		"
"	macro		"		
	delay				
"	multiarg-apply			"
"	char-ready?"
"	rev4-optional-procedures"

	r4rs				

"	ieee-p1178			"

	full-continuation		
	ieee-floating-point		

"	srfi			"	

	defmacro			
	promise
	))

(define (output-port-width . arg) 79)

(define (output-port-height . arg) 24)

(define current-error-port
  (let ((port (current-output-port)))
    (lambda () port)))

(define tmpnam (let ((cntr 100))
		 (lambda () (set!! cntr (+ 1 cntr))
			 (string-append 'slib_' (#'number->string' cntr)))))


(define (delete-file f) false)

"FORCE-OUTPUT flushes any pending output on optional arg output port
use this definition if your system doesn''t have such a procedure."
(define (force-output . arg) true)

"'CHAR-CODE-LIMIT is one greater than the largest integer which can
be returned by CHAR->INTEGER."
(define char-code-limit 256)

"';;@ MOST-POSITIVE-FIXNUM is used in modular.scm"
(define most-positive-fixnum 16rFFFFFFF)

(define (identity x) x)

"SLIB:EVAL is single argument eval using the top-level (user) environment."
(define slib:eval eval)

";; If your implementation provides R4RS macros:
;(define macro:eval slib:eval)
;(define macro:load load)"
(define #'*defmacros*'
  (list (cons $'defmacro
	      (lambda (name parms . body)
		`(set!! #'*defmacros*' (cons (cons $',name (lambda ,parms ,@body))
					 #'*defmacros*'))))))

(define (defmacro? m) (and (assq m #'*defmacros*') true))

(define (#'macroexpand-1' e)
  (if (pair? e)
      (let ((a (car e)))
	(cond ((symbol? a) (set!! a (assq a #'*defmacros*'))
	       (if a (apply (cdr a) (cdr e)) e))
	      (else e)))
      e))

(define (macroexpand e)
  (if (pair? e)
      (let ((a (car e)))
	(cond ((symbol? a)
	       (set!! a (assq a #'*defmacros*'))
	       (if a (macroexpand (apply (cdr a) (cdr e))) e))
	      (else e)))
      e))

(define gentemp
  (let ((#'*gensym-counter*' -1))
    (lambda ()
      (set!! #'*gensym-counter*' (+ #'*gensym-counter*' 1))
      (#'string->symbol'
       (#'string-append' 'slib:G' (#'number->string' #'*gensym-counter*'))))))

(define base:eval slib:eval)

(define (defmacro:eval x) (base:eval (defmacro:expand* x)))

(define (defmacro:expand* x)
  (require $'defmacroexpand) (apply defmacro:expand* x $'()))

(define (defmacro:load #'<pathname>')
  (slib:eval-load #'<pathname>' defmacro:eval))

"
(define slib:warn
  (lambda args
    (let ((cep (current-error-port)))
      (if (provided? $'trace) (print-call-stack cep))
      (display 'Warn: ' cep)
      (for-each (lambda (x) (display #'#\ ' cep) (write x cep)) args))))
"
(define (slib:warn . args)
	(princ 'Warn:')
	(for-each (lambda (x) (princ ' ') (princ x)) args)
 	(print ''))

"define an error procedure for the library"
(define (slib:error . args)
  (if (provided? $'trace) (print-call-stack (current-error-port)))
  (error (prin1-to-string args)))

(define (make-exchanger obj)
  (lambda (rep) (let ((old obj)) (set!! obj rep) old)))
(define (open-file filename modes)
  (case modes
    ((r rb) (open-input-file filename))
    ((w wb) (open-output-file filename))
    (else (slib:error $'open-file $'mode? modes))))
(define (port? obj) (or (input-port? port) (output-port? port)))
(define (call-with-open-ports . ports)
  (define proc (car ports))
  (cond ((procedure? proc) (set!! ports (cdr ports)))
	(else (set!! ports (reverse ports))
	      (set!! proc (car ports))
	      (set!! ports (reverse (cdr ports)))))
  (let ((ans (apply proc ports)))
    (for-each close-port ports)
    ans))
(define (close-port port)
  (cond ((input-port? port)
	 (close-input-port port)
	 (if (output-port? port) (close-output-port port)))
	((output-port? port) (close-output-port port))
	(else (slib:error $'close-port $'port? port))))

"(define (browse-url url) ......"

";;@ define these as appropriate for your system."
(define slib:tab (#'integer->char' 9))
(define slib:form-feed (#'integer->char' 12))


";;@ Define SLIB:EXIT to be the implementation procedure to exit or
;;; return if exiting not supported."
(define slib:exit (lambda args false))

(define scheme-file-suffix 
    (lambda () '.scm'))

";;@ (SLIB:LOAD-SOURCE 'foo') should load 'foo.scm' or with whatever
;;; suffix all the module files in SLIB have.  See feature 'SOURCE."
(define (string-ending str n)
	(let* ((len (length str))
		   (n (min n len)))
		(substring  str (- len n) len)))

(define (slib:load-source f) 
	(load: (if (equal? '.scm' (string-ending f 4))
				f
				(string-append f '.scm'))
		true))

(define slib:load slib:load-source)

(slib:load (in-vicinity (library-vicinity) 'require'))


)


! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 10/24/2006 15:50'!
slibIntegration

	"transparently using SLIB"

	^#(in-library slib-integration

(defun display-source (symbol) 
	'Display the source code for the procedure bound to SYMBOL
This can be either Lisp or Smalltalk code' 
	(let ((proc (symbol-function symbol)))
		(if (#'primitive?' symbol) 
				(display (procedure-source proc))
			(require $'pretty-print) 
			(pretty-print (procedure-source proc)))))
		
)


! !

!ELisp class methodsFor: 'libraries' stamp: 'spfa 11/12/2006 20:59'!
smallMacros

	"a set of macros for mapping Smalltalk methods into functions. it makes it easy to define lisp functions based on simple message sends; moreover the compiler knows how to handle them."

	^
#(in-library small-macros

(defmacro defunary (lisp-name selector #'&optional' doc-string)
	`(progn
		(defun ,lisp-name (x) ,doc-string (send-message $',selector x))
		(put $',lisp-name $'unary-message $',selector)))

(defmacro defbinary (lisp-name selector #'&optional' doc-string)
	`(progn
		(defun ,lisp-name (x y) ,doc-string (send-message $',selector x y))
		(put $',lisp-name $'binary-message $',selector)))

(defmacro defboolean1 (lisp-name selector #'&optional' doc-string)
	`(defun ,lisp-name (x) 
		,doc-string 
		(send-message-boolean $',selector x)))

(defmacro defboolean2 (lisp-name selector #'&optional' doc-string)
	`(defun ,lisp-name (x y) 
		,doc-string 
		(send-message-boolean $',selector x y)))

(defmacro defcascade (lisp-name selectors #'&optional' doc-string)
	`(defun ,lisp-name (x) ,doc-string
		(send-cascade $',selectors x)))

(defmacro defselectors (lisp-name selectors #'&optional' doc-string)
	`(defun ,lisp-name (x) ,doc-string
		(send-selectors $',selectors x)))
)! !

!SLisp methodsFor: 'LISP-functions' stamp: 'spfa 6/8/2006 09:53'!
smalltalk: aConsCell
	
"(smalltalk STRING)
Evaluate STRING as Smalltalk code."

	aConsCell car isString ifFalse: [self lispError: 'string argument expected'].

	"the invocation below needs methods #selectionInterval and #text to work properly; Parser should be fixed I guess."
	^ Compiler
		evaluate: aConsCell car
		for: self notifying: self logged: false.! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'muOuser 3/20/2007 22:05'!
sourceFileExtension

	"used for autocompletion of filenames without extensions, see #load:"

	^ '.lisp'! !

!ULisp methodsFor: 'private - subclasses may implement' stamp: 'muOuser 3/20/2007 22:05'!
sourceFileExtension

	^ '.scm'! !

!LKPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 09:55'!
spawn! !

!LKTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 09:54'!
spawn

	! !

!LispKernel methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 17:44'!
specialFormP: aConsCell

"(special-form-p SYMBOL)
If SYMBOL globally names a special form, then a non-nil value is returned; otherwise nil is returned"	

	| sf sel |

	sf _ self symbolFunction: aConsCell car ifNone: [^ self falseValue].
	sf isLKPrimitive ifTrue: [sel _ sf selector].
	sf isSymbol ifTrue: [sel _ sf].
	sel ifNil: [^ self falseValue].

	^ self class test: (self class specialForms includes: sel) 
	! !

!LispKernel class methodsFor: 'private' stamp: 'spfa 6/7/2006 14:12'!
specialForms

	^ SpecialForms! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 10/19/2006 16:10'!
specialForms: aConsCell

"(special-forms)
Return a list of all special forms implemented as primitives."

	^ self class specialForms asArray sort asCons
	! !

!CLisp methodsFor: 'private - special variables' stamp: 'spfa 10/12/2006 22:30'!
specialVariables

	^ specialVariables ! !

!CLisp methodsFor: 'private - special variables' stamp: 'spfa 10/12/2006 15:51'!
specialVariables: anIdentitySet

	specialVariables _ anIdentitySet
	! !

!SScheme class methodsFor: 'libraries' stamp: 'muOuser 3/28/2007 14:44'!
sscheme

	^#(in-library sscheme

"	(require $' #'srfi-1') "			"defines 'reduce, conflicts with JACAL"
	(require $'format)
	(require $'array)
	(require $'dynamic-wind)
"	(require $'macro)" 					"fails..."
	(require $'macros-that-work)
"	(require $'syntactic-closures)"		"fails..."
"	(require $'syntax-case)		"	"slow"
"	(require $'collect) " 				"defines 'reduce, conflicts with JACAL"
	(require $'hash-table)
 	(require $'sort)
	(require $'string-case)
	(require $'coerce)
	(require $'stdio)
	(require $'pretty-print)

	(define (sscheme)
		"displays general information about this version of SScheme"
		(display (string-append
'Available libraries:
--------------------

SLIB version ' #'*slib-version*' ', by Aubrey Jaffer
http://swiss.csail.mit.edu/~jaffer/SLIB.html '))
		(newline) 		(newline)
		(display 'Currently provided features: ')
		(display (sort #'slib:features' #'string<?'))
		(newline)		(newline)
		(display '
... use (require ''feature) to load a new ''feature''

Tiny-CLOS, a CLOS-like object system by Gregor Kiczales
http://community.schemewiki.org/?Tiny-CLOS
http://home.adelphi.edu/sbloch/class/archive/272/spring1997/tclos/tutorial.shtml
... load it via (load-library ''tiny-clos)

Schelog: Prolog-style logic programming in Scheme, by Dorai Sitaram
http://www.ccs.neu.edu/home/dorai/schelog/schelog.html
... load it via (load-library ''schelog)

Portable Regular Expressions for Scheme and Common Lisp, by Dorai Sitaram
http://www.ccs.neu.edu/~dorai/pregexp/pregexp.html
... load it via (load-library ''pregexp)

JACAL version 1b7, an interactive symbolic calculator by Aubrey Jaffer
http://www-swiss.ai.mit.edu/~jaffer/JACAL.html
... load it via (load-library ''jacal)

miniKANREN, a logic declarative system by Oleg and al.
http://kanren.sourceforge.net/
... load it via (load-library ''mini-kanren)


This version of SScheme supports R4RS hygienic macros via SLIB''s ''macros-that-work. 
'))

	(define (help)
		(display
'examples of useful functions:
(about ''display-source)
(display-source ''display-source)
(explore (cons ''a ''b))
(begin (define (test x) (let ((y 1)) (debug))) (test "this is a test"))
'
	))

)

! !

!SScheme class methodsFor: 'libraries' stamp: 'spfa 10/24/2006 16:46'!
sschemeIntro

	^#(in-library sscheme-intro

	(display 'welcome to SScheme, the experimental Squeak Scheme') (newline)
	(display '--------------------------------------------------')	
	(newline)
	(display 'type (sscheme) for details and legalese, (help) to get started')
	(newline)
	(display 'SLIB features: ')
	(display (sort #'slib:features' #'string<?'))
	(newline)
	(newline)
)

! !

!LispKernel methodsFor: 'private - variables' stamp: 'spfa 10/20/2006 13:17'!
standardInput

	^ self symbolValue: #'*standard-input*' ifNone: [nil]! !

!ULisp methodsFor: 'private' stamp: 'spfa 11/7/2006 15:08'!
standardInput
	^inputPort ifNil: [inputPort := LKIOPort forInput]! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 11/7/2006 15:08'!
standardInputPort
	"the default port for input, used by read functions"

	upperLisp ifNotNil: [^upperLisp standardInputPort	"safer"].
	^inputPort ifNil: [inputPort := LKIOPort forInput]! !

!ULisp methodsFor: 'private' stamp: 'spfa 11/7/2006 15:08'!
standardInput: aLKIOPort 
	inputPort := aLKIOPort! !

!LispKernel methodsFor: 'private - variables' stamp: 'spfa 10/10/2006 10:23'!
standardOutput

	^ self symbolValue: #'*standard-output*'	ifNone: [nil]! !

!ULisp methodsFor: 'private' stamp: 'spfa 11/7/2006 15:07'!
standardOutput
	^outputPort ifNil: [outputPort := LKIOPort forOutput]! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 11/7/2006 15:08'!
standardOutputPort
	"the default port for output, used by print functions"

	upperLisp ifNotNil: [^upperLisp standardOutputPort	"safer"].
	^outputPort ifNil: [outputPort := LKIOPort forOutput]! !

!ULisp methodsFor: 'private' stamp: 'spfa 11/7/2006 15:07'!
standardOutput: aLKIOPort 
	outputPort := aLKIOPort! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:04'!
status

	^ status ! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:04'!
status: aSymbol

	status _ aSymbol! !

!Array methodsFor: '*LispKit' stamp: 'spfa 3/23/2007 17:10'!
storeCycles: anIdentityDictionary with: anIdentitySet

	(anIdentitySet includes: self)
	ifTrue: 
	[
		(anIdentityDictionary keys includes: self)
			ifFalse: [anIdentityDictionary add: self -> (anIdentityDictionary size + 1)].
		^ anIdentityDictionary
	]. 
	anIdentitySet add: self.

	self do: [:ea |
		(ea isConsCell | ea isArray) ifTrue:
			[ea storeCycles: anIdentityDictionary with: anIdentitySet]].

	^ anIdentityDictionary! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 3/23/2007 16:48'!
storeCycles: anIdentityDictionary with: anIdentitySet

	(anIdentitySet includes: self)
	ifTrue: 
	[
		(anIdentityDictionary keys includes: self)
			ifFalse: [anIdentityDictionary add: self -> (anIdentityDictionary size + 1)].
		^ anIdentityDictionary
	]. 
	anIdentitySet add: self.

	(car isConsCell | car isArray) ifTrue: 
		[car storeCycles: anIdentityDictionary with: anIdentitySet].
	(cdr isConsCell | cdr isArray) ifTrue: 
		[cdr storeCycles: anIdentityDictionary with: anIdentitySet].

	^ anIdentityDictionary! !

!ConsCell methodsFor: 'printing' stamp: 'spfa 6/3/2006 01:29'!
storeOn: aStream

	aStream nextPutAll: '(ConsCell car: '.
	car storeOn: aStream.
	aStream nextPutAll: ' cdr: '.
	cdr storeOn: aStream.
	aStream nextPut: $)! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 9/23/2006 11:02'!
storeTopFormsIn: aStream

	aStream nextPut: car.
	cdr isConsCell ifTrue: [cdr storeTopFormsIn: aStream] 
		ifFalse: [cdr ifNotNil: [aStream nextPut: cdr]]
! !

!LKIOPort methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 13:08'!
stream

	^ self isInput ifTrue: [inStream] ifFalse: [outStream]
! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 14:00'!
stringP: aConsCell

"(stringp OBJECT)
Return t if OBJECT is a String."

	^ self class test: (aConsCell car isString and: [aConsCell car isSymbol not])! !

!LispKernel class methodsFor: 'string format conversion' stamp: 'spfa 11/30/2006 13:46'!
stringRepresentedBy: aString

	"transcode aString from this lisp format (i.e. with specific escape sequences) into Smalltalk format"

	| str |

	str _ aString.
	(str includes: $\) ifFalse: [^ str].

	str _ str copyReplaceAll: '\\' with: '<-<double-slash-here>->'. 
	str _ str copyReplaceAll: '#\' with: '<-<#-slash-here>->'. 
	str _ str copyReplaceAll: '\"' with: '"'. 
	self escapeSequences do: [:assoc |
		str _ str copyReplaceAll: assoc key with: assoc value].    

	str _ str copyReplaceAll: '<-<#-slash-here>->' with: '#\'.
	^ str copyReplaceAll: '<-<double-slash-here>->' with: '\'.
! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 6/23/2006 15:55'!
stringSetD: aConsCell

	aConsCell car at: aConsCell cadr + 1 put: aConsCell cdr cadr.
	^ aConsCell car

! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 10/19/2006 15:19'!
stringTOlist: aConsCell

	^ aConsCell car asArray asCons! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 11/13/2006 10:44'!
stringTOnumber: aConsCell

"(string->number STRING [BASE])
Returns a number expressed by STRING. BASE must be either 2, 8, 10, or 16. If supplied, BASE may be overridden by an explicit radix prefix in string. If BASE is not supplied, then it defaults to 10. If STRING is not a syntactically valid notation for a number, returns #f."

	| base string n |

	string _ aConsCell car.
	base _ aConsCell cadr ifNil: [10].

	string ifEmpty: [^ self falseValue].

	(string first == $# 
		and: [string size >= 2]
		and: [#($o $O $x $X $b $B $r $R $d $i) identityIncludes: string second])
	ifTrue: 
	[[ ^ self reader read: (ReadStream on: string)] 
		on: Error do: [^self falseValue]].
	
	n _ [self reader token parse: aConsCell car base: base] 
			on: Error do: [^self falseValue].
	n isSymbol ifTrue: [^self falseValue].

	^ n


! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/24/2006 21:45'!
string: aStream

	^ String streamContents: [:str |
		| c |
		[c == $"] whileFalse:
		[
			c _ aStream next.
			(self class syntacticTypes at: c asciiValue) == #singleEscape
				ifTrue: [str nextPut: aStream next]
				ifFalse: [c == $" ifFalse: [str nextPut: c]]
		]]
			
	! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 6/30/2006 18:24'!
string: aConsCell

"(string CHARACTERS)
Return a string with CHARACTERS"

	^ String withAll: aConsCell arrayForm
! !

!LKMonitor methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 19:23'!
subLisp: aForm! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 10/15/2006 14:10'!
subLisp: aSymbol form: aForm body: aConsCell

	^ self subLisp: aSymbol form: aForm body: aConsCell environment: environment newChild
! !

!CLisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/15/2006 14:26'!
subLisp: aSymbol form: aForm body: aConsCell environment: anLKEnvironment

	|sublisp |
	
	sublisp _ super subLisp: aSymbol form: aForm body: aConsCell environment: anLKEnvironment.
	sublisp 
		dynamicSymbolValues: IdentityDictionary new;
		specialVariables: IdentitySet new;
		checkDeclarations: aConsCell.
	^ sublisp
	! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 10/22/2006 23:19'!
subLisp: aSymbol form: aForm body: aConsCell environment: aLKEnvironment

	"local scope is implemented by creating a temporary copy of the whole interpreter where local bindings will be made. this method is the place for defining how exactly the copy should be made.

	the 'body' argument is used by CLisp for handling of declarations. see how it overrides this method"


	self monitor ifNotNil: [self monitor subLisp: aForm from: self].

	^ self copy
		environment: aLKEnvironment;
		upperLisp: self;
		upperHead: aSymbol;
		upperTail: aForm! !

!SLisp methodsFor: 'private' stamp: 'spfa 10/21/2006 15:40'!
subLisp: aSymbol form: aForm body: aConsCell environment: anLKEnvironment

	|sublisp |
	
	sublisp _ super subLisp: aSymbol form: aForm body: aConsCell environment: anLKEnvironment.

	sublisp symbolValuesAdd: #self -> sublisp.

	^ sublisp! !

!LKFunctionsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 00:30'!
subLisp: aForm from: aLisp
"
	aLisp displayStream 
		nextPut: $\;
		nextPutAll: (aLisp depth + 1) asString ; tab;
		nextPutAll: (aForm printStringForLisp: aLisp limitedTo: 50); cr.
"! !

!LKMonitor methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 19:25'!
subLisp: aForm from: aLisp! !

!LKSymbolsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 00:30'!
subLisp: aForm from: aLisp
"
	aLisp displayStream 
		nextPut: $\;
		nextPutAll: (aLisp depth + 1) asString ; tab;
		nextPutAll: (aForm printStringForLisp: aLisp limitedTo: 50); cr.
"! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 3/14/2007 22:59'!
substring: aConsCell

"(substring STRING START [END])
Return the substring of STRING from START to END.
If END is omitted, it defaults to the length of the string.
If START or END is negative, it counts from the end.
"

	| string beg end |

	string _ aConsCell car.
	beg _ aConsCell cadr.
	beg < 0 ifTrue: [beg _ string size + beg].
	end _ aConsCell cddr car ifNil: [string size + 1].
	end  < 0 ifTrue: [end _ string size + end].

	^ string copyFrom: beg + 1 to: end! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 6/8/2006 08:34'!
sugar

	^ Sugar ifNil: [QuotingSugar]! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 6/22/2006 14:21'!
sugarKeys

	^ #(#, #',@' $' #` #'#`')! !

!SLisp class methodsFor: 'private-subclasses may implement' stamp: 'spfa 6/19/2006 14:18'!
sugarKeys

	^ #(#, #',@' $' #` $#)! !

!LispKernel methodsFor: 'private - symbols' stamp: 'spfa 7/19/2006 14:22'!
symbolFunctions

	^ environment symbolFunctions! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 7/19/2006 14:23'!
symbolFunctions 

	^ symbolFunctions! !

!ULisp methodsFor: 'private' stamp: 'spfa 7/19/2006 14:33'!
symbolFunctions
	
	"one namespace only, functions are just values"

	^ environment symbolValues! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 20:50'!
symbolFunctionsDictionaryFor: aSymbol

	"look-up for the dictionary in which a function binding for aSymbol should be stored"

	((self symbolFunctions includesKey: aSymbol) 
		or: [upperBindings isNil])
		ifTrue: [^ self symbolFunctions].

	^ upperBindings symbolFunctionsDictionaryFor: aSymbol
! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 3/27/2007 15:55'!
symbolFunction: aConsCell

"(symbol-function SYMBOL)
Return SYMBOL's function definition.  Raise an error if there is none."

	^ self symbolFunction: aConsCell car
				ifNone: [self errorUndefinedFunction: aConsCell car].
! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 3/27/2007 15:14'!
symbolFunction: aSymbol ifNone: aBlock

	"look-up for the function bound to aConscell car (which should be a symbol). if none found, evaluate aBlock"

	(self class primitives includes: aSymbol) 
		ifTrue: [^ LKPrimitive selector: aSymbol for: self].
	^ self nonPrimitiveSymbolFunction: aSymbol ifNone: aBlock
	

! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 9/30/2006 15:38'!
symbolFunction: aSymbol ifNone: aBlock

	^ self symbolFunctions at: aSymbol 
		ifAbsent: [(upperBindings ifNil: [^ aBlock value])
						symbolFunction: aSymbol ifNone: aBlock]
! !

!ULisp methodsFor: 'private - subclasses may implement' stamp: 'spfa 9/30/2006 15:38'!
symbolFunction: aSymbol ifNone: aBlock

	 ^ environment symbolValue: aSymbol ifNone: aBlock
! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 6/6/2006 13:46'!
symbolName: aConsCell

"(symbol-name SYMBOL)
Return SYMBOL's name, a string."

	aConsCell car isSymbol ifFalse: [self lispError: 'not a symbol'].
	^ aConsCell car asString! !

!LispKernel methodsFor: 'private - symbols' stamp: 'spfa 7/19/2006 14:29'!
symbolPlists

	^ environment symbolPlists! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 7/19/2006 14:23'!
symbolPlists

	^ symbolPlists! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 7/19/2006 14:26'!
symbolPlists: aDictionary

	symbolPlists _ aDictionary! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 7/19/2006 14:35'!
symbolPlist: aConsCell

"(symbol-plist SYMBOL)
Return SYMBOL's property list."

	aConsCell car isSymbol ifFalse: [self lispError: 'not a symbol'].
	^ self symbolPlists at: aConsCell car ifAbsent: [nil]! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 14:00'!
symbolP: aConsCell

"(symbolp OBJECT)
Return t if OBJECT is a Symbol."

	^ self class test: aConsCell car isSymbol! !

!LKHalt methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 22:41'!
symbolsValuesAdded: anAssociation in: aLisp! !

!LKMonitor methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 19:34'!
symbolsValuesAdded: anAssociation in: aLisp! !

!LKSymbolsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 22:04'!
symbolsValuesAdded: anAssociation in: aLisp

	(symbols includes: anAssociation key)
		ifTrue: [
			aLisp standardOutput stream nextPutAll: 'BIND'; tab; 
				nextPutAll: anAssociation key;
				nextPutAll: ' -> ';
				nextPutAll: (anAssociation value printStringForLisp: aLisp limitedTo: 100); cr.
			aLisp standardOutput endEntry]
! !

!LKTracer methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 22:13'!
symbolsValuesAdded: anAssociation in: aLisp

	| str |

	str _ aLisp standardOutput stream.

	self tabulate: str to: self depth + 1.

	str nextPutAll: 'BIND ';
		nextPutAll: anAssociation key;
		nextPutAll: ' -> ';
		nextPutAll: (anAssociation value printStringForLisp: aLisp limitedTo: 100); cr. 
	aLisp standardOutput endEntry
! !

!LKSymbolsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 18:25'!
symbols: anArray

	symbols _ anArray! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 7/1/2006 22:01'!
symbolTOstring: aConsCell

	^ aConsCell car asString! !

!LispKernel methodsFor: 'private - symbols' stamp: 'spfa 7/19/2006 14:29'!
symbolValues

	^ environment symbolValues! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 7/19/2006 14:23'!
symbolValues

	^ symbolValues! !

!CLisp methodsFor: 'private - override' stamp: 'spfa 10/13/2006 09:30'!
symbolValuesAdd: anAssociation

	((specialVariables includes: anAssociation key) 
		or: [self hasGlobalDynamicValue: anAssociation key])
	ifFalse: [^ super symbolValuesAdd: anAssociation].

	self dynamicSymbolValues add: anAssociation .
	self monitor ifNotNil: 
		[self monitor symbolsValuesAdded: anAssociation in: self]! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 7/19/2006 14:30'!
symbolValuesAdd: anAssociation

	self symbolValues add: anAssociation .
	self monitor ifNotNil: 
		[self monitor symbolsValuesAdded: anAssociation in: self]! !

!CLisp methodsFor: 'private - override' stamp: 'spfa 10/13/2006 09:31'!
symbolValuesDictionaryFor: aSymbol

	^ (self dynamicSymbolValuesDictionaryFor: aSymbol)
		ifNil: [super symbolValuesDictionaryFor: aSymbol] ! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 7/19/2006 14:38'!
symbolValuesDictionaryFor: aSymbol

	^ environment symbolValuesDictionaryFor: aSymbol! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 20:49'!
symbolValuesDictionaryFor: aSymbol

	"look-up for the dictionary in which a value binding for aSymbol should be stored"

	((self symbolValues includesKey: aSymbol) 
		or: [upperBindings isNil])
		ifTrue: [^ self symbolValues].

	^ upperBindings symbolValuesDictionaryFor: aSymbol! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 20:50'!
symbolValuesDictionaryFor: aSymbol ifNone: aBlock

	(self symbolValues includesKey: aSymbol) ifTrue: [^ self symbolValues].
	^ (upperBindings ifNil: [^ aBlock value]) symbolValuesDictionaryFor: aSymbol ifNone: aBlock! !

!CLisp methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 10/12/2006 15:54'!
symbolValue: aConsCell

"(symbol-value SYMBOL)
Return SYMBOL's value.  Raise an error if there is none.
SYMBOL must be a special variable"

	"Note: this is confusing since it is not the same semantics as #symbolValue:ifNone:
	the reason for this is that this is a public lisp function and we are giving it the semantics defined by Common Lisp
	OTOH #symbolValue:ifNone: is private and its name correctly reflects the actual implementation"

	^ self dynamicSymbolValue: aConsCell car
		ifNone: [self lispError: 'no dynamic value for symbol ', aConsCell car asString]
! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 9/30/2006 15:41'!
symbolValue: aConsCell

"(symbol-value SYMBOL)
Return SYMBOL's value.  Raise an error if there is none."

	^ self symbolValue: aConsCell car
		ifNone: [self lispError: 'no value for symbol ', aConsCell car asString]
! !

!CLisp methodsFor: 'private - override' stamp: 'spfa 10/12/2006 18:57'!
symbolValue: aSymbol ifNone: aBlock

	(specialVariables includes: aSymbol)
		ifTrue: [^ self dynamicSymbolValue: aSymbol
					ifNone: [self lispError: 'no dynamic value for symbol ', aSymbol]].

	 ^ super symbolValue: aSymbol ifNone: 
			[self dynamicSymbolValue: aSymbol ifNone: aBlock]

	! !

!LispKernel methodsFor: 'private - subclasses may implement' stamp: 'spfa 9/30/2006 15:34'!
symbolValue: aSymbol ifNone: aBlock

	":keywords evaluate to themselves"
	aSymbol first == $: ifTrue: [^ aSymbol].

	 ^ environment symbolValue: aSymbol ifNone: aBlock

	
	! !

!LKEnvironment methodsFor: 'as yet unclassified' stamp: 'spfa 9/30/2006 15:35'!
symbolValue: aSymbol ifNone: aBlock

	"look-up for the value bound to aSymbol. if none found, evaluate aBlock"

	 ^ self symbolValues at: aSymbol 
		ifAbsent: [(upperBindings ifNil: [^ aBlock value])
						symbolValue: aSymbol ifNone: aBlock]
	! !

!SLisp methodsFor: 'smalltalk invocation' stamp: 'spfa 10/11/2006 15:37'!
symbolValue: aSymbol ifNone: aBlock

	"use the Smalltalk namespace in last ressort"

	^ super symbolValue: aSymbol 
		ifNone: [Smalltalk at: aSymbol ifAbsent: [aBlock value]]
! !

!ULisp methodsFor: 'private - subclasses may implement' stamp: 'spfa 9/30/2006 15:35'!
symbolValue: aSymbol ifNone: aBlock

	 ^ environment symbolValue: aSymbol ifNone: aBlock
! !

!LKReader class methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 21:41'!
syntacticTypes

	^ SyntacticTypes 
		! !

!SLisp methodsFor: 'private' stamp: 'spfa 6/8/2006 08:31'!
syntax

	^ syntax ifNil: [#lisp]! !

!SLisp methodsFor: 'private' stamp: 'spfa 6/8/2006 08:31'!
syntax: aSymbol

	syntax _ aSymbol! !

!SScheme class methodsFor: 'libraries' stamp: 'muOuser 3/27/2007 23:00'!
systemLibraries

	^ super systemLibraries
! !

!ULisp class methodsFor: 'libraries' stamp: 'spfa 3/25/2007 14:51'!
systemLibraries

	"the bindings defined by these libraries will belong to the scheme-report-environment"

	^ #(glue #'provide-library' plist #'small-macros' common scheme "loop")! !

!ELisp methodsFor: 'LISP-functions-system' stamp: 'spfa 3/20/2007 23:37'!
systemPath: aConsCell

"(system-path PATH)
Return a version of PATH (a string) suitable for the current operating system.
For example, on linux all #\ and #\: are replaced with #/
PATH should be relative"

	| sep path |

	path _ aConsCell car.
	sep _ FileDirectory slash.
	#('\' '/' ':') do: [:s | path _ path copyReplaceAll: s with: sep].

	^ path! !

!LKTracer methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 22:26'!
tabulate: aStream to: d

	| nl |

	nl _ ((d - 1) / 30) floor.

	nl isZero ifFalse:
		[aStream nextPutAll: nl asString, '>'; space].

	((d - 1) \\ 30) timesRepeat: [aStream nextPut: $| ; space].
! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:05'!
tally: aConsCell

"(tally FORM)
Evaluate FORM with a MessageTally spying."

	^ MessageTally spyOn: [self evalObject: aConsCell car] ! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context _ aContext.
	[context notNil] whileTrue: [context _ context swapSender: nil]
! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 09:59'!
testAddLast

	| list1 list2  |

	list1 _ #(1 2 3) asCons.
	list2 _ #(5 4) asCons.
	self assert: (list1 addLast: list2) = #(1 2 3 (5 4)) asCons.
	self assert: list1= #(1 2 3 (5 4)) asCons.
	self assert: list2 = #(5 4) asCons.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 23:36'!
testAnd

	self assert: (lisp top: #(and true 4 (* 10 45))) = 450.
	self assert: (lisp top: #(and true nil (* 10 45))) isNil.
	self assert: (lisp top: #(and () nil (* 10 45))) isNil.
! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/7/2006 21:54'!
testAnd

	self assert: (lisp top: #(and true 4 (* 10 45))) = 450.
	self assert: (lisp top: #(and true false (* 10 45))) = false.
	self assert: (lisp top: #(and () nil (* 10 45))) = 450.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 7/3/2006 15:36'!
testAnd

	self assert: (lisp top: #(and true 4 (* 10 45))) = 450.
	self assert: (lisp top: #(and true nil (* 10 45))) = 450.
	self assert: (lisp top: #(and true (* 10 45) nil)) isNil.
	self assert: (lisp top: #(and true false (* 10 45))) = lisp falseValue.
 	self assert: (lisp top: #(and () false (* 10 45))) = lisp falseValue.
! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 3/24/2007 16:15'!
testAppend

	| list1 list2  |

	list1 _ #(1 2 3) asCons.
	list2 _ #(5 4) asCons.

	self assert: (list1 append: list2) == list1.
	self assert: list1= #(1 2 3 5 4) asCons.
	self assert: list2 = #(5 4) asCons.

	self assert: (list1 append: list2) == list1.
	self assert: list1 lispPrintString = '(1 2 3 . #1=(5 4 . #1#))'.
	self assert: list2 lispPrintString = '#1=(5 4 . #1#)'.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/9/2006 20:37'!
testAppend

	(lisp top: #(setq uh $'(1 2))).
	self assert: (lisp top: #(eq: uh (append uh))) = lisp trueValue.
	self assert: (lisp top: #(eq: uh (append uh ()))) = lisp falseValue.

	(lisp top: #(setq oh $'(3 4))).
	self assert: (lisp top: #(append 5)) = 5.
	self assert: (lisp top: #(append uh oh)) = #(1 2 3 4) asCons.
	self assert: (lisp top: #uh) = #(1 2) asCons.
	self assert: (lisp top: #oh) = #(3 4) asCons.

	self assert: (lisp top: #(append uh oh oh oh)) = #(1 2 3 4 3 4 3 4) asCons.
	self assert: (lisp top: #uh) = #(1 2) asCons.
	self assert: (lisp top: #oh) = #(3 4) asCons.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 3/23/2007 09:24'!
testAppend2

	(lisp top: #(progn 
					(setq un $'(1 2))
					(setq trois $'(3 4))
					(setq ap (append un trois)))).

	self assert: (lisp top: #(eq: (cddr ap) trois))= lisp trueValue.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 14:46'!
testApply

	self assert: (lisp top: #(apply $'+ 1 (list: 7))) = 8.
	self assert: (lisp top: #(apply $'+ 1 2 (list:))) = 3.
	self assert: (lisp top: #(apply $'(lambda (x y) (* x y)) 1 $'(7))) = 7.
	self assert: (lisp top: #(apply $'+ 1 10 (list: 7 10 10))) = 38.
	self assert: (lisp top: #(apply $'+ (list: 7 10 10))) = 27.

	self assert: (lisp top: #(apply $'> (list (+ 1 3) 2))) = lisp trueValue.
	self assert: (lisp top: #(apply $'car $'((list (+ 1 1) 2)))) = #list.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 3/27/2007 14:55'!
testApply

	self assert: (lisp top: #(apply + 1 (list: 7))) = 8.
	self assert: (lisp top: #(apply + 1 2 (list:))) = 3.
	self assert: (lisp top: #(apply (lambda (x y) (* x y)) 1 $'(7))) = 7.
	self assert: (lisp top: #(apply + 1 10 (list: 7 10 10))) = 38.
	self assert: (lisp top: #(apply + (list: 7 10 10))) = 27.

	self assert: (lisp top: #(apply > (list (+ 1 3) 2))) = lisp trueValue.
	self assert: (lisp top: #(apply car $'((list (+ 1 1) 2)))) = #list.

	self should: [lisp top: #(apply $'+ 1 (list: 7))] raise: LispError.
	self should: [lisp top: #(apply $'(lambda (x y) (* x y)) 1 $'(7))] raise: LispError.

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:04'!
testArithmetic

	self assert: (lisp top: 45) = 45.
	self assert: (lisp top: #(+)) = 0.
	self assert: (lisp top: #(+ 4)) = 4.
	self assert: (lisp top: #(+ 4 (+ 10 45))) = 59.
	self assert: (lisp top: #(+ 4 (* 10 45))) = 454
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 9/30/2006 22:08'!
testArray

	self assert: ((lisp evalString: '#(1 2 3 4)') printStringForLisp: lisp) = '#(1 2 3 4)'.
	self assert: ((lisp evalString: '#(1 2 (3 4))') printStringForLisp: lisp) = '#(1 2 (3 4))'.
	self assert: ((lisp evalString: '#(1 2 #(3 4))') printStringForLisp: lisp) = '#(1 2 #(3 4))'.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 21:49'!
testAtom

	self assert: (lisp top: #(atom 5)) = lisp trueValue.
	self assert: (lisp top: #(atom (+ 3 2))) =  lisp trueValue.
	self assert: (lisp top: #(atom 'bouh')) = lisp trueValue.
	self assert: (lisp top: #(atom $k)) =  lisp trueValue.
	self assert: (lisp top: #(atom (list 1 2) (list 1 2))) =  lisp falseValue.! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 22:23'!
testAtom

	! !

!ELispTest methodsFor: 'fun' stamp: 'spfa 3/15/2007 00:31'!
testAutoModifyingFunction

	"
	here is a function modifying its own source code while it is running !!
	(note that this example works because dotimes is not a macro)
	"

	lisp loadDefaultLibraries.

	lisp top: #(defun counter (n &optional counts)
	(dotimes (i n counts)
		(add-to-list $'counts 0 "<--- the (0) cell is being dynamically changed")
		(let ((cell (cddadr (cdaddr (symbol-function $'counter)))))
 			(setcar cell (+ 1 (car cell)))))).

	self assert: (lisp top: #(counter 4)) = #(0 1 2 3) asCons.
	self assert: (lisp top: #(counter 4)) = #(4 5 6 7) asCons.
	self assert: (lisp top: #(counter 2)) = #(8 9) asCons.


	"
	the following example use a macro (loop) so the modification is only taken into account during the next expansion, that is the next function invocation
	"

	lisp top: #(defun counter (n)
	(let ((cell (nthcdr 10 (cadr (cdaddr (symbol-function $'counter))))))
		(loop for i from 1 to n
			do (setcar cell (+ 1 (car cell))) 
			collect 0 "<--- the (0) cell is being dynamically changed"))).

	self assert: (lisp top: #(counter 4)) = #(0 0 0 0) asCons.
	self assert: (lisp top: #(counter 4)) = #(4 4 4 4) asCons.
	self assert: (lisp top: #(counter 2)) = #(8 8) asCons.

	"
	credit:
	idea borrowed from the incMe example in the PicoLisp FAQ: 
	http://software-lab.de/faq.html
	"
! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 3/20/2007 23:48'!
testAutoModifyingFunction

	"
	here is a function modifying its own source code while it is running !!
	(note that this example works because dotimes is not a macro)
	"

	lisp loadDefaultLibraries.

	lisp top: #(defun counter (n &optional counts)
	(dotimes (i n counts)
		(add-to-list $'counts 0 "<--- the (0) cell is being dynamically changed")
		(let ((cell (cddadr (cdaddr (symbol-function $'counter)))))
 			(setcar cell (+ 1 (car cell)))))).

	self assert: (lisp top: #(counter 4)) = #(0 1 2 3) asCons.
	self assert: (lisp top: #(counter 4)) = #(4 5 6 7) asCons.
	self assert: (lisp top: #(counter 2)) = #(8 9) asCons.
! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 3/20/2007 23:43'!
testAutoModifyingFunction! !

!SLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2006 11:33'!
testBasics

	self assert: (lisp top: #(@ 10 15)) = (10@15).
	self assert: (lisp top: #(smalltalk '10@15')) = (10@15)! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2006 13:24'!
testBindFromSpec

	self assert: (lisp bindAll: nil
						fromSpec: nil
						macrop: false) = #().

	self assert: (lisp bindAll: #(1 2 3 4) asCons 
						fromSpec: #(x y #'&rest' z) asCons 
						macrop: false) = {#x->1. #y->2. #z->#(3 4) asCons}.

	self assert: (lisp bindAll: #(1 2 3 4) asCons 
						fromSpec: (ConsCell car: #x cdr: #z)
						macrop: false) = {#x->1. #z->#(2 3 4) asCons}.

	self assert: (lisp bindAll: #(1 2 3 4) asCons 
						fromSpec: #(x y z k) asCons 
						macrop: false) = {#x->1 . #y->2 . #z->3 . #k->4}.

	self assert: (lisp bindAll: #(1 2) asCons 
						fromSpec: #(x y) asCons 
						macrop: true) = {#x->1 . #y->2}.

	self assert: (lisp bindAll: nil
						fromSpec: #(#'&rest' args) asCons 
						macrop: false) = {#args->nil}.

	self assert: (lisp bindAll: #(1 2) asCons
						fromSpec: #args 
						macrop: false) = {#args->#(1 2) asCons}.

	self assert: (lisp bindAll: #(1 2) asCons
						fromSpec: #(x #'&optional' y) asCons 
						macrop: false) = {#x->1 . #y->2}. 

	self assert: (lisp bindAll: #(1) asCons
						fromSpec: #(x #'&optional' y) asCons 
						macrop: false) = {#x->1 . #y->nil} ! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/17/2006 21:42'!
testBindFromSpec2

	lisp top: #(setq x 1). 
	lisp top: #(setq y 2). 
	lisp top: #(setq a 3).
	lisp top: #(setq b 5).

	self assert: (lisp bindAll: #(1 2 a b) asCons 
						fromSpec: #(x y #'&rest' z) asCons 
						macrop: false) = {#x->1. #y->2. #z->#(3 5) asCons}.

	self assert: (lisp bindAll: #(1 2 a b) asCons 
						fromSpec: #(x y #'&rest' z) asCons 
						macrop: true) = {#x->1. #y->2. #z->#(a b) asCons}.

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/24/2006 15:12'!
testCallCC

	lisp top: #(define reciprocals
  					(lambda (ls)
    						(call-with-current-continuation
      						(lambda (k)
        							(map (lambda (x)
               							(if (= x 0)
                   								(k 'zero found')
                   								(/ 1 x)))
             								ls))))).

	self assert: (lisp top: #(reciprocals (list 2 (/ 1 3) 5 (/ 1 4))))
					=  { 1/2 . 3 . 1/5 . 4} asCons.

	self assert: (lisp top: #(reciprocals (list 2 (/ 1 3) 0 5 (/ 1 4))) ) asOneLispValue
					= 'zero found'
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 14:59'!
testCallCC2

	lisp top: #(begin

(define retry false)

(define factorial
  (lambda (x)
    (if (= x 0)
        	(call-with-current-continuation (lambda (k) (set!! retry k) 1))
        (* x (factorial (- x 1))))))
).

	self assert: (lisp top: #(factorial 4)) = 24.
	self assert: (lisp top: #(retry 1)) = 24.
	self assert: (lisp top: #(retry 2)) = 48.

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 14:59'!
testCallCC3

	self assert: (lisp top: #(let ((x (call/cc (lambda (k) k))))
  									(x (lambda (ignore) 'hi')))) = 'hi'! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 14:59'!
testCallCC4

	"according to R. Kent Dybvig (author of book 'The Scheme Programming Language'), the example below is 'the most confusing Scheme program of its size'"

	self assert: (lisp top: #(((call/cc (lambda (k) k)) (lambda (x) x)) 'HEY!!')) = 'HEY!!'! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/29/2006 11:11'!
testCallCC5

	lisp top: #(define k (call/cc (lambda (k) k))).
	lisp top: #(k 18).

	self assert: (lisp top: #k) = 18.

	lisp top: #(define k (call/cc call/cc)).
	lisp top: #(k 'yo').

	self assert: (lisp top: #k) = 'yo'

	"why it is so explained there: 	http://notvincenz.blogspot.com/2006/11/continuations.html"
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/29/2006 13:56'!
testCallCC6

	"the incredibly obfuscated factorial example from
	http://okmij.org/ftp/Scheme/callcc-calc-page.html

	as Oleg says:
	note, that there is no overt recursion nor iteration nor self-application"

	lisp top: #(define fact
         ((lambda (f)
            ((lambda (u) (u (lambda (x)
                      (lambda (n) ((f (u x)) n)))))
             (call/cc (call/cc (call/cc 
                (call/cc (call/cc (lambda (x) x))))))))
           (lambda (f) (lambda (n)
                (if (<= n 0) 1 (* n (f (- n 1)))))))).

	self assert: (lisp top: #(fact 10)) = 3628800

	
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/6/2006 13:31'!
testCatch

	lisp top: #(defun outer-foo (x) (catch $'foo (inner-foo x))).
	lisp top: #(defun inner-foo (x) (if (equal x 10) (throw $'foo 'bouh') (+ 10 x)) 'the end').

	self assert: (lisp top: #(outer-foo 8)) = 'the end'.
	self assert: (lisp top: #(outer-foo 10)) = 'bouh'.


! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 16:33'!
testCatch

	"no catch"! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:04'!
testCatch2

	lisp top: #(defun fun1 (x)  (catch $'trap (+ 3 (fun2 x)))).
	lisp top: #(defun fun2 (y)  (catch $'trap (* 5 (fun3 y)))). 
	lisp top: #(defun fun3 (z) (throw $'trap z)).

	self assert: (lisp top: #(fun1 7)) = 10.


! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 16:33'!
testCatch2

	"no catch"! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:04'!
testCatch3

	lisp top: #(defun fun1 (x)  (catch $'trap (+ 3 (fun2 x)))).
	lisp top: #(defun fun2 (y)  (catch $'snare (* 5 (fun3 y)))). 
	lisp top: #(defun fun3 (z) (throw $'trap z)).

	self assert: (lisp top: #(fun1 7)) = 7.


! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 16:33'!
testCatch3

	"no catch"! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 10:04'!
testCellsDo

	| list sum |

	list _ #(1 2 3) asCons.
	sum _ 0.
	list cellsDo: [:c | sum _ sum + c car]. 

	self assert: sum = 6
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 9/30/2006 22:08'!
testCharacters

	self assert: (lisp evalString: '#\newline') == Character linefeed.
	self assert: (lisp evalString: '#\n') == $n.
	self assert: (lisp evalString: '(prin1-to-string #\newline)') = '#\newline'! !

!ELisp class methodsFor: 'benchmarks' stamp: 'muOuser 3/26/2007 09:29'!
testCode

	^ {
'(+ 1 1)'.
'(defun assoc (x a)
	(cond
		((null a) nil)
		((equal x (car (car a))) (car a))
		(t (assoc x (cdr a)))))'.
'(assoc 1 (list (list 2 5) (list 1 8)))'.
'(fib 12)'
		}! !

!ULisp class methodsFor: 'benchmarks' stamp: 'muOuser 3/26/2007 09:32'!
testCode

	^ {
'(+ 1 1)'.
'(define (assoc x a)
	(cond
		((null? a) nil)
		((equal? x (car (car a))) (car a))
		(#t (assoc x (cdr a)))))'.
'(assoc 1 (list (list 2 5) (list 1 8)))'.
'(fib 12)'
		}! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 10:09'!
testCollect

	| list |

	list _ #(1 2 3) asCons.

	self assert: (list collect: [:c | c + 1]) = #(2 3 4) asCons.
	self assert: list = #(1 2 3) asCons.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/10/2006 19:16'!
testCompiler1

	lisp top: #(defun plus1 (x) (+ 1 x)).
	lisp top: #(compile $'plus1).

	self assert: (lisp top: #(plus1 1)) = 2.

	self assert: (lisp top: #(eval (compile-sexp $'(+ 1 1)))) = 2.

	lisp top: #(setq exp (compile-sexp $'(+ 1 u))).
	self should: [lisp top: #(eval exp)] raise: Error.
	lisp top: #(setq u 2).
	self assert: (lisp top: #(eval exp)) = 3
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/26/2006 22:57'!
testCompiler1

	lisp top: #(define (plus1 x) (+ 1 x)).
	lisp top: #(compile plus1).

	self assert: (lisp top: #(plus1 1)) = 2.

	self assert: (lisp top: #(eval (compile-sexp $'(+ 1 1)))) = 2.

	lisp top: #(define exp (compile-sexp $'(+ 1 u))).
	self should: [lisp top: #(eval exp)] raise: Error.
	lisp top: #(define u 2).
	self assert: (lisp top: #(eval exp)) = 3
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/10/2006 19:19'!
testCompiler2

	lisp top: #(defun bouh (w) (list w (list w $'bouh) (glop w))).
	lisp top: #(compile $'bouh).
	self should: [lisp top: #(bouh 8)] raise: LispError.
	lisp top: #(defun glop (x) x).
	self assert: (lisp top: #(bouh 8)) = #(8 (8 bouh) 8) asCons.
! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/10/2006 20:56'!
testCompiler2

	"different behavior for funbound symbol"! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/10/2006 20:57'!
testCompiler2

	"lexical scoping"! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/21/2006 22:04'!
testCompiler3

	lisp loadDefaultLibraries.

	lisp top: 
	#(defun fib (x)
	      (if (< x 2)
		  x
		  (+ (fib (- x 1))
	     (fib (- x 2))))).

	lisp top: #(compile $'fib).

	self assert: (lisp top: #(fib 10)) = 55
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/26/2006 22:57'!
testCompiler3

	lisp top: 
	#(defun fib (x)
	      (if (< x 2)
		  x
		  (+ (fib (- x 1))
	     (fib (- x 2))))).

	lisp top: #(compile fib).

	self assert: (lisp top: #(fib 10)) = 55
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/17/2006 21:43'!
testCompiler4

	lisp top: #(setq x 10).
	lisp top: #(defun id (z) z).

	lisp top: #(setq forms 
(mapcar (lambda (f) (list f (compile-sexp f)))
$'(
		x
		(quote x)
		(+ 1 x)
		(+ 1 2)
		(car $'(1 2))
		(car $'(1 x))
		(list 1 2)
		(list x 1)
		((lambda (x y) (+ x y)) 5 6)
		(+ 1 (id 1))
		(+ x (id x))
		$'uh
		'hello'
		4
		(primitives)
))).
"
	lisp top: #(setq x 10).
	lisp top: #(defun id (z) z).
"
	lisp top: #(dolist (form forms)
					(if (not (equal (eval (car form)) (eval (cadr form))))
						(error (prin1-to-string form)))).

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/14/2006 22:19'!
testCompiler5

	"inlining"

	lisp loadDefaultLibraries.

	lisp top: #(progn
					(defun plus (x y) (+ x y))
					(defun test1 (x) (plus x 10))
					(compile $'test1)
					(put $'plus $'inline t)
					(defun test2 (x) (plus x 10))
					(compile $'test2)).

	self assert: (lisp top: #(test1 5)) = 15.
	self assert: (lisp top: #(test2 5)) = 15.

	lisp top: #(defun plus (x y) (+ x y 100)).

	self assert: (lisp top: #(test1 5)) = 115.
	self assert: (lisp top: #(test2 5)) = 15.

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/14/2006 22:19'!
testCompiler5

	! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/27/2006 14:55'!
testCompiler6

	lisp loadDefaultLibraries.

	self assert: (lisp top: #(compile-sexp $'(< 1 (+ 1 2)))) = lisp trueValue.
	self assert: (lisp top: #(compile-sexp $'(if (> 1 (+ 1 2)) $'a $'b))) = #b inQuotedCons.

	self assert: (lisp top: #(compile-sexp $'(car $'(a b)))) = #a inQuotedCons.
	! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/21/2006 22:04'!
testCompiler6

	self assert: (lisp top: #(compile-sexp $'(< 1 (+ 1 2)))) = lisp trueValue.
	self assert: (lisp top: #(compile-sexp $'(if (> 1 (+ 1 2)) $'a $'b))) = #b inQuotedCons! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 9/30/2006 22:08'!
testComplex

	self assert: (lisp evalString: '(* #c(1 2) #C(2 3))') = (-4 + 7 i).
	self assert: (lisp evalString: '(prin1-to-string #c(-1 1.5))') = '#C(-1 1.5)'
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 9/30/2006 22:12'!
testComplex

	self assert: (lisp evalString: '(* #c(1 2) #C(2 3))') = (-4 + 7 i).
	self assert: (lisp evalString: '(* 2+3i 1+2i)') = (-4 + 7 i).
	self assert: (lisp evalString: '-i') = -1 i.
	self assert: (lisp evalString: '+i') = 1 i.

	self assert: (lisp evalString: '(prin1-to-string #c(-1 1.5))') = '-1+1.5i'


! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2006 22:44'!
testCond

	self assert: (lisp top: #(cond 
								((listp (+ 1 1)) $'bah)
								((listp $'(+ 1 1)) 'one' 'two' $'yo)
								((listp 5) $'yep))) = #yo.

	self assert: (lisp top: #(cond 
								((listp (+ 1 1)) $'bah)
								((listp 5) $'yo))) = lisp falseValue.

	self assert: (lisp top: #(cond ((+ 1 1)))) = 2

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/17/2006 20:19'!
testCond

	self assert: (lisp top: #(cond 
								((list? (+ 1 1)) $'bah)
								((list? $'(+ 1 1)) $'yo)
								((list? 5) $'yep))) = #yo.

	self assert: (lisp top: #(cond 
								((list? (+ 1 1)) $'bah)
								((list? 5) $'yo))) = lisp falseValue.

	self assert: (lisp top: #(cond ((+ 1 1)))) = 2.

	self assert: (lisp top: #(cond 
								((list? (+ 1 1)) $'bah)
								(else $'yo))) = #yo.

	self assert: (lisp top: #(cond 
								((+ 2 2) => sqrt)
								(else $'yo))) = 2.

	self assert: (lisp top: #(cond 
								((assv $'b $'((a 1) (b 2))) => cadr)
		     					(else #f))) = 2
"
	... not implemented yet

	lisp loadDefaultLibraries.

	self assert: (lisp top: #(let ((=> 5)) (cond (1 => add1)))) = (lisp top: #(progn add1))
"! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/2/2006 18:10'!
testCons

	self assert: (lisp top: #(progn (list 1 2 3))) arrayForm = #(1 2 3).
	self assert: (lisp top: #(progn (list 1 2 3) (* 10 2))) = 20.

	self assert: (lisp top: #(cons 5 4)) printString = '(5 . 4)'.
	self should: [(lisp top: #(cons 5 4)) arrayForm] raise: Error.
	self assert: (lisp top: #(cons 5 nil)) arrayForm = #(5).

	self assert: (lisp top: #(car (list 4 5))) = 4.
	self assert: (lisp top: #(cdr (list 4 5))) arrayForm = #(5).
	self assert: (lisp top: #(cdr (cons 5 4))) = 4! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/20/2006 12:53'!
testConsList

	self assert: #(1 2 3 4 5) asConsList = #(1 2 3 4 5) asCons.
	self assert: #() asConsList = nil.
	self assert: #(1) asConsList = #(1) asCons.
	self assert: #((1) 2 (3) 4 5) asConsList printString = '(#(1) 2 #(3) 4 5)' .! !

!ConsCellTest methodsFor: 'to do' stamp: 'spfa 3/24/2007 18:37'!
testCyclicPrinting

	| cons str |

	cons _ #(1 2 3 4 5) asCons.
	cons cdr setcar: cons.

	str _ cons lispPrintString.

 	self assert: str = '#1=(1 #1# 3 4 5)'.

	self assert: (ELisp new evalString:  '''', str) lispPrintString = str
! !

!ConsCellTest methodsFor: 'to do' stamp: 'spfa 3/24/2007 18:38'!
testCyclicPrinting2

	| cons str |

	cons _ #(1 2 3 4 5) asCons.
	cons cdr setcar: cons.
	cons cddr cddr setcdr: cons cddr cdr.

	str _ cons lispPrintString.

 	self assert: str = '#1=(1 #1# 3 . #2=(4 5 . #2#))'.

	self assert: (ELisp new evalString:  '''', str) lispPrintString = str
! !

!ConsCellTest methodsFor: 'to do' stamp: 'spfa 3/24/2007 18:38'!
testCyclicPrinting3

	| cons str |

	cons _ #(1 2 3 4 5) asCons.
	cons cdr setcar: cons.
	cons setcar: (Array with: #a with: cons with: #b).

	str _ cons lispPrintString.

 	self assert: str = '#1=(#(a #1# b) #1# 3 4 5)'.
! !

!ConsCellTest methodsFor: 'to do' stamp: 'spfa 3/24/2007 18:39'!
testCyclicPrinting4

	| cons str |

	cons _ #(1 2) asCons.
	cons _ {cons . cons . cons} asCons.

	str _ cons lispPrintString.

 	self assert: str = '(#1=(1 2) #1# #1#)'.

	self assert: (ELisp new evalString:  '''', str) lispPrintString = str
! !

!ConsCellTest methodsFor: 'to do' stamp: 'spfa 3/24/2007 18:41'!
testCyclicPrinting5

	| cons vec str |

	cons _ #(1 2 3) asCons.
	vec _ {10 . cons . 20}.
	cons cdr setcar: vec.

	str _ cons lispPrintString.
 	self assert: str = '#1=(1 #(10 #1# 20) 3)'.

	str _ vec lispPrintString.
 	self assert: str = '#1=#(10 (1 #1# 3) 20)'.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/12/2006 21:38'!
testDefcascade

	lisp loadDefaultLibraries.
	self assert: (lisp top: 
		#(send-cascade $'((at:put: 2 $a) (copyFrom:to: 1 2)) 'hello')) = 'ha'.

	lisp top: #(defcascade yo ((at:put: 2 $a) (copyFrom:to: 1 2))).

	self assert: (lisp top: #(yo 'mimi')) = 'ma'
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/12/2006 22:04'!
testDefcascade

	self assert: (lisp top: 
		#(send-cascade $'((at:put: 2 $a) (copyFrom:to: 1 2)) 'hello')) = 'ha'.

	lisp top: #(defcascade yo ((at:put: 2 $a) (copyFrom:to: 1 2))).

	self assert: (lisp top: #(yo 'mimi')) = 'ma'
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 23:53'!
testDefconstant

	lisp top: #(defconstant x 'beuh').
	self should: [lisp top: #(let ((x 10)) x)] raise: LispError.
	self should: [lisp top: #(setq x 10)] raise: LispError.
	self should: [lisp top: #(defvar x 10)] raise: LispError.
	self assert: (lisp top: #(progn x)) = 'beuh'
! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/6/2006 18:45'!
testDefine

	lisp top: #(define (quadruple x)
   					(let ((double (lambda (x) (+ x x))))
      					(double (double x)))).

	self assert: (lisp top: #(quadruple 3)) = 12.

	lisp top: #(define quinze 15).
	self assert: (lisp top: #(begin quinze)) = 15.

! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/6/2006 21:14'!
testDefineMacro

	lisp top: #(define-macro when1
  					(lambda (test . branch)
    						`(if ,test
        			 			(begin ,@branch)))).

	self assert: (lisp top: #(when1 (equal? 1 1) 12 45)) = 45.
	
	lisp top: #(define-macro (when2 test . branch)
    					`(if ,test
        		 			(begin ,@branch))).

	self assert: (lisp top: #(when2 (equal? 1 1) 12 45)) = 45.
	
	lisp top: #(defmacro when3 (test . branch)
    					`(if ,test
        		 			(begin ,@branch))).

	self assert: (lisp top: #(when3 (eq? 1 1) 12 45)) = 45.
	! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 15:04'!
testDefmacro

	lisp top: #(defmacro add4 (x y z) `(+ ,x ,y ,@z)).
	self assert: (lisp top: #(add4 (+ 1 1) (+ 2 2) (10 10))) = 26! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 15:04'!
testDefmacro2

	lisp top: #(defmacro with (sym val form)
				`(let ((,sym ,val))
					,form)).

	lisp top: #(setq bouh 18).
	self assert: (lisp top: #(with bouh 32 (+ 1 bouh))) = 33.	
	self assert: (lisp top: #bouh) = 18.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 09:50'!
testDefmacro3

	lisp top: #(defmacro add (x y . z) `(+ ,x ,y ,@z)).
	self assert: (lisp top: # (add 4 5 10 20)) = 39.	

	lisp top: #(defmacro add (x y &body z) `(+ ,x ,y ,@z)).
	self assert: (lisp top: # (add 4 5 10 20)) = 39.	
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/12/2006 21:27'!
testDefselectors

	lisp loadDefaultLibraries.
	lisp top: #(defselectors cadddr2 (cdr (nthcdr: 2) car)).
	self assert: (lisp top: #(cadddr2  $'(1 2 3 4 5 6))) = 4
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/12/2006 22:05'!
testDefselectors

	lisp top: #(defselectors cadddr2 (cdr (nthcdr: 2) car)).
	self assert: (lisp top: #(cadddr2  $'(1 2 3 4 5 6))) = 4
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/2/2006 18:09'!
testDefun

	self should: [lisp top: #(plus  5 4)] raise: LispError.

	lisp top: #(defun plus (x y) (+ x y)).

	self assert: (lisp top: #(plus  5 4)) = 9.
	self assert: (lisp top: #(plus (+ 1 1) (+ 2 2))) = 6.! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/5/2006 20:44'!
testDefun

	self should: [lisp top: #(plus  5 4)] raise: Error. "not a LispError any more"

	lisp top: #(defun plus (x y) (+ x y)).

	self assert: (lisp top: #(plus  5 4)) = 9.
	self assert: (lisp top: #(plus (+ 1 1) (+ 2 2))) = 6.! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 21:34'!
testDefun

	"no defun. use define"! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/10/2006 18:21'!
testDefunWithKeywords

	lisp top: #(defun test (a &optional b) (list a b)).

	self assert: (lisp top: #(test 1 2)) =  #(1 2) asCons.
	self assert: (lisp top: #(test 1) ) = #(1 nil) asCons.

	self should: [lisp top: #(test)] raise: LispError.
	self should: [lisp top: #(test 1 2 3)] raise: Error.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/10/2006 18:23'!
testDefunWithKeywords2

	lisp top: #(defun test (a &rest b) (list a b)).

	self assert: (lisp top: #(test 1 2)) =  #(1 (2)) asCons.
	self assert: (lisp top: #(test 1 2 3) ) = #(1 (2 3)) asCons.
	self assert: (lisp top: #(test 1)) =  #(1 ()) asCons.

	self should: [lisp top: #(test)] raise: Error.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 23:47'!
testDefunWithKeywords3

	lisp top: #(defun test (a &body b) (list a b)).
	self assert: (lisp top: #(test 1 2)) =  #(1 (2)) asCons.

	lisp top: #(defun test (a . b) (list a b)).
	self assert: (lisp top: #(test 1 2)) =  #(1 (2)) asCons.

	lisp top: #(defun test a a).  "note: this is not allowed in CLISP"
	self assert: (lisp top: #(test 1 2)) =  #(1 2) asCons.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2006 21:37'!
testDefunWithKeywords4

	lisp class wantsFullArgumentsListsSupport ifFalse: [^ self].
	lisp loadDefaultLibraries.

	lisp top: #(defun beuh (a &optional b &key c d (e 17)) (list a b c d e)).

	self assert: (lisp top: #(beuh 1 2 :e 5 :c 12 :d 'a')) =  #(1 2 12 'a' 5) asCons.
	self assert: (lisp top: #(beuh 1 2) ) = #(1 2 nil nil 17) asCons.! !

!StaticLispTest methodsFor: 'to do' stamp: 'spfa 8/3/2006 23:38'!
testDefunWithKeywords4

	"fails. depends on code initially written for Emacs (full dynamic scoping)"! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 14:59'!
testDelayedEvaluation

	lisp top: #(begin 

(define stream-car
  (lambda (s)
    (car (force s))))

(define stream-cdr
  (lambda (s)
    (cdr (force s))))

(define counters
  (let next ((n 1))
    (delay (cons n (next (+ n 1))))))
).

	self assert: (lisp top: #(stream-car counters)) = 1.
	self assert: (lisp top: #(stream-car (stream-cdr counters))) = 2.

	lisp top: #(begin 

(define stream-add
  (lambda (s1 s2)
    (delay (cons
             (+ (stream-car s1) (stream-car s2))
             (stream-add (stream-cdr s1) (stream-cdr s2))))))

(define even-counters
  (stream-add counters counters))
).

	self assert: (lisp top: #(stream-car even-counters)) =  2.
	self assert: (lisp top: #(stream-car (stream-cdr even-counters))) = 4! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 3/14/2007 22:16'!
testDelete

	self assert: (lisp top: #(delq 5 $'(1 5 3 4 5 6))) = #(1 3 4 6) asCons.
	self assert: (lisp top: #(delq 5 $'(5 3 4 5 6))) = #(3 4 6) asCons.

	self assert: (lisp top: #(delete 5 $'(1 5 3 4 5 6))) = #(1 3 4 6) asCons.
	self assert: (lisp top: #(delete 5 $'(5 3 4 5 6))) = #(3 4 6) asCons.

	self assert: (lisp top: #(delq 'uh' $'(5 'uh' 4))) = #(5 'uh' 4) asCons.
	self assert: (lisp top: #(delete 'uh' $'(5 'uh' 4))) = #(5 4) asCons.
! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 10:04'!
testDo

	| list sum |

	list _ #(1 2 3) asCons.
	sum _ 0.
	list do: [:c | sum _ sum + c]. 

	self assert: sum = 6
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/20/2006 12:59'!
testDo

	self assert: (lisp top: 
		#(let ((x (list 1 3 5 7 9)))
			(do ((x x (cdr x)) 
				(sum 0 (+ sum (car x)))) 
				((null? x) sum)))) = 25.

	self assert: (lisp top: 
		#(do ((vec (make-vector 5))
				(i 0 (+ i 1)))
				((= i 5) vec)
				(vector-set!! vec i i))) = #(0 1 2 3 4)
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/2/2006 18:08'!
testDolist

	lisp top: #(setq test nil).
	self assert: (lisp top: #(dolist (i $'(10 20 30) (+ 1 1))
									(setq test (append test (list (* i i)))))) = 2.
	self assert: (lisp top: #(progn test)) = #(100 400 900) asCons.
	self should: [lisp top: #(progn i)] raise: LispError! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 21:35'!
testDolist

	lisp top: #(define test nil).
	self assert: (lisp top: #(dolist (i $'(10 20 30) (+ 1 1))
									(set!! test (append test (list (* i i)))))) = 2.
	self assert: (lisp top: #(begin test)) = #(100 400 900) asCons.
	self should: [lisp top: #(begin i)] raise: LispError! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:06'!
testDynamicScoping

	lisp top: #(defun addx (y) (+ x y)).
	self assert: (lisp top: #(let ((x 10)) (addx 5))) = 15
! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 8/3/2006 22:00'!
testDynamicScoping

	"no dynamic scoping"! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/9/2006 20:33'!
testEq

	self assert: (lisp top: #(eq 5 5)) =  lisp trueValue.
	self assert: (lisp top: #(eq 5 (+ 3 2))) =  lisp trueValue.
	self assert: (lisp top: #(eq (list 1 2) (list 1 2))) = lisp falseValue.

	(lisp top: #(setq uh $'(1 2))).
	self assert: (lisp top: #(eq: uh ` ,uh)) = lisp trueValue.! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/16/2006 18:32'!
testEq

	self assert: (lisp top: #(eq? 5 5)) = lisp trueValue.
	self assert: (lisp top: #(eq? 5 (+ 3 2))) = lisp trueValue.
	self assert: (lisp top: #(eq? (list 1 2) (list 1 2))) = lisp falseValue.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 21:51'!
testEqual

	self assert: (lisp top: #(equal 5 5)) = lisp trueValue.
	self assert: (lisp top: #(equal 5 (+ 3 2))) = lisp trueValue.
	self assert: (lisp top: #(equal (list 1 2) (list 1 2))) = lisp trueValue.

	self assert: (lisp top: #(equal 5 10)) = lisp falseValue.! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/16/2006 18:32'!
testEqual

	self assert: (lisp top: #(equal? 5 5)) = lisp trueValue.
	self assert: (lisp top: #(equal? 5 (+ 3 2))) = lisp trueValue.
	self assert: (lisp top: #(equal? (list 1 2) (list 1 2))) = lisp trueValue.

	self assert: (lisp top: #(equal? 5 10)) = lisp falseValue.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 9/22/2006 16:11'!
testEval

	lisp top: #(defun test () (eval $'(setq blep 452)) blep).
	self assert: (lisp top: #(test)) = 452.
	self assert: (lisp top: #(progn blep)) = 452.

	self should: [lisp top: #(let ((x 10)) (eval $'x))] raise: LispError.

	lisp top: #(defun test2 (n) (eval n)).
	self assert: (lisp top: #(test2 $'(+ 1 1))) = 2.! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 9/22/2006 16:11'!
testEval

	lisp top: #(define test (lambda () (eval $'(define blep 452)) blep)).
	self assert: (lisp top: #(test)) = 452.
	self assert: (lisp top: #(begin blep)) = 452.

	self should: [lisp top: #(let ((x 10)) (eval $'x))] raise: LispError.

	lisp top: #(define test2 (lambda (n) (eval n))).
	self assert: (lisp top: #(test2 $'(+ 1 1))) = 2.! !

!LKTokenTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 23:35'!
testExponent

	self assert: (LKToken parse: '-12e8') = -1.2e9 .
	self assert: (LKToken parse: '-12.e8') = -1.2e9 .
	self assert: (LKToken parse: '-12.0e8') = -1.2e9 .
	self assert: (LKToken parse: '-12e+8') = -1.2e9 .
	self assert: (LKToken parse: '-12e+8.') = #'-12e+8.' .
	self assert: ((LKToken parse: '12e-3') closeTo: 0.012).
	self assert: ((LKToken parse: '12.e-3') closeTo: 0.012).
	self assert: (LKToken parse: '12e-+3') = #'12e-+3' .! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/21/2007 23:14'!
testFiles

	^ self filesInULispDirectory: 'tests'! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2006 21:08'!
testFirst

	| list |

	list _ #(1 2 3 4 5) asCons.
	self assert: list first = 1.
	self assert: list second = 2.
	self assert: list third = 3.	
	self assert: list last = #(5) asCons! !

!LKTokenTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 23:24'!
testFloats

	self assert: (LKToken parse: '123.0') isFloat.
	self assert: (LKToken parse: '123.0') = 123.
	self assert: (LKToken parse: '123.0I') = #'123.0I'.
	self assert: (LKToken parse: '-12.3') = -12.3.
	self assert: ((LKToken parse: '+.123') closeTo: 0.123).
	self assert: (LKToken parse: '.0') isFloat.
	self assert: (LKToken parse: '.0') = 0.0
! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 14:59'!
testFluidLet

	lisp top: #(begin
					(define counter 1)
					(define bump-counter
	  					(lambda ()
 	   						(set!! counter (+ counter 1))
	    						counter))).

	self assert: (lisp top: #(bump-counter)) = 2.
	self assert: (lisp top: #(bump-counter)) = 3.

	self assert: (lisp top: #(fluid-let ((counter 99))
  									(list (bump-counter)  
										(bump-counter)  
										(bump-counter)))) = #(100 101 102) asCons.
	
	self assert: (lisp top: #(begin counter)) = 3.
	! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/21/2006 14:21'!
testForEach

	lisp top: #(define x 0).
	lisp top: #(for-each (lambda (n) (set!! x (+ x n))) $'(1 2 3)).
	self assert: (lisp top: #x) = 6! !

!LKTokenTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 23:26'!
testFractions

	self assert: (LKToken parse: '12/35') = (12/35).
	self assert: (LKToken parse: '12/35') isFraction.
	self assert: (LKToken parse: '-12/35') = (-12/35).
	self assert: (LKToken parse: '-12/35') isFraction.
	self assert: (LKToken parse: '12//35') = #'12//35'.
	self assert: (LKToken parse: '12/3.5') = #'12/3.5'.
	self assert: (LKToken parse: '12./35') = #'12./35'.
	self assert: (LKToken parse: '12/-35') = #'12/-35'.
	self assert: (LKToken parse: '12/+35') = #'12/+35'.
	self assert: (LKToken parse: '-12/-35') = #'-12/-35'.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:05'!
testFuncall

	self assert: (lisp top: #(funcall $'+ 1 7)) = 8.
	self assert: (lisp top: #(funcall $'car (list 1 7))) = 1.
	self assert: (lisp top: #(funcall $'(lambda (x y) (* x y)) 1 7)) = 7.

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 16:34'!
testFuncall

	! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/21/2006 00:55'!
testFunctionApplication

 	self assert: (lisp top: #((identity identity) 12)) = 12.
 	self assert: (lisp top: #(((identity identity) identity) 12)) = 12.

	self assert: (lisp top: #((if (odd? 3) + -) 6 2)) = 8.

	self assert: (lisp top: #(let ((f (lambda (x) (+ x x))))
  									(f 8))) = 16! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:05'!
testIf

	self assert: (lisp top: #(if true 4 (* 10 45))) = 4.
	self assert: (lisp top: #(if nil 4 (* 10 45))) = 450.
	self assert: (lisp top: #(if $'nil 4 (* 10 45))) = 450.
	self assert: (lisp top: #(if #() 4 (* 10 45))) = 450.

	self assert: (lisp top: #(if $'ok 4 (/ 1 0))) = 4.
	self should: [lisp top: #(if nil 4 (/ 1 0))] raise: Error! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/7/2006 21:53'!
testIf

	self assert: (lisp top: #(if true 4 (* 10 45))) = 4.
	self assert: (lisp top: #(if nil 4 (* 10 45))) = 4.
	self assert: (lisp top: #(if $'nil 4 (* 10 45))) = 4.
	self assert: (lisp top: #(if #() 4 (* 10 45))) = 4.
	self assert: (lisp top: #(if false 4 (* 10 45))) = 450.

	self assert: (lisp top: #(if $'ok 4 (/ 1 0))) = 4.
	self should: [lisp top: #(if false 4 (/ 1 0))] raise: Error! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 7/3/2006 15:36'!
testIf

	self assert: (lisp top: #(if true 4 (* 10 45))) = 4.
	self assert: (lisp top: #(if nil 4 (* 10 45))) = 4.
	self assert: (lisp top: #(if false 4 (* 10 45))) = 450.
	self assert: (lisp top: #(if #() 4 (* 10 45))) = 4.

	self assert: (lisp top: #(if $'ok 4 (/ 1 0))) = 4.
! !

!LKTokenTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 23:22'!
testIntegers

	self assert: (LKToken parse: '123') = 123.
	self assert: (LKToken parse: '123.') = 123.
	self assert: (LKToken parse: '123I') = #'123I'.
	self assert: (LKToken parse: '-123') = -123.
	self assert: (LKToken parse: '+123') = 123.
	self assert: (LKToken parse: '0.') = 0.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 21:22'!
testLambda

	self assert: (lisp top: #((lambda () 2))) = 2.
	self assert: (lisp top: #((lambda nil 2))) = 2.
	self assert: (lisp top: #(lambda (x y) (+ x y 2))) = #(lambda (x y) (+ x y 2)) asCons.
	self assert: (lisp top: #((lambda (x y) (+ x y 2)) 5 8)) = 15.
! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/5/2006 21:05'!
testLambda

	self assert: (lisp top: #((lambda () 2))) = 2.
	self assert: (lisp top: #((lambda nil 2))) = 2.
	self assert: (lisp top: #(lambda (x y) (+ x y 2))) printString = '(lambda (x y) (+ x y 2))'.
	self assert: (lisp top: #((lambda (x y) (+ x y 2)) 5 8)) = 15.
! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 10:38'!
testLast

	self assert: #(1 2 3) asCons last = #(3) asCons.
	! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 15:00'!
testLast

	self assert: (lisp top: #(last $'(1 2 3 4))) = 4.      "srfi-1"
	self assert: (lisp top: #(last-pair $'(1 2 3 4))) = #(4) asCons.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:05'!
testLet

	lisp top: #(setq y 2).
	self assert: (lisp top: #(let ((y 1) (z y)) (list y z))) arrayForm = #(1 2).
	self assert: (lisp top: #y) = 2
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 21:36'!
testLet

	lisp top: #(define y 2).
	self assert: (lisp top: #(let ((y 1) (z y)) (list y z))) arrayForm = #(1 2).
	self assert: (lisp top: #y) = 2! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2006 18:08'!
testLetRec

	lisp top: #(define (test1)
   					((let ((to-zero (lambda (n) (if (equal? 1 n) 0 (to-zero (- n 1))))))
      					to-zero) 10)).

	self should: [lisp top: #(test1)] raise: LispError.

	lisp top: #(define (test2)
   					((letrec ((to-zero (lambda (n) (if (equal? 1 n) 0 (to-zero (- n 1))))))
      					to-zero) 10)).

	self assert: (lisp top: #(test2)) = 0.

! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 14:58'!
testLetRec2

	lisp top: #(define (property-list-search lis target)
   					(letrec ((loop (lambda (l)
                     						(cond 	((null? l) false)
                           							((eq? (car l) target) (car (cdr l)))
                           							(true (loop (cdr (cdr l))))))))
      					(loop lis))) .

	self assert: (lisp top: #(property-list-search
									$'(:un 1 :deux 2 :trois 3)
									$':deux)) = 2.

! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 14:58'!
testLetRec3

	self assert: (
	lisp top: #(letrec ((local-even? (lambda (n)
                     						(if (= n 0) true
                         						(local-odd? (- n 1)))))
      				 (local-odd? (lambda (n)
                    						(if (= n 0) false
                        						(local-even? (- n 1))))))
  					(list (local-even? 23) (local-odd? 23))) 
	) = #(false true) asCons.


! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/6/2006 13:32'!
testLetStar

	lisp top: #(setq y 2).
	self assert: (lisp top: #(let* ((y 1) (z y)) (list y z))) arrayForm = #(1 1).
	self assert: (lisp top: #y) = 2
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 21:36'!
testLetStar

	lisp top: #(define y 2).
	self assert: (lisp top: #(let* ((y 1) (z y)) (list y z))) arrayForm = #(1 1).
	self assert: (lisp top: #y) = 2
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 17:08'!
testList

	self assert: (lisp top: #(list 1 2 3)) arrayForm = #(1 2 3).
	self assert: (lisp top: #(list 1 2 (+ 4 5)))  arrayForm = #(1 2 9).! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 10:02'!
testListCopy

	| list1 list2  |

	list1 _ #(1 2 3) asCons.
	list2 _ list1 listCopy.
	list2 addLast: 55.

	self assert: list1= #(1 2 3) asCons.
	self assert: list2 = #(1 2 3 55) asCons.

	(list1 nthCell: 1) setcar: 22.

	self assert: list1= #(1 22 3) asCons.
	self assert: list2 = #(1 2 3 55) asCons.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 3/25/2007 14:45'!
testLoop

	lisp loadDefaultLibraries.
	lisp top: #(require-library $'loop).

	self assert: (lisp top: #(loop for i in $'(1 2 3)  collect i)) = #(1 2 3) asCons.
	self assert: (lisp top: #(loop for i from 1 to 4 collect i)) = #(1 2 3 4) asCons.
	self assert: (lisp top: #(loop until t finally (return 'a'))) = 'a'.

	"note: the following is allowed by CLtL2 but forbddien by ANSI CL"
	self assert: (lisp top: #(loop until t finally return 'a')) = 'a'.
! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/15/2006 15:32'!
testLoop

	"hangs forever. 
	loop code requires t/nil as booleans while we have true/false in SLisp"! !

!StaticLispTest methodsFor: 'to do' stamp: 'spfa 8/3/2006 23:38'!
testLoop

	"fails. depends on code initially written for Emacs (full dynamic scoping)"! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 3/25/2007 14:50'!
testLoop

	"loop returns multiple values, hence the #asOneLispValue message"

	lisp top: #(load-library $'loop).

	self assert: (lisp top: #(loop for i in $'(1 2 3)  collect i)) asOneLispValue 
		= #(1 2 3) asCons.
	self assert: (lisp top: #(loop for i from 1 to 4 collect i)) asOneLispValue 
		= #(1 2 3 4) asCons.
	self assert: (lisp top: #(loop until true finally (return 'a'))) asOneLispValue
		 = 'a'.

	"note: the following is allowed by CLtL2 but forbddien by ANSI CL"
	self should: [lisp top: #(loop until true finally return 'a')] raise: LispError! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2006 17:55'!
testMacro

	self assert: (lisp top: #((macro (x &rest y) `(+ ,x ,@y 2)) 5 4 3 1)) = 15.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 16:34'!
testMacro

	! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 17:18'!
testMap

	self assert: (lisp top: #(map + $'(1 2 3) $'(3 2 1))) = #( 4 4 4) asCons.
	self assert: (lisp top: #(map car $'((:un deux)))) = #(:un) asCons.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 14:59'!
testMultipleValue

	self assert: (lisp top:#(values 1 2 3)) = (#(1 2 3) as: LKValues).
	self assert: (lisp top:#(values-list $'(1 2 3))) = (#(1 2 3) as: LKValues).

	self assert: (lisp top:#(+ (values 1 2 3) 1)) = 2.

	self assert: (lisp top:#(multiple-value-list (values 1 2 3))) = #(1 2 3) asCons.
	self assert: (lisp top:#(multiple-value-list 5)) = #(5) asCons.

	self assert: (lisp top:#(multiple-value-call (symbol-function $'+) (values 5 3) (values 19 4))) = 31.

	self assert: (lisp top:#(multiple-value-prog1 1 2 3)) = (#(1) as: LKValues).
	self assert: 
		(lisp top:#(multiple-value-prog1 (values 1 4) 2 3)) = (#(1 4) as: LKValues).
	self assert: (lisp top:#(prog1 (values 1 4) 2 3)) = 1.

	self assert: 
		(lisp top:#(multiple-value-bind (x) (values 5 3) (list x))) = 5 inCons.
	self assert: 
		(lisp top:#(multiple-value-bind (x y) (values 5 3) (list x y))) = #(5 3) asCons.
	self assert: 
		(lisp top:#(multiple-value-bind (x y) 5 (list x y))) = #(5 nil) asCons.! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/16/2006 18:31'!
testNamedLet

	lisp top: #(define list?
  					(lambda (x)
    						(let race ((h x) (t x))
      						(if (pair? h)
          						(let ((h (cdr h)))
            							(if (pair? h)
               							(and (not (eq? h t))
                     								(race (cdr h) (cdr t)))
                							(null? h)))
          						(null? h))))).

	self assert: (lisp top: #(list? (list 2 (/ 1 3) 5 (/ 1 4))))	=  lisp trueValue.

	self assert: (lisp top: #(list? (cons 2 17))) = lisp falseValue.
! !

!SLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 20:54'!
testNameSpace

	lisp top: #(setq p (@ 10 15)).
	self assert: (lisp top: #(smalltalk 'p + (1@2)')) = (11@17).

	self assert: (lisp top: #(let ((x 1)) (smalltalk 'x'))) = 1.
	self should: [lisp top: #(let ((#'n--uh!!' 1)) (smalltalk 'n--uh!!'))] raise: Error! !

!SLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2006 17:48'!
testNameSpace2

	| q |

	lisp top: #(setq p 2).
	q _ -2.
	self should: [lisp top: #(!! 'q + p)')] raise: Error.	
	self assert: (lisp top: {#+ . q . #p}) = 0	! !

!SLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/19/2006 14:19'!
testNameSpace3

	lisp top: #(setq m (new Morph)).
	lisp top: #(progn {m position: (5@56)}).

	self assert: (lisp top: #(progn {m position})) = (5@56).	! !

!ELispTest methodsFor: 'fun' stamp: 'spfa 10/19/2006 15:15'!
testNonRecursiveFactorial

	"just use a circular program !!"

	lisp evalString: '(defun fact (n) #1=(if (< n 1) 1 (setq n (- n 1)) (* (+ 1 n) #1#)))'.

	self assert: (lisp top: #(fact 8)) = 40320! !

!ELispTest methodsFor: 'fun' stamp: 'spfa 11/15/2006 14:46'!
testNonRecursiveFib

	"fibonacci numbers - another circular program"

	lisp evalString: 
'(defun fib (n) 
	#1=(if (< n 2) 
			n 
			(+ (let ((n (- n 1))) #1#)
				(let ((n (- n 2))) #1#))))'.

	self assert: (lisp top: #(fib 10)) = 55! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 23:37'!
testOr

	self assert: (lisp top: #(or true 4 (* 10 45))) = true.
	self assert: (lisp top: #(or nil true nil (* 10 45))) = true.
	self assert: (lisp top: #(or () nil)) isNil.
! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/7/2006 21:54'!
testOr

	self assert: (lisp top: #(or true 4 (* 10 45))) = true.
	self assert: (lisp top: #(or nil true false (* 10 45))) = nil.
	self assert: (lisp top: #(or false)) = lisp falseValue.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 7/3/2006 15:37'!
testOr

	self assert: (lisp top: #(or true 4 (* 10 45))) = lisp trueValue.
	self assert: (lisp top: #(or false true #f (* 10 45))) = true.
	self assert: (lisp top: #(or () nil)) isNil.
	self assert: (lisp top: #(or (not $'f) false)) = lisp falseValue..
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 15:00'!
testPregexp

	"http://www.ccs.neu.edu/home/dorai/pregexp/pregexp.html"

	lisp top: #(load-library $'pregexp).
	lisp top: #(test-pregexp).

	self assert: (lisp top: #(begin #'*failed*')) = 0
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 18:02'!
testPrimitivesRepresentation

	self assert: (lisp top: #(symbol-function $'car)) printString = 'primitive car:'.
	self assert: (lisp top: #(symbol-function $'car:)) printString = 'primitive car:'.
	self assert: ((lisp top: #(primitives)) topForms includes: #car:).
	self assert: ((lisp top: #(primitives)) topForms includes: #car) not.
	self assert: (lisp top: #(primitivep $'car)) = lisp trueValue.	
	self assert: (lisp top: #(primitivep $'car:)) = lisp trueValue.	
	self assert: (lisp top: #(fboundp $'car)) = lisp trueValue.	
	self assert: (lisp top: #(fboundp $'car:)) = lisp trueValue.	
	self assert: (lisp top: #(eq (symbol-function $'car) (symbol-function $'car:))) = lisp trueValue.
	self assert: (lisp top: #(documentation $'car)) isString.	

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 18:01'!
testPrimitivesRepresentation

	self assert: (lisp top: #car) printString = 'primitive car:'.
	self assert: (lisp top: #car:) printString = 'primitive car:'.
	self assert: ((lisp top: #(primitives)) topForms includes: #car:).
	self assert: ((lisp top: #(primitives)) topForms includes: #car) not.
	self assert: (lisp top: #(primitive? $'car)) = lisp trueValue.	
	self assert: (lisp top: #(primitive? $'car:)) = lisp trueValue.	
	self assert: (lisp top: #(eq? car car:)) = lisp trueValue.
	self assert: (lisp top: #(procedure? car)) = lisp trueValue.	
	self assert: (lisp top: #(procedure? car:)) = lisp trueValue.	
	self assert: (lisp top: #(documentation $'car)) isString.	

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 23:37'!
testProgn

	self assert: (lisp top: #(progn (list 1 2 3))) arrayForm = #(1 2 3).
	self assert: (lisp top: #(progn (list 1 2 3) (* 10 2))) = 20.
	self assert: (lisp top: #(progn)) isNil.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/6/2006 23:31'!
testQuasiquote1

	self assert: (lisp top: #(equal `(1 5 . ,(+ 2 3)) $'(1 5 . 5))) = lisp trueValue.
"	self assert: (lisp top: #(equal `(1 5 . (unquote (+ 2 3))) $'(1 5 . 5))) = lisp trueValue." "not implemented yet"

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 21:17'!
testQuasiquote2

	lisp top: #(setq x 10).
	self assert: (lisp top: #(progn `(,x 5))) = #(10 5) asCons.
	self assert: (lisp top: #(eval ` ,(car (list 1 2)))) = 1.
	self assert: (lisp top: #(progn `(let ((x ,(- x 8))) (progn `(,x 5))))) 
					= #(let ((x 2)) (progn (quasiquote ((unquote x) 5)))) asCons.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 7/8/2006 21:17'!
testQuasiquote2

	lisp top: #(define x 10).
	self assert: (lisp top: #(begin `(,x 5))) = #(10 5) asCons.
	self assert: (lisp top: #(begin `(let ((x ,(- x 8))) (begin `(,x 5))))) 
					= #(let ((x 2)) (begin (quasiquote ((unquote x) 5)))) asCons.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 3/24/2007 16:30'!
testQuasiquote3

	"example from paper 'Quasiquotation in Lisp' by Alan Bawden, attibuted to Mike MacMahon"

	| str |

	lisp top: #(setq autoeval (quote
					(let ((let $' `(let ((let $' ,let)) ,let))) `(let ((let $' ,let)) ,let))
					)).

	self assert: (lisp top: #(equal (eval autoeval) autoeval)) = lisp trueValue.

	"more striking forms:"

	str _ '(let ((let (quote: (quasiquote: (let ((let (quote: (unquote let)))) (unquote let)))))) (quasiquote: (let ((let (quote: (unquote let)))) (unquote let))))'.

	self assert: ((lisp evalString: str) printStringForLisp: lisp) = str.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 9/22/2006 22:26'!
testQuasiquote4

	self assert: (lisp top: #(progn `(1 $'(2 ,(+ 1 3))))) = #(1 (quote (2 4))) asCons.
	self assert: (lisp top: #(progn `(1 `(2 ,(+ 1 3))))) = #(1 (quasiquote (2 (unquote (+ 1 3))))) asCons.


! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 21:17'!
testQuasiquote5

	"note: GNU Emacs 21.2.1 fails to give the correct result, where CLISP 2.36 and PLT Scheme 350 do"

	self assert: (lisp top: #(progn `(list `(list 1 , $' , 2)))) 
					= #(list (quasiquote (list 1(unquote (quote 2))))) asCons.

	self assert: (lisp top: #(eval `(list `(list 1 , $' , 2)))) = #((list 1 2)) asCons
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/21/2006 13:51'!
testQuasiquote6

	"note: both GNU Emacs 21.2.1 and CLISP 2.36 fail here, while PLT Scheme 350 answers correctly"

	self assert: (lisp top: # (eval ` `(, ,2))) 
					= #(2) asCons.

	self assert: (lisp top: # (eval ` `(, ,@(list 1 2 3 4 5)))) 
					= #(1 2 3 4 5) asCons.

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/23/2006 13:25'!
testQuasiquote7

	self assert: (lisp top: #(quasiquote ((split) . pea))) = (#split inCons inCons cdr: #pea)! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/6/2006 23:42'!
testQuasiquote8

	"MIT Scheme, PLT Scheme agree with the following, while Emacs Lisp, CLISP and SBCL return (1 unquote (+ 1 1)) :"
	self assert: (lisp top: #(quasiquote (1 unquote (+ 1 1)))) = (ConsCell car: 1 cdr: 2).

	"MIT Scheme agrees with the following, while PLT Scheme signals an error:"
	self assert: (lisp top: #(quasiquote (1 unquote (+ 1 1) 3))) = #(1 unquote (+ 1 1) 3) asCons! !

!ELispTest methodsFor: 'to do' stamp: 'spfa 3/24/2007 23:49'!
testQuasiquote9

	self assert: (lisp evalString: ' `(,@''() . foo)') = #foo.
"
to do:
	self should: [lisp evalString: '''( . foo)'] raise: Error
"! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:05'!
testQuote

	self assert: (lisp top: #(eval (eval (quote (list (quote +) 10 100 2))))) = 112.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 15:00'!
testR4SR

	"use R4RS compliance tests from file r4rstest.scm in SCM version 5e2
	http://www.swiss.ai.mit.edu/~jaffer/SCM.html"

	lisp ignoreCase.

	lisp top: #(load (system-path 'ulisp/tests/r4rstest.scm')).
	lisp top: #(test-cont).
	lisp top: #(test-sc4).
	lisp top: #(test-delay).

	self assert: (lisp top: #errs) isNil

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 21:17'!
testRewrite

	self assert: (lisp top: #(defmacro add (x y) (quasiquote (+ (unquote x) (unquote y))))) 
				= (lisp top: #(defmacro add (x y) `(+ ,x ,y))).

	self assert: (lisp top: #(defmacro add (x y) (quasiquote (+ (unquote x) (unquote-splicing y))))) 
				= (lisp top: #(defmacro add (x y) `(+ ,x ,@y))).! !

!LispKernelTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/20/2006 12:58'!
testRewrite1

	self assert: 
	(LispKernel rewrite: #(asciiValue97) asCons) = {#a} asCons.

	self assert: 
	(LispKernel rewrite: {#asciiValue97} inCons) arrayForm = {{#a}}.

	! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/24/2006 15:17'!
testSchelog

	lisp top: #(load-library $'schelog).
	lisp top: #(load (system-path 'ulisp/schelog/examples/bible.scm')).
	self assert: (lisp top: #(terachs-kids-test)) asOneLispValue arrayForm 
			= #((cc (haran nachor abraham))).
	self assert: (lisp top: #(#'terachs-kids-test-2')) asOneLispValue arrayForm 
			= #((kk (abraham nachor haran))).


! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/2/2006 18:15'!
testScope

	"same behavior as in Emacs Lisp, while it works in Common Lisp and in Scheme"

	self should:
	[
		lisp top: #(let (func)
						(let ((x 10))
							(setq func (lambda (y) (+ x y))))
						(funcall func 5))
	] 
	raise: LispError
! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 7/22/2006 16:37'!
testScope

	self assert: (lisp top: #(let (func)
						(let ((x 10))
							(setq func (lambda (y) (+ x y))))
						(apply func $'(5)))) = 15

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 21:37'!
testScope

	self assert: (lisp top: #(let (func)
						(let ((x 10))
							(set!! func (lambda (y) (+ x y))))
						(apply func $'(5)))) = 15

! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 16:35'!
testScope01

	self assert:
	(
		lisp top: #(let (func)
						(let ((x 10))
							(setq func (lambda (y) (+ x y))))
						(apply func $'(5)))
	) = 15.
	
	self assert:
	(
		lisp top: #(progn 
						(let ((x 10))
							(defun func (y) (+ x y)))
						(func 5))
	) = 15.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 8/14/2006 13:29'!
testScope01

	self assert:
	(
		lisp top: #(let (func)
						(let ((x 10))
							(set!! func (lambda (y) (+ x y))))
						(apply func $'(5)))
	) = 15.

! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 9/24/2006 14:21'!
testScope02

	lisp loadDefaultLibraries.

	lisp top: #(defun compose (f g) 
  					(lambda (x) (funcall f (funcall g x)))).

	self assert: (lisp top: #(funcall (compose $'sqrt $'abs) -9)) = 3.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 16:35'!
testScope02

	! !

!CLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/6/2006 13:34'!
testScope03

	lisp top: #(progn
					(setq regular 5)
 					(defun check-regular () regular)).

	self assert: (lisp top: #(check-regular)) = 5.
	self assert: (lisp top: #(let ((regular 6)) (check-regular))) = 5.

	lisp top: #(progn
					(defvar special 5)
 					(defun check-special () special)).

	self assert: (lisp top: #(check-special )) = 5.
	self assert: (lisp top: #(let ((special 6)) (check-special ))) = 6.
! !

!CLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/21/2006 14:20'!
testScope04

	self should: [
	lisp top: #(let ((x 1) (y 2))
					(let ((y 2) (z 3)) 
						(+ x y z)) 
					z)
	] raise: Error.

	lisp top: #(defvar z 10).

	lisp assert: (
	lisp top: #(let ((x 1) (y 2))
					(let ((y 2) (z 3)) 
						(setq sum (+ x y z)))
					z)
	) = 10.

	self assert: (lisp top: #sum) = 6.

! !

!CLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/3/2006 23:30'!
testScope05

	lisp top: #(progn
					(defvar z 1) 
					(defun foo () z)
					(defun baz ()
						(let ((z 2)) 
						(foo)))).

	self assert: (lisp top: #(baz)) = 2

! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/5/2006 21:06'!
testScope06

	lisp top: #(progn
					(setq z 1) 
					(defun foo () z)
					(defun baz ()
						(let ((z 2)) 
							(foo)))).

	self assert: (lisp top: #(baz)) = 1

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 21:40'!
testScope06

	lisp top: #(begin
					(define z 1) 
					(define (foo) z)
					(define (baz)
						(let ((z 2)) 
							(foo)))).

	self assert: (lisp top: #(baz)) = 1


! !

!CLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/6/2006 13:34'!
testScope07


	lisp top: #(progn
					(defun baz ()
						(let ((x 2))
							(list x (symbol-value $'x)))) 
					(defun foo ()
						(let ((x 1))
							(baz)))).

	self should: [lisp top: #(foo)] raise: LispError

! !

!CLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/12/2006 13:52'!
testScope08

	lisp top: #(progn
					(defun baz ()
						(let ((x 2))
							(list x (symbol-value $'x)))) 
					(defun foo ()
						(let ((x 1))
							(declare (special x)) 
							(baz)))).

	self assert: (lisp top: #(foo)) = #(2 1) asCons
! !

!CLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/3/2006 23:31'!
testScope09

	lisp top: #(progn
					(defvar x 1)
					(defun baz () x)
					(defun foo ()
						(let ((x 2)) 
							(baz)))).

	self assert: (lisp top: #(foo)) = 2

! !

!CLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/3/2006 20:44'!
testScope10

	lisp top: #(progn
					(setq x 1)
					(defun baz () x)
					(defun foo ()
						(let ((x 2)) 
						(baz)))).

	self assert: (lisp top: #(foo)) = 1.

	lisp top: #(progn
					(defvar x 1)
					(defun baz () x)
					(defun foo ()
						(let ((x 2)) 
						(baz)))).

	self assert: (lisp top: #(foo)) = 2

! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/5/2006 21:07'!
testScope11

	lisp top: #(defun baz ()
					(let ((x 1)) 
						(lambda ()
							(setq x (+ x 1))))).

	lisp top: #(progn 
					(setq x1 (baz))
					(setq x2 (baz))).

	self assert: (lisp top: #(funcall x1)) = 2.
	self assert: (lisp top: #(funcall x1)) = 3.
	self assert: (lisp top: #(funcall x1)) = 4.
	self assert: (lisp top: #(funcall x2)) = 2.

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 18:47'!
testScope11

	lisp top: #(define (baz)
					(let ((x 1)) 
						(lambda ()
							(set!! x (+ x 1))))).

	lisp top: #(begin 
					(define x1 (baz))
					(define x2 (baz))).

	self assert: (lisp top: #(apply x1 $'())) = 2.
	self assert: (lisp top: #(apply x1 $'())) = 3.
	self assert: (lisp top: #(apply x1 $'())) = 4.
	self assert: (lisp top: #(apply x2 $'())) = 2.

! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/16/2006 21:38'!
testScope12

	lisp loadDefaultLibraries. "for first and second"

	lisp top: #(progn 
					(defun up-n-down ()
					(let ((x 0))
						(list
							(lambda () (setq x (+ x 1)))
							(lambda () (setq x (- x 1))))))
					(setq f1 (up-n-down)) 
					(setq f2 (up-n-down))). 

	self assert: (lisp top: #(funcall (first f1))) = 1.
	self assert: (lisp top: #(funcall (first f1))) = 2.
	self assert: (lisp top: #(funcall (first f1))) = 3.
	self assert: (lisp top: #(funcall (second f1))) = 2.
	self assert: (lisp top: #(funcall (first f2))) = 1.
	self assert: (lisp top: #(funcall (first f2))) = 2.
	self assert: (lisp top: #(funcall (first f2))) = 3.
	self assert: (lisp top: #(funcall (second f2))) = 2.
						! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 15:00'!
testScope12

	lisp top: #(begin 
					(define (up-n-down)
					(let ((x 0))
						(list
							(lambda () (set!! x (+ x 1)))
							(lambda () (set!! x (- x 1))))))
					(define f1 (up-n-down)) 
					(define f2 (up-n-down))). 

	self assert: (lisp top: #(apply (first f1) $'())) = 1.
	self assert: (lisp top: #(apply (first f1) $'())) = 2.
	self assert: (lisp top: #(apply (first f1) $'())) = 3.
	self assert: (lisp top: #(apply (second f1) $'())) = 2.
	self assert: (lisp top: #(apply (first f2) $'())) = 1.
	self assert: (lisp top: #(apply (first f2) $'())) = 2.
	self assert: (lisp top: #(apply (first f2) $'())) = 3.
	self assert: (lisp top: #(apply (second f2) $'())) = 2.

! !

!StaticLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/16/2006 21:38'!
testScope13

	lisp loadDefaultLibraries.

	lisp top: #(progn 
					(defun up-n-down ()
					(let ((x 0))
						(list
							(lambda () (setq x (+ x 1)))
							(let ((y 2))
								(lambda () (setq x (- x 1)))))))
					(setq f1 (up-n-down)) 
					(setq f2 (up-n-down))). 

	self assert: (lisp top: #(funcall (first f1))) = 1.
	self assert: (lisp top: #(funcall (first f1))) = 2.
	self assert: (lisp top: #(funcall (first f1))) = 3.
	self assert: (lisp top: #(funcall (second f1))) = 2.
	self assert: (lisp top: #(funcall (first f2))) = 1.
	self assert: (lisp top: #(funcall (first f2))) = 2.
	self assert: (lisp top: #(funcall (first f2))) = 3.
	self assert: (lisp top: #(funcall (second f2))) = 2.
						! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 15:00'!
testScope13

	lisp top: #(begin 
					(define (up-n-down)
					(let ((x 0))
						(list
							(lambda () (set!! x (+ x 1)))
							(let ((y 2))
								(lambda () (set!! x (- x 1)))))))
					(define f1 (up-n-down)) 
					(define f2 (up-n-down))). 

	self assert: (lisp top: #(apply (first f1) $'())) = 1.
	self assert: (lisp top: #(apply (first f1) $'())) = 2.
	self assert: (lisp top: #(apply (first f1) $'())) = 3.
	self assert: (lisp top: #(apply (second f1) $'())) = 2.
	self assert: (lisp top: #(apply (first f2) $'())) = 1.
	self assert: (lisp top: #(apply (first f2) $'())) = 2.
	self assert: (lisp top: #(apply (first f2) $'())) = 3.
	self assert: (lisp top: #(apply (second f2) $'())) = 2.
						! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 8/4/2006 17:30'!
testScope15

	lisp top: #	(let ((x 10)) (define beuh 18)). 

	self should: [lisp top: #(begin beuh)] raise: Error
		! !

!CLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/12/2006 13:52'!
testScope20

	lisp top: #(progn
					(defvar x 45)
					(let ((y 2)) (setq x y))).

	self assert: (lisp top: #x) = 2.

	lisp top: #	(setq x 10).

	self assert: (lisp top: #x) = 10.
! !

!CLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/12/2006 14:04'!
testScope21

	lisp top: #(progn
					(defvar x 45)
					(let ((y 2)) (makunbound $'x))).

	self should: [lisp top: #x] raise: LispError.

! !

!CLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/12/2006 14:07'!
testScope22

	self should: [lisp top: #(progn
					(defvar x 45)
					(let ((x 2)) (makunbound $'x) x))] raise: LispError


! !

!CLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/12/2006 16:00'!
testScope23

	lisp top: #(defun bouh () joe).

	self should: [lisp top: #(bouh)] raise: LispError.
	self should: [lisp top: #(let ((joe 5)) (bouh))] raise: LispError.

	self assert: (lisp top: #(let ((joe 5)) (declare (special joe)) (bouh))) = 5
! !

!CLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/12/2006 22:31'!
testScope24

	"from Common Lisp the Language, 2nd edition, section 9.2"

	lisp top: #(defvar x).
	lisp top: #(defvar sum).
	lisp top: #(defun foo (x) (list x y)).

	self should: [lisp top: #(foo 25)] raise: LispError.

	lisp top: #(defun test (x y)   
					(declare (special y))  
					(let ((y 3) (x (* x 2)))   
						(setq sum (+ y (locally (declare (special y)) y)))   
						(let ((y 4)) (declare (special y)) (foo x)))).

	self assert: (lisp top: #(test 1 10)) = #(2 4) asCons.
	self assert: (lisp top: #sum) = 13.

	lisp top: #(defun test (x y)   
					(declare (special y))  
					(let ((y 3) (x (* x 2)))   
						(setq sum (+ y (locally (declare (special y)) y)))   
						(let ((y 4)) (foo x)))).

	self assert: (lisp top: #(test 1 10)) = #(2 10) asCons.
	self assert: (lisp top: #sum) = 13.
	self should: [lisp top: #x] raise: LispError.
	self should: [lisp top: #y] raise: LispError! !

!SLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/31/2006 11:37'!
testSelectorRedirection

	"see #lispPerform:with:"

	self assert: (lisp top: #(size (rgbTriplet (blue Color)))) = 3

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:06'!
testSetcar

	lisp top: #(setq animals $'(antelope giraffe lion tiger)).
	lisp top: #(setcar animals $'hippopotamus).
	self assert: (lisp top: #(car animals)) = #hippopotamus.

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 22:19'!
testSetcar

	lisp top: #(define animals $'(antelope giraffe lion tiger)).
	lisp top: #(set-car!! animals $'hippopotamus).
	self assert: (lisp top: #(car animals)) = #hippopotamus.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 5/30/2006 18:06'!
testSetcdr

	self assert: (lisp top: #(progn (setq animals $'(antelope giraffe lion tiger))
					(setcdr animals $'(cat dog))
					(nth 2 animals))) = #dog.

	lisp top: #(setq animals $'(antelope giraffe lion tiger)).
	lisp top: #(setcdr animals $'(cat dog)).
	self assert: (lisp top: #(nth 2 animals)) = #dog.
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 22:19'!
testSetcdr

	self assert: (lisp top: #(begin (define animals $'(antelope giraffe lion tiger))
					(set-cdr!! animals $'(cat dog))
					(list-ref animals 2))) = #dog.

	lisp top: #(define animals $'(antelope giraffe lion tiger)).
	lisp top: #(set-cdr!! animals $'(cat dog)).
	self assert: (lisp top: #(list-ref animals 2)) = #dog.
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2006 17:57'!
testSetq

	self should: [lisp top: #bouga] raise: LispError.
	self assert: (lisp top: #(setq bouga (+ 5 5))) = 10.
	self assert: (lisp top: #bouga) = 10.
	self assert: (lisp top: #(+ 1 bouga)) = 11.

	lisp top: #(setq x 10 y (+ x 10) z (* 2 y)).
	self assert: (lisp top: #(list x y z)) = #(10 20 40) asCons.

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 21:43'!
testSetq

	"use set!!"! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 15:01'!
testSLIB

	"http://swiss.csail.mit.edu/~jaffer/SLIB.html"
	
	"this tests version 3a3 "

	lisp top: #(require $'factor).

	self assert: (lisp top: #(factor 565)) = #(113 5) asCons! !

!LKTokenTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 23:51'!
testSpecials

	self assert: (LKToken parse: '+') = #'+' .
	self assert: (LKToken parse: '-') = #'-' .
	self assert: (LKToken parse: '+.') = #'+.' .
	self assert: (LKToken parse: '-.') = #'-.' .
	self assert: (LKToken parse: '+-') = #'+-' .
	self assert: (LKToken parse: '-+') = #'-+' .
	self assert: (LKToken parse: '.') = #'.' .

	self assert: (LKToken parse: 'e') = #e .
	self assert: (LKToken parse: '12e') = #'12e' .
	self assert: (LKToken parse: 'e1') = #'e1' .

	self assert: (LKToken parse: '/') = #'/' .
	self assert: (LKToken parse: '/5') = #'/5' .
	self assert: (LKToken parse: '5/') = #'5/' .! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 9/23/2006 22:22'!
testStringEscapes

	self assert: ((lisp top: {#'string->list' . {#'list->string' . $' . {$a . Character lf . $b}}}) printString = '(#\a #\newline #\b)').
	self assert: ((lisp top: {#'string->list' . {#'list->string' . $' . {$a . Character tab . $b}}}) printString = '(#\a #\tab #\b)').

	self assert: ((lisp top: #(eval (read '(prin1-to-string #\newline)'))) = '#\newline').




! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 16:26'!
testStringReader

	self assert: (lisp evalString: '(setq *boup--bloup* 15)') = 15 .
	self assert: (lisp evalString: '*boup--bloup*') = 15 .

	self assert: (lisp evalString: '(setq beuh//et-voila 16)') = 16 .
	self assert: (lisp evalString: 'beuh//et-voila') = 16 .

	self assert: (lisp evalString: '(setq |gloup:bah| 17)') = 17 .
	self assert: (lisp evalString: '|gloup:bah|') = 17 .

	self assert: (lisp evalString: '`(1 2 ,(+ 2 1) ,@(list 4 5))') = #(1 2 3 4 5) asCons.

	self assert: (lisp evalString: '3.1415') = 3.1415 .
	self assert: (lisp evalString: '2e-7') = 2e-7 .
	self assert: (lisp evalString: '.5') = 0.5 .
	self assert: (lisp evalString: '+.5') = 0.5 .
	self assert: (lisp evalString: '+1.5') = 1.5 .
	self assert: (lisp evalString: '-.5') = -0.5 .

	self assert: (lisp evalString: '1/2') = (1/2) .
	self assert: (lisp evalString: '-1/2') = (-1/2) .

	self assert: (lisp evalString: '"et''hop"') = 'et''hop' .
	self assert: (lisp evalString: '"un c''est \"un\""') = 'un c''est "un"' .

	self assert: (lisp evalString: '

(let ;test
; comments "comments" comments" 
	((x 10))
		(+ x 20) ;; beuh
)
') = 30
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 9/30/2006 22:09'!
testStringReader2

	self assert: (lisp evalString: '`'',(cons ''a ''b)') asString = '(quote (a . b))'.
	self assert: (lisp evalString: '''`,(cons ''a ''b)') asString = '(quasiquote (unquote (cons (quote a) (quote b))))'.

	self assert: (lisp evalString: '(eval ``(,,@(list 1 2 3 4 5)))') asString = '(1 2 3 4 5)'.
	self assert: (lisp evalString: '(eval ``(,,2))') asString = '(2)'.! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 9/30/2006 22:09'!
testStringReader3

	self assert: (lisp evalString: '(let ((true ''false)) true)') = #false .
	self should: [lisp evalString: '(list true false)'] raise: LispError .
! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 9/30/2006 22:12'!
testStringReader3

	self should: [lisp evalString: '(let ((true ''false)) true)'] raise: LispError .
	self assert: (lisp evalString: '(list true false)') = #(true false) asCons
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/5/2006 18:12'!
testStringReader4

	self assert: (lisp evalString: '(+ 1 1 #| 5 4 |# 1)') = 3 .
	self assert: (lisp evalString: '(+ 1 1 #| 5 ; 4 |# 1)') = 3 .
	self assert: (lisp evalString: '(+ 1 1 #| 5 4|# 1)') = 3 .
	self assert: (lisp evalString: '(+ 1 1 #|5 4|# 1)') = 3 .
	self assert: (lisp evalString: '(+ 1 1 #| 5 )) ( 4 |# 1)') = 3 .
	self assert: (lisp evalString: '(concat "1 1" "#| 5 )) ( 4 |#" "1")') = '1 1#| 5 )) ( 4 |#1' .
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/5/2006 18:15'!
testStringReader5

	self assert: (lisp evalString: '(+ 1 1 #. (+ 5 4) 1)') = 12 .
	self assert: (lisp evalString: '(+ 1 1 #.(+ 5 4) 1)') = 12 .

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/20/2006 10:09'!
testStringReader6

	lisp loadDefaultLibraries.

	lisp evalString: '(setq x ''#0=(1 2 . #0#))'.	
	self assert: (lisp top: #(caddr x)) = 1 .
	self assert: (lisp top: #(nth 15 x)) = 2 .

	lisp evalString: '(setq y ''(1 2 #1=#(3 4) . #1#))' .
	self assert: (lisp top: #(eq (caddr y) (cdddr y))) = lisp trueValue .

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/20/2006 10:09'!
testStringReader6

	lisp evalString: '(define x ''#0=(1 2 . #0#))'.	
	self assert: (lisp top: #(caddr x)) = 1 .
	self assert: (lisp top: #(list-ref x 15)) = 2 .

	lisp evalString: '(define y ''(1 2 #1=#(3 4) . #1#))' .
	self assert: (lisp top: #(eq? (caddr y) (cdddr y))) = lisp trueValue .

! !

!CLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/22/2006 21:34'!
testSymbols

	self assert: (lisp top: #(eq (make-symbol 'uh') (make-symbol 'uh'))) == lisp falseValue.

	self assert: (lisp top: #(eq (intern 'uh') (intern 'uh') )) == lisp trueValue.

	self assert: (lisp top: #(eq (make-symbol 'uh') (intern 'uh'))) == lisp falseValue.

	self assert: (lisp top: #(let ((s (make-symbol 'uh')) (uh 20)) 
									(set s 10)
									(list (eval s) uh))) = #(10 20) asCons! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 10/22/2006 19:37'!
testSymbols

	self assert: (lisp top: #(eq (make-symbol 'uh') (make-symbol 'uh'))) == lisp falseValue.

	self assert: (lisp top: #(eq (intern 'uh') (intern 'uh') )) == lisp trueValue.

	self assert: (lisp top: #(eq (make-symbol 'uh') (intern 'uh'))) == lisp falseValue.

	self assert: (lisp top: #(let ((s (make-symbol 'uh')) (uh 20)) 
									(set s 10)
									(list (symbol-value s) uh))) = #(10 20) asCons! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/22/2006 20:47'!
testSymbols

	self assert: (lisp top: #(eq? (#'string->uninterned-symbol' 'uh') (#'string->uninterned-symbol' 'uh'))) == lisp falseValue.

	self assert: (lisp top: #(eq? (#'string->symbol' 'uh') (#'string->symbol' 'uh') )) == lisp trueValue.

	self assert: (lisp top: #(eq? (#'string->uninterned-symbol' 'uh') (#'string->symbol' 'uh'))) == lisp falseValue.

	self assert: (lisp top: #(let ((s (#'string->uninterned-symbol' 'uh')) (uh 20)) 
									(eval `(define ,s 10))
									(list (eval s) uh))) = #(10 20) asCons! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/17/2006 22:58'!
testTailCallOptimization

	"this blows up CLISP and Emacs, works fine in SBCL"

	lisp top: #(defun test (n) (if (< n 5000) (test (+ n 1)) 'ok')).
	self assert: (lisp top: #(test 0)) = 'ok'
! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/30/2006 14:02'!
testTailCallOptimization2

	lisp top: #(setq x 0).
	lisp top: #(defun test (n) 
					(if (< n 500) 
						(progn 
							(princ n) 
							(let ((u x)) (setq x (+ x 1)) (test (+ u n 1)))) 
						(list x n))).

	self assert: (lisp top: #(test 0)) = #(32 528) asCons
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 11/18/2006 17:09'!
testTailCallOptimization2

	lisp top: #(define incx false).
	lisp top: #(define getx false).
	lisp top: #(let ((x 0)) 
					(set!! incx (lambda () (set!! x (+ x 1)))) 
					(set!! getx (lambda () x))).

	lisp top: #(define (test n) 
					(if (< n 500) 
						(begin 
							(display n) 
							(newline) 
							(let ((u (getx))) 
								(incx) 
								(test (+ u n 1)))) 
						(list (getx) n))).

	self assert: (lisp top: #(test 0)) = #(32 528) asCons
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 3/20/2007 23:32'!
testTinyClos

	"http://community.schemewiki.org/?Tiny-CLOS"

	lisp top: #(load-library $'tiny-clos).
	lisp top: #(begin

(define initialize-slots
    (lambda (object initargs)
      (let ((not-there (list $'shes-not-there)))
	(for-each (lambda (slot)
		    (let ((name (car slot)))
		      (let ((value  (getl initargs name not-there)))
			(if (#'eq?' value not-there)
			    $'do-nothing
			    (#'slot-set!!' object name value)))))
		  (class-slots (class-of object))))))

(define #'<pos>' (make #'<class>'                         
		    $'direct-supers (list #'<object>')  
		    $'direct-slots  (list $'x $'y)))   

(add-method initialize
    (make-method (list #'<pos>')
      (lambda (call-next-method pos initargs)
	(call-next-method)
	(initialize-slots pos initargs))))

(define p1 (make #'<pos>' $'x 1 $'y 2))
(define p2 (make #'<pos>' $'x 3 $'y 5))

).

	self assert: (lisp top: #(slot-ref p1 $'x)) = 1.
	self assert: (lisp top: #(slot-ref p2 $'y)) = 5.
! !

!CLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/12/2006 21:09'!
testUnboundDynamicVariables

	self should: [lisp top: #(locally (declare (special y)) y)] raise: LispError.

	lisp top: #(defvar uh).
	self should: [lisp top: #uh] raise: LispError.
	! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/6/2006 13:32'!
testUnwindProtect

	lisp top: #(defun dangerous (x) 
					(unwind-protect (/ 10 x) (setq comment 'things went ok'))).

	lisp top: #(setq comment 'no comment').
	self assert: (lisp top: #comment) = 'no comment'.
	self assert: (lisp top: #(dangerous 5)) = 2.
	self assert: (lisp top: #comment) = 'things went ok'.

	lisp top: #(setq comment 'no comment').
	self assert: (lisp top: #(dangerous 0)) isNil.
	self assert: (lisp top: #comment) = 'things went ok'.

! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/6/2006 16:34'!
testUnwindProtect

	! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/24/2006 18:50'!
testValues

	lisp top: 
#(define split
  (lambda (ls)
    (if (or (null? ls) (null? (cdr ls)))
        (values ls ())
        (call-with-values
          (lambda () (split (cddr ls)))
          (lambda (odds evens)
            (values (cons (car ls) odds)
                    (cons (cadr ls) evens))))))) .

	self assert: (lisp top: #(split $'(a b c d e f))) 
		= (LKValues with: #(a c e) asCons with: #(b d f) asCons)! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 15:00'!
testValues2

	self assert: (lisp top: #(call-with-values
  								(lambda () (values $'bond $'james))
  								(lambda (x y) (cons y x))))
		asString = '(james . bond)' ! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/19/2006 15:00'!
testValues3

	self assert: (lisp top: #(call-with-values
  									(lambda () (call/cc (lambda (k) (k 2 3))))
 									(lambda (x y) (list x y)))) = #(2 3) asCons! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 11/20/2006 13:07'!
testVectors

	self assert: (lisp top: #(vector 1 '2' $'trois)) =  #(1 '2' trois).
	self assert: (lisp top: #(setq v (make-vector 3 $'Z))) =  #(Z Z Z).
	self assert: (lisp top: #(vectorp v)) = lisp trueValue.
	self assert: (lisp top: #(equal (vector `Z `Z `Z) v)) = lisp trueValue.
	self assert: (lisp evalString: '(equal #(Z Z Z) v)') = lisp trueValue.
	self assert: (lisp top: #(eq (vector `Z `Z `Z) v)) = lisp falseValue.
	self assert: (lisp top: #(vconcat v v)) =  #(Z Z Z Z Z Z)! !

!SLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/6/2006 13:33'!
testVectors

	self assert: (lisp top: #(rgbTriplet (blue Color))) = #(0.0 0.0 1.0).
	self assert: (lisp top: #(elt (rgbTriplet (blue Color)) 2)) = 1.0.
	self assert: (lisp top: #(vector-to-list (rgbTriplet (blue Color)))) = #(0.0 0.0 1.0) asCons
! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 3/27/2007 14:53'!
testVectors

	lisp top: #(define v (make-vector 3 $'Z)).
	self assert: (lisp top: #v) = #(Z Z Z).
	self assert: (lisp top: #(vector? v)) = lisp trueValue.
	self assert: (lisp top: #(equal? (vector `Z `Z `Z) v)) = lisp trueValue.
	self assert: (lisp top: #(eq? (vector `Z `Z `Z) v)) = lisp falseValue.
	self assert: (lisp top: #(vconcat v v)) = #(Z Z Z Z Z Z).

	lisp top: #(define ev (vector 1 2 (vector 3))).
	self assert: (lisp top: #(equal? (#'list->vector' (#'vector->list' ev)) ev)) = lisp trueValue ! !

!SLispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/21/2006 11:20'!
testVectors2

	self assert: (lisp top: #(apply $'vector (vector-to-list (rgbTriplet (blue Color))))) = #(0.0 0.0 1.0).

! !

!ELispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 23:49'!
testWhile

	lisp top: #(progn 
					(setq i 5)
					(while (> i 0) (setq i (- i 1)))).

	self assert: (lisp top: #(progn i)) = 0! !

!ULispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/21/2006 14:21'!
testWhile

	lisp top: #(begin 
					(define i 5)
					(while (> i 0) (set!! i (- i 1)))).

	self assert: (lisp top: #i) = 0! !

!ConsCellTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/7/2006 10:19'!
testWith

	| list1 list2  |

	list1 _ #(1 2 3 4 5) asCons.
	list2 _ #(5 4 3 2 1) asCons.
	self assert: (list1 with: list2 collect: [:i :j | i+j]) = #(6 6 6 6 6) asCons.
	self assert: list1 = #(1 2 3 4 5) asCons.
	self assert: list2 = #(5 4 3 2 1) asCons! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 10/24/2006 20:47'!
testWithSmalltalkSyntax

	self assert: (lisp top: #(+ 2 {4 sqrt})) = 4.

	self assert: 
	(lisp top: #(progn {(5@6) flipBy: $#vertical centerAt: (0@ [- 5 5])})) = (5@-6).

	self assert: 
	(lisp top: #(progn {Morph new perform: $#yourself})) isMorph.

	self assert: (lisp top: #(+ 10 {1+ [+ 2 2 {3 + 3 + 3}] + 1})) = 25.
	
	self assert: (lisp top: #(if {5 isNumber} 'ok' 'no!!')) = 'ok'.

	self assert: (lisp top: #(setq string (smalltalk '''abc'' , ''def'''))) = 'abcdef'.

	self assert: (lisp top:#(if {$#symbol isSymbol} 1 0)) = 1
! !

!SLispTest methodsFor: 'changes from kernel' stamp: 'spfa 6/19/2006 14:34'!
testWithSmalltalkSyntax2

	self assert: (lisp top: #(progn {5 - 5})) = 0.
	self should: [lisp top: #(progn {5-5})] raise: Error! !

!ULispTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/24/2006 11:03'!
testY

	"from 'the Why of Y' by Richard P. Gabriel"
	
	lisp top: #(define y (lambda (f)
					(let ((g (lambda (h)
								(lambda (x) ((f (h h)) x)))))
					(g g)))).

	self assert: (lisp top: #(let ((f (y (lambda (h)
											(lambda (n)
												(if (< n 2) 1 (* n (h (- n 1)))))))))
									(f 10))) = 3628800! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 7/1/2006 21:09'!
test: aBoolean

	^ self class test: aBoolean! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 6/7/2006 21:41'!
test: aBoolean

	^ aBoolean ifTrue: [self trueValue] ifFalse: [self falseValue]! !

!SLisp methodsFor: 'hacks' stamp: 'spfa 5/30/2006 22:01'!
text
	
	"required by Parser>>#removeUnusedTemps"

	^ ' ' asText! !

!ConsCell methodsFor: 'accessing' stamp: 'spfa 6/3/2006 01:27'!
third

	^ cdr cdr car! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:05'!
throw: aConsCell

"(throw TAG VALUE)
Throw to the catch for TAG and return VALUE from it.
Both TAG and VALUE are evaluated."

	aConsCell ifNil: [^ #()].

	((LKThrowNotification new)
		tag: (self evalObject: aConsCell first);
		value: (self evalObject: aConsCell second)) signal
	

	! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 11/4/2006 18:23'!
time: aConsCell

"(time EXPRESSION)
times the evaluation of EXPRESSION, printing timing information to the current output port. 
returns the result of EXPRESSION."

	| dur val gcStats str port |

	gcStats _ SmalltalkImage current getVMParameters.
	dur _ [val _ self evalObject: aConsCell car] durationToRun.
	SmalltalkImage current getVMParameters keysAndValuesDo:
		[:idx :gcVal| gcStats at: idx put: (gcVal - (gcStats at: idx))].

	str _ (port _ self standardOutput) stream.
	
	str nextPutAll: 'time: '.
	dur printOn: str.
	str cr; nextPutAll: 'full gc: '.
	(gcStats at: 7) printOn: str.
	str nextPutAll: ' time: '.
	(gcStats at: 8) printOn: str.
	str cr; nextPutAll: 'incr. gc: '.
	(gcStats at: 9) printOn: str.
	str nextPutAll: ' time: '.
	(gcStats at: 10) printOn: str.
	str cr.

	port endEntry.

	^ val
! !

!ULisp class methodsFor: 'libraries' stamp: 'muOuser 3/28/2007 14:41'!
tinyClos

	"CLOS-like object system for Scheme, by Gregor Kiczales:

	http://community.schemewiki.org/?Tiny-CLOS
	http://home.adelphi.edu/sbloch/class/archive/272/spring1997/tclos/tutorial.shtml
	"

	^#(in-library tiny-clos
			(load (system-path 'ulisp/tiny-clos/tiny-clos.scm')))


! !

!LispKitInfo methodsFor: 'ulisp' stamp: 'spfa 3/21/2007 23:14'!
tinyclosFiles

	^ self filesInULispDirectory: 'tiny-clos'! !

!LKReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 15:20'!
token

	^ LKToken! !

!ULispReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/19/2006 15:20'!
token

	^ ULispToken! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 7/8/2006 00:21'!
topForms

	^ Array streamContents: [:stream | self storeTopFormsIn: stream]

! !

!UndefinedObject methodsFor: '*LispKit' stamp: 'spfa 9/23/2006 20:42'!
topForms

	^ #()! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 7/8/2006 18:56'!
topLevelLisp

	"should be invoked by functions primitives only. answer the lisp instance at top level, which is either the receiver or a member of the #upperLisp chain"

	^ self topLevelLispFor: thisContext
! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 7/8/2006 20:06'!
topLevelLispFor: aContext

	"private - anciliary method for #topLevelLisp"

	(aContext receiver class
		selectorAtMethod: aContext method 
		setClass: [:c | ])
	== #top: 
	ifTrue: [^ aContext receiver].

	^ self topLevelLispFor: aContext sender
! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 11/26/2006 22:22'!
topmostLisp

	^ topmostLisp! !

!LispKernel methodsFor: 'entry points' stamp: 'spfa 11/20/2006 10:18'!
top: anObject

	"entry point to the Lisp interpreter for the evaluation of Arrays as Lisp code. 

	anObject can be anything; the message #asCons converts it in a suitable data structure for Lisp.
	notably, if it is an Array it will be converted into a ConsCell (with an exception for vectors, see Array>>asCons). 
	the #rewrite: call allows syntactic sugar such as ` and ,@ in Arrays.

	because it is an entry point to the interpreter context, #top: should never be sent from within a Lisp program; it should not be used by any primitive. use #rewriteAndEval: instead.

	see #enterInterpreterContextAndEval: for the rationale"

	^ self enterInterpreterContextAndEval: (self class rewrite: anObject asCons).
! !

!LispKernel class methodsFor: 'public' stamp: 'spfa 10/1/2006 00:11'!
top: anObject

	^ self new top: anObject! !

!LKFunctionsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 18:14'!
traceResult: anObject for: bObject in: aLisp! !

!LKHalt methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 22:34'!
traceResult: anObject for: bObject in: aLisp
! !

!LKMonitor methodsFor: 'as yet unclassified' stamp: 'spfa 7/3/2006 14:02'!
traceResult: anObject for: bObject in: aLisp! !

!LKSymbolsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 7/7/2006 18:25'!
traceResult: anObject for: bObject in: aLisp! !

!LKTracer methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 22:21'!
traceResult: anObject for: bObject in: aLisp

	| str | 

	str _ aLisp standardOutput stream.

	depth _ self depth - 1.
	depth < 0 ifTrue: [^ self].

	(bObject isSymbol or: [bObject isConsCell ])
		ifFalse: [^ self].

	self tabulate: str to: depth + 1.

	str	nextPutAll: '=> ';
		nextPutAll: (anObject printStringForLisp: aLisp limitedTo: 100); cr.

	aLisp standardOutput endEntry
! !

!LKFunctionsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 22:03'!
trace: anObject in: aLisp

	| str |

	(anObject isConsCell and: [functions includes: anObject car])
		ifFalse: [^ anObject].

	str _ aLisp standardOutput stream.

	str	nextPutAll: aLisp depth asString ; tab;
		nextPutAll: ((aLisp upperForm ifNil: ['<top>']) printStringForLisp: aLisp limitedTo: 100); cr.
	str tab; nextPutAll: (anObject printStringForLisp: aLisp limitedTo: 100); cr.
	aLisp standardOutput endEntry.

	^ anObject! !

!LKHalt methodsFor: 'as yet unclassified' stamp: 'spfa 7/8/2006 22:42'!
trace: anObject in: aLisp

	(anObject isConsCell and: [functions includes: anObject car])
		ifFalse: [^ anObject].

	aLisp debug.	
	aLisp halt: nil.

	^ anObject! !

!LKMonitor methodsFor: 'as yet unclassified' stamp: 'spfa 7/3/2006 14:02'!
trace: anObject in: aLisp

	^ anObject! !

!LKSymbolsTracer methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 22:03'!
trace: anObject in: aLisp

	| symbs str |

	(anObject isConsCell 
		and: [(symbs _ symbols intersection: anObject topForms) notEmpty])
		ifFalse: [^ anObject].

	str _ aLisp standardOutput stream.

	str	nextPutAll: aLisp depth asString ; tab;
		nextPutAll: ((aLisp upperForm ifNil: ['<top>']) printStringForLisp: aLisp limitedTo: 100); cr.
	str tab; nextPutAll: (anObject printStringForLisp: aLisp limitedTo: 100); cr.
	symbs do: [:s |
		str tab; tab; nextPutAll: s, ' => ';
			nextPutAll: (aLisp symbolValue: s ifNone: ['<unbound>']) asString;
			cr].
	aLisp standardOutput endEntry.
	^ anObject

	

! !

!LKTracer methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 22:13'!
trace: anObject in: aLisp

	| str | 

	depth _ self depth + 1.

	(anObject isSymbol or: [anObject isConsCell ])
		ifFalse: [^ anObject].

	str _ aLisp standardOutput stream.
"	str	nextPutAll: aLisp depth asString."

	self tabulate: str to: depth.

	str nextPutAll: (anObject printStringForLisp: aLisp limitedTo: 100); cr.
	aLisp standardOutput endEntry.

	^ anObject! !

!ConsCell methodsFor: 'tree operations' stamp: 'spfa 10/18/2006 09:28'!
treeDo: aBlock

	aBlock value: self.
	car isConsCell ifTrue: [car treeDo: aBlock].
	cdr isConsCell ifTrue: [cdr treeDo: aBlock]

! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 6/5/2006 23:39'!
trueValue

	^ #t! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 6/7/2006 21:48'!
trueValue

	^ self class trueValue! !

!SLisp class methodsFor: 'booleans' stamp: 'spfa 6/7/2006 21:37'!
trueValue

	^ true! !

!ULisp class methodsFor: 'booleans' stamp: 'spfa 6/30/2006 18:33'!
trueValue

	^ true! !

!LispKernel class methodsFor: 'booleans' stamp: 'spfa 6/18/2006 19:56'!
trueValuePrintString

	^ 't'! !

!SLisp class methodsFor: 'booleans' stamp: 'spfa 6/18/2006 19:55'!
trueValuePrintString

	^ 'true'! !

!ULisp class methodsFor: 'booleans' stamp: 'spfa 6/18/2006 19:55'!
trueValuePrintString

	^ '#t'! !

!ELisp methodsFor: 'LISP-functions-math' stamp: 'spfa 10/25/2006 14:26'!
truncate: aConsCell

	| x n |

	x _ aConsCell car.	
	n _ x truncated.
	^ LKValues with: n with: x-n! !

!ELisp methodsFor: 'private - symbols' stamp: 'spfa 10/22/2006 18:30'!
uninternedSymbols

	^ uninternedSymbols! !

!ELisp methodsFor: 'private - symbols' stamp: 'spfa 10/22/2006 20:40'!
uninternedSymbol: aSymbol 

	(uninternedSymbols identityIncludes: aSymbol)
		ifFalse: [^ aSymbol].

	^ (aSymbol subStrings: ':') last

! !

!ELisp methodsFor: 'private - symbols' stamp: 'spfa 10/22/2006 18:47'!
unintern: aSymbol n: aNumber

	^ ('uninterned:::', aNumber asString, ':::', aSymbol) asSymbol! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 6/21/2006 13:44'!
unquoteSplicing: aConsCell

"(unquote-splicing ANYTHING)
This form as such evaluates to itself. It should only be used within a quasiquote expression; usually the syntactic sugar ',@' is preferred."

	^ ConsCell car: #'unquote-splicing' cdr: aConsCell

! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 6/21/2006 13:44'!
unquote: aConsCell

"(unquote ANYTHING)
This form as such evaluates to itself. It should only be used within a quasiquote expression; usually the syntactic sugar ',' is preferred."

	^ ConsCell car: #unquote cdr: aConsCell

! !

!LKReader methodsFor: 'macros' stamp: 'spfa 10/6/2006 14:51'!
unquote: aStream

	aStream peek == $@
		ifTrue: 
		[
			aStream next.
			^ #'unquote-splicing' inCons addLast: (self read: aStream)
		].

	^ #unquote inCons addLast: (self read: aStream)! !

!LispKernel methodsFor: 'LISP-special forms' stamp: 'spfa 10/24/2006 10:42'!
unwindProtect: aConsCell

"(unwind-protect BODYFORM &rest UNWINDFORMS)
Do BODYFORM, protecting with UNWINDFORMS.
If BODYFORM completes normally, its value is returned after executing the UNWINDFORMS.
If BODYFORM exits nonlocally, the UNWINDFORMS are executed anyway."

	| val |

	aConsCell ifNil: [^ #()].

	[val _ self evalObject: aConsCell first multipleValue: true]
		on: Exception do: [].

	self progn: aConsCell cdr.

	^ val

	! !

!LispKernel class methodsFor: 'private' stamp: 'spfa 9/28/2006 14:47'!
updatePrimitives

"Perform the integration of newly defined primitives into the LispKernel hierarchy system, clean up if necessary
This has on-the-fly effect to all lisp interpreter instances"

	LispKernel withAllSubclasses do: [:lispclass | lispclass compilePrimitiveLists].! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 9/28/2006 14:19'!
updatePrimitives: ignored

"(update-primitives)
Perform the integration of newly defined primitives into the LispKernel hierarchy system, clean up if necessary
This has on-the-fly effect to all lisp interpreter instances"

	LispKernel updatePrimitives.
	^ self trueValue! !

!LKREPLMorph methodsFor: 'contents' stamp: 'spfa 9/28/2006 23:22'!
updateText: text

	text size > self characterLimit 
		ifFalse: [^ super setMyText: text].

	 super setMyText: (text copyFrom: text size - self characterLimit to: text size)

! !

!LKREPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 9/29/2006 14:57'!
update: aSymbol 

	aSymbol ifNil: [^self].
	aSymbol == #appendEntry 
		ifTrue: 
			[self appendEntry].
	aSymbol == #clearText 
		ifTrue: 
			[self clear].
	aSymbol == #force 
		ifTrue: 
			[self outputQueue].! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 10/21/2006 15:44'!
upperForm
	^upperHead inCons append: upperTail! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 10/21/2006 15:41'!
upperForms

	upperLisp ifNil: [^ {self upperForm}].

	^ {self upperForm}, upperLisp upperForms! !

!LispKernel methodsFor: 'LISP-functions-debugging' stamp: 'spfa 7/8/2006 15:24'!
upperForms: ignored

	^ self upperForms asConsList! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 10/21/2006 15:33'!
upperHead

	^ upperHead! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 10/21/2006 15:33'!
upperHead: aSymbol

	upperHead _ aSymbol! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 6/2/2006 17:55'!
upperLisp

	^ upperLisp ! !

!LispKernel methodsFor: 'private - interpreter' stamp: 'spfa 6/2/2006 17:55'!
upperLisp: aLisp

	upperLisp _ aLisp! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 10/21/2006 15:44'!
upperTail
	^upperTail! !

!LispKernel methodsFor: 'private - utils' stamp: 'spfa 10/21/2006 15:44'!
upperTail: aConsCell 
	upperTail := aConsCell! !

!LKContinuation class methodsFor: 'instance creation' stamp: 'spfa 10/23/2006 14:36'!
upTo: aMethod
	^ self new initializeFromContext: thisContext sender upTo: aMethod! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 6/19/2006 14:59'!
useCurlyBrackets

	^ false! !

!SLisp class methodsFor: 'rewriter' stamp: 'spfa 6/19/2006 15:02'!
useCurlyBrackets

	^ true! !

!LispKernel class methodsFor: 'array code rewriter' stamp: 'spfa 6/19/2006 14:59'!
useSquareBrackets

	^ false! !

!SLisp class methodsFor: 'rewriter' stamp: 'spfa 6/19/2006 15:02'!
useSquareBrackets

	^ true! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!LKThrowNotification methodsFor: 'as yet unclassified' stamp: 'spfa 5/25/2006 18:53'!
value

	^ value! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 10/23/2006 22:45'!
valuesList: aConsCell

	^ LKValues withAll: aConsCell car topForms

! !

!LispKernel methodsFor: 'LISP-functions-interpreter' stamp: 'spfa 10/23/2006 21:49'!
values: aConsCell

	^ LKValues withAll: aConsCell topForms

! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !

!LKContinuation methodsFor: 'invocation' stamp: 'spfa 6/16/2006 13:34'!
value: v

	| topSenders |

	topSenders _ self getTopSendersFrom: thisContext.
	self terminate: thisContext.
	self restoreValuesWithTop: topSenders.
	thisContext swapSender: values first.
	^v! !

!LKThrowNotification methodsFor: 'as yet unclassified' stamp: 'spfa 5/25/2006 18:53'!
value: anObject

	value _ anObject! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 11/20/2006 12:55'!
vconcat: aConsCell

"(vconcat &rest VECTORS)
Concatenate all the arguments.
The result is a vector whose elements are the elements of all VECTORS."

	^ Array streamContents: [:str |
	 	aConsCell do: [:v | str nextPutAll: v]]! !

!LispKernel methodsFor: 'LISP-functions-predicates' stamp: 'spfa 11/20/2006 10:25'!
vectorP: aConsCell

"(vectorp OBJECT)
Return #t if OBJECT is a vector."

	^ self class test: aConsCell car isArray! !

!SLisp methodsFor: 'LISP-functions-arrays' stamp: 'spfa 6/1/2006 14:41'!
vectorp: aConsCell

"(vectorp: OBJECT)
Return t if OBJECT is an array."

	^ self class test: (aConsCell car isArray)! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 11/20/2006 13:20'!
vectorSetD: aConsCell

"(vector-set!! VECTOR INDEX VALUE)
Set the INDEXth element of VECTOR be VALUE.  Returns VECTOR."

	^ aConsCell first at: aConsCell second + 1 put: aConsCell third

! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 12/1/2006 16:12'!
vectorTOlist: aConsCell

"(vector-to-list VECTOR)
Returns a list with the elements of VECTOR"

	^ aConsCell car asConsList
! !

!LispKernel methodsFor: 'LISP-functions' stamp: 'spfa 11/20/2006 13:22'!
vector: aConsCell

"(vector &rest OBJECTS)
Return a newly created vector with specified arguments as elements.
Any number of arguments, even zero arguments, are allowed."
	
	aConsCell ifNil: [^ #()].
	^ Array streamContents: [:str | aConsCell do: [:o | str nextPut: o]]
! !

!SLisp methodsFor: 'LISP-functions-arrays' stamp: 'spfa 6/1/2006 13:52'!
vector: aConsCell

"(vector &rest OBJECTS)
Return a newly created array with specified arguments as elements.
Any number of arguments, even zero arguments, are allowed."
	
	aConsCell ifNil: [^ #()].
	^ Array streamContents: [:str |
		1 to: aConsCell length do: [:i | str nextPut: (aConsCell nth: i-1)]]
! !

!LKToken class methodsFor: 'as yet unclassified' stamp: 'spfa 10/10/2006 21:22'!
void

	^ (self on: '') initialize
	! !

!LKREPLMorph methodsFor: 'initialization' stamp: 'spfa 6/18/2006 23:05'!
wantsFrameAdornments

	^ false! !

!ELisp class methodsFor: 'private' stamp: 'spfa 11/4/2006 15:47'!
wantsFullArgumentsListsSupport
	
	"there is a noticeable overall speedup if this is set to false.
	in that case, only &rest and &optional keywords are recognized

	requires the function deploy-arguments-list defined in library #argumentsLists"

	^ true! !

!SLisp class methodsFor: 'private-subclasses may implement' stamp: 'spfa 6/9/2006 16:13'!
wantsFullArgumentsListsSupport
	
	^ false! !

!ULisp class methodsFor: 'private' stamp: 'spfa 6/9/2006 17:51'!
wantsFullArgumentsListsSupport

	^ false! !

!ELisp methodsFor: 'LISP-special forms' stamp: 'spfa 9/30/2006 23:02'!
while: aConsCell

"(while TEST &rest BODY)
If TEST yields non-nil, eval BODY and repeat until TEST returns nil."

	^ [(self evalObject: aConsCell first) == self falseValue]
		whileFalse: [(aConsCell nthCell: 1) do: [:form | self evalObject: form]]! !

!SLisp class methodsFor: 'libraries' stamp: 'spfa 9/24/2006 14:53'!
widgets

	^ 
#(in-library widgets

	(defun make-button (label action)
	'Return a SimpleButtonMorph with LABEL triggering ACTION
ACTION must be a function or lambda expression of zero arguments'
		(let ((b (newWithLabel: SimpleButtonMorph label)))
			(target: b self)	
			(actionSelector: b $'funcall:)
			(arguments: b (vector (list action)))))

	(defun get-button (label action)
	'Open in Hand a SimpleButtonMorph with LABEL triggering ACTION
ACTION must be a function or lambda expression of zero arguments'
		(openInHand (make-button label action)))

	"examples"
	(defun widgets-example1 ()
	'An example of get-button usage'
		(get-button 'spawn GUI' (lambda () {self topmostLisp openGui})))

	(defun widgets-example2 ()
	'An example of get-button usage'
		(get-button 'explore this Lisp' (lambda () {self topmostLisp explore})))
)! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 3/24/2007 16:27'!
withCut

	| cons c2 |
	cons _ self veryDeepCopy.
	c2 _ cons cdr.
	cons cdr: nil.		
	^ c2! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 11/7/2006 14:40'!
withInputFromFile: aConsCell

"(with-input-from-file FILENAME THUNK)
"

	| result file stdin |

	stdin _ self standardInput.
	
	[
		(file _ StandardFileStream readOnlyFileNamed: aConsCell car)
			ifNil: [self lispError: 'Could not read file "', aConsCell car asString, '"'].
		self standardInput: (LKIOPort input: file).
		result _ self evalObject: aConsCell cdr.
		file close.
	]
	ensure: [self standardInput: stdin].

	^ result! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/29/2006 15:19'!
withLisp: aLisp

	^ self withLisp: aLisp multipleValue: false tail: false! !

!ConsCell methodsFor: 'conversion' stamp: 'spfa 11/29/2006 15:19'!
withLisp: aLisp multipleValue: mflag tail: tflag

	^ aLisp evalObject: self multipleValue: mflag tail: tflag! !

!LKBlock methodsFor: 'as yet unclassified' stamp: 'spfa 11/29/2006 15:22'!
withLisp: aLisp multipleValue: mflag tail: tflag

	| vals |

	vals _ block clone fixTemps value: aLisp value: mflag.

	(vals isTailCall and: [tflag not]) ifTrue: 
		[vals _ vals evaluate].

	(vals isLKValues and: [mflag not])
		ifTrue: [^ vals asOneLispValue].

	^ vals! !

!Object methodsFor: '*LispKit' stamp: 'spfa 11/29/2006 15:23'!
withLisp: aLisp multipleValue: mflag tail: tflag

	^ self! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 11/7/2006 15:04'!
withOutputToFile: aConsCell

"(with-output-to-file FILENAME THUNK)
"

	| result file stdout |

	stdout _ self standardOutput.
	
	[
		(file _ FileDirectory default forceNewFileNamed: aConsCell car)
			ifNil: [self lispError: 'Could not write to file "', aConsCell car asString, '"'].
		self standardOutput: (LKIOPort output: file).
		result _ self evalObject: aConsCell cdr.
		file close.
	]
	ensure: [self standardOutput: stdout].

	^ result! !

!SLisp methodsFor: 'LISP-special forms' stamp: 'spfa 10/24/2006 10:44'!
withSmalltalkSyntax: aConsCell

"(with-smalltalk-syntax &rest BODY)
Evaluate BODY with Smalltalk syntax. 
You can use ';' as syntactic sugar. 
For example:
	(+ 1 ;((0 to: 10) size))
is expanded into
	(+ 1 (with-smalltalk-syntax ((0 to: 10) size))))
which is evaluated as
	(+ 1 (size (to: 0 10)))
and return
	12
You can use '!!' to insert a regular Lisp form in BODY, and '!!!!' to insert a quoted form.
Examples:
	(+ 1 ;(2 + !!(+ 3 3) + 2))	
	;(Morph new perform: !!!!openInWorld) 
';' can be nested:
	;(1 + !!(+ 2 2 ;(3 + 3)))"

	| lisp val |

	lisp _ self copy syntax: #smalltalk.

	aConsCell do: [:c | val _ lisp evalObject: c multipleValue: true].
	^ val! !

!SLispReader methodsFor: 'as yet unclassified' stamp: 'spfa 10/24/2006 20:36'!
withSmalltalkSyntax: aStream

	^ #withSmalltalkSyntax: inCons addLast: (self openList: aStream)! !

!ConsCell methodsFor: 'list operations' stamp: 'spfa 6/7/2006 10:27'!
with: aConsCell collect: aBlock

	^ ConsCell car: (aBlock value: car value: aConsCell car)
		cdr: ((cdr isConsCell and: [aConsCell cdr isConsCell])
					ifTrue: [cdr with: aConsCell cdr collect: aBlock] ifFalse: [cdr])! !

!ConsCell methodsFor: 'brackets rewriting' stamp: 'spfa 6/19/2006 10:42'!
wrapCurlyBlocksWith: o

	self nest: #({}) with: o! !

!ConsCell methodsFor: 'brackets rewriting' stamp: 'spfa 6/19/2006 15:01'!
wrapSquareBlocksWith: o

	self nest: #([]) with: o! !

!ULisp methodsFor: 'LISP-functions' stamp: 'spfa 10/20/2006 14:45'!
writeChar: aConsCell

"(write-char char [port])
Writes the character char (not an external representation of the character) to the given port "

	| port |

	(port _ aConsCell cadr ifNil: [self standardOutput]) stream
		nextPutAll: aConsCell car asString.
	port endEntry.
	^ self trueValue! !

!LKPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 21:32'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!LKREPLMorph methodsFor: 'command processing' stamp: 'spfa 6/18/2006 22:06'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!LKPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 21:31'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !

!LKREPLMorph methodsFor: 'command processing' stamp: 'spfa 6/18/2006 22:06'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !

!ELisp methodsFor: 'LISP-functions-predicates' stamp: 'spfa 10/19/2006 13:55'!
zeroP: aConsCell

"(zerop NUMBER)
Test weither NUMBER is 0."

	^ self class test: aConsCell car isZero! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:08'!
* aConsCell

"(* &rest NUMBERS)
Return the product of any number of NUMBERS, even 0"

	| mul |

	mul _ 1.
	(aConsCell ifNil: [^ 1]) do: [:each | 
		(each isNumber or: [each isComplex]) ifFalse: [self lispError: 'Number expected'].
		mul _ mul * each].

	^ mul! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:08'!
+ aConsCell

"(+ &rest NUMBERS)
Return the sum of any number of NUMBERS, even 0"

	| sum |

	sum _ 0.

	(aConsCell ifNil: [^ 0]) do: [:each | 
		(each isNumber or: [each isComplex]) ifFalse: [self lispError: 'Number expected'].
		sum _ sum + each].

	^ sum! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:08'!
- aConsCell

"(- NUMBER &rest MORE-NUMBERS)
Negate number or subtract numbers.
With one arg, negates it.  With more than one arg, subtracts all but the first from the first."
	
	| x |

	aConsCell ifNil: [self lispError: 'At least one argument expected'].
	x _ aConsCell car.
	(aConsCell cdr ifNil: [^ x negated]) do: [:each | 
		(each isNumber or: [each isComplex]) ifFalse: [self lispError: 'Number expected'].
		x _ x - each].

	^ x! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 6/22/2006 21:08'!
/ aConsCell

"(/ DIVIDEND DIVISOR &rest MORE-DIVISORS)
Returns first argument divided by all the remaining arguments. 
All arguments must be numbers"

	| x |

	aConsCell ifNil: [self lispError: 'At least one argument expected'].
	x _ aConsCell car.
	(aConsCell cdr ifNil: [^ 1/x ]) do: [:each | 
		(each isNumber or: [each isComplex]) ifFalse: [self lispError: 'Number expected'].
		x _ x / each].

	^ x

! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 9/26/2006 13:41'!
< aConsCell

"(< NUM1 NUM2 &rest NUMS)
Return t if the arguments (which should be numbers) are in increasing order"

	aConsCell cellsDo: [:c |
		(c car < (c cadr ifNil: [^ self trueValue])) ifFalse: [^ self falseValue]]. 
! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 9/26/2006 13:42'!
<= aConsCell

"(<= NUM1 NUM2 &rest NUMS)
Return t if the arguments (which should be numbers) are in increasing order, with equal arguments allowed"

	aConsCell cellsDo: [:c |
		(c car <= (c cadr ifNil: [^ self trueValue])) ifFalse: [^ self falseValue]]. 
! !

!ConsCell methodsFor: 'testing' stamp: 'spfa 3/24/2007 18:39'!
= aConsCell

	self isCircular ifTrue: 
		[^ self withCut = aConsCell withCut].

	self species = aConsCell species
		ifTrue: [^ car = aConsCell car and: [cdr = aConsCell cdr]]
		ifFalse: [^false]! !

!LKClosure methodsFor: 'testing' stamp: 'spfa 6/5/2006 20:53'!
= aClosure

	^ self species = aClosure species
		and: [form = aClosure lambdaForm]
		and: [environment = aClosure environment]! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 9/26/2006 13:42'!
> aConsCell

"(> NUM1 NUM2 &rest NUMS)
Return t if the arguments (which should be numbers) are in decreasing order"

	aConsCell cellsDo: [:c |
		(c car > (c cadr ifNil: [^ self trueValue])) ifFalse: [^ self falseValue]]. 
! !

!ELisp methodsFor: 'LISP-functions' stamp: 'spfa 9/26/2006 13:42'!
>= aConsCell

"(>= NUM1 NUM2 &rest NUMS)
Return t if the arguments (which should be numbers) are in decreasing order, with equal arguments allowed"

	aConsCell cellsDo: [:c |
		(c car >= (c cadr ifNil: [^ self trueValue])) ifFalse: [^ self falseValue]]. 
! !
LispKernel initialize!
LKReader initialize!
SLisp initialize!
SLispReader initialize!
ULispReader initialize!
